<?php

/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/**
 * Description of cDadosRelaPDF
 *
 * @author VINEVALA
 */
class CDadosRelaPDF extends CI_Controller {

    public function cash($idFatura) {
        $this->db->select('cash');
        $this->db->from('pagamentos_parcelados');
        $this->db->where('idfatura', $idFatura);
        $consulta = $this->db->get();
        $total = 0;
        foreach ($consulta->result() as $value) {
            $total = $total + $value->cash;
        }
        return $total;
    }

    public function calcularIva($idFatura) {
        $totalIva = 0;
        foreach ($this->mFatura->listaItensFctura($idFatura)as $linha) {
            $total = $linha->total;
            $desconto = $linha->desconto;
            $idproduto = $linha->idpr;
            $ivaInt = $this->mIva->calculo_iva_int($desconto + $total, $idproduto);
            $totalIva = $totalIva + $ivaInt;
        }
        return $totalIva;
    }

    public function calcularIvaFornecedor($idFatura) {
        $totalIvaFornecedor = 0;
        foreach ($this->mFatura->listaItensFctura($idFatura)as $linha) {

            $idproduto = $linha->idpr;
            $ivafornecedor = $this->mIva->iva_fornecedor($idproduto);
            $totalIvaFornecedor = $totalIvaFornecedor + $ivafornecedor;
        }
        return $totalIvaFornecedor;
    }

    public function tpa($idFatura) {
        $this->db->select('tpa');
        $this->db->from('pagamentos_parcelados');
        $this->db->where('idfatura', $idFatura);
        $consulta = $this->db->get();
        $total = 0;
        foreach ($consulta->result() as $value) {
            $total = $total + $value->tpa;
        }
        return $total;
    }

    public function dadosEmpresa() {
        $consulta = $this->mempresa->empresa();
        $data = array();
        foreach ($consulta as $row) {
            $data = array(
                'nomeEmpresa' => $row->empresa,
                'nif' => $row->nif,
                'endereco' => $row->endereco,
                'idRegime' => $row->idRegime,
                'fone' => $row->fone,
                'fone1' => $row->fone1,
                'email' => $row->email,
                'provincia' => $row->provincia,
                'img' => $row->img,
            );
        }
        return $data;
    }

    public function resumoDeVendasPDF() {
        $dataminima = $this->input->post('dataminima');
        $datamaxima = $this->input->post('datamaxima');
        $this->load->model('mFatura');
        $this->load->model('mMoeda');
        $this->load->model('mIva');
        $this->load->model('mempresa');
        $subTotalVd = 0;
        $descontoVd = 0;
        $credito = 0;
        $debito = 0;
        $creditoVd = 0;
        $debitoVd = 0;
        $totaIvaFd = 0;
        $creditoFt = 0;
        $debitoFt = 0;
        $subTotalgeralFt = 0;
        $descontoGeralFt = 0;
        $debitoGeralFt = 0;
        $creditoGeralFt = 0;
        $totalIvaFt = 0;
        $totalretecaoFt = 0;
        $totalretecaoVd = 0;
        $subTotalgeral = 0;
        $descontoGeral = 0;
        $debitoGeral = 0;
        $creditoGeral = 0;
        $totalIva = 0;
        $totalretecao = 0;
        $totalFT = 0;
        $totalGeralFT = 0;
        $totalVD = 0;
        $totalGeralVD = 0;
        $totalGERAL = 0;
        $totalIvaFornecedor = 0;

        $ftItens = array();
        $frItens = array();
        $empresa = $this->dadosEmpresa();
        foreach ($this->mFatura->mlistaVendasPorData($dataminima, $datamaxima)as $row) {
            $idFatura = $row->fatura;
            $serie = $this->mFatura->serie($idFatura);
            $dataVenda = $row->data;
            $idTipoDocumento = $this->mFatura->tipoVenda($idFatura);
            if ($idTipoDocumento == 1) {
                $abrDoc = 'FT';
                $tipoDocumento = 'Factura';
                $numero = $this->mFatura->pegaNumeroFtPorIdFatura($idFatura);
                $subtotalFt = $this->mFatura->somaTotalVendas($idFatura);
                $descontosFt = $this->mFatura->somaTotalDesconto($idFatura);
                $ivaFt = $this->calcularIva($idFatura);
                $ivaFornecedorFt = $this->calcularIvaFornecedor($idFatura);
                $retecaoFt = $ivaFt > $ivaFornecedorFt ? $ivaFt - $ivaFornecedorFt : $ivaFt;
                $totalretecaoFt = $retecaoFt + $totalretecaoFt;

                $subTotalgeralFt = $subtotalFt + $subTotalgeralFt;
                $descontoGeralFt = $descontosFt + $descontoGeralFt;
                $debitoFt = 0;

                $debitoGeralFt = $debitoFt;
                $totalIvaFt = $ivaFt + $totalIvaFt;
                $totalFT = $subtotalFt - $descontosFt;
                $totalGeralFT = $totalGeralFT + $totalFT;
                $creditoFt = $totalFT;
                $creditoGeralFt = $creditoFt + $creditoGeralFt;
                $ftItens[] = array(
                    'numeroFatura' => $abrDoc . '-' . $serie . '/' . $numero,
                    'dataVenda' => $dataVenda,
                    'entidade' => $row->nome,
                    'subtotalFt' => $subtotalFt,
                    'descontosFt' => $descontosFt,
                    'totalFT' => $totalFT,
                    'debitoFt' => $debitoFt,
                    'creditoFt' => $creditoFt,
                    'ivaFt' => $ivaFt,
                );
            } else {
                $abrDoc = 'FR';
                $tipoDocumento = 'Factura/Recibo'; // 
                $numero = $this->mFatura->pegaNumeroFrPorIdFatura($idFatura);
                $subtotal = $this->mFatura->somaTotalVendas($idFatura);
                $descontos = $this->mFatura->somaTotalDesconto($idFatura);
                $iva = $this->calcularIva($idFatura);
                $ivaFornecedor = $this->calcularIvaFornecedor($idFatura);
                $retecao = $iva > $totalIvaFornecedor ? $iva - $ivaFornecedor : $iva;
                $totalretecaoVd = $retecao + $totalretecaoVd;

                $subTotalVd = $subtotal + $subTotalVd;
                $descontoVd = $descontos + $descontoVd;

                $totaIvaFd = $iva + $totaIvaFd;
                $credito = 0;
                $creditoVd = $credito = 0;
                $totalVD = $subtotal - $descontos;
                $totalGeralVD = $totalGeralVD + $totalVD;
                $debito = $totalVD;
                $debitoVd = $debito + $debitoVd;
                $frItens[] = array(
                    'numeroFatura' => $abrDoc . '-' . $serie . '/' . $numero,
                    'dataVenda' => $dataVenda,
                    'entidade' => $row->nome,
                    'subtotal' => $subtotal,
                    'descontos' => $descontos,
                    'totalFr' => $totalVD,
                    'debito' => $debito,
                    'credito' => $credito,
                    'iva' => $iva,
                );
            }
            $subTotalgeral = $subTotalgeralFt + $subTotalVd;
            $descontoGeral = $descontoGeralFt + $descontoVd;
            $debitoGeral = $debitoGeralFt + $debitoVd;
            $creditoGeral = $creditoGeralFt + $creditoVd;
            $totalIva = $totalIvaFt + $totaIvaFd;
            $totalretecao = $totalretecaoFt + $totalretecaoVd;
            $totalGERAL = $totalGeralVD + $totalGeralFT;
        }
        $totais = array(
            'subTotalgeral' => $subTotalgeral,
            'descontoGeral' => $descontoGeral,
            'debitoGeral' => $debitoGeral,
            'creditoGeral' => $creditoGeral,
            'totalIva' => $totalIva,
            'totalretecao' => $totalretecao,
            'totalGeral' => $totalGERAL,
        );
        $datais = array(
            'dataminima' => $dataminima,
            'datamaxima' => $datamaxima,
        );
        echo json_encode(array(
            "ftItens" => $ftItens,
            "frItens" => $frItens,
            "empresa" => $empresa,
            "totais" => $totais,
            "datais" => $datais,
        ));
    }

    public function vendasPorArtigo() {
        $dataminima = $this->input->post('dataminima');
        $datamaxima = $this->input->post('datamaxima');
        $this->load->model('mFatura');
        $this->load->model('mIva');
        $this->load->model('mempresa');
        $this->load->model('mResumoVendasArtigo');
        $subTotalgeral = 0;
        $subTotalgastos = 0;
        $totalLucroBruto = 0;
        $totalQtd = 0;
        $subTotalgeralCategoria = 0;
        $totalQtdCategoria = 0;

        $produtos = array();
        $empresa = $this->dadosEmpresa();
        foreach ($this->mFatura->mResumoVendasPorArtigo($dataminima, $datamaxima)as $row) {
            $idFatuta = $row->fatura;
            $idProduto = $row->idpr;
            $categoria = $row->categoria;
            $totalVenda = $this->mFatura->mpega_total2($dataminima, $datamaxima, $idProduto);
            $subTotalgeral = $subTotalgeral + $totalVenda;
            $subTotalgeralCategoria = $subTotalgeralCategoria + $totalVenda;
            $qtd = $this->mResumoVendasArtigo->qtd($dataminima, $datamaxima, $idProduto);
            $totalQtd = $totalQtd + $qtd;
            $totalQtdCategoria = $totalQtdCategoria + $qtd;
            $media = $this->mResumoVendasArtigo->valor_media_venda($dataminima, $datamaxima, $idProduto);
            $gastos = $this->mResumoVendasArtigo->total_gastos($dataminima, $datamaxima, $idProduto);
            $subTotalgastos = $subTotalgastos + $gastos;
            $lucroBruto = $totalVenda - $gastos;
            $totalLucroBruto = $totalLucroBruto + $lucroBruto;
            $margemLucro = number_format(($lucroBruto / $totalVenda), 2);
            $percentagemLucro = $margemLucro * 100;
            $produtos[] = array(
                'artigo' => $row->produto,
                'qtd' => $qtd,
                'categoria' => $categoria,
                'unidade' => $row->nunidade,
                'media' => $media,
                'totalVenda' => $totalVenda,
                'gastos' => $gastos,
                'lucroBruto' => $lucroBruto,
                'percentagemLucro' => $percentagemLucro,
            );
        }

        if ($subTotalgeral > 0) {
            $margemLucroB = number_format(($totalLucroBruto / $subTotalgeral), 2);
            $percentagemLucroBruto = $margemLucroB * 100;
        } else {
            $percentagemLucroBruto = 0;
        }
        $totais = array(
            'percentagemLucroBruto' => $percentagemLucroBruto,
            'margemLucroB' => $margemLucroB,
        );
        $datais = array(
            'dataminima' => $dataminima,
            'datamaxima' => $datamaxima,
        );
        echo json_encode(array(
            "produtos" => $produtos,
            "empresa" => $empresa,
            "totais" => $totais,
            "datais" => $datais,
        ));
    }

    public function resumoDeVendasPorOperadorPDF() {
        $dataminima = $this->input->get('dataminima');
        $datamaxima = $this->input->get('datamaxima');
        $this->load->model('mFatura');
        $this->load->model('mUsuario');
        $this->load->model('mempresa');
        $dinhero = 0;
        $credito = 0;
        $totalDoc = 0;
        $totalDinheiro = 0;
        $totalCredito = 0;
        $totalCash = 0;
        $totalTpa = 0;
        $totalTrans = 0;
        $empresa = $this->dadosEmpresa();
        $dadosDocumentos = array();
        foreach ($this->mFatura->listaResumoVendasDivisoes($dataminima, $datamaxima)as $row) {
            $iduser = $row->iduser;
            $operador = $this->mUsuario->mlistaridNome($iduser);
            $docs = $this->mFatura->conta_tota_faturas($dataminima, $datamaxima, $iduser);
            $dinhero = $this->mFatura->listar_vendas_cash($dataminima, $datamaxima, $iduser);
            $credito = $this->mFatura->soma_vendas_a_credito($dataminima, $datamaxima, $iduser);
            $vendaTpa = $this->mFatura->listar_vendas_tpa($dataminima, $datamaxima, $iduser);
            $transBanc = $this->mFatura->listar_vendas_trans_banc($dataminima, $datamaxima, $iduser);
            $totalDoc = $totalDoc + $docs;
            $totalDinheiro = $totalDinheiro + $dinhero + $vendaTpa + $transBanc;
            $totalCredito = $totalCredito + $credito;
            $totalCash = $totalCash + $dinhero;
            $totalTpa = $totalTpa + $vendaTpa;
            $totalTrans = $totalTrans + $transBanc;
            $dadosDocumentos[] = array(
                'operador' => $operador,
                'docs' => $docs,
                'credito' => $credito,
                'dinheiro' => $dinhero+$vendaTpa+$transBanc,
                
            );
        }
        $totais = array(
            'totalCredito' => $totalCredito,
            'totalDinheiro' => $totalDinheiro,
            'totalCash' => $totalCash,
            'totalTpa' => $totalTpa,
            'totalTrans' => $totalTrans,
            'totalDoc' =>$totalDoc,
        );
        $datais = array(
            'dataminima' => $dataminima,
            'datamaxima' => $datamaxima,
        );
        echo json_encode(array(
            "dadosDocumentos" => $dadosDocumentos,
            "empresa" => $empresa,
            "totais" => $totais,
            "datais" => $datais,
        ));
    }

}
