<?php

/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/**
 * Description of cDadosResCaixaPdF
 *
 * @author VINEVALA
 */
class cDadosResCaixaPdF extends CI_Controller {

    public function somaQtdVendas($dataVenda, $idUsuario, $idProduto) {// 
        $this->db->select_sum('qtd');
        $this->db->from('faturas');
        $this->db->join('item_fatura', 'faturas.fatura=item_fatura.fatura');
        $this->db->where('faturas.data', $dataVenda);
        $this->db->where('faturas.iduser', $idUsuario);
        $this->db->where('idpr', $idProduto);
        $consulta = $this->db->get();
        foreach ($consulta->result() as $value) {
            return $value->qtd;
        }
    }

    public function somaTotalVendas($dataVenda, $idUsuario, $idProduto) {// 
        $this->db->select_sum('total');
        $this->db->from('faturas');
        $this->db->join('item_fatura', 'faturas.fatura=item_fatura.fatura');
        $this->db->where('faturas.data', $dataVenda);
        $this->db->where('faturas.iduser', $idUsuario);
        $this->db->where('idpr', $idProduto);
        $consulta = $this->db->get();
        foreach ($consulta->result() as $value) {
            return $value->total;
        }
    }

    public function listarItemEscluidos($idUsuario, $data) {
        $this->db->select('*');
        $this->db->from('item_cancelados');
        $this->db->join('prodt', 'item_cancelados.idProduto=prodt.idpr');
        $this->db->where('item_cancelados.idUsuario', $idUsuario);
        $this->db->where('data', $data);
        $this->db->group_by('item_cancelados.idProduto');
        $consulta = $this->db->get();
        return $consulta->result();
    }

    public function somaQtdCancelado($idUsuario, $data, $idProduto) {// 
        $this->db->select_sum('qtd');
        $this->db->from('item_cancelados');
        $this->db->join('prodt', 'item_cancelados.idProduto=prodt.idpr');
        $this->db->where('item_cancelados.idUsuario', $idUsuario);
        $this->db->where('data', $data);
        $this->db->where('idpr', $idProduto);
        $consulta = $this->db->get();
        foreach ($consulta->result() as $value) {
            return $value->qtd;
        }
    }

    public function somaTotalCancelado($idUsuario, $data, $idProduto) {// 
        $this->db->select_sum('total');
        $this->db->from('item_cancelados');
        $this->db->join('prodt', 'item_cancelados.idProduto=prodt.idpr');
        $this->db->where('item_cancelados.idUsuario', $idUsuario);
        $this->db->where('data', $data);
        $this->db->where('idpr', $idProduto);
        $consulta = $this->db->get();
        foreach ($consulta->result() as $value) {
            return $value->total;
        }
    }

    public function dadosEmpresa() {
        $consulta = $this->mempresa->empresa();
        $data = array();
        foreach ($consulta as $row) {
            $data = array(
                'nomeEmpresa' => $row->empresa,
                'nif' => $row->nif,
                'endereco' => $row->endereco,
                'idRegime' => $row->idRegime,
                'fone' => $row->fone,
                'fone1' => $row->fone1,
                'email' => $row->email,
                'provincia' => $row->provincia,
                'img' => $row->img,
            );
        }
        return $data;
    }

    public function docResCaixaPDF() {
        $idUsuario = $this->input->get('idUsuario');
        $idCaixaAberto = $this->input->get('idCaixaAberto');
        $this->load->model('mfluxoCaixa');
        $this->load->model('mIva');
        $this->load->model('mFatura');
        $this->load->model('mUsuario');
        $this->load->model('mempresa');
         $dataCaixa = $this->mfluxoCaixa->data_caixa($idUsuario, $idCaixaAberto);
        $empresa = $this->dadosEmpresa();

        $vendaCash = $this->mfluxoCaixa->listar_vendas_cash($dataCaixa, $idUsuario);
        $vendaTpa = $this->mfluxoCaixa->listar_vendas_tpa($dataCaixa, $idUsuario);
        $vendaCashParcelado = $this->mfluxoCaixa->listaCashParcelado($dataCaixa, $idUsuario);
        $vendaTpaParcelado = $this->mfluxoCaixa->listaTpaParcelado($dataCaixa, $idUsuario);
        $saldoInicial = $this->mfluxoCaixa->listarSaldo_caixa_abertuta($dataCaixa, $idUsuario);
        $sangria = $this->mfluxoCaixa->listarSaldo_caixa_sagria($dataCaixa, $idUsuario);
        $entreque = $this->mfluxoCaixa->listar_valor_entregue($dataCaixa, $idUsuario);
        $estado = $this->mfluxoCaixa->pega_estado_caixa($dataCaixa, $idUsuario);
        $nome = $this->mUsuario->mlistaridNome($idUsuario);
        $horaAbertura = $this->mfluxoCaixa->pega_hora_abertura($dataCaixa, $idUsuario);
        $dataEnceramento = $this->mfluxoCaixa->pega_data_encerramemto($dataCaixa, $idUsuario);
        $horaEnceramento = $this->mfluxoCaixa->pega_hora_encerramemto($dataCaixa, $idUsuario);
        $entradas = $vendaCash + $vendaTpa + $saldoInicial + $vendaCashParcelado + $vendaTpaParcelado;
        $total = $entradas - $sangria;
        $dif = $total - $entreque;
        if ($dif < 0) {
            $dif = 0;
        }
        $detalhesCaixa = array(
            'nome' => $nome,
            'estado' => $estado,
            'aberto' => $dataCaixa.' '.$horaAbertura,
            'encerrado' => $dataEnceramento.' '.$horaEnceramento,
            'suprimentos' => $saldoInicial,
            'sangria' => $sangria,
            'cash' => $vendaCash+$vendaCashParcelado,
            'tpa' => $vendaTpa+$vendaTpaParcelado,
            'total' => $total ,
            'entreque' => $entreque,
            'dif' => $dif,
        );
        $produtos = array();
        foreach ($this->mFatura->pegaProdutosResumo($dataCaixa, $idUsuario) as $linha) {
            $idProduto = $linha->idpr;

            $linha->qtd;
            $linha->custo;
            $linha->total;
            $produtos[] = array(
                'produto' => $linha->produto,
                'qtd' => $this->somaQtdVendas($dataCaixa, $idUsuario, $idProduto),
                'valor' => $this->somaTotalVendas($dataCaixa, $idUsuario, $idProduto),
            );
        }
        // fim do  foreach
        $totalCancelado = 0;
        $itensCancelados = array();
        foreach ($this->listarItemEscluidos($idUsuario, $dataCaixa) as $linha) {
            $idProduto = $linha->idpr;
            $linha->qtd;
            $total1 = $this->somaTotalCancelado($idUsuario, $dataCaixa, $idProduto);
            $totalCancelado = $totalCancelado + $total1;
           
            $itensCancelados[] = array(
                'produto' => $linha->produto,
                'qtd' => $this->somaQtdCancelado($idUsuario, $dataCaixa, $idProduto),
                'valor' => $this->somaTotalCancelado($idUsuario, $dataCaixa, $idProduto)
            );
        }
        $detalhesDoc = array(
            'tipoDocumento' => $itensCancelados,
            
        );
        echo json_encode(array(
            "detalhesCaixa" => $detalhesCaixa,
            "empresa" => $empresa,
            "detalhesDoc" => $detalhesDoc,
            "produtos" => $produtos,
            "itensCancelados" => $itensCancelados,
        ));
    }

}
