<?php

/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/**
 * Description of texte
 *
 * @author VINEVALA
 */
class CEmpresa extends CI_Controller {

    private function getPostData() {
        return array(
            'idEmpresa' => $this->input->post('idEmpresa'),
            'idprovincia' => $this->input->post('idProvincia'),
            'nome' => $this->input->post('nempresa'),
            'nif' => $this->input->post('nif'),
            'endereco' => $this->input->post('endereco'),
            'telefone' => $this->input->post('telefone'),
            'fone1' => $this->input->post('telefone2'),
            'email' => $this->input->post('email'),
            'website' => $this->input->post('website'),
            'idRegime' => $this->input->post('idRegime'),
//            'control' => $this->input->post('control'),
//            'conservatoria' => $this->input->post('conservatoria'),
//            'capitalsocial' => $this->input->post('capitalsocial'),
//            'nomecomercial' => $this->input->post('nomecomercial'),
//            'slogan' => $this->input->post('slogan')
        );
    }

    public function crud_empresa() {
        // Coleta os dados do POST
        $data = $this->getPostData();

        $this->load->model('MEmpresa');

        // Processa o upload do logo, se houver
        $logoFileName = '';
        if (!empty($_FILES['logo']['name'])) {
            $logoFileName = $this->handleLogoUpload();
            if ($logoFileName === false) {
                // Já enviou a mensagem de erro, então interrompe o processamento
                return;
            }
        }

        // Se $data['idEmpresa'] não estiver vazio, atualiza os dados da empresa
        if (!empty($data['idEmpresa']) && $data['idEmpresa'] !== 'null') {
            // Chame o método de atualização do seu modelo (ex.: atualizar_empresa)
            $this->MEmpresa->atualizar_empresa($data);
            $idEmpresa = $data['idEmpresa'];
        } else {
            // Caso $data['idEmpresa'] esteja vazio (ou seja, nova empresa)
            // Verifica se já existe uma empresa cadastrada
            if ($this->MEmpresa->contar()) {
                echo json_encode('ENC');
                return;
            } else {
                // Cria uma nova empresa e captura o ID retornado
                $idEmpresa = $this->MEmpresa->gr_empresa(
                        $data['idprovincia'], $data['nome'], $data['nif'], $data['endereco'], $data['telefone'],
                        $data['email'], $data['fone1'], $data['website'], $data['idRegime'], $data['control'],
                        $data['conservatoria'], $data['capitalsocial'], $data['nomecomercial'], $data['slogan']
                );
            }
        }

        // Se houver upload de logo, atualiza o caminho da imagem
        if (!empty($logoFileName)) {
            $this->MEmpresa->caminho_imagem($idEmpresa, $logoFileName);
        }

        echo json_encode('OK');
    }

    private function handleLogoUpload() {
        // Configurações para upload de imagem
        $config = array(
            'upload_path' => APPPATH . 'images/logo/',
            'allowed_types' => 'gif|jpg|png|jpeg',
            'max_size' => 2048, // tamanho máximo em KB (2MB)
            'encrypt_name' => TRUE
        );

        $this->load->library('upload', $config);

        if (!$this->upload->do_upload('logo')) {
            $error = $this->upload->display_errors();
            // Verifica se o erro é relacionado ao tamanho da imagem
            if (strpos($error, 'excede o tamanho permitido') !== false) {
                echo json_encode('GR');
            } else {
                echo json_encode($error);
            }
            return false;
        }

        $uploadData = $this->upload->data();

        // Redimensiona a imagem, se necessário
        $this->resizeImage($uploadData['full_path']);

        return $uploadData['file_name'];
    }

    private function resizeImage($sourceImage) {
        $configResize = array(
            'image_library' => 'gd2',
            'source_image' => $sourceImage,
            'maintain_ratio' => TRUE,
            'width' => 400,
            'height' => 400
        );

        $this->load->library('image_lib', $configResize);

        if (!$this->image_lib->resize()) {
            // Registra o erro sem interromper o fluxo
            log_message('error', $this->image_lib->display_errors());
        }
    }



   

    public function listar_empresa() {
        $id = $this->input->get('id');
        $this->load->model('MEmpresa');
        $array = $this->MEmpresa->listar_empresam($id);
        $dados = array();

        foreach ($array as $row) {
            if ($row->fone1 == '___-___-') {
                $fone = '';
            } else {
                $fone = $row->fone1;
            }
            $dados[] = array(
                'idEmpresa' => $row->id,
                'nome' => $row->empresa,
                'endereco' => $row->endereco,
                'email' => $row->email,
                'telefone' => $row->fone,
                'fone1' => $fone,
                'nif' => $row->nif,
                'idprovincia' => $row->idprovincia,
                'provincia' => $row->provincia,
                'img' => $row->img,
                'idRegime' => $row->idRegime,
                'website' => $row->website,
                'control' => $row->control,
                'conservatoria' => $row->conservatoria,
                'capitalsocial' => $row->capitalsocial,
                'nomecomercial' => $row->nomecomercial,
                'slogan' => $row->slogan,
            );
        }
        echo json_encode(array(
            "draw" => 1,
            "recordsTotal" => 1,
            "recordsFiltered" => 1,
            "data" => $dados
        ));
    }

    public function pega_empresa_edit() {
        $idEmpresa = $this->input->get('idEmpresa');
        $this->load->model('MEmpresa');
        $array = $this->MEmpresa->listar_empresam($idEmpresa);
        $dados = array();
        foreach ($array as $row) {
            $dados = array(
                'idEmpresa' => $row->id,
                'nome' => $row->empresa,
                'endereco' => $row->endereco,
                'email' => $row->email,
                'telefone' => $row->fone,
                'fone1' => $row->fone1,
                'nif' => $row->nif,
                'idprovincia' => $row->idprovincia,
                'provincia' => $row->provincia,
                'img' => $row->img,
                'idRegime' => $row->idRegime,
                'website' => $row->website,
                'control' => $row->control,
                'conservatoria' => $row->conservatoria,
                'capitalsocial' => $row->capitalsocial,
                'nomecomercial' => $row->nomecomercial,
                'slogan' => $row->slogan,
            );
        }
        echo json_encode($dados);
    }

    public function listar_tipo_negocio() {

        $this->load->model('MEmpresa');
        $array = $this->MEmpresa->listaTipoNegocio();
        foreach ($array as $row) {
            $data = array(
                'idNegocio' => $row->id,
                'tipoNegocio' => $row->tipoNegocio,
                'ativo' => $row->ativo,
            );
            $response['results'][] = $data;
        }
        echo json_encode($response);
    }

    public function listar_regime_empresa() {

        $this->load->model('MEmpresa');
        $array = $this->MEmpresa->regime_empresa();
        $dados = array();
        foreach ($array as $row) {
            $dados[] = array(
                'idRegime' => $row->idRegime,
                'nregime' => $row->nregime,
            );
        }
        echo json_encode($dados);
    }

    public function logo() {
        require 'WideImage/WideImage.php';
        $dir = '' . APPPATH . 'images/logo/';
        $pasta = './uploads/';
        $codigo = $this->input->post('codigo');
        $this->load->model('mempresa');
        $consulta = $this->mempresa->pegarCaminho($codigo);
        foreach ($consulta as $linha) {
            $caminho = $linha->img;
            $imagem = $caminho;
            if (file_exists($dir . $imagem) && !is_dir($dir . $imagem)) {
                unlink($dir . $imagem);
            }
            if (file_exists($pasta . $imagem) && !is_dir($pasta . $imagem)) {
                unlink($pasta . $imagem);
            }
        }

        if (!empty($_FILES['photo']['tmp_name'])) {
            $foto = $_FILES['photo'];
            if (preg_match('/.(gif|bmp|png|jpg|jpeg){1}$/i', $foto['type'])) {
                $imagem = $_FILES['photo'];
                $ext = substr($imagem['name'], -3);
                $new_name = md5(uniqid(time())) . '.' . $ext;
                $image = WideImage::load($imagem['tmp_name']);
//                     $image = $image->resize(180, 190, 'outside');
//                     $image = $image->crop('center', 'center', 180, 190);
                $image->saveToFile($dir . $new_name);
                $image->saveToFile($pasta . $new_name);

                $this->mempresa->logo($codigo, $new_name);
                $this->json->success('Logotipo Salvo');
            } else {
                $this->json->GerarMessagemJSONText("isto não é uma imagem");
            }
        }
    }

    public function seleciona_tipo_negocio() {
        $idNegocio = $this->input->post('idNegocio');
        $ativo = $this->input->post('ativo');
        if ($ativo == 'true') {
            $ativo = 's';
        }
        $this->load->model('mempresa');
        if ($ativo == 'false') {
            $this->json->success('n');
        } else {
            if ($this->mempresa->reset_tipo_negocio()) {
                $this->mempresa->ativa_tipo_negocio($idNegocio, $ativo);
                $this->json->success('Tipo de negócio alterado');
            }
        }
    }

    public function listar_ramo_atividade() {
        $this->load->model('mempresa');
        echo $this->json->success($this->mempresa->pegaRamoAtividade());
    }

}

?>
