<?php

/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/**
 * Description of cItens
 *
 * @author VINEVALA,
 */
class cItens extends CI_Controller {

    public function lista_itens() {
        // Pegar os parâmetros de paginação e pesquisa
        $start = $this->input->get('start');
        $limit = $this->input->get('limit');
        $pesquisa = $this->input->get('pesquisa');

        // Carregar o model
        $this->load->model('mItens');

        // Obter os itens paginados
        $resultados = $this->mItens->mlista_itens($start, $limit, $pesquisa);

        // Contar o total de produtos (sem paginação) para enviar no JSON
        $total = $this->mItens->contar_produtos();

        // Verificar se existem resultados
        if ($resultados) {
            $imprimir = array();

            // Montar a lista de produtos
            foreach ($resultados as $row) {
                $imprimir[] = array(
                    'idpr' => $row->idpr,
                    'produto' => $row->produto,
                    'categoria' => $row->categoria,
                    'preco' => $row->preco,
                    'idcategoria' => $row->idcategoria
                );
            }

            // Montar o array final com itens e total de produtos
            $response = array(
                'products' => $imprimir, // Lista de produtos
                'totalItems' => $total    // Total de produtos (para paginação)
            );
            // Codificar o array como JSON
            echo json_encode($response);
        } else {
            // Caso não haja resultados, retornar uma resposta vazia
            echo json_encode(array(
                'products' => array(),
                'totalItems' => 0
            ));
        }
    }

    public function precoComIVa($preco, $idpr) {
        if ($this->mempresa->pegaRegime() == 2 || $this->mempresa->pegaRegime() == 3) {
            return '0.00';
        } else {
            $iva = $this->mIva->calculo_iva_int($preco, $idpr);
//            $iva = $this->mIva->calculo_iva($preco, $idpr);
            return $iva + $preco;
        }
    }

    public function pega_qtd($td, $idGrupoPreco, $idProduto) {
        if ($this->mGestaoStock->tipo_grupo($idGrupoPreco) == 'gr') {
            if ($this->mGestaoStock->mconsulta_idproduto_compra($idProduto)) {
                $total_por_unidade = $this->mGestaoStock->pega_total_por_unidade($idProduto);
                return intval($this->calcula_qtd($total_por_unidade, $td));
            } else {
                return $td;
            }
        } else {
            return $td;
        }
    }

    public function lista_itens_grid_pos() {
        $this->load->model('mItens');
        $this->load->model('mGestaoStock');
        $this->load->model('mArtigos');
        $this->load->model('MEmpresa');
        $this->load->model('mIva');
        // Receber os dados da requisição AJAX

        $searchValue = ($_POST["search"] ["value"]);
        $draw = $this->input->post("draw");
        $limit = $this->input->post('length'); // Número de registros por página
        $offset = $this->input->post('start'); // Offset para paginação
        $idCategoriaPontoVenda = $this->input->post('idCategoriaPontoVenda');
        $idGrupoPreco = $this->input->post('idGrupoPreco');
        // Obter o total de registros
        $totalRecords = $this->mItens->get_total_records_produtos();

        // Obter os registros filtrados
        $filteredRecords = $this->mItens->get_filtered_records_count($searchValue);

        // Obter os dados com limite e offset para paginação
        $data = array();

        foreach ($this->mItens->get_filtered_data($searchValue, $limit, $offset)as $linha) {
            $qtd = $this->pega_qtd($linha->qtd, $idGrupoPreco, $linha->idpr);
            $preco = $this->mItens->pegaPrecoPorGrupo($idGrupoPreco, $linha->idpr);
            $isencao = $this->mArtigos->produto_isencao($linha->idpr);
            if ($isencao == 1) {
                $taxa = $this->mArtigos->pegaIvaVenda($linha->idpr);
            } else {
                $taxa = 0;
            }
            if ($this->MEmpresa->pegaRegime() == 1) {
                $venda = $this->precoComIVa($preco, $linha->idpr);
            } else {
                $venda = $preco;
            }
            $sub_array = array();
            $sub_array[] = $linha->produto;
            $sub_array[] = number_format($venda, 2);
            $sub_array[] = '<a href="#" title="Adicionar no carrinho de compras" class="icon-action adicionarModalQtd" id="' . $linha->idpr . '"><i class="iconsminds-add-cart"></i> </a>';
            $data[] = $sub_array;
        }

        echo json_encode(array(
            "draw" => $draw,
            "recordsTotal" => $totalRecords,
            "recordsFiltered" => $filteredRecords,
            "data" => $data
        ));
        // Retornar a resposta em JSON
    }

    /**
     * Retorna o valor do IVA aplicável para a venda de um produto,
     * com base na exceção de isenção e no regime fiscal da empresa.
     *
     * A lógica aplicada é a seguinte:
     * - Se a empresa está no regime geral (regime = 1):
     *     - Verifica se o produto está sujeito a IVA (produto_isencao retorna 1).
     *       (Ou seja, se o tipo de isenção for igual a 1, o produto tem IVA.)
     *       - Se sim, retorna o valor do IVA para a venda do produto.
     *       - Caso contrário, retorna 0.00.
     * - Se a empresa não está no regime geral, nenhum IVA é aplicado e retorna 0.00.
     *
     * @param int $idproduto ID do produto a consultar.
     * @return float Valor do IVA ou 0.00 se não aplicável.
     */
    public function pega_exepcao($idproduto) {
        // Carrega os modelos necessários
        $this->load->model('mArtigos');
        $this->load->model('mempresa');

        // Verifica se a empresa está no regime geral (regime == 1)
        if ($this->mempresa->pegaRegime() == 1) {
            // Verifica se o produto tem IVA (produto_isencao retorna 1 => produto sujeito a IVA)
            if ($this->mArtigos->produto_isencao($idproduto) == 1) {
                // Retorna o valor do IVA para a venda
                return $this->mArtigos->pegaIvaVenda($idproduto);
            } else {
                // Se o produto não for sujeito a IVA, retorna 0.00
                return 0.00;
            }
        } else {
            // Se a empresa não está no regime geral, retorna 0.00
            return 0.00;
        }
    }

    public function preco_promocao($preco, $idProduto) {
        $hoje = date('Y-m-d');
        $this->load->model('MPromocao');
        if ($this->MPromocao->conta_produto_existe_procao($idProduto)) {
            foreach ($this->MPromocao->mpega_lista_mpromocao2($idProduto) as $linha) {
                $data_fim = $linha->data_fim;
                $data_inicio = $linha->data_inicio;
                if (strtotime($hoje) < strtotime($data_inicio)) {
                    return $preco;
                } elseif (strtotime($hoje) > strtotime($data_fim)) {
                    return $preco;
                } else {
                    $percentagem = number_format(($linha->desconto * $preco) / 100, 2);
                    return number_format($preco - $percentagem, 2);
                }
            }
        } else {
            return $preco;
        }
    }

    public function itens_pos() {
        $idproduto = $this->input->get('idProduto');
        $idLoja = $this->input->get('idLoja');
        $idGrupoPreco = $this->input->get('idGrupoPreco');
        $this->load->model('mArtigos');
        $this->load->model('mStock');
        $this->load->model('mGestaoStock');
        $this->load->model('MEmpresa');
        $this->load->model('mIva');
        $listar = $this->mArtigos->pegarPr($idproduto, $idLoja);

        foreach ($listar as $linha) {
            $idTipo = $linha->idTipo;
            $control = $linha->control;
            $precoIva = 0;
            if ($idTipo == 3 && $control == 's') {
                $stock = $this->pega_qtd($linha->qtd, $idGrupoPreco, $linha->idpr);
            } else {
                $stock = '';
            }
            $preco = $this->preco_promocao($this->mStock->pegaPrecoPorGrupo($idGrupoPreco, $linha->idpr), $linha->idpr);
            if ($this->MEmpresa->pegaRegime() == 1) {
                $precoIva = $this->precoComIVa($preco, $linha->idpr);
            }
            $dados[] = array(
                'preco' => $preco,
                'idproduto' => $linha->idpr,
                'stock' => $stock,
                'produto' => $linha->produto,
                'tipo' => $idTipo,
                'control' => $control,
                'desconto' => $linha->desconto,
                'imei' => $linha->imei,
                'sim' => $linha->sim,
                'qtd' => 1,
                'iva' => $this->pega_exepcao($idproduto),
                'precoIva' => $precoIva,
            );
        }
        echo json_encode($dados);
    }

    // listar produtos do tipo A
    public function pegaIdProduto() { // pega o id do produto atravez do codigo de barraidPr
        $pesquisa = $this->input->get('pesquisa');
        $this->load->model('mItens');
        echo json_encode($this->mItens->idProduto($pesquisa));
    }

}
