<?php

/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/**
 * Description of cNotaCredito
 *
 * @author VINEVALA
 */
class cNotaCredito extends CI_Controller {

    public function anularDocumento() {// tota de credito total
        $idFatura = $this->input->post('idFatura');
        $idUsuario = $this->input->post('idUsuario');
        $dataComputador = date('Y-m-d H:i:s');
        $this->load->model('mNotaCredito');
        $this->load->model('mFatura');
        $ultimaDta = $this->mFatura->retornaUltimaDataHoraPorFatura($idFatura);
        if (strtotime($dataComputador) < strtotime($ultimaDta)) {
            echo json_encode(array("idNota" => 0, "msg" => 'INV'));
        } elseif ($this->mFatura->verifica_fatura_reportada_agt($idFatura) == true) {
            echo json_encode(array("idNota" => 0, "msg" => 'Rep'));
        } elseif ($this->mNotaCredito->consultar_fatura_nota_credito($idFatura) == true) { // se  a fatura a anular ainda não for reportada ou não tinha sido anulada antes
            echo json_encode(array("idNota" => 0, "msg" => 'anulada'));
        } else { // 
            $idNota = $this->mNotaCredito->registarNota($idFatura, $idUsuario);
            foreach ($this->mNotaCredito->listaProduto($idFatura) as $linha) {
                $idProduto = $linha->idpr;
                $qtd = $linha->qtd;
                $this->mNotaCredito->atualizarSubtrairQtd($idProduto, $qtd);
                $this->mNotaCredito->alteraestado($idFatura, $idProduto);
            }
            $this->gerarHash($idNota, $idFatura);
            echo json_encode(array("idNota" => $idNota, "msg" => 'OK'));
        }
    }

    public function cRegistaNotaCredito() {// tota de credito parcial
        $idFatura = $this->input->post('idFatura');
        $idUsuario = $this->input->post('idUsuario');
        $produtosAnulados = json_decode($this->input->post('produtosAnulados'), true);

        $dataComputador = date('Y-m-d H:i:s');
        $this->load->model('mNotaCredito');
        $this->load->model('mFatura');
        $ultimaDta = $this->mFatura->retornaUltimaDataHoraPorFatura($idFatura);
        if (strtotime($dataComputador) < strtotime($ultimaDta)) {
            echo json_encode(array("idNota" => 0, "msg" => 'INV'));
        } elseif ($this->mFatura->verifica_fatura_reportada_agt($idFatura) == true) {
            echo json_encode(array("idNota" => 0, "msg" => 'Rep'));
        } else {
            $idNota = $this->mNotaCredito->registarNotaParcial($idFatura, $idUsuario);
            foreach ($produtosAnulados as $idProduto) {
                $idProduto = $idProduto['IdProduto']; // Acessa o valor corretamente
                $this->mNotaCredito->atualizarSubtrairQtd($idProduto, $this->mNotaCredito->pegaQtd($idFatura, $idProduto));
                $this->mNotaCredito->registarNotaCreditoItem($idNota, $idProduto);
                $this->mNotaCredito->alteraestadoP($idFatura, $idProduto);
            }
            $totalGroso = $this->calculaTotalAgroso($idFatura);
            $this->gerarHashParcial($idNota, $idFatura, $totalGroso);
            echo json_encode(array("idNota" => $idNota, "msg" => 'OK'));
        }
    }

    public function gerarHash($idNota, $idFatura) { // gera a assinatura digital para as anulação de faturas
        $this->load->model('mNotaCredito');
        $stipoVenda = 'NC';
        $inVoiveDate = $this->mNotaCredito->inVoiceDate($idNota);
        $systemEntryate = $this->mNotaCredito->systemEntryate($idNota); // data e hora da fatura
        $grossTotal = $this->mNotaCredito->grossTotal($idNota, $idFatura);
        $serie = $this->mNotaCredito->serie($idNota);
        $inVoiceNo = $stipoVenda . ' ' . $serie . '/' . $idNota;
        if ($this->mNotaCredito->contarRegistosNotas() > 1) {// se ja existe notas de creditos  assinadas
            $hasUltimo = $this->mNotaCredito->hash_da_ultima_fatura($idNota);
            $registo = $inVoiveDate . ';' . $systemEntryate . ';' . $inVoiceNo . ';' . $grossTotal . ';' . $hasUltimo;
        } else {// caso nao caso 
            $registo = $inVoiveDate . ';' . $systemEntryate . ';' . $inVoiceNo . ';' . $grossTotal . ';';
        }


        $priv_key = file_get_contents('./ChavePrivada/ChavePrivada.pem');
        $key = openssl_get_privatekey($priv_key);
        $ignature = '';
        openssl_sign($registo, $ignature, $key, OPENSSL_ALGO_SHA1);
        $registoHash = base64_encode($ignature);
        $control1 = $registoHash[0];
        $control2 = $registoHash[10];
        $control3 = $registoHash[20];
        $control4 = $registoHash[30];

        $hasControl = $control1 . '' . $control2 . '' . $control3 . '' . $control4;
        $this->mNotaCredito->matualizar_hash($idNota, $registoHash, $hasControl);
    }

    public function gerarHashParcial($idNota, $idFatura, $totalGroso) { // gera a assinatura digital para as retificações de faturas de faturas
        $this->load->model('mNotaCredito');
        $stipoVenda = 'NC';
        $inVoiveDate = $this->mNotaCredito->inVoiceDate($idNota);
        $systemEntryate = $this->mNotaCredito->systemEntryate($idNota); // data e hora da fatura
        $grossTotal = $totalGroso;
        $serie = $this->mNotaCredito->serie($idNota);
        $inVoiceNo = $stipoVenda . ' ' . $serie . '/' . $idNota;
        if ($this->mNotaCredito->contarRegistosNotas() > 1) {// se ja existe notas de creditos  assinadas
            $hasUltimo = $this->mNotaCredito->hash_da_ultima_fatura($idNota);
            $registo = $inVoiveDate . ';' . $systemEntryate . ';' . $inVoiceNo . ';' . $grossTotal . ';' . $hasUltimo;
        } else {// caso nao caso 
            $registo = $inVoiveDate . ';' . $systemEntryate . ';' . $inVoiceNo . ';' . $grossTotal . ';';
        }


        $priv_key = file_get_contents('./ChavePrivada/ChavePrivada.pem');
        $key = openssl_get_privatekey($priv_key);
        $ignature = '';
        openssl_sign($registo, $ignature, $key, OPENSSL_ALGO_SHA1);
        $registoHash = base64_encode($ignature);
        $control1 = $registoHash[0];
        $control2 = $registoHash[10];
        $control3 = $registoHash[20];
        $control4 = $registoHash[30];

        $hasControl = $control1 . '' . $control2 . '' . $control3 . '' . $control4;
        $this->mNotaCredito->matualizar_hash($idNota, $registoHash, $hasControl);
    }

    public function gerarHashParcialTeste() { // gera a assinatura digital para as retificações de faturas de faturas
        $idNota = 4;
        $idFatura = 0;
        $totalGroso = 0;
        $this->load->model('mNotaCredito');
        $stipoVenda = 'NC';
        $inVoiveDate = $this->mNotaCredito->inVoiceDate($idNota);
        $systemEntryate = $this->mNotaCredito->systemEntryate($idNota); // data e hora da fatura
        $grossTotal = $totalGroso;
        $serie = $this->mNotaCredito->serie($idNota);
        $inVoiceNo = $stipoVenda . ' ' . $serie . '/' . $idNota;
        if ($this->mNotaCredito->contarRegistosNotas() > 1) {// se ja existe notas de creditos  assinadas
            $hasUltimo = $this->mNotaCredito->hash_da_ultima_fatura($idNota);
            //  $registo= $inVoiveDate.';'.$systemEntryate.';'.$inVoiceNo.';'.$grossTotal.';'.$hasUltimo;       
            $registo = '2020-09-23;2020-09-23T00:27:00;NC 2020/4;2280.00;YnfBLmd74O0wVdnT5+SlYGyd7ns5KUw2iShYu61pxc54tf/SBXqLAr6ROGk74iHQzOwUcDeo8v2Ml8m5ZwNKCTSBsHU08WgKn4Ospy8lY949hIGQ0YlRycoUMEVxk8iZRkoGKfHoWECt2apbNNzk9ziR07RJqYUqyearLZOlxyw=';
        } else {// caso nao caso  2020-09-22;2020-09-22T15:15:08;NC 2020/3;0;ZRyzqsgwn9jwTyvoW3e/WaYkEnkDZErhO3KQEt16c8dx1UoMwUwpoUKQG0iku4aXBBplAPT2yQTrLUyH37hfl0O4a9gJ04ASL1Dojw6cubrEllBLSJHGU6x9+yo+bdpT4Hc+dqcv6TBOPZ4fzp+kOxm+RlMMCvivAqxYZlhmj1s=
            $registo = $inVoiveDate . ';' . $systemEntryate . ';' . $inVoiceNo . ';' . $grossTotal . ';';
        }


        $priv_key = file_get_contents('./ChavePrivada/ChavePrivada.pem');
        $key = openssl_get_privatekey($priv_key);
        $ignature = '';
        openssl_sign($registo, $ignature, $key, OPENSSL_ALGO_SHA1);
        echo $registoHash = base64_encode($ignature);
        $control1 = $registoHash[0];
        $control2 = $registoHash[10];
        $control3 = $registoHash[20];
        $control4 = $registoHash[30];

        $hasControl = $control1 . '' . $control2 . '' . $control3 . '' . $control4;
        //   $this->mNotaCredito->matualizar_hash($idNota,$registoHash,$hasControl);
    }

    public function listaNotaCredito() {
        $searchValue = ('pesquisa');
        $draw = $this->input->post("draw");
        $limit = $this->input->post('length'); // Número de registros por página
        $offset = $this->input->post('start');
        $this->load->model('mNotaCredito');
        $this->load->model('mFatura');
        $dados = array();
        $totalFiltrados = $this->mNotaCredito->obter_total_registos_filtrados_notas_credito();
        foreach ($this->mNotaCredito->listaNotaCredito($offset, $limit) as $linha) {
            $idFatura = $linha->fatura;
            $data = $linha->data;
            $sd = new DateTime($data);
            $dt = utf8_encode(strftime("%A %d de %B de %Y", strtotime($sd->format("d. M. Y "))));
            $ano = utf8_encode(strftime(" %Y", strtotime($sd->format("d. M. Y "))));
            $idTipoDocumento = $this->mFatura->tipoVenda($idFatura);
            $serie = $this->mFatura->serie($idFatura);
            if ($idTipoDocumento == 1) {
                $abrDoc = 'FT';
                $numero = $this->mFatura->pegaNumeroFtPorIdFatura($idFatura);
            } else {
                $abrDoc = 'FR';
                $numero = $this->mFatura->pegaNumeroFrPorIdFatura($idFatura);
            }
            $dados[] = array(
                'idFatura' => $idFatura,
                'idNota' => $linha->idNota,
                'numerodocumento' => "NC" . $ano . '/' . $linha->idNota,
                'Referencia' => $abrDoc . ' ' . $serie . '/' . $numero,
                'total' => $linha->total_venda,
                'dataAnulacao' => $linha->data,
                'cliente' => $linha->nome,
                'unome' => $linha->unome,
            );
        }

        echo json_encode(array(
            "draw" => $draw,
            "recordsTotal" => $this->mNotaCredito->contarNotaCredito(),
            "recordsFiltered" => $totalFiltrados,
            "data" => $dados
        ));
    }

    public function imprimir_nota_credito() {
        $idNota = $this->input->post('idNota');
        $this->load->model('mNotaCreditoPDF');
        $this->load->model('mNotaCredito');

        if ($this->mNotaCredito->estado($idNota) == 'EM ESPERA') {
            $documento = 'Original';
            $this->mNotaCredito->atualizarEstado($idNota, 'FINALIZADO');
            $this->mNotaCreditoPDF->imprimirPdfNoTaCredito($idNota, $documento);
            $this->json->success('Ipmrimir');
        } else {
            $documento = '2.ª Via em conformidade com o original';
            $this->mNotaCreditoPDF->imprimirPdfNoTaCredito($idNota, $documento);
            $this->json->success('Ipmrimir');
        }
    }

    public function acharTotal($totalSemIva14Porcento) {
        return number_format(($totalSemIva14Porcento * 14) / 100, 2, '.', '');
    }

    public function calculaTotalAgroso($idFatura) {// Calcula o total a grosso para as notas de credito parcia
        $this->load->model('mFatura');
        $totalSemIva14Porcento = $this->mFatura->pegaTotalParcial14($idFatura);
        $iva14 = $this->acharTotal($totalSemIva14Porcento);
        $isento = $this->mFatura->pegaTotalParcialIsento($idFatura);
        $totalComIva14 = $totalSemIva14Porcento + $iva14;
        return number_format($isento + $totalComIva14, 2, '.', '');
    }

    public function calculaTotalAgrosoTeste() {// apagar
        $idFatura = 69;
        $this->load->model('mFatura');
        $totalSemIva14Porcento = $this->mFatura->pegaTotalParcial14($idFatura);
        $iva14 = $this->acharTotal($totalSemIva14Porcento);
        $isento = $this->mFatura->pegaTotalParcialIsento($idFatura);
        $totalComIva14 = $totalSemIva14Porcento + $iva14;
        echo number_format($isento + $totalComIva14, 2, '.', '');
    }

}

?>
