<?php

// application/libraries/Migration.php

defined('BASEPATH') OR exit('No direct script access allowed');

class Migration {

    public function __construct() {
        $this->CI =& get_instance(); // Carregar a instância do CodeIgniter
        $this->CI->load->dbforge(); // Carregar o dbforge
    }

    public function criarTabela() {
        // Verificar se a tabela já existe
        if (!$this->CI->db->table_exists('stock_loja_dt_caducidade')) {
            // Criar a tabela
            $this->criarTabelaStockLoja();
        }
    }

    private function criarTabelaStockLoja() {
        // Definir os campos da tabela
        $fields = array(
            'id_stock' => array(
                'type' => 'INT',
                'constraint' => 11,
                'auto_increment' => TRUE
            ),
            'idProduto' => array(
                'type' => 'INT',
                'constraint' => 11,
            ),
            'qtd' => array(
                'type' => 'DECIMAL',
                'constraint' => '10,2',
            ),
            'lote' => array(
                'type' => 'VARCHAR',
                'constraint' => '255',
                'null' => TRUE
            ),
            'dt_caducidade' => array(
                'type' => 'DATE',
                'null' => TRUE
            )
        );

        // Criar a tabela
        $this->CI->dbforge->add_field($fields);
        $this->CI->dbforge->add_key('id_stock', TRUE); // Define a chave primária
        $this->CI->dbforge->create_table('stock_loja_dt_caducidade', TRUE);
    }
}
