<?php


defined('BASEPATH') OR exit('No direct script access allowed');

class Migration_Create_stock_loja_dt_caducidade extends CI_Migration {

    // Método para aplicar a migração (criação da tabela)
    public function up()
    {
        $this->dbforge->add_field(array(
            'id_stock' => array(
                'type' => 'INT',
                'constraint' => 11,
                'auto_increment' => TRUE
            ),
            'idProduto' => array(
                'type' => 'INT',
                'constraint' => 11,
                'null' => FALSE
            ),
            'qtd' => array(
                'type' => 'DECIMAL',
                'constraint' => '10,2',
                'null' => FALSE
            ),
            'lote' => array(
                'type' => 'VARCHAR',
                'constraint' => '255',
                'null' => TRUE
            ),
            'dt_caducidade' => array(
                'type' => 'DATE',
                'null' => TRUE
            ),
        ));

        // Define 'id_stock' como chave primária
        $this->dbforge->add_key('id_stock', TRUE);

        // Cria a tabela 'stock_loja_dt_caducidade'
        $this->dbforge->create_table('stock_loja_dt_caducidade');
    }

    // Método para reverter a migração (excluir a tabela)
    public function down()
    {
        // Exclui a tabela 'stock_loja_dt_caducidade'
        $this->dbforge->drop_table('stock_loja_dt_caducidade');
    }
}

