<?php

/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/**
 * Description of mArtigos
 *
 * @author VINEVALA
 */
class mArtigos extends CI_Model {

    public function listaProdutosParaAtualizarIVA() {
        $this->db->select('*');
        $this->db->from('prodt');
        $this->db->order_by('produto', 'asc');
        $consulta = $this->db->get();
        return $consulta->result();
    }

    function qtd($idproduto) {// 
        $this->db->select('qtd');
        $this->db->from('stock_copiar');
        $this->db->where('idproduto', $idproduto);
        $consulta = $this->db->get();
        foreach ($consulta->result() as $linha) {
            return $linha->qtd;
        }
    }

    function custo($idproduto) {// 
        $this->db->select('custo');
        $this->db->from('stock_copiar');
        $this->db->where('idproduto', $idproduto);
        $consulta = $this->db->get();
        foreach ($consulta->result() as $linha) {
            return $linha->custo;
        }
    }

    function venda($idproduto) {// 
        $this->db->select('venda');
        $this->db->from('stock_copiar');
        $this->db->where('idproduto', $idproduto);
        $consulta = $this->db->get();
        foreach ($consulta->result() as $linha) {
            return $linha->venda;
        }
    }

    function mExiste_CB($cb) {// verifica se ja existe no bd um codigo de barra igual ao gerado
        $this->db->select('idpr');
        $this->db->from('prodt');
        $this->db->where('codigodebara', $cb);
        if ($this->db->count_all_results() > 0) {
            return true;
        } else {
            return false;
        }
    }

    function possui_codigo_barra($idproduto) {// pega o codigo de barra do produto se ja existir
        $this->db->select('codigodebara');
        $this->db->from('prodt');
        $this->db->where('idpr', $idproduto);
        $consulta = $this->db->get();
        foreach ($consulta->result() as $linha) {
            return $linha->codigodebara;
        }
    }

    function nomeProduto($idproduto) {// 
        $this->db->select('produto');
        $this->db->from('prodt');
        $this->db->where('idpr', $idproduto);
        $consulta = $this->db->get();
        foreach ($consulta->result() as $linha) {
            return $linha->produto;
        }
    }

    public function registarProdutoM($categoria, $produto, $bbr, $idIsencao, $idUnidade, $idTipo, $vender, $comprar, $custo, $venda, $desconto, $control, $referencia, $ativo, $dtcaducidade) {
        $dados = array(
            'idcategoria' => $categoria,
            'produto' => $produto,
            'codigodebara' => $bbr,
            'idIsencao' => $idIsencao,
            'stockMaximo' => 5,
            'stockMinimo' => 5,
            'idUnidade' => $idUnidade,
            'idTipo' => $idTipo,
            'comprar' => $comprar,
            'vender' => $vender,
            'custopr' => $custo,
            'preco' => $venda,
            'desconto' => $desconto,
            'control' => $control,
            'referencia' => $referencia,
            'ativo' => $ativo,
            'dtcaducidade' => $dtcaducidade,
        );
        $this->db->insert('prodt', $dados);
        return $this->db->insert_id();
    }

    public function registarServico($produto, $preco, $idIsencao, $idUnidade) {
        $tipo = 'B';
        $dados = array(
            'produto' => $produto,
            'preco' => $preco,
            'tipo' => $tipo,
            'idIsencao' => $idIsencao,
            'idUnidade' => $idUnidade
        );
        $this->db->insert('prodt', $dados);
    }

    public function listarPathImagem($idProduto) {
        $this->db->select('*');
        $this->db->from('prodt');
        $this->db->where('idpr', $idProduto);
        $consulta = $this->db->get();
        return $consulta->result();
    }

    public function listarServcos($start, $limit) {

        $this->db->select('*');
        $this->db->from('prodt');
        $this->db->join('tax_exeption_reason', 'prodt.idIsencao=tax_exeption_reason.id');
        $this->db->join('unidade_medida', 'prodt.idUnidade=unidade_medida.idUnidade');
        $this->db->order_by('produto', 'asc');
        $this->db->limit($limit, $start);
        $consulta = $this->db->get();
        return $consulta->result();
    }

    public function listar_produto_servicoM($start, $limit, $produto) {
        $this->db->select('*');
        $this->db->from('prodt');
        if ($produto != '') {
            $this->db->like('produto', $produto);
        }
        $this->db->where('preco>', 0);
        $this->db->order_by('produto', 'asc');
        $this->db->limit($limit, $start);
        $consulta = $this->db->get();
        return $consulta->result();
    }

    public function produtosServicos($start, $limit) {
        $this->db->select('*');
        $this->db->from('prodt');

        $this->db->order_by('produto', 'asc');
        $this->db->limit($limit, $start);
        $consulta = $this->db->get();
        return $consulta->result();
    }

    public function contarTotalArtigos() {
        $this->db->select('*');
        $this->db->from('prodt');
        return $this->db->count_all_results();
    }

    public function mlistarArtigos($pesquisa, $limit, $offset) {
        $this->db->select('*');
        $this->db->from('prodt');
        $this->db->join('categorias', 'prodt.idcategoria=categorias.idcategoria');
        $this->db->join('tax_exeption_reason', 'prodt.idIsencao=tax_exeption_reason.id');
        $this->db->join('unidade_medida', 'prodt.idUnidade=unidade_medida.idUnidade');
        $this->db->join('tipo_produto', 'prodt.idTipo=tipo_produto.idTipo');
        if (!empty($pesquisa)) {
            $this->db->group_start(); // Abre o grupo de condições
            $this->db->like('idpr', $this->db->escape_like_str($pesquisa));
            $this->db->or_like('produto', $this->db->escape_like_str($pesquisa));
            $this->db->or_like('codigodebara', $this->db->escape_like_str($pesquisa));
            $this->db->or_like('referencia', $this->db->escape_like_str($pesquisa));
            $this->db->group_end(); // Fecha o grupo de condições
        }
        $this->db->order_by('produto', 'asc');

        // Definir limite e offset para paginação
        $this->db->limit($limit, $offset);
        $consulta = $this->db->get();
        return $consulta->result();
    }

    public function mlistarArtigosPorId($idProduto) {
        $this->db->select('produto,idTipo,idcategoria,codigodebara,referencia,idUnidade,control,ativo,dtcaducidade,preco');
        $this->db->from('prodt');
        $this->db->join('tax_exeption_reason', 'prodt.idIsencao=tax_exeption_reason.id');
        $this->db->where('prodt.idpr', $idProduto);
        $consulta = $this->db->get();
        return $consulta->result();
    }

    public function pega_estado_dt_caducidade($idProduto) {
        $this->db->select('dtcaducidade');
        $this->db->from('prodt');
        $this->db->where('prodt.idpr', $idProduto);
        $consulta = $this->db->get();
        return $consulta->result();
    }

    // Obter a contagem de registros filtrados
    public function obter_total_registos_filtrados($pesquisa) {
        if (!empty($pesquisa)) {
            $this->db->group_start(); // Abre o grupo de condições
            $this->db->like('idpr', $this->db->escape_like_str($pesquisa));
            $this->db->or_like('produto', $this->db->escape_like_str($pesquisa));
            $this->db->or_like('codigodebara', $this->db->escape_like_str($pesquisa));
            $this->db->or_like('referencia', $this->db->escape_like_str($pesquisa));
            $this->db->group_end(); // Fecha o grupo de condições
        }
        return $this->db->count_all_results('prodt');
    }

    public function contarProdutos() {
        $this->db->select('*');
        $this->db->from('prodt');
        return $this->db->count_all_results();
    }

    public function contarServicos() {
        $tipo = 'B';
        $this->db->select('*');
        $this->db->where('tipo', $tipo);
        $this->db->from('prodt');
        return $this->db->count_all_results();
    }

    //metodo para echer a combo com produtos
    public function listaPrID() {
        $query = $this->db->get('prodt');
        return $query->result();
    }

    //metodo para precher form 
    public function pegarPr($id, $idLoja) {
        $this->db->select('*');
        $this->db->from('prodt');
        $this->db->join('categorias', 'prodt.idcategoria=categorias.idcategoria');
        $this->db->join('stock_quantidade', 'prodt.idpr=stock_quantidade.idproduto');
        if ($id != '') {
            $this->db->where('idpr', $id);
        }
        $this->db->where('stock_quantidade.idArmaze', $idLoja);
        $this->db->where('stock_quantidade.disponivel', 's');
        $query = $this->db->get();
        return $query->result();
    }

    public function pegarPrProforma($id) {
        $this->db->select('*');
        $this->db->from('prodt');
        $this->db->join('categorias', 'prodt.idcategoria=categorias.idcategoria');
        $this->db->join('stock_quantidade', 'prodt.idpr=stock_quantidade.idproduto');
        if ($id != '') {
            $this->db->where('idpr', $id);
        }

        $query = $this->db->get();
        return $query->result();
    }

    public function pegarPrOrcamento($id) {
        $this->db->select('*');
        $this->db->from('prodt');
        $this->db->join('categorias', 'prodt.idcategoria=categorias.idcategoria');

        if ($id != '') {
            $this->db->where('idpr', $id);
        }

        $query = $this->db->get();
        return $query->result();
    }

    public function atualizaArtigo($idProduto, $produto, $idCategoria, $bbr, $idIsencao, $idUnidade, $idTipo, $vender, $comprar, $custo, $venda, $desconto, $control, $referencia, $ativo, $dtcaducidade) {
        $dados = array(
            'produto' => $produto,
            'idcategoria' => $idCategoria,
            'idIsencao' => $idIsencao,
            'codigodebara' => $bbr,
            'idUnidade' => $idUnidade,
            'idTipo' => $idTipo,
            'comprar' => $comprar,
            'vender' => $vender,
            'custopr' => $custo,
            'preco' => $venda,
            'desconto' => $desconto,
            'control' => $control,
            'referencia' => $referencia,
            'ativo' => $ativo,
            'dtcaducidade' => $dtcaducidade,
        );
        $this->db->where('idpr', $idProduto);
        $this->db->set($dados);
        $this->db->update('prodt');
    }

    public function atualizaServicoM($idpr, $pr, $valor, $idIsencao, $idUnidade) {
        $this->db->where('idpr', $idpr);
        $this->db->set('produto', $pr);
        $this->db->set('preco', $valor);
        $this->db->set('idIsencao', $idIsencao);
        $this->db->set('idUnidade', $idUnidade);
        $this->db->update('prodt');
    }

    public function produtos() {// pega os  serviços para a combo da tela de vendas e Orcamentos
        $this->db->select('*');
        $this->db->from('prodt');
        //  $this->db->like('produto',$produto);
        $this->db->where('preco>', 0);
        $this->db->where('idTipo', 2);
        $this->db->order_by('produto', 'asc');
        $consulta = $this->db->get();
        return $consulta->result();
    }

    public function produtosProForma() {// pega os produtos e serviços para a combo da tela de vendas 
        $this->db->select('*');
        $this->db->from('prodt');
        //  $this->db->like('produto',$produto);
        $this->db->where('preco>', 0);
        $this->db->where('idTipo', 3);
        $this->db->order_by('produto', 'asc');
        $consulta = $this->db->get();
        return $consulta->result();
    }

    public function pegaQtd($idproduto) {//
        $this->db->select('*');
        $this->db->from('stock_quantidade');
        $this->db->where('idproduto', $idproduto);
        $consulta = $this->db->get();
        foreach ($consulta->result() as $value) {
            return $value->qtd;
        }
    }

    public function mlista_insecao() {
        $this->db->select('*');
        $this->db->from('tax_exeption_reason');
        $this->db->where('id !=', 1);
        $this->db->where('id !=', 2);
        $this->db->where('id !=', 3);
        $this->db->where('id !=', 4);
        $consulta = $this->db->get();
        return $consulta->result();
    }

    public function classe_produto($idproduto) {//
        $this->db->select('idTipo');
        $this->db->from('prodt');
        $this->db->where('idpr', $idproduto);
        $consulta = $this->db->get();
        foreach ($consulta->result() as $value) {
            return $value->idTipo;
        }
    }

    public function pega_produto($idproduto) {//
        $this->db->select('produto');
        $this->db->from('prodt');
        $this->db->where('idpr', $idproduto);
        $consulta = $this->db->get();
        foreach ($consulta->result() as $value) {
            return $value->produto;
        }
    }

    public function produto_isencao($idproduto) {//
        $this->db->select('*');
        $this->db->from('prodt');
        $this->db->where('idpr', $idproduto);
        $consulta = $this->db->get();
        foreach ($consulta->result() as $value) {
            return $value->idIsencao;
        }
    }

    public function mpega_exepcao($idproduto) {//
        $this->db->select('*');
        $this->db->from('prodt');
        $this->db->join('tax_exeption_reason', 'prodt.idIsencao=tax_exeption_reason.id');
        $this->db->where('idpr', $idproduto);
        $consulta = $this->db->get();
        foreach ($consulta->result() as $value) {
            return $value->cod;
        }
    }

    public function mpega_exepcao_rasao($idproduto) {//
        $this->db->select('*');
        $this->db->from('prodt');
        $this->db->join('tax_exeption_reason', 'prodt.idIsencao=tax_exeption_reason.id');
        $this->db->where('idpr', $idproduto);
        $consulta = $this->db->get();
        foreach ($consulta->result() as $value) {
            return $value->motivo;
        }
    }

    public function mpegaIdProduto($codeBar, $referencia, $idPr) { // pega o id do produto atravez do codigo de barra
        $this->db->select('idpr,produto');
        $this->db->from('prodt');

        if (!empty($codeBar)) {
            $this->db->where('codigodebara', $codeBar);
        }
        if (!empty($referencia)) {
            $this->db->where('referencia', $referencia);
        }
        if (!empty($idPr)) {
            $this->db->where('idpr', $idPr);
        }
        $consulta = $this->db->get();
        return $consulta->result();
    }

    public function mpegaIdProdutoPorid($idproduto) { // pega o id do produto atravez do codigo de barra
        $this->db->select('idpr,produto');
        $this->db->from('prodt');
        $this->db->where('idpr', $idproduto);
        $consulta = $this->db->get();
        return $consulta->result();
    }

    public function gerarCoigoDeBarra($idproduto) { // pega o id do produto atravez do codigo de barra
        $codeBar = $this->possui_codigo_barra($idproduto);
        if ($codeBar == '') {// se o candidato não possui codigo de baara
            $cb_unico = "";
            do {
                $CodigoBarra = chr(rand(ord("A"), ord("Z"))) . rand(0, 9) . chr(rand(ord("A"), ord("Z"))) . rand(0, 9) . chr(rand(ord("A"), ord("Z"))) . rand(0, 9);
                if ($this->mExiste_CB($CodigoBarra) == false) {
                    $cb_unico = $CodigoBarra;
                }
            } while ($this->mExiste_CB($CodigoBarra));
            $this->atualiza_codigo_barra($idproduto, $cb_unico);
        }
    }

    public function atualiza_codigo_barra($idproduto, $cb_unico) {
        $dados = array(
            'codigodebara' => $cb_unico,
        );
        $this->db->where('idpr', $idproduto);
        $this->db->set($dados);
        $this->db->update('prodt');
    }

    public function caminho_imagem($idproduto, $path) {
        $this->db->where('idpr', $idproduto);
        $this->db->set('path', $path);
        $this->db->update('prodt');
    }

    public function unidadeMedida() {// 
        $this->db->select('*');
        $this->db->from('unidade_medida');
        $this->db->order_by('nunidade', 'asc');
        $consulta = $this->db->get();
        return $consulta->result();
    }

    public function unidadeMedida2($idUnidade) {// 
        $this->db->select('nunidade,idUnidade');
        $this->db->from('unidade_medida');
        $this->db->where('idUnidade', $idUnidade);
        $consulta = $this->db->get();
        return $consulta->result();
    }

    public function tipoProduto() {// pega os produtos e serviços para a combo da tela de vendas 
        $this->db->select('*');
        $this->db->from('tipo_produto');
        $consulta = $this->db->get();
        return $consulta->result();
    }

    public function ponto_venda_produto($idProduto, $idPontoVenda) {
        $dados = array(
            'idProduto' => $idProduto,
            'idPontoVenda' => $idPontoVenda,
        );
        $this->db->insert('ponto_venda_produto', $dados);
    }

    public function regVariacaoProduto($idVariacao, $idProduto) {
        $dados = array(
            'idVariacao' => $idVariacao,
            'idProduto' => $idProduto,
        );
        $this->db->insert('variacaoProduto', $dados);
    }

    public function ponto_venda_produto_atualizar($idProduto, $idPontoVenda) {
        $this->db->where('idProduto', $idProduto);
        $this->db->set('idPontoVenda', $idPontoVenda);
        $this->db->update('ponto_venda_produto');
    }

    public function cansulta_posto_venda($idProduto) {
        $this->db->select('*');
        $this->db->from('ponto_venda_produto');
        $this->db->where('idProduto', $idProduto);
        if ($this->db->count_all_results() > 0) {
            return true;
        } else {
            return false;
        }
    }

    public function pegaPontoVendaProduto($idProduto) {
        $this->db->select('idPontoVenda');
        $this->db->from('ponto_venda_produto');
        $this->db->where('idProduto', $idProduto);
        $query = $this->db->get();
        foreach ($query->result() as $value) {
            return $value->idPontoVenda;
        }
    }

    public function pegaImpostos() {
        $this->db->select('*');
        $this->db->from('impostos');
        $this->db->where('idImposto !=', 3);
        $this->db->where('idImposto !=', 4);
        $this->db->where('idImposto !=', 5);
        $this->db->order_by('percentagem');
        $consulta = $this->db->get();
        return $consulta->result();
    }

    public function percentagemImposto($idImposto) {
        $this->db->select('*');
        $this->db->from('impostos');
        $this->db->where('idImposto', $idImposto);
        $consulta = $this->db->get();
        return $consulta->result();
    }

    public function pegaImpostosIrtm() {
        $this->db->select('*');
        $this->db->from('impostos');
        $this->db->where('nimposto', 'IRT');
        $this->db->order_by('percentagem');
        $consulta = $this->db->get();
        return $consulta->result();
    }

    public function impostoCompraIva($idProduto, $idImposto) {
        $dados = array(
            'idProduto' => $idProduto,
            'idImposto' => $idImposto,
        );
        $this->db->insert('imposto_compra', $dados);
    }

    public function impostoVendaIva($idProduto, $idImposto) {
        $dados = array(
            'idProduto' => $idProduto,
            'idImposto' => $idImposto,
        );
        $this->db->insert('imposto_venda', $dados);
    }

    public function atualiza_imposto_venda($idProduto, $idImposto) {

        $this->db->where('idProduto', $idProduto);
        $this->db->set('idImposto', $idImposto);
        $this->db->update('imposto_venda');
    }

    public function impostoCompraAtualizarIva($idProduto, $idImposto) {

        $this->db->where('idProduto', $idProduto);
        $this->db->set('idImposto', $idImposto);
        $this->db->update('imposto_compra');
    }

    public function impostoAtualizarVendaIva($idProduto, $idImposto) {
        $this->db->where('idProduto', $idProduto);
        $this->db->set('idImposto', $idImposto);
        $this->db->update('imposto_venda');
    }

    public function cansulta_impostoProdutoCompra($idProduto) {
        $this->db->select('*');
        $this->db->from('imposto_compra');
        $this->db->where('idProduto', $idProduto);
        if ($this->db->count_all_results() > 0) {
            return true;
        } else {
            return false;
        }
    }

    public function cansulta_impostoProdutoVenda($idProduto) {
        $this->db->select('*');
        $this->db->from('imposto_venda');
        $this->db->where('idProduto', $idProduto);
        if ($this->db->count_all_results() > 0) {
            return true;
        } else {
            return false;
        }
    }

    function pegaIvaVenda($idproduto) {// 
        $this->db->select('percentagem');
        $this->db->from('imposto_venda');
        $this->db->join('impostos', 'imposto_venda.idImposto=impostos.idImposto');
        $this->db->where('idProduto', $idproduto);
        $consulta = $this->db->get();
        foreach ($consulta->result() as $linha) {
            return $linha->percentagem;
        }
    }

    function pegaIvaCompra($idproduto) {// 
        $this->db->select('percentagem');
        $this->db->from('imposto_compra');
        $this->db->join('impostos', 'imposto_compra.idImposto=impostos.idImposto');
        $this->db->where('idProduto', $idproduto);
        $consulta = $this->db->get();
        foreach ($consulta->result() as $linha) {
            return $linha->percentagem;
        }
    }

    function precoProduto($idproduto) {// 
        $this->db->select('custopr');
        $this->db->from('prodt');
        $this->db->where('idpr', $idproduto);
        $consulta = $this->db->get();
        foreach ($consulta->result() as $linha) {
            return $linha->custopr;
        }
    }

    function custo2($idproduto) {// 
        $this->db->select('custo');
        $this->db->from('stock_quantidade');
        $this->db->where('idproduto', $idproduto);
        $consulta = $this->db->get();
        foreach ($consulta->result() as $linha) {
            return $linha->custo;
        }
    }

    function precoProduto2($idproduto) {// 
        $this->db->select('preco');
        $this->db->from('prodt');
        $this->db->where('idpr', $idproduto);
        $consulta = $this->db->get();
        foreach ($consulta->result() as $linha) {
            return $linha->preco;
        }
    }

    function controlo($idproduto) {// 
        $this->db->select('control');
        $this->db->from('prodt');
        $this->db->where('idpr', $idproduto);
        $consulta = $this->db->get();
        foreach ($consulta->result() as $linha) {
            return $linha->control;
        }
    }

    public function listarQtdMTelaMobile($produto, $idCategoria, $idLoja) {
        $this->db->select('*');
        $this->db->from('stock_quantidade');
        $this->db->join('prodt', 'stock_quantidade.idproduto = prodt.idpr');
        $this->db->join('categorias', 'prodt.idcategoria=categorias.idcategoria');
        $this->db->join('unidade_medida', 'prodt.idUnidade=unidade_medida.idUnidade');
        $this->db->join('ponto_venda_produto', 'prodt.idpr=ponto_venda_produto.idProduto');
        $this->db->where('stock_quantidade.disponivel', 's');
        $this->db->where('idTipo', 3);
        if ($idCategoria != '') {
            $this->db->like('prodt.idcategoria', $idCategoria);
        }
        if ($produto != '') {
            $this->db->like('produto', $produto);
        }
        if ($idLoja != '') {
            $this->db->where('stock_quantidade.idArmaze', $idLoja);
        }

        //   $this->db->order_by('produto');
        $this->db->group_by('stock_quantidade.idproduto');
        $query = $this->db->get();
        return $query->result();
    }

    function mdeleteProduto($idpr) {
        if ($this->db->delete('prodt', array('idpr' => $idpr)))
            return true;
        else
            return false;
    }

    public function mRegistaImail($idProduto, $emei1, $emei2) {
        $dados = array(
            'idProduto' => $idProduto,
            'emei1' => $emei1,
            'emei2' => $emei2,
        );
        $this->db->insert('imeis', $dados);
    }

    public function verificaProduto($idProduto) {
        $this->db->select('idpr');
        $this->db->from('item_fatura');
        $this->db->where('idpr', $idProduto);
        if ($this->db->count_all_results() > 0) {
            return true;
        } else {
            return false;
        }
    }

    public function listarCategoriaMTelaMobile() {
        $this->db->select('*');
        $this->db->from('stock_quantidade');
        $this->db->join('prodt', 'stock_quantidade.idproduto = prodt.idpr');
        $this->db->join('categorias', 'prodt.idcategoria=categorias.idcategoria');
        $this->db->where('idTipo', 3);
        $this->db->order_by('categoria');
        $this->db->group_by('prodt.idcategoria');
        $query = $this->db->get();
        return $query->result();
    }

    public function totalDeProdutosRegistados() {
        $this->db->select('*');
        $this->db->from('prodt');
        $this->db->where('idTipo', 3);
        return $this->db->count_all_results();
    }

    function stockMinimo($idproduto) {// 
        $this->db->select('stockMinimo');
        $this->db->from('prodt');
        $this->db->where('idpr', $idproduto);
        $consulta = $this->db->get();
        foreach ($consulta->result() as $linha) {
            return $linha->stockMinimo;
        }
    }

    function pegaDesconto($idproduto) {// 
        $this->db->select('desconto');
        $this->db->from('prodt');
        $this->db->where('idpr', $idproduto);
        $consulta = $this->db->get();
        foreach ($consulta->result() as $linha) {
            return $linha->desconto;
        }
    }

    public function mRegistaImeil($idVenda, $idpr, $imei) {
        $dados = array(
            'idVenda' => $idVenda,
            'idpr' => $idpr,
            'imei' => $imei,
        );
        $this->db->insert('item_carrinho_imei', $dados);
    }

    public function mRegistaSim($idVenda, $idpr, $sim_numero) {
        $dados = array(
            'idVenda' => $idVenda,
            'idpr' => $idpr,
            'sim_numero' => $sim_numero,
        );
        $this->db->insert('item_carrinho_sim', $dados);
    }

    public function mlistaProdutosLoja($idProduto) {
        $this->db->select('*');
        $this->db->from('stock_quantidade');
        $this->db->join('prodt', 'stock_quantidade.idproduto = prodt.idpr');
        $this->db->join('armanzes', 'stock_quantidade.idArmaze=armanzes.id');
        $this->db->where('prodt.idpr', $idProduto);
        $this->db->order_by('produto');
        $query = $this->db->get();
        return $query->result();
    }

    function totaLojasProductos($idProduto) {// 
        $this->db->select_sum('qtd');
        $this->db->from('stock_quantidade');
        $this->db->where('idproduto', $idProduto);
        $consulta = $this->db->get();
        foreach ($consulta->result() as $linha) {
            return $linha->qtd;
        }
    }

    public function mlistaArmanzes($idArmanze) {
        $this->db->select('*');
        $this->db->from('armanzes');
        $this->db->where('id !=', 1);
        $this->db->where('id !=', 3);
        $this->db->where('id !=', $idArmanze);
        $query = $this->db->get();
        return $query->result();
    }

    public function mlistaArmanzes2() {
        $this->db->select('*');
        $this->db->from('armanzes');
        $this->db->where('id !=', 1);
        $this->db->where('id !=', 3);

        $query = $this->db->get();
        return $query->result();
    }

    public function consultaProdutoStock($idProduto, $idArmaze) {
        $this->db->select('idproduto');
        $this->db->from('stock_quantidade');
        $this->db->where('idproduto', $idProduto);
        $this->db->where('idArmaze', $idArmaze);
        if ($this->db->count_all_results() > 0) {
            return true;
        } else {
            return false;
        }
    }

    function armanze($idArmanze) {// 
        $this->db->select('narmanze');
        $this->db->from('armanzes');
        $this->db->where('id', $idArmanze);
        $consulta = $this->db->get();
        foreach ($consulta->result() as $linha) {
            return $linha->narmanze;
        }
    }

    public function mlistaGrupoPreco() {
        $this->db->select('*');
        $this->db->from('grupo_preco');
        $query = $this->db->get();
        return $query->result();
    }

    public function mlistaArmanzesView() {
        $this->db->select('*');
        $this->db->from('armanzes');
        $this->db->where('id !=', 1);
        $this->db->where('id !=', 3);

        $query = $this->db->get();
        return $query->result();
    }

    public function atualizaPrecoProduto($idProduto, $preco) {
        $this->db->where('idpr', $idProduto);
        $this->db->set('preco', $preco);
        $this->db->update('prodt');
    }

    public function atualizarPrecoProdutoGrupo($idGrupoPreco, $idProduto, $preco) {
        $this->db->where('idGrupoPreco', $idGrupoPreco);
        $this->db->where('idProduto', $idProduto);
        $this->db->set('preco', $preco);
        $this->db->update('precos_produtos');
    }

    public function registarPrecoProdutoGrupo($idGrupoPreco, $idProduto, $preco) {
        $dados = array(
            'idGrupoPreco' => $idGrupoPreco,
            'idProduto' => $idProduto,
            'preco' => $preco,
        );
        $this->db->insert('precos_produtos', $dados);
    }

    public function atualizaDisponiblidade($idProduto, $idArmaze, $disponivel) {
        $this->db->where('idproduto', $idProduto);
        $this->db->where('idArmaze', $idArmaze);
        $this->db->set('disponivel', $disponivel);
        $this->db->update('stock_quantidade');
    }

    function pegaPrecoProduto($idGrupoPreco, $idProduto) {// 
        $this->db->select('preco');
        $this->db->from('precos_produtos');
        $this->db->where('idGrupoPreco', $idGrupoPreco);
        $this->db->where('idProduto', $idProduto);
        $consulta = $this->db->get();
        foreach ($consulta->result() as $linha) {
            if ($linha->preco == null) {
                return 0;
            } else {
                return $linha->preco;
            }
        }
    }

    function pegaDisponiblidadeProduto($idArmanze, $idProduto) {// 
        $this->db->select('disponivel');
        $this->db->from('stock_quantidade');
        $this->db->where('idArmaze', $idArmanze);
        $this->db->where('idproduto', $idProduto);
        $consulta = $this->db->get();
        foreach ($consulta->result() as $linha) {
            return $linha->disponivel;
        }
    }

    function mqtdArmaze($idArmanze, $idProduto) {// 
        $this->db->select('qtd');
        $this->db->from('stock_quantidade');
        $this->db->where('idArmaze', $idArmanze);
        $this->db->where('idproduto', $idProduto);
        $consulta = $this->db->get();
        foreach ($consulta->result() as $linha) {
            return $linha->qtd;
        }
    }

    public function consultaPrecoProduto($idProduto, $idGrupoPreco) {
        $this->db->select('idProduto');
        $this->db->from('precos_produtos');
        $this->db->where('idGrupoPreco', $idGrupoPreco);
        $this->db->where('idProduto', $idProduto);
        if ($this->db->count_all_results() > 0) {
            return true;
        } else {
            return false;
        }
    }

    public function consultaDiponiblidadeLoja($idProduto, $idArmaze) {
        $this->db->select('idproduto');
        $this->db->from('stock_quantidade');
        $this->db->where('idArmaze', $idArmaze);
        $this->db->where('idproduto', $idProduto);
        if ($this->db->count_all_results() > 0) {
            return true;
        } else {
            return false;
        }
    }

    public function mlistaClassemBemCB() {
        $this->db->select('*');
        $this->db->from('classe_de_bem');
        //   $this->db->where('id !=', 1);
        $query = $this->db->get();
        return $query->result();
    }

    public function mlistaMarcasCB() {
        $this->db->select('*');
        $this->db->from('marcas');
        //   $this->db->where('id !=', 1);
        $query = $this->db->get();
        return $query->result();
    }

    public function mlistaVariacaoProduto($idProduto) {
        $this->db->select('*');
        $this->db->from('variacaoProduto');
        // $this->db->join('prodt', 'stock_quantidade.idproduto = prodt.idpr');
        $this->db->where('idProduto', $idProduto);
        $query = $this->db->get();
        return $query->result();
    }

    public function mregistaVariacaoTamanhoProduto($idProduto, $idVariacao, $idCor, $idTamanho, $idArmaze) {
        $dados = array(
            'idVariacao' => $idVariacao,
            'idCor' => $idCor,
            'idTamanho' => $idTamanho,
            'idProduto' => $idProduto,
            'qtd' => 0,
            'idLoja' => $idArmaze,
        );
        $this->db->insert('variacao_tamanho_produto', $dados);
    }

    public function pega_unidade_medida($idProduto) {
        $this->db->select('idUnidade');
        $this->db->from('prodt');
        $this->db->where('idpr', $idProduto);
        $query = $this->db->get();
        foreach ($query->result() as $value) {
            return $value->idUnidade;
        }
    }

    public function atualizarProcoCompra($idProduto, $preco_compra) {
        $this->db->where('idpr', $idProduto);
        $this->db->set('custopr', $preco_compra);
        $this->db->update('prodt');
    }

    function statu_dt_caducidade($idproduto) {
        // Verifica se a tabela possui o campo 'dtcaducidade'
        $field_exists = $this->db->field_exists('dtcaducidade', 'prodt');

        if ($field_exists) {
            // Se o campo existe, realiza a consulta
            $this->db->select('dtcaducidade');
            $this->db->from('prodt');
            $this->db->where('idpr', $idproduto);
            $consulta = $this->db->get();

            // Retorna o valor de 'dtcaducidade', se encontrado
            if ($consulta->num_rows() > 0) {
                $linha = $consulta->row();
                return $linha->dtcaducidade;
            } else {
                // Retorna null caso nenhum registro seja encontrado
                return null;
            }
        } else {
            // Retorna null ou uma mensagem indicando que o campo não existe
            return null;
        }
    }

    //  
}
