<?php

/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/**
 * Description of mClientes
 *
 * @author VINEVALA
 */
class mClientes extends CI_Model {

    public function registarclM($nome, $email, $fone, $fone1, $nif, $localizacao, $desconto, $tipo, $genero) { // Regista o clinte a partir da ficha principal do cliente
        $dados = array(
            'nome' => $nome,
            'desconto' => $desconto,
            'tipo' => $tipo,
            'genero' => $genero
        );
        $this->db->insert('clientes', $dados);
        $pegarId = $this->db->insert_id();
        $dadosFone = array(
            'idcliente' => $pegarId,
            'fone' => $fone,
            'fone1' => $fone1,
            'nif' => $nif,
            'email' => $email,
            'localizacao' => $localizacao
        );
        $this->db->insert('cliente_contacto', $dadosFone);
    }

    public function registarclM2($nome) { // Regista o clinte a partir de uma venda
        $dados = array(
            'nome' => $nome,
        );
        $this->db->insert('clientes', $dados);
        $pegarId = $this->db->insert_id();
        $dadosFone = array(
            'idcliente' => $pegarId,
            'nif' => 'Consumidor Final',
        );
        $this->db->insert('cliente_contacto', $dadosFone);
        return $pegarId;
    }

    public function mRegistaClientes($nome, $email, $fone, $fone1, $nif, $localizacao, $desconto, $tipo) {
        $dados = array(
            'nome' => $nome,
            'desconto' => $desconto,
            'tipo' => $tipo
        );
        $this->db->insert('clientes', $dados);
        $pegarId = $this->db->insert_id();
        $dadosFone = array(
            'idcliente' => $pegarId,
            'fone' => $fone,
            'fone1' => $fone1,
            'nif' => $nif,
            'email' => $email,
            'localizacao' => $localizacao
        );
        $this->db->insert('cliente_contacto', $dadosFone);
        return $pegarId;
    }

    // funcao para listar clientes na grid modelo
    public function mlistar_entidades($start, $limit, $pesquisa) {
        $this->db->select('*');
        $this->db->from('clientes');
        $this->db->join('cliente_contacto', 'clientes.idcliente=cliente_contacto.idcliente');
        $this->db->where('clientes.idcliente !=', 60);
        if (!empty($pesquisa)) {
            $this->db->group_start(); // Abre o grupo de condições
            $this->db->like('nome', $this->db->escape_like_str($pesquisa));
            $this->db->or_like('fone', $this->db->escape_like_str($pesquisa));
            $this->db->or_like('nif', $this->db->escape_like_str($pesquisa));
            $this->db->or_like('email', $this->db->escape_like_str($pesquisa));
            $this->db->or_like('localizacao', $this->db->escape_like_str($pesquisa));
            $this->db->group_end(); // Fecha o grupo de condições
        }
        // Limitação e paginação
        $this->db->limit($limit, $start);
        $this->db->order_by('nome');
        $query = $this->db->get();
        return $query->result();
    }
  //funcao que conta as linhas exitente na tabela clientes modelo
    public function totalClientes() {
        $this->db->select('*');
        $this->db->from('clientes');
        $this->db->join('cliente_contacto', 'clientes.idcliente=cliente_contacto.idcliente');
        return $this->db->count_all_results();
    }
    // Obter a contagem de registros filtrados
    public function obter_total_registos_filtrados($pesquisa) {
        if (!empty($pesquisa)) {
            $this->db->like('nome', $pesquisa);
        }
        return $this->db->count_all_results('clientes');
    }
    //
    public function pegaDadosCliente($idCliente) {
        $this->db->select('nome,fone,email,fone1,nif,localizacao');
        $this->db->from('clientes');
        $this->db->join('cliente_contacto', 'clientes.idcliente=cliente_contacto.idcliente');
        $this->db->where('clientes.idcliente', $idCliente);
        $query = $this->db->get();
        return $query->result();
    }

    // fucao que lista clientes pra a combo box Modelo
    public function mlista_entidades_txt_search($pesquisa) {
        $this->db->select('clientes.idcliente,nome');
        $this->db->from('clientes');
        $this->db->join('cliente_contacto', 'clientes.idcliente=cliente_contacto.idcliente');
        $this->db->where("(nome LIKE '%" . $this->db->escape_like_str($pesquisa) . "%' or 
                email LIKE '%" . $this->db->escape_like_str($pesquisa) . "%' or 
                fone LIKE '%" . $this->db->escape_like_str($pesquisa) . "%' or 
                nif LIKE '%" . $this->db->escape_like_str($pesquisa) . "%')");
        $query = $this->db->get();
        return $query->result();
    }

    //
    public function listarClientesformM($id) {

        $this->db->where('idcliente', $id);
        $query = $this->db->get('clientes');
        return $query->result();
    }

    

    public function pegaTelefone($idcliente) {
        $this->db->select('*');
        $this->db->from('cliente_contacto');
        $this->db->where('idcliente', $idcliente);
        $query = $this->db->get();
        foreach ($query->result() as $value) {
            return $value->fone;
        }
    }

    public function atualizarClientem($idCliente, $nome, $email, $fone, $fone1, $nif, $localizacao, $desconto, $tipo) {
        $dadosNome = array(
            'nome' => $nome,
            'desconto' => $desconto,
            'tipo' => $tipo
        );
        $this->db->where('idcliente', $idCliente);
        $this->db->set($dadosNome);
        $this->db->update('clientes');
        $dadosFone = array(
            'fone' => $fone,
            'fone1' => $fone1,
            'nif' => $nif,
            'email' => $email,
            'localizacao' => $localizacao
        );
        //   $this->db->insert('cliente_contacto',$dadosFone);
        $this->db->where('idcliente', $idCliente);
        $this->db->set($dadosFone);
        $this->db->update('cliente_contacto');
    }

    public function atualizarClienteNome($idCliente, $nome, $email, $fone, $fone1, $localizacao, $desconto, $tipo) {
        $dadosNome = array(
            'nome' => $nome,
            'desconto' => $desconto,
            'tipo' => $tipo
        );
        $this->db->where('idcliente', $idCliente);
        $this->db->set($dadosNome);
        $this->db->update('clientes');
        $dadosFone = array(
            'fone' => $fone,
            'fone1' => $fone1,
            'email' => $email,
            'localizacao' => $localizacao
        );
        //   $this->db->insert('cliente_contacto',$dadosFone);
        $this->db->where('idcliente', $idCliente);
        $this->db->set($dadosFone);
        $this->db->update('cliente_contacto');
    }

    public function atualizarClienteNif($idCliente, $email, $fone, $fone1, $nif, $localizacao, $desconto, $tipo) {
        $dadosNome = array(
            'desconto' => $desconto,
            'tipo' => $tipo
        );
        $this->db->where('idcliente', $idCliente);
        $this->db->set($dadosNome);
        $this->db->update('clientes');
        $dadosFone = array(
            'fone' => $fone,
            'fone1' => $fone1,
            'nif' => $nif,
            'email' => $email,
            'localizacao' => $localizacao
        );
        //   $this->db->insert('cliente_contacto',$dadosFone);
        $this->db->where('idcliente', $idCliente);
        $this->db->set($dadosFone);
        $this->db->update('cliente_contacto');
    }

    public function atualizarDadosClientes($idCliente, $email, $fone, $fone1, $localizacao, $desconto, $tipo) {
        $dadosNome = array(
            'desconto' => $desconto,
            'tipo' => $tipo
        );
        $this->db->where('idcliente', $idCliente);
        $this->db->set($dadosNome);
        $this->db->update('clientes');
        $dadosFone = array(
            'fone' => $fone,
            'fone1' => $fone1,
            'email' => $email,
            'localizacao' => $localizacao
        );
        //   $this->db->insert('cliente_contacto',$dadosFone);
        $this->db->where('idcliente', $idCliente);
        $this->db->set($dadosFone);
        $this->db->update('cliente_contacto');
    }

    public function mdescontoGlobal($idcliente) {
        $this->db->select('desconto');
        $this->db->from('clientes');
        $this->db->where('idcliente', $idcliente);
        $query = $this->db->get();
        foreach ($query->result() as $value) {
            return $value->desconto;
        }
    }

    public function tipoCliete($idcliente) {
        $this->db->select('tipo');
        $this->db->from('clientes');
        $this->db->where('idcliente', $idcliente);
        $query = $this->db->get();
        foreach ($query->result() as $value) {
            return $value->tipo;
        }
    }

    public function pegaIrt($idImposto) {
        $this->db->select('percentagem');
        $this->db->from('impostos');
        $this->db->where('idImposto', $idImposto);
        $query = $this->db->get();
        foreach ($query->result() as $value) {
            return $value->percentagem;
        }
    }

    public function verifica_cliente_fez_compraM($idCliente) {
        $this->db->select('*');
        $this->db->from('clientes');
        $this->db->join('cliente_contacto', 'clientes.idcliente=cliente_contacto.idcliente');
        $this->db->join('faturas', 'clientes.idcliente=faturas.idcliente');
        $this->db->where('faturas.idcliente', $idCliente);
        $query = $this->db->get();
        return $query->result();
    }

    public function registaDadosFaturacliente($idFatura, $clinteNome, $morada, $telefone) {
        $dados = array(
            'idFatura' => $idFatura,
            'clinteNome' => $clinteNome,
            'morada' => $morada,
            'telefone' => $telefone,
        );
        $this->db->insert('dados_inalteraveis_fatura', $dados);
    }

    public function clienteFatura($idFatura) {
        $this->db->select('clinteNome');
        $this->db->from('dados_inalteraveis_fatura');
        $this->db->where('idFatura', $idFatura);
        $query = $this->db->get();
        foreach ($query->result() as $value) {
            return $value->clinteNome;
        }
    }

    public function clienteMorada($idFatura) {
        $this->db->select('morada');
        $this->db->from('dados_inalteraveis_fatura');
        $this->db->where('idFatura', $idFatura);
        $query = $this->db->get();
        foreach ($query->result() as $value) {
            return $value->morada;
        }
    }

    public function clienteTelefone($idFatura) {
        $this->db->select('telefone');
        $this->db->from('dados_inalteraveis_fatura');
        $this->db->where('idFatura', $idFatura);
        $query = $this->db->get();
        foreach ($query->result() as $value) {
            return $value->telefone;
        }
    }

    public function mpega_dados_cliente_tooltip($idcliente) {
        $this->db->select('clientes.idcliente,nome,fone,nif,email');
        $this->db->from('clientes');
        $this->db->join('cliente_contacto', 'clientes.idcliente=cliente_contacto.idcliente');
        $this->db->where('clientes.idcliente', $idcliente);
        $query = $this->db->get();
        return $query->result();
    }

    public function eliminaCliente($idcliente) {
        $this->db->where('clientes.idcliente', $idcliente);
        $this->db->delete('clientes');
    }

    public function clienteNome($idcliente) {
        $this->db->select('nome');
        $this->db->from('clientes');
        $this->db->where('idcliente', $idcliente);
        $query = $this->db->get();
        foreach ($query->result() as $value) {
            return $value->nome;
        }
    }

}

?>
