<?php

/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

/**
 * Description of mContaCliente
 *
 * @author GRAFICA BILL
 */
class mContaCliente extends CI_Model {

    public function dividaPeriodo($idcliente, $total) {
        $dados = array(
            'idcliente' => $idcliente,
            'data' => @date('Y-m-d'),
            'divida' => $total,
            'pagamento' => 0,
            'idtipoMovimento' => 2,
        );
        $this->db->insert('clientes_conta_corrente', $dados);
    }

    public function pagamentoMercadoria($idcliente, $total) {
        $dados = array(
            'idcliente' => $idcliente,
            'data' => @date('Y-m-d'),
            'divida' => $total,
            'pagamento' => 0,
            'idtipoMovimento' => 4,
        );
        $this->db->insert('clientes_conta_corrente', $dados);
    }

    public function pagamentoPeriodo($idcliente, $valor) {
        $dados = array(
            'idcliente' => $idcliente,
            'data' => date('Y-m-d'),
            'divida' => 0,
            'pagamento' => $valor,
            'idtipoMovimento' => 4,
        );
        $this->db->insert('clientes_conta_corrente', $dados);
    }

    public function regularizacaoDebito($idCliente, $montante, $observacao, $idTipoMovimento, $dataMovimento, $idFormaPagamento) {
        $dados = array(
            'idcliente' => $idCliente,
            'data' => date('Y-m-d'),
            'divida' => $montante,
            'pagamento' => 0,
            'idtipoMovimento' => $idTipoMovimento,
            'observacao' => $observacao,
            'dataMovimento' => $dataMovimento,
            'idFormaPagamento' => $idFormaPagamento,
        );
        $this->db->insert('clientes_conta_corrente', $dados);
    }

    public function regularizacaoCredito($idCliente, $montante, $observacao, $idTipoMovimento, $dataMovimento, $idFormaPagamento) {
        $dados = array(
            'idcliente' => $idCliente,
            'data' => date('Y-m-d'),
            'divida' => 0,
            'pagamento' => $montante,
            'idtipoMovimento' => $idTipoMovimento,
            'observacao' => $observacao,
            'dataMovimento' => $dataMovimento,
            'idFormaPagamento' => $idFormaPagamento,
        );
        $this->db->insert('clientes_conta_corrente', $dados);
    }

    public function dividaTransitadaCliente($idCliente) {
        $this->db->select_sum('valor');
        $this->db->from('contasreceber');
        $this->db->where('idcliente', $idCliente);
        $this->db->where('data_vencimento <', date('Y-m-d'));  // Usar data de VENCIMENTO
        $this->db->where('idEstadoPagFatura !=', 3);  // Considerar apenas não pagas
//        $this->db->where('deletado', 0);  // Evitar registros excluídos logicamente

        $consulta = $this->db->get();

        // Resultado direto sem loop
        $resultado = $consulta->row();

        return ($resultado->valor !== null) ? $resultado->valor : 0;
    }

    public function obter_total_registos_filtrados($idCliente, $dataminima, $datamaxima) {
        $this->db->select('COUNT(*) as total'); // Apenas conta o número de registros
        $this->db->from('clientes_conta_corrente');
        $this->db->where('idCliente', $idCliente);
        if (!empty($dataminima)) {
            $this->db->where('data >=', $dataminima);
            $this->db->where('data <=', $datamaxima);
        }
        $query = $this->db->get(); // Executa a consulta
        $result = $query->row(); // Obtém o resultado
        return $result->total; // Retorna o total
    }

    public function contarClienteContaCorrente($idCliente) {
        $this->db->select('COUNT(*) as total'); // Apenas conta o número de registros
        $this->db->from('clientes_conta_corrente');
        $this->db->where('idCliente', $idCliente);

        $query = $this->db->get(); // Executa a consulta
        $result = $query->row(); // Obtém o resultado
        return $result->total; // Retorna o total
    }

    public function dividasCorrente($idCliente) {
        $this->db->select_sum('valor');
        $this->db->from('contasreceber');
        $this->db->where('idcliente', $idCliente);
        // Considera somente faturas cujo intervalo entre emissão e vencimento é inferior a 365 dias
        $this->db->where("DATEDIFF(data_vencimento,datavenda) <= 365", null, false);

        $consulta = $this->db->get();
        $resultado = $consulta->row();

        return ($resultado->valor !== null) ? $resultado->valor : 0;
    }
    /**
 * Retorna o valor total da dívida associada a um determinado crédito.
 *
 * Esse método busca na tabela 'contasreceber' o registro cujo campo 'idrecebimento'
 * corresponde ao valor de $idCredito e retorna o valor da dívida registrado no campo 'valor'.
 *
 * @param int $idCredito O identificador do crédito (ou recebimento) a ser consultado.
 * @return float O valor da dívida, ou 0 se não houver valor registrado.
 */
public function totalDivida($idCredito) {
    // Seleciona a coluna 'valor' da tabela 'contasreceber'
    $this->db->select('valor');
    $this->db->from('contasreceber');
    $this->db->where('idrecebimento', $idCredito);
    $consulta = $this->db->get();
    $resultado = $consulta->row();

    // Verifica se o campo 'valor' não é nulo e o retorna; caso contrário, retorna 0.
    return ($resultado->valor !== null) ? $resultado->valor : 0;
}


    public function dividaTransitadaCliente2($idCliente, $datamaxima) {
        $this->db->select_sum('valor');
        $this->db->from('contasreceber');
        $this->db->where('idcliente', $idCliente);
        if (empty($datamaxima)) {
            $this->db->where('datavenda <', date('Y-m-d'));
        } else {
            $this->db->where('datavenda <', $datamaxima);
        }
        // Apenas valores positivos
        $this->db->where('valor >', 0);

        $consulta = $this->db->get();
        $resultado = $consulta->row();

        return ($resultado->valor !== null) ? $resultado->valor : 0;
    }

    public function mlistaContaCliente($idCliente, $dataminima, $datamaxima) {
        $this->db->select('*');
        $this->db->from('clientes_conta_corrente');
        $this->db->join('tipo_movimento', 'clientes_conta_corrente.idtipoMovimento = tipo_movimento.idTipoMovimento');
        $this->db->where('idCliente', $idCliente);
        if (!empty($dataminima)) {
            $this->db->where('data >=', $dataminima);
            $this->db->where('data <=', $datamaxima);
        }
        $consulta = $this->db->get();
        return $consulta->result();
    }

    public function pegaDivida($idCliente) {
        $this->db->select_sum('divida');
        $this->db->from('clientes_conta_corrente');
        $this->db->where('idCliente', $idCliente);
        $consulta = $this->db->get();
        $resultado = $consulta->row();
        return ($resultado->divida !== null) ? $resultado->divida : 0;
    }

    public function pegaPagamentos($idCliente) {
        $this->db->select_sum('pagamento');
        $this->db->from('clientes_conta_corrente');
        $this->db->where('idCliente', $idCliente);
        $consulta = $this->db->get();
        $resultado = $consulta->row();
        return ($resultado->pagamento !== null) ? $resultado->pagamento : 0;
    }

    public function mlista_tipo_movimento() {
        $this->db->select('*');
        $this->db->from('tipo_movimento');
        $this->db->where('idTipoMovimento !=', 1);
        $this->db->where('idTipoMovimento !=', 2);
        $consulta = $this->db->get();
        return $consulta->result();
    }

    /**
     * Calcula a soma dos pagamentos efetuados para um cliente específico.
     *
     * @param int $idCliente ID do cliente
     * @return float O total de pagamentos, ou 0 se não houver pagamentos positivos.
     */
    public function somaPagamentos($idCliente) {
        // Seleciona a soma da coluna 'pagamento' e a nomeia como 'total_pagamento'
        $this->db->select_sum('pagamento', 'total_pagamento');
        $this->db->from('clientes_conta_corrente');
        $this->db->where('idCliente', $idCliente);
        // Executa a consulta
        $consulta = $this->db->get();
        $resultado = $consulta->row();
        return ($resultado && $resultado->total_pagamento > 0) ? $resultado->total_pagamento : 0;
    }

    /**
     * Calcula a soma total das dívidas registradas para um cliente específico.
     *
     * @param int $idCliente ID do cliente
     * @return float Valor total das dívidas ou 0 se não houver dívidas positivas.
     */
    public function somaDividas($idCliente) {
        // Seleciona a soma da coluna 'divida' e nomeia o resultado como 'total_divida'
        $this->db->select_sum('divida', 'total_divida');
        $this->db->from('clientes_conta_corrente');
        $this->db->where('idCliente', $idCliente);

        // Executa a consulta e obtém a primeira linha do resultado
        $consulta = $this->db->get();
        $resultado = $consulta->row();

        // Retorna o valor da soma se for maior que 0, caso contrário retorna 0
        return ($resultado && $resultado->total_divida > 0) ? $resultado->total_divida : 0;
    }

    public function faturas($dataminima, $datamaxima, $idCliente) {
        $this->db->select('*');
        $this->db->from('faturas');
        $this->db->join('clientes', 'faturas.idcliente=clientes.idcliente');
        $this->db->join('usuarios', 'faturas.iduser=usuarios.id_usiario');
        $this->db->join('cliente_contacto', 'clientes.idcliente=cliente_contacto.idcliente');
        $this->db->where('clientes.idcliente', $idCliente);
        $this->db->where('data >=', $dataminima);
        $this->db->where('data <=', $datamaxima);

        $consulta = $this->db->get();
        return $consulta->result();
    }

}
