<?php

class mItens extends CI_Model {

    function __construct() {
        parent::__construct();
    }

    public function mlista_itens($start, $limit, $pesquisa) {
        // Seleção dos campos
        $this->db->select('prodt.idpr, prodt.produto, qtd, idArmaze, control, path, categorias.categoria, precos_produtos.preco, categorias.idcategoria');
        $this->db->from('prodt');

        // Joins com as outras tabelas
        $this->db->join('stock_quantidade', 'prodt.idpr = stock_quantidade.idproduto');
        $this->db->join('categorias', 'prodt.idcategoria = categorias.idcategoria');
        $this->db->join('precos_produtos', 'prodt.idpr = precos_produtos.idProduto');

        // Condição de pesquisa (LIKE) com segurança e agrupamento lógico
        if (!empty($pesquisa)) {
            $this->db->group_start(); // Abre o grupo de condições
            $this->db->like('produto', $this->db->escape_like_str($pesquisa));
            $this->db->or_like('codigodebara', $this->db->escape_like_str($pesquisa));
            $this->db->or_like('referencia', $this->db->escape_like_str($pesquisa));
            $this->db->group_end(); // Fecha o grupo de condições
        }

        // Limitação e paginação
        $this->db->limit($limit, $start);
        // Execução da consulta e retorno dos resultados
        $this->db->group_by('prodt.idpr');
        $query = $this->db->get();
        return $query->result();
    }

    public function contar_produtos() {
        $this->db->select('*');
        $this->db->from('prodt');
        // Joins com as outras tabelas
        $this->db->join('stock_quantidade', 'prodt.idpr = stock_quantidade.idproduto');
        return $this->db->count_all_results();
    }

    // Obter o total de registros (sem filtros)
    public function get_total_records_produtos() {
        return $this->db->count_all('prodt');
    }

    // Obter a contagem de registros filtrados
    public function get_filtered_records_count($searchValue) {
        if (!empty($searchValue)) {
            $this->db->like('produto', $searchValue);
        }
        return $this->db->count_all_results('prodt');
    }

    // Obter os dados filtrados com limite e offset (para paginação)
    public function get_filtered_data($searchValue, $limit, $offset) {
        $this->db->select('prodt.produto,  precos_produtos.preco,prodt.idpr, qtd');
        $this->db->from('prodt');
        // Joins com as outras tabelas
        $this->db->join('stock_quantidade', 'prodt.idpr = stock_quantidade.idproduto');
        $this->db->join('categorias', 'prodt.idcategoria = categorias.idcategoria');
        $this->db->join('precos_produtos', 'prodt.idpr = precos_produtos.idProduto');

        if (!empty($searchValue)) {
            $this->db->like('prodt.produto', $searchValue);
        }
        // Definir limite e offset para paginação
        $this->db->limit($limit, $offset);

        // Executar a consulta e retornar os dados
        $query = $this->db->get();
        return $query->result();
    }

    public function pegaPrecoPorGrupo($idGrupoPreco, $idProduto) {
        $this->db->select('preco'); //
        $this->db->from('precos_produtos');
        $this->db->where('idGrupoPreco ', $idGrupoPreco);
        $this->db->where('idProduto ', $idProduto);
        $consulta = $this->db->get();
        foreach ($consulta->result() as $value) {
            if ($value->preco && $value->preco != null) {
                return $value->preco;
            } else {
                return 0;
            }
        }
    }

    // Pega o Id do produto por codigo de barra, referência ou o proprio ID
    public function idProduto($pesquisa) {
        $this->db->select('prodt.idpr');
        $this->db->from('prodt');
        $this->db->group_start(); // Abre o grupo de condições
        $this->db->where('idpr', $pesquisa);
        $this->db->or_where('codigodebara', $pesquisa);
        $this->db->or_where('referencia', $pesquisa);
        $this->db->group_end(); // Fecha o grupo de condições
        $query = $this->db->get();
        return $query->result();
    }

}
