<?php

/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/**
 * Description of mStock
 *
 * @author VINEVALA
 */
class mStock extends CI_Model {

    public function registarFaturaFornecedor($idfornecedor, $nfatura, $dtaCompra, $idusuario, $valorFatura, $dataVencimento, $hashDoc) {
        $dados = array(
            'idfornecedor' => $idfornecedor,
            'nfatura' => $nfatura,
            'hora' => @date('H:i:s'),
            'dataCompra' => $dtaCompra,
            'dataentrada' => @date('Y-m-d'),
            'id_usiario' => $idusuario,
            'dataVencimento' => $dataVencimento,
            'valorFatura' => $valorFatura,
            'hash ' => $hashDoc,
        );
        $this->db->insert('compras', $dados);
        return $this->db->insert_id();
    }

    public function registarQtd($idProduto, $qtd, $custo, $totalcompras, $idArmaze, $disponivel) {
        $dados = array(
            'idproduto' => $idProduto,
            'qtd' => $qtd,
            'custo' => $custo,
            'totalcompras' => $totalcompras,
            'ultimadata' => @date('Y-m-d'),
            'idArmaze' => $idArmaze,
            'disponivel' => $disponivel,
        );
        $this->db->insert('stock_quantidade', $dados);
    }

    public function registarQtdLoja($idProduto, $qtd, $custo, $totalcompras, $idArmaze, $disponivel) {
        $dados = array(
            'idproduto' => $idProduto,
            'qtd' => $qtd,
            'custo' => $custo,
            'totalcompras' => $totalcompras,
            'idArmaze' => $idArmaze,
            'ultimadata' => date('Y-m-d'),
            'disponivel' => $disponivel,
        );
        $this->db->insert('stock_quantidade', $dados);
    }

    public function registarPedidos($idfornecedor, $motivo, $idusuario) {
        $dados = array(
            'motivo' => $motivo,
            'idFornecedor' => $idfornecedor,
            'dataPedido' => @date('Y-m-d'),
            'idUsuario' => $idusuario
        );
        $this->db->insert('pedidoCompras', $dados);
        return $this->db->insert_id();
    }

    public function registarPedidosItem($idCompra, $idProduto, $qtd, $idUnidade) {
        $dados = array(
            'idPedido' => $idCompra,
            'idProduto' => $idProduto,
            'qtd' => $qtd,
            'idUnidade' => $idUnidade
        );
        $this->db->insert('itemPedido', $dados);
    }

    public function registarStockM($idProduto, $qtd, $custo, $venda, $totalcompras, $iva, $idusuario, $idCompra) {
        $dados = array(
            'idproduto' => $idProduto,
            'qtd' => $qtd,
            'custo' => $custo,
            'venda' => $venda,
            'iva' => $iva,
            'totalcompra' => $totalcompras,
            'data' => @date('Y-m-d'),
            'id_usiario' => $idusuario,
            'idCompra' => $idCompra,
        );
        $this->db->insert('item_compras', $dados);
    }

    public function registarItemCompras($idProduto, $qtd, $custo, $idUnidade, $totalcompras, $iva, $idusuario, $idCompra, $prazo, $totalUnidade, $desconto) {
        $dados = array(
            'idproduto' => $idProduto,
            'qtd' => $qtd,
            'custo' => $custo,
            'idUnidade' => $idUnidade,
            'totalcompra' => $totalcompras,
            'id_usiario' => $idusuario,
            'idCompra' => $idCompra,
            'iva' => $iva,
            'prazo_validade' => $prazo,
            'total_por_unidade' => $totalUnidade,
            'desconto' => $desconto,
        );
        $this->db->insert('item_compras', $dados);
    }

    // metodo para atualizar stock somando
    public function atualiarQtd($idProduto, $qtd, $custo, $venda, $totalcompras) {
        $data = @date('Y-m-d');
        $this->db->where('idproduto', $idProduto);
        $this->db->set('qtd', 'qtd+' . $qtd, FALSE);
        $this->db->set('custo', $custo);
        $this->db->set('venda', $venda);
        $this->db->set('totalcompras', $totalcompras);
        $this->db->set('ultimadata', $data);
        $this->db->update('stock_quantidade');
    }

    public function pegarQtd($idProduto) {
        $this->db->select('*');
        $this->db->from('stock_quantidade');
        $this->db->where('idproduto', $idProduto);
        $query = $this->db->get();
        return $query->result();
    }

    public function atualizarSubtrairQtd($idProduto, $qtd, $idLoja) {
        $this->db->where('idproduto', $idProduto);
        $this->db->where('idArmaze', $idLoja);
        $this->db->set('qtd', 'qtd-' . $qtd, FALSE);
        $this->db->update('stock_quantidade');
    }

    public function atualizaEstadoCompra($idProduto, $idPedido, $comprado) {
        $this->db->where('idPedido', $idPedido);
        $this->db->where('idProduto', $idProduto);
        $this->db->set('comprado', $comprado);
        $this->db->update('itempedido');
    }

    // metodo para verificar se o produto ja existe em stock
    public function consulta($idProduto) {
        $this->db->where('idproduto', $idProduto);
        $this->db->from('stock_quantidade');
        if ($this->db->count_all_results() > 0) {
            return true;
        } else
            return false;
    }

//    metodo para vrificar a quantidade
    public function consultaQtd($idProduto, $qtd) {

        $this->db->where('idproduto', $idProduto);
        $this->db->where('qtd <', $qtd);
        $this->db->from('stock_quantidade');
        if ($this->db->count_all_results() > 0) {
            return true;
        } else
            return false;
    }

//    metodo para listar a quantidade  disponivel
    public function mlistaArtigosQtdStock($pesquisa, $limit, $offset) {
        $this->db->select('*');
        $this->db->from('stock_quantidade');
        $this->db->join('prodt', 'stock_quantidade.idproduto = prodt.idpr');
        $this->db->where('qtd !=', null);
        if (!empty($pesquisa)) {
            $this->db->group_start(); // Abre o grupo de condições
            $this->db->like('idpr', $this->db->escape_like_str($pesquisa));
            $this->db->or_like('produto', $this->db->escape_like_str($pesquisa));
            $this->db->or_like('codigodebara', $this->db->escape_like_str($pesquisa));
            $this->db->or_like('referencia', $this->db->escape_like_str($pesquisa));
            $this->db->group_end(); // Fecha o grupo de condições
        }
        $this->db->order_by('produto', 'asc');
        $this->db->group_by('stock_quantidade.idproduto');
        $this->db->limit($limit, $offset);
        $query = $this->db->get();
        return $query->result();
    }
    public function mlistaArtigosDtCaducidade($pesquisa, $limit, $offset) {
        $this->db->select('*');
        $this->db->from('stock_dt_caducidade');
        $this->db->join('prodt', 'stock_dt_caducidade.idProduto = prodt.idpr');
        if (!empty($pesquisa)) {
            $this->db->group_start(); // Abre o grupo de condições
            $this->db->like('idpr', $this->db->escape_like_str($pesquisa));
            $this->db->or_like('produto', $this->db->escape_like_str($pesquisa));
            $this->db->or_like('codigodebara', $this->db->escape_like_str($pesquisa));
            $this->db->or_like('referencia', $this->db->escape_like_str($pesquisa));
            $this->db->group_end(); // Fecha o grupo de condições
        }
        $this->db->order_by('data_validade', 'asc');
        $this->db->limit($limit, $offset);
        $query = $this->db->get();
        return $query->result();
    }
     public function mlistaArtigosAddStock($pesquisa, $limit, $offset) {
        $this->db->select('prodt.idpr,prodt.produto,stock_quantidade.idstock,stock_quantidade.qtd,armanzes.narmanze');
        $this->db->from('stock_quantidade');
        $this->db->join('prodt', 'stock_quantidade.idproduto = prodt.idpr');
         $this->db->join('armanzes', 'stock_quantidade.idArmaze = armanzes.id');
        $this->db->where('qtd !=', null);
        if (!empty($pesquisa)) {
            $this->db->group_start(); // Abre o grupo de condições
            $this->db->like('idpr', $this->db->escape_like_str($pesquisa));
            $this->db->or_like('produto', $this->db->escape_like_str($pesquisa));
            $this->db->or_like('codigodebara', $this->db->escape_like_str($pesquisa));
            $this->db->or_like('referencia', $this->db->escape_like_str($pesquisa));
            $this->db->group_end(); // Fecha o grupo de condições
        }
        $this->db->order_by('produto', 'asc');
        $this->db->limit($limit, $offset);
        $query = $this->db->get();
        return $query->result();
    }
    

    //    metodo para listar a quantidade  disponivel
    public function listarProdutosPOS($start, $limit, $produto, $idLoja, $idGrupoPreco, $referencia) {
        $this->db->select('*');
        $this->db->from('stock_quantidade');
        $this->db->join('prodt', 'stock_quantidade.idproduto = prodt.idpr');
        $this->db->join('precos_produtos', ' prodt.idpr = precos_produtos.idProduto');
        if ($produto != '') {
            $this->db->like('produto', $produto);
        }
        if ($referencia != '') {
            $this->db->like('referencia', $referencia);
        }
        $this->db->where('stock_quantidade.idArmaze', $idLoja);
        $this->db->where('stock_quantidade.disponivel', 's');
        $this->db->where('precos_produtos.idGrupoPreco', $idGrupoPreco);
        $this->db->where('precos_produtos.preco >', 0);
        $this->db->where('qtd !=', null);
        $this->db->limit($limit, $start);
        $this->db->order_by('produto');
        $query = $this->db->get();
        return $query->result();
    }

    //    metodo para listar a quantidade  disponivel
    public function contarProdutosPOS($idLoja) {
        $this->db->select('*');
        $this->db->from('stock_quantidade');
        $this->db->join('prodt', 'stock_quantidade.idproduto = prodt.idpr');
        $this->db->where('stock_quantidade.idArmaze', $idLoja);
        $this->db->where('stock_quantidade.disponivel', 's');
        $this->db->where('qtd !=', null);
        $this->db->order_by('produto');
        $query = $this->db->get();
        return $query->result();
    }

    //    metodo para listar a quantidade  disponivel
    public function listarstockDisponivelPDF() {
        $this->db->select('*');
        $this->db->from('stock_quantidade');
        $this->db->join('prodt', 'stock_quantidade.idproduto = prodt.idpr');
        $this->db->where('qtd !=', null);
        $this->db->order_by('produto');
        $query = $this->db->get();
        return $query->result();
    }

    //    metodo para listar os Servicos na view do ponto de Venda
    public function listarServicosView($start, $limit, $produto) {
        $this->db->select('*');
        $this->db->from('prodt');

        if ($produto != '') {
            $this->db->like('produto', $produto);
        }
        $this->db->where('idTipo', 2);
        $this->db->limit($limit, $start);
        $this->db->order_by('produto');
        $query = $this->db->get();
        return $query->result();
    }

    public function contarlistarServicosView() {
        $this->db->select('*');
        $this->db->from('prodt');
        $this->db->where('idTipo', 2);
        return $this->db->count_all_results();
    }

    public function totalQtdEmStock() {
        $this->db->select_sum('qtd');
        $this->db->from('stock_quantidade');
        $consulta = $this->db->get();
        // Verifica se 'qtd' está definido ou é null e retorna 0 caso contrário
        $resultado = $consulta->row();
        return isset($resultado->qtd) ? $resultado->qtd : 0; 
    }

    public function obter_total_registos_filtrados($pesquisa) {
        $this->db->select('COUNT(*) as total'); // Apenas conta os registros
        $this->db->from('stock_quantidade');
        $this->db->join('prodt', 'stock_quantidade.idproduto = prodt.idpr');
        if (!empty($pesquisa)) {
            $this->db->group_start();
            $this->db->or_like('produto', $this->db->escape_like_str($pesquisa));
            $this->db->or_like('codigodebara', $this->db->escape_like_str($pesquisa));
            $this->db->or_like('referencia', $this->db->escape_like_str($pesquisa));
            $this->db->group_end();
        }
        $query = $this->db->get(); // Executa a consulta
        $result = $query->row(); // Obtém o resultado
        return $result->total; // Retorna o total
    }
    public function obter_total_registos_dt_val_filtrados($pesquisa) {
        $this->db->select('COUNT(*) as total'); // Apenas conta os registros
        $this->db->from('stock_dt_caducidade');
        $this->db->join('prodt', 'stock_dt_caducidade.idProduto = prodt.idpr');
        if (!empty($pesquisa)) {
            $this->db->group_start();
            $this->db->or_like('produto', $this->db->escape_like_str($pesquisa));
            $this->db->or_like('codigodebara', $this->db->escape_like_str($pesquisa));
            $this->db->or_like('referencia', $this->db->escape_like_str($pesquisa));
            $this->db->group_end();
        }
        $query = $this->db->get(); // Executa a consulta
        $result = $query->row(); // Obtém o resultado
        return $result->total; // Retorna o total
    }

    public function mTotalContaRegistosStock() {
        $this->db->select('COUNT(*) as total'); // Apenas conta o número de registros
        $this->db->from('stock_dt_caducidade');
        $this->db->join('prodt', 'stock_dt_caducidade.idProduto = prodt.idpr');
        $query = $this->db->get(); // Executa a consulta
        $result = $query->row(); // Obtém o resultado
        return $result->total; // Retorna o total
    }
     public function mTotalContaRegisDtCaducidade() {
        $this->db->select('COUNT(*) as total'); // Apenas conta o número de registros
        $this->db->from('stock_quantidade');
        $this->db->join('prodt', 'stock_quantidade.idproduto = prodt.idpr');
        $query = $this->db->get(); // Executa a consulta
        $result = $query->row(); // Obtém o resultado
        return $result->total; // Retorna o total
    }

    //metodo para listar stock realizados
    public function listarComprasM($start, $limit, $dataminima, $datamaxima) {
        $this->db->select('*');
        $this->db->from('compras');
        $this->db->join('contaspagar', ' compras.idCompra= contaspagar.idCompra');
        $this->db->join('usuarios', 'compras.id_usiario = usuarios.id_usiario');
        $this->db->join('fonecedores', 'compras.idfornecedor = fonecedores.idfornecedor');
        if ($datamaxima != '') {
            $this->db->where('dataentrada >=', $dataminima);
            $this->db->where('dataentrada<=', $datamaxima);
        }

        $this->db->limit($limit, $start);
        $this->db->order_by('dataentrada', 'DESC');
        $query = $this->db->get();
        return $query->result();
    }

    //metodo que conta as linhas exitente na tabela quantidade_stock
    public function contarlinhasM() {
        $this->db->select('*');
        $this->db->from('stock_quantidade');
        $this->db->join('prodt', 'stock_quantidade.idproduto = prodt.idpr');
        $this->db->where('qtd !=', null);
        return $this->db->count_all_results();
    }

    //metodo que conta as linhas exitente na tabela stock
    public function contarlinhasStok() {
        $this->db->select('*');
        $this->db->from('compras');
        return $this->db->count_all_results();
    }

    //verifica se a quantidade desejada e menor ue a existente no bd
    public function consultaQuantidade($idpr, $qtd) {
        $this->db->where('idproduto', $idpr);
        $this->db->where('qtd <', $qtd);
        $this->db->from('stock_quantidade');
        if ($this->db->count_all_results() > 0) {
            return true;
        } else
            return false;
    }

    public function selecionarIdStock($idpr, $idLoja) {
        $this->db->select('*');
        $this->db->from('stock_quantidade');
        $this->db->where('idArmaze', $idLoja);
        $this->db->where('idproduto', $idpr);
        $query = $this->db->get();
        return $query->result();
    }

//

    public function CopiarStock() {

        $this->db->select('*');
        $this->db->from('stock_quantidade');
        $this->db->join('prodt', 'stock_quantidade.idproduto = prodt.idpr');
        $this->db->where('prodt.idTipo', 3);
        $query = $this->db->get();
        return $query->result();
    }

    // metodo para atualizar o novo valor no  stock subtraindo
    public function atualizarValor($idstock, $novovalofinal) {

        $this->db->where('idstock', $idstock);
        $this->db->set('totalcompras', 'totalcompras-' . $novovalofinal, FALSE);
        $this->db->update('stock_quantidade');
    }

    // Imprimir vendas
    public function listarCompras($dataminima, $datamaxima) {
        $this->db->select('*');
        $this->db->from('stock');
        $this->db->join('prodt', 'stock.idproduto = prodt.idpr');
        $this->db->join('usuarios', 'stock.id_usiario = usuarios.id_usiario');
        if ($datamaxima != '') {
            $this->db->where('data >=', $dataminima);
            $this->db->where('data<=', $datamaxima);
        }
        $this->db->order_by('data', 'DESC');
        $query = $this->db->get();
        return $query->result();
    }

    public function preco_produto($idProduto, $preco) {
        $this->db->where('idpr', $idProduto);
        $this->db->set('preco', $preco);
        $this->db->update('prodt');
    }

    public function atualizaPrecoStQtd($idstock, $custo, $venda, $data, $idProduto) {
        $dados = array(
            'custo' => $custo,
            'venda' => $venda,
        );
        $this->db->where('idstock', $idstock);
        $this->db->set($dados);
        $this->db->update('stock_quantidade');
        $qtd = $this->pegaQtdPorData($data);
        $totalcompra = $qtd * $custo;
        $dadosStock = array(
            'custo' => $custo,
            'venda' => $venda,
            'totalcompra' => $totalcompra,
        );
        $this->db->where('idproduto', $idProduto);
        $this->db->where('data', $data);
        $this->db->set($dadosStock);
        $this->db->update('stock');

        $dadosProduto = array(
            'preco' => $venda,
        );
        $this->db->where('idpr', $idProduto);
        $this->db->set($dadosProduto);
        $this->db->update('prodt');
    }

    public function pegaQtdPorData($data) {
        $this->db->select('qtd');
        $this->db->from('stock');
        $this->db->where('data', $data);
        $query = $this->db->get();
        foreach ($query->result() as $value) {
            return $value->qtd;
        }
    }

    public function pegarPrecoIva($idProduto) {
        $this->db->select('*');
        $this->db->from('stock');
        $this->db->where('idproduto', $idProduto);
        $this->db->order_by('idstock', 'DESC');
        $this->db->limit(1);
        $query = $this->db->get();
        return $query->result();
    }

    public function registarCompra($idfornecedor, $nfatura, $dtaCompra, $idusuario, $idPedido) {
        $dados = array(
            'idfornecedor' => $idfornecedor,
            'nfatura' => $nfatura,
            'hora' => @date('H:i:s'),
            'dataCompra' => $dtaCompra,
            'dataentrada' => @date('Y-m-d'),
            'id_usiario' => $idusuario,
            'idPedido' => $idPedido,
        );
        $this->db->insert('compras', $dados);
        return $this->db->insert_id();
    }

    public function qtdAntiga($idstock) { // pega  a quandidade 
        $this->db->select('qtd'); //
        $this->db->from('stock');
        $this->db->where('idstock', $idstock);
        $consulta = $this->db->get();
        foreach ($consulta->result() as $value) {
            return $value->qtd;
        }
    }

    public function pegaIdProduto($idstock) { // pega o a id do dproduto atraves do id stock 
        $this->db->select('idproduto'); //
        $this->db->from('stock_quantidade');
        $this->db->where('idstock', $idstock);
        $consulta = $this->db->get();
        foreach ($consulta->result() as $value) {
            return $value->idproduto;
        }
    }
    public function pegaIdArmanzen($idstock) { // 
        $this->db->select('idArmaze'); //
        $this->db->from('stock_quantidade');
        $this->db->where('idstock', $idstock);
        $consulta = $this->db->get();
        foreach ($consulta->result() as $value) {
            return $value->idArmaze;
        }
    }

    public function pegaCusto($idProduto) { // pega o custo da compra do produto
        $this->db->select('custopr'); //
        $this->db->from('prodt');
        $this->db->where('idpr', $idProduto);
        $consulta = $this->db->get();
        foreach ($consulta->result() as $value) {
            return $value->custopr;
        }
    }

    // meto que reseta a quantidade  comprada
    public function resetarQtd($idProduto, $qtd) {

        $this->db->where('idstock', $idProduto);
        $this->db->set('totalcompra', 0);
        $this->db->set('qtd', 'qtd-' . $qtd, FALSE);
        $this->db->update('stock');
    }

    // meto que soma a quantidade em comprada
    public function somaQtdCompra($idstock, $qtd, $totalcompras) {
        $this->db->where('idstock', $idstock);
        $this->db->set('totalcompra', 'totalcompra+' . $totalcompras, FALSE);
        $this->db->set('qtd', 'qtd+' . $qtd, FALSE);
        $this->db->update('stock');
    }

    // subtrair a quanidade
    public function subtrairQuantidede($idproduto, $qtd) {// subtrai a quantidade atraves do ProdutoId
        $this->db->where('idproduto', $idproduto);

        $this->db->set('qtd', 'qtd-' . $qtd, FALSE);
        $this->db->update('stock_quantidade');
    }

    public function somaQuantidedePrecoCompra($idproduto, $qtd, $totalcompras, $idArmanzeDestino) {

        $this->db->where('idproduto', $idproduto);
        $this->db->where('idArmaze', $idArmanzeDestino);
        $this->db->set('totalcompras', 'totalcompras+' . $totalcompras, FALSE);
        $this->db->set('qtd', 'qtd+' . $qtd, FALSE);
        $this->db->update('stock_quantidade');
    }

    public function pegaIdStockQauntidade($idproduto) { // pega id Stock quantidade
        $this->db->select('idstock'); //
        $this->db->from('stock_quantidade');
        $this->db->where('idproduto', $idproduto);
        $consulta = $this->db->get();
        foreach ($consulta->result() as $value) {
            return $value->idstock;
        }
    }

    public function pegaUltimaDataCompra($idproduto) { // pega a ultima data da compra
        $this->db->select('ultimadata'); //
        $this->db->from('stock_quantidade');
        $this->db->where('idproduto', $idproduto);
        $consulta = $this->db->get();
        foreach ($consulta->result() as $value) {
            return $value->ultimadata;
        }
    }

    public function verificar_se_existe_inventario($idstock, $data) {// 
        $this->db->select('idstock');
        $this->db->from('inventario');
        $this->db->where('datainventario>=', $data);
        $this->db->where('idstock', $idstock);
        if ($this->db->count_all_results() > 0) {
            return true;
        } else
            return false;
    }

    public function pegaIdInventario($idstock, $data) {// 
        $this->db->select('idinventario');
        $this->db->from('inventario');
        $this->db->where('datainventario >=', $data);
        $this->db->where('idstock', $idstock);
        $this->db->limit(1);
        $this->db->order_by('idinventario', 'DESC');
        $consulta = $this->db->get();
        foreach ($consulta->result() as $value) {
            return $value->idinventario;
        }
    }

    public function pegaIdHistorico($idproduto) {// 
        $this->db->select('idhistorico');
        $this->db->from('historicoprodutos');
        $this->db->where('idproduto', $idproduto);
        $this->db->where('tipomovimento', 'ENTRADA');
        $this->db->limit(1);
        $this->db->order_by('idhistorico', 'DESC');
        $consulta = $this->db->get();
        foreach ($consulta->result() as $value) {
            return $value->idhistorico;
        }
    }

    public function resetaHistorico($idhistorico, $qtd) {
        $this->db->where('idhistorico', $idhistorico);
        $this->db->set('qtd', 'qtd-' . $qtd, FALSE);
        $this->db->update('historicoprodutos');
    }

    public function atualizaHistorico($idhistorico, $qtd) {
        $this->db->where('idhistorico', $idhistorico);
        $this->db->set('qtd', 'qtd+' . $qtd, FALSE);
        $this->db->update('historicoprodutos');
    }

    public function pega_preco_venda($idproduto) {// 
        $this->db->select('preco');
        $this->db->from('prodt');
        $this->db->where('idpr', $idproduto);

        $consulta = $this->db->get();
        foreach ($consulta->result() as $value) {
            return $value->preco;
        }
    }

    public function pega_preco_compra($idproduto) {// 
        $this->db->select('custopr');
        $this->db->from('prodt');
        $this->db->where('idpr', $idproduto);

        $consulta = $this->db->get();
        foreach ($consulta->result() as $value) {
            return $value->custopr;
        }
    }

    public function totalGeralVendas() { // soma o valor total de vendas 
        $this->db->select('qtd,idproduto');
        $this->db->from('stock_quantidade');
        $query = $this->db->get();
        $totalGeral = 0;
        foreach ($query->result() as $linha) {
            $qtd = $linha->qtd;
            $venda = $this->pega_preco_venda($linha->idproduto);
            $totalv = $qtd * $venda;
            $totalGeral = $totalv + $totalGeral;
        }
        return $totalGeral;
    }

    public function totalGeralCompras() { // soma o valor total de vendas 
        $this->db->select('qtd,idproduto');
        $this->db->from('stock_quantidade');
        $query = $this->db->get();
        $totalGeral = 0;
        foreach ($query->result() as $linha) {
            $qtd = $linha->qtd;
            $compra = $this->pega_preco_compra($linha->idproduto);
            $totalCom = $qtd * $compra;
            $totalGeral = $totalCom + $totalGeral;
        }
        return $totalGeral;
    }
    public function totalQtd() {
        $this->db->select_sum('qtd');     
        $this->db->from('stock_quantidade'); 
        $consulta = $this->db->get();  // Executa a consulta no banco de dados
        $row = $consulta->row();
        return ($row && $row->qtd !== null) ? $row->qtd : 0;
    }
 //este método lista todos os produtos disnponiveil em stok e 
    public function mListaProdutosParaTotalGeralVenda() {
        $this->db->select('*');
        $this->db->from('stock_quantidade');
        $this->db->join('prodt', 'stock_quantidade.idproduto = prodt.idpr');
        $this->db->where('idArmaze',2);
        $this->db->where('stock_quantidade.qtd IS NOT NULL');
        $this->db->order_by('prodt.produto', 'ASC');
        $query = $this->db->get();
        return $query->result();
    }
    // Imprimir 
    public function listarPedido() {
        $this->db->select('*');
        $this->db->from('pedidoCompras');
        $this->db->join('fonecedores', 'pedidoCompras.idFornecedor = fonecedores.idfornecedor');
        $this->db->join('usuarios', 'pedidoCompras.idUsuario = usuarios.id_usiario');

        $this->db->order_by('idPedido', 'DESC');
        $query = $this->db->get();
        return $query->result();
    }

    public function contarPedidos() {// 
        $this->db->select('*');
        $this->db->from('pedidoCompras');
        $this->db->join('fonecedores', 'pedidoCompras.idFornecedor = fonecedores.idfornecedor');
        $this->db->join('usuarios', 'pedidoCompras.idUsuario = usuarios.id_usiario');
        return $this->db->count_all_results();
    }

    public function atualizaPedidosm($idPedido, $dataEntrega, $valor) {

        $this->db->where('idPedido', $idPedido);
        $this->db->set('dataEntrega', $dataEntrega);
        $this->db->set('valor', $valor);
        $this->db->update('pedidoCompras');
    }

    public function listarPedidoPdf($idPedido) {
        $this->db->select('*');
        $this->db->from('pedidoCompras');
        $this->db->join('itemPedido', 'pedidoCompras.idPedido = itemPedido.idPedido');
        $this->db->join('prodt', 'itemPedido.idProduto = prodt.idpr');
        $this->db->join('fonecedores', 'pedidoCompras.idFornecedor = fonecedores.idfornecedor');
        $this->db->join('contatofornecedor', 'fonecedores.idfornecedor = contatofornecedor.idfornecedor');
        $this->db->join('usuarios', 'pedidoCompras.idUsuario = usuarios.id_usiario');

        $this->db->where('pedidoCompras.idPedido', $idPedido);
        $query = $this->db->get();
        return $query->result();
    }

    //verifica se o produto ja existe na tabela stok
    public function verificaProdutoStock($idpr) {
        $this->db->where('idproduto', $idpr);
        $this->db->from('stock_quantidade');
        if ($this->db->count_all_results() > 0) {
            return true;
        } else
            return false;
    }

    public function total_qtd_compra_por_fatura_fornecedor($idCompra) { // 
        $this->db->select_sum('qtd'); //
        $this->db->from('compras');
        $this->db->join('item_compras', 'compras.idCompra = item_compras.idCompra');
        $this->db->where('compras.idCompra', $idCompra);
        $consulta = $this->db->get();
        foreach ($consulta->result() as $value) {
            return $value->qtd;
        }
    }

    public function total_custo_compra_por_fatura_fornecedor($idCompra) { // 
        $this->db->select_sum('custo'); //
        $this->db->from('compras');
        $this->db->join('item_compras', 'compras.idCompra = item_compras.idCompra');
        $this->db->where('compras.idCompra', $idCompra);
        $consulta = $this->db->get();
        foreach ($consulta->result() as $value) {
            return $value->custo;
        }
    }

    public function listatotal_compra_por_fatura_fornecedor($idCompra) { // 
        $this->db->select('*'); //
        $this->db->from('compras');
        $this->db->join('item_compras', 'compras.idCompra = item_compras.idCompra');
        $this->db->join('prodt', 'item_compras.idproduto = prodt.idpr');
        $this->db->join('unidade_medida', 'item_compras.idUnidade = unidade_medida.idUnidade');
        $this->db->where('compras.idCompra', $idCompra);
        $consulta = $this->db->get();
        return $consulta->result();
    }

    public function listarNumeroPedidos() {
        $this->db->select('idPedido');
        $this->db->from('pedidoCompras');
        $this->db->order_by('idPedido', 'DESC');
        $query = $this->db->get();
        return $query->result();
    }

    public function lista_pedido_compra($idPedido) { // 
        $this->db->select('itempedido.idUnidade,itempedido.idproduto,itempedido.qtd,itempedido.comprado,prodt.produto'); //
        $this->db->from('itempedido');
        $this->db->join('prodt', 'itempedido.idproduto = prodt.idpr');
        $this->db->where('idPedido', $idPedido);
        $this->db->group_by('itempedido.idproduto');
        $consulta = $this->db->get();
        return $consulta->result();
    }

    public function lista_unidade($idUnidade) { // 
        $this->db->select('nunidade'); //
        $this->db->from('unidade_medida');
        $this->db->where('idUnidade', $idUnidade);
        $consulta = $this->db->get();
        foreach ($consulta->result() as $value) {
            return $value->nunidade;
        }
    }

    public function lista_total_por_unidade($idproduto) { // 
        $this->db->select('total_por_unidade'); //
        $this->db->from('item_compras');
        $this->db->where('idproduto', $idproduto);
        $consulta = $this->db->get();
        $total_por_unidade = 1.00;
        foreach ($consulta->result() as $value) {
            return $total_por_unidade = $value->total_por_unidade;
        }
    }

    public function resetQtd($idStock, $qtd) {
        $this->db->where('idstock', $idStock);
        $this->db->set('qtd', 'qtd-' . $qtd, FALSE);
        if ($this->db->update('stock_quantidade')) {
            return true;
        } else {
            return false;
        }
    }

    public function pegaIdProduto2($idstock) {
        $this->db->select('idproduto'); //
        $this->db->from('stock_quantidade');
        $this->db->where('idstock', $idstock);
        $consulta = $this->db->get();
        foreach ($consulta->result() as $value) {
            return $value->idproduto;
        }
    }

    public function custo($idstock) {
        $this->db->select('custo'); //
        $this->db->from('stock_quantidade');
        $this->db->where('idstock', $idstock);
        $consulta = $this->db->get();
        foreach ($consulta->result() as $value) {
            return $value->custo;
        }
    }

    // metodo para atualizar stock somando
    public function somaQtd($idProduto, $qtd, $idArmaze) {
        $this->db->where('idproduto', $idProduto);
        $this->db->where('idArmaze', $idArmaze);
        $this->db->set('qtd', 'qtd+' . $qtd, FALSE);
        $this->db->set('ultimadata', date('Y-m-d'));
        $this->db->update('stock_quantidade');
    }

    // metodo para atualizar stock somando
    public function somaQtdVariacoes($idProduto, $qtd, $idArmaze, $idCor, $idTamanho) {
        $this->db->where('idProduto', $idProduto);
        $this->db->where('idCor', $idCor);
        $this->db->where('idTamanho', $idTamanho);
        $this->db->where('idLoja', $idArmaze);
        $this->db->set('qtd', 'qtd+' . $qtd, FALSE);
        $this->db->update('variacao_tamanho_produto');
    }

    // metodo para atualizar stock subtraindo
    public function subtraiQtd($idProduto, $qtd, $idArmaze) {
        $this->db->where('idproduto', $idProduto);
        $this->db->where('idArmaze', $idArmaze);
        $this->db->set('qtd', 'qtd-' . $qtd, FALSE);
        $this->db->set('ultimadata', date('Y-m-d'));
        $this->db->update('stock_quantidade');
    }

    // metodo para atualizar stock subtraindo
    public function subtraiQtdVariacoes($idProduto, $qtd, $idArmaze, $idCor, $idTamanho) {
        $this->db->where('idProduto', $idProduto);
        $this->db->where('idCor', $idCor);
        $this->db->where('idTamanho', $idTamanho);
        $this->db->where('idLoja', $idArmaze);
        $this->db->set('qtd', 'qtd-' . $qtd, FALSE);
        $this->db->update('variacao_tamanho_produto');
    }

    public function registarHistoricoStock($idProduto, $qtd, $operacao, $idUsuario, $idArmanze, $tipo, $preco_compra) {
        $dados = array(
            'idProduto' => $idProduto,
            'operacao' => $operacao,
            'hora' => @date('H:i:s'),
            'data' => @date('Y-m-d'),
            'idUsuario' => $idUsuario,
            'qtd' => $qtd,
            'idArmanze' => $idArmanze,
            'tipo' => $tipo,
            'preco_compra' => $preco_compra,
        );
        $this->db->insert('historicoStock', $dados);
        return $this->db->insert_id();
    }
    public function mstock_dt_caducidade($idProduto, $idStock, $data_validade, $lote) {
        $dados = array(
            'idProduto' => $idProduto,
            'idStock' => $idStock,
            'data_validade' => $data_validade,
            'lote' => $lote,
            
        );
        $this->db->insert('stock_dt_caducidade', $dados);
    }

    public function registarHistoricoStockVariacooes($idProduto, $qtd, $operacao, $idUsuario, $idArmanze, $tipo, $idCor, $idTamanho) {
        $dados = array(
            'idProduto' => $idProduto,
            'operacao' => $operacao,
            'hora' => @date('H:i:s'),
            'data' => @date('Y-m-d'),
            'idUsuario' => $idUsuario,
            'qtd' => $qtd,
            'idArmanze' => $idArmanze,
            'tipo' => $tipo,
            'idCor' => $idCor,
            'idTamanho' => $idTamanho,
        );
        $this->db->insert('historicostockvariacoes', $dados);
        return $this->db->insert_id();
    }

    public function registarHistoricoStockLojaOrigemVariacao($idHistoricoStock, $idArmanze) {
        $dados = array(
            'idHistoricoStock' => $idHistoricoStock,
            'idArmanze' => $idArmanze,
        );
        $this->db->insert('loja_origem_produto_variacoes', $dados);
    }

    public function registarHistoricoStockLojaOrigem($idHistoricoStock, $idArmanze) {
        $dados = array(
            'idHistoricoStock' => $idHistoricoStock,
            'idArmanze' => $idArmanze,
        );
        $this->db->insert('loja_origem_produto', $dados);
    }

    public function registarHistoricoStockLojaDesdino($idHistoricoStock, $idArmanze) {
        $dados = array(
            'idHistoricoStock' => $idHistoricoStock,
            'idArmanze' => $idArmanze,
        );
        $this->db->insert('loja_destino_produto', $dados);
    }

    public function registarHistoricoStockLojaDesdinoVariacoes($idHistoricoStock, $idArmanze) {
        $dados = array(
            'idHistoricoStock' => $idHistoricoStock,
            'idArmanze' => $idArmanze,
        );
        $this->db->insert('loja_destino_produto_variacoes', $dados);
    }

    public function mlistarHistoricoPorLojas($idArmaze, $idProduto) { //  
        $this->db->select('*'); //
        $this->db->from('historicoStock');
        $this->db->join('armanzes', 'historicoStock.idArmanze = armanzes.id');
        $this->db->join('usuarios', 'historicoStock.idUsuario = usuarios.id_usiario');
        $this->db->where('armanzes.id', $idArmaze);
        $this->db->where('idProduto', $idProduto);
        $this->db->order_by('idHistoricoStock', 'DESC');
        $consulta = $this->db->get();
        return $consulta->result();
    }

    public function mlistarHistoricoPorLojasVariacoes($idArmaze, $idProduto, $idCor, $idTamanho) { //  
        $this->db->select('*'); //
        $this->db->from('historicostockvariacoes');
        $this->db->join('armanzes', 'historicostockvariacoes.idArmanze = armanzes.id');
        $this->db->join('usuarios', 'historicostockvariacoes.idUsuario = usuarios.id_usiario');
        $this->db->where('armanzes.id', $idArmaze);
        $this->db->where('idProduto', $idProduto);
        $this->db->where('idCor', $idCor);
        $this->db->where('idTamanho', $idTamanho);
        $this->db->order_by('idHistoricoStock', 'DESC');
        $consulta = $this->db->get();
        return $consulta->result();
    }

    public function idArmanzeDestino($idHistoricoStock) {
        $this->db->select('idArmanze'); //
        $this->db->from('loja_destino_produto');
        $this->db->where('idHistoricoStock', $idHistoricoStock);

        $consulta = $this->db->get();
        foreach ($consulta->result() as $value) {
            return $value->idArmanze;
        }
    }

    public function idArmanzeDestinoVariacoes($idHistoricoStock) {
        $this->db->select('idArmanze'); //
        $this->db->from('loja_destino_produto_variacoes');
        $this->db->where('idHistoricoStock', $idHistoricoStock);

        $consulta = $this->db->get();
        foreach ($consulta->result() as $value) {
            return $value->idArmanze;
        }
    }

    public function idArmanzeDestino2($idHistoricoStock) {
        $this->db->select('idArmanze'); //
        $this->db->from('loja_destino_produto');
        $this->db->where('idHistoricoStock >', $idHistoricoStock);
        $this->db->limit(1);
        $this->db->order_by('idHistoricoStock', 'ASC');
        $consulta = $this->db->get();
        foreach ($consulta->result() as $value) {
            return $value->idArmanze;
        }
    }

    public function idArmanzeDestino2VariacoesProdutos($idHistoricoStock) {
        $this->db->select('idArmanze'); //
        $this->db->from('loja_destino_produto');
        $this->db->where('idHistoricoStock >', $idHistoricoStock);
        $this->db->limit(1);
        $this->db->order_by('idHistoricoStock', 'ASC');
        $consulta = $this->db->get();
        foreach ($consulta->result() as $value) {
            return $value->idArmanze;
        }
    }

    public function idArmanzeDestinoVariacoesProdutos($idHistoricoStock) {
        $this->db->select('idArmanze'); //
        $this->db->from('loja_destino_produto');
        $this->db->where('idHistoricoStock >', $idHistoricoStock);
        $this->db->limit(1);
        $this->db->order_by('idHistoricoStock', 'ASC');
        $consulta = $this->db->get();
        foreach ($consulta->result() as $value) {
            return $value->idArmanze;
        }
    }

    public function idArmanzeOrigem($idHistoricoStock) {
        $this->db->select('idArmanze'); //
        $this->db->from('loja_origem_produto');
        $this->db->where('idHistoricoStock', $idHistoricoStock);
        $consulta = $this->db->get();
        foreach ($consulta->result() as $value) {
            return $value->idArmanze;
        }
    }

    public function idArmanzeOrigem2($idHistoricoStock) {
        $this->db->select('idArmanze'); //
        $this->db->from('loja_origem_produto');
        $this->db->where('idHistoricoStock <', $idHistoricoStock);
        $this->db->limit(1);
        $this->db->order_by('idHistoricoStock', 'DESC');
        $consulta = $this->db->get();
        foreach ($consulta->result() as $value) {
            return $value->idArmanze;
        }
    }

    public function idArmanzeOrigem2Variacoes($idHistoricoStock) {
        $this->db->select('idArmanze'); //
        $this->db->from('loja_origem_produto_variacoes');
        $this->db->where('idHistoricoStock <', $idHistoricoStock);
        $this->db->limit(1);
        $this->db->order_by('idHistoricoStock', 'DESC');
        $consulta = $this->db->get();
        foreach ($consulta->result() as $value) {
            return $value->idArmanze;
        }
    }

    public function pegaPrecoPorGrupo($idGrupoPreco, $idProduto) {
        $this->db->select('preco'); //
        $this->db->from('precos_produtos');
        $this->db->where('idGrupoPreco ', $idGrupoPreco);
        $this->db->where('idProduto ', $idProduto);
        $consulta = $this->db->get();
        foreach ($consulta->result() as $value) {
            if ($value->preco && $value->preco != null) {
                return $value->preco;
            } else {
                return 0;
            }
        }
    }

    public function pegaLojasProduto() {// Lista as lojas com Produtos disponiveis
        $this->db->select('id  as idArmaze,narmanze'); //
        $this->db->from('armanzes');
        $this->db->where('armanzes.id !=', 1);
        $this->db->where('armanzes.id !=', 3);
        $this->db->order_by('armanzes.id');
        $consulta = $this->db->get();
        return $consulta->result();
    }

    public function stockLojaArmanze($idProduto, $idArmaze) {
        $this->db->select('qtd'); //
        $this->db->from('stock_quantidade');
        $this->db->where('idproduto', $idProduto);
        $this->db->where('idArmaze', $idArmaze);
        $consulta = $this->db->get();
        return $consulta->result();
    }

    public function mListaVariacaoTamanhoProduto($idProduto) {
        $this->db->select('*'); //
        $this->db->from('variacao_tamanho_produto');
        $this->db->join('variacoes', 'variacao_tamanho_produto.idVariacao = variacoes.idVariacao');
        $this->db->join('variacao_cor', 'variacao_tamanho_produto.idCor = variacao_cor.idCor');
        $this->db->join('variacao_tamanho', 'variacao_tamanho_produto.idTamanho = variacao_tamanho.idTamanho');
        $this->db->where('idproduto', $idProduto);
        //  $this->db->where('variacao_cor.idCor', $idCor);
        $this->db->group_by('variacao_cor.idCor,variacao_tamanho.idTamanho');
        $consulta = $this->db->get();
        return $consulta->result();
    }

    public function stockLojaArmanzeTamanhoProduto($idProduto, $idArmaze, $idTamanho, $idCor) {
        $this->db->select('variacao_tamanho_produto.qtd, armanzes.narmanze'); //
        $this->db->from('variacao_tamanho_produto');
        $this->db->join('armanzes', 'variacao_tamanho_produto.idLoja = armanzes.id');
        $this->db->where('idProduto', $idProduto);
        $this->db->where('idCor', $idCor);
        $this->db->where('idTamanho', $idTamanho);
        $this->db->where('idLoja', $idArmaze);
        $consulta = $this->db->get();
        return $consulta->result();
    }

    public function stockVariacoesProdutos($idProduto, $idCor) {
        $this->db->select_sum('qtd'); //
        $this->db->from('variacao_tamanho_produto');
        $this->db->where('idProduto ', $idProduto);
        $this->db->where('idCor ', $idCor);
        $consulta = $this->db->get();
        foreach ($consulta->result() as $value) {
            if ($value->qtd && $value->qtd != null) {
                return $value->qtd;
            } else {
                return 0;
            }
        }
    }

    public function pega_qtd_todas_lojas($idProduto) {
        $this->db->select_sum('qtd'); //
        $this->db->from('stock_quantidade');
        $this->db->where('idproduto ', $idProduto);
        $consulta = $this->db->get();
        foreach ($consulta->result() as $value) {
            return $value->qtd;
        }
    }

    public function alteraStock($idProduto, $dArmanze, $qtd) {
        $this->db->where('idproduto', $idProduto);
        $this->db->where('idArmaze', $dArmanze);
        $this->db->set('qtd', $qtd);
        $this->db->update('stock_quantidade');
    }

    public function acertos_inventario($idProduto, $idArmanze, $qtAlterar, $qtd) {
        $dados = array(
            'idProduto' => $idProduto,
            'qtd' => $qtd - $qtAlterar,
            'data_acerto' => date('Y-m-d'),
            'idArmanze' => $idArmanze,
        );
        $this->db->insert('acerto_inventario', $dados);
    }

    public function consulta_rececao_stock($datarececcao) {
        $this->db->where('data', $datarececcao);
        $this->db->from('historicostock');
        return $this->db->count_all_results();
    }

    public function consulta_acerto_inventario($data_acerto) {
        $this->db->where('data_acerto', $data_acerto);
        $this->db->from('acerto_inventario');
        return $this->db->count_all_results();
    }

    public function transferirStockm($destino, $idLoja, $idUsuario) {
        $dados = array(
            'destino' => $destino,
            'hora' => date('H:i:s'),
            'data' => date('Y-m-d'),
            'idUsuario' => $idUsuario,
            'idLoja' => $idLoja,
        );
        $this->db->insert('transf_produtos', $dados);
        return $this->db->insert_id();
    }

    public function itemTrasfereStock($idProduto, $qtd, $idTrans) {
        $dados = array(
            'idProduto' => $idProduto,
            'idTrans' => $idTrans,
            'qtd' => $qtd,
        );
        $this->db->insert('transf_produtos_item', $dados);
    }

    public function listarProdutosTransferencia($start, $limit) {
        $this->db->select('*');
        $this->db->from('transf_produtos');
        $this->db->join('usuarios', ' transf_produtos.idUsuario = usuarios.id_usiario');
        $this->db->join('armanzes', ' transf_produtos.idLoja = armanzes.id');
        $this->db->limit($limit, $start);
        $this->db->order_by('idTrans', 'DESC');
        $query = $this->db->get();
        return $query->result();
    }

    public function totalTrasferencia() {
        $this->db->from('transf_produtos');
        return $this->db->count_all_results();
    }

    public function verificaDiponiblidadeArmazem($idProduto, $idLoja) {
        $this->db->select('disponivel');
        $this->db->from('stock_quantidade');
        $this->db->where('idproduto', $idProduto);
        $this->db->where('idArmaze', $idLoja);
        $query = $this->db->get();
        foreach ($query->result() as $value) {
            return $value->disponivel;
        }
    }

    public function getQuantidadeArmazem($idproduto, $idArmaze) {
        $this->db->select('qtd');
        $this->db->from('stock_quantidade');
        $this->db->where('idproduto', $idproduto);
        $this->db->where('idArmaze', $idArmaze);
        $query = $this->db->get();
        return $query->result();
    }

}
