 
<script src="<?php echo base_url(); ?>src/pos/conta_corrente.js"></script>

<style>
    /* Header principal */
    .main-header {
        display: flex;
        justify-content: space-between;
        align-items: center;
        margin-bottom: 20px;
    }
    /* Estilo dos cards */
    .card-info {
        text-align: center;
        padding: 15px;
        border-radius: 8px;
        transition: transform 0.3s ease, box-shadow 0.3s ease;
        height: 180px;
        /* Se desejar ocultar o excesso de conteúdo */
        overflow: hidden;
    }

    .card-info:hover {
        transform: translateY(-5px);
        box-shadow: 0 5px 15px rgba(0,0,0,0.2);
    }
    /* Animação de fade-in para textos */
    .card-info h5, .card-info p {
        opacity: 0;
        animation: fadeIn 0.8s forwards;
    }
    .card-info p {
        animation-delay: 0.2s;
    }
    .card-info h5 {
        animation-delay: 0s;
    }
    @keyframes fadeIn {
        from {
            opacity: 0;
            transform: translateY(10px);
        }
        to {
            opacity: 1;
            transform: translateY(0);
        }
    }
    /* Valores e rótulos */
    .saldo-negativo {
        color: red;
        font-size: 24px;
        font-weight: bold;
    }
    .saldo-positivo {
        color: green;
        font-size: 24px;
        font-weight: bold;
    }
    .valor-label {
        font-size: 0.9rem;
        color: #555;
        margin: 0;
    }
    .valor-destaque {
        font-size: 0.9rem;
        font-weight: bold;
        margin: 0;
        transition: transform 0.2s, color 0.3s;
    }
    .valor-destaque:hover {
        transform: scale(1.1);
        color: #005F9E;
    }
    /* Card 1: Conta Corrente – fundo degradê */
    .card-conta {
        background: linear-gradient(135deg, #d9e4f5, #b3cde0);
        color: #002F5F;
    }
    /* Cards 2, 3 e 4: Adaptação ao modo claro/escuro */
    .card-dark-mode {
        background-color: #f8f9fa;
        color: #333;
    }
    @media (prefers-color-scheme: dark) {
        .card-dark-mode {
            background-color: #343a40;
            color: #f8f9fa;
        }
    }
    /* Header dos cards */
    .card-header {
        padding: 0.5rem;
        text-align: center;
        font-weight: bold;
        color: #fff;
        border-top-left-radius: 8px;
        border-top-right-radius: 8px;
        position: relative;
    }
    .header-hoje    {
        background-color: #17a2b8;
    }
    .header-mes     {
        background-color: #28a745;
    }
    .header-ano     {
        background-color: #ffc107;
        color: #000;
    }
    .header-hoje-alt {
        background-color: #6f42c1;
        color: #fff;
    }
    .header-mes-alt  {
        background-color: #fd7e14;
        color: #fff;
    }
    .header-ano-alt  {
        background-color: #20c997;
        color: #fff;
    }
    /* Botão pequeno transparente para Liquidar Fatura (nos cards 2 e 3) */
    .btn-transparent {
        background-color: transparent;
        border: none;
        color: inherit;
        position: absolute;
        right: 5px;
        top: 50%;
        transform: translateY(-50%);
    }
    .btn-transparent:hover {
        color: #fd7e14;
    }
    /* Linha de botões para ações */
    .btn-group-flex {
        display: flex;
        gap: 10px;
        flex-wrap: wrap;
    }
    /* Estilos padrão */
    .main-header h4 {
        font-size: 1.5rem;
    }
    .main-header button {
        font-size: 1rem;
        padding: 0.5rem 1rem;
    }

    /* Estilos para telas pequenas */
    @media (max-width: 576px) {
        .main-header h4 {
            font-size: 1.2rem; /* Fonte menor em telas pequenas */
        }
        .main-header button {
            font-size: 0.8rem;       /* Botões com fonte menor */
            padding: 0.3rem 0.5rem;   /* Reduzindo os espaçamentos internos */
        }
    }
    /* Sombreamento extra para a modal */
    .modal-content {
        box-shadow: 0 5px 15px rgba(0, 0, 0, 0.5);
    }
    /* Animações e transições para campos e botões */
    .form-control {
        transition: border-color 0.3s, box-shadow 0.3s;
    }
    .form-control:focus {
        border-color: #80bdff;
        box-shadow: 0 0 8px rgba(128,189,255,0.5);
    }
    .btn {
        transition: background-color 0.3s, transform 0.2s;
    }
    .btn:hover {
        transform: scale(1.05);
    }
    .header-entrada-saldo-cliente {
        background-color: #6f42c1;
        color: #fff;
    }
</style>

<main>
    <div class="container-fluid py-4">
        <!-- Header principal -->
        <div class="d-flex flex-column flex-sm-row justify-content-between align-items-center main-header">
            <!--div que recebe o nome da entidade-->
           <div> <h4 class="mb-2 mb-sm-0 nomeDaEntidade2"></strong></h4></div>
            <div>
                <button class="btn btn-outline-primary me-2 mb-2 mb-sm-0 liquiFatura">💰 Liquidar Faturas</button>
                <button class="btn btn-primary me-2 mb-2 mb-sm-0 regularizar">✔ Regularizar</button>
                <button class="btn btn-outline-primary backEntidades"> <i class="fas fa-user-tie"></i> Entidades</button>
            </div>
        </div>


        <!-- Linha dos 4 Cards -->
        <div class="row g-3">
            <!-- Card 1: Conta Corrente -->
            <div class="col-md-3">
                <div class="card card-info shadow-sm card-conta">
                    <div class="card-header header-hoje">Kz</div>
                    <div class="card-body bg-light">
                        <p class="valor-label">Conta Corrente</p>

                    </div>
                </div>
            </div>
            <!-- Card 2: Saldo Total com botão Liquidar Fatura -->
            <div class="col-md-3">
                <div class="card card-info shadow-sm card-dark-mode">
                    <div class="card-header header-mes-alt">

                        Saldo Total
                    </div>
                    <div class="card-body bg-light">
                        <p class="valor-destaque saldo-positivo saldo1">0.00</p>
                        <p class="descricao1">Valor que o cliente não pagou</p>
                    </div>
                </div>
            </div>
            <!-- Card 3: Dívida Corrente com botão Liquidar Fatura -->
            <div class="col-md-3">
                <div class="card card-info shadow-sm card-dark-mode">
                    <div class="card-header header-ano-alt" style="position: relative;">
                        Dívida Corrente
                        <button type="button" class="btn btn-transparent btn-sm" data-bs-toggle="tooltip" data-bs-placement="top" title="Liquidar Fatura" style="position: absolute; bottom: 5px; right: 5px;">
                            <i class="bi bi-cash-coin"></i>
                        </button>
                    </div>
                    <div class="card-body bg-light">
                        <p class="valor-destaque saldo-positivo saldo2">0</p>
                        <p class="descricao2">Não existem pagamentos pendetes</p>
                    </div>
                </div>

            </div>
            <!-- Card 4: Dívida Vencida -->
            <div class="col-md-3">
                <div class="card card-info shadow-sm card-dark-mode">
                    <div class="card-header header-mes">Dívida Vencida</div>
                    <div class="card-body bg-light">
                        <p class="valor-destaque saldo-positivo saldo3">0.00</p>
                        <p class="descricao3">Não existem pagamentos fora do prazo</p>
                    </div>
                </div>
            </div>
        </div>

        <!-- Tabela de movimentações -->
        <div class="table-responsive mt-3">
            <table class="data-table data-table-scrollable responsive" id="tabelaContaCliente">
                <thead class="table-light">
                    <tr>
                        <th width="15%">Data</th>
                        <th width="15%">Designação</th>
                        <th width="15%">Saldo</th>
                        <th width="15%">Dívida no Período</th>
                        <th width="15%">Pagamento no Período</th>
                        <th width="15%">Saldo Total</th>
                    </tr>
                </thead>
                <tbody>


                </tbody>
            </table>
        </div>
</main>
<!--Modal para RegistarSaldo do Cliente-->
<!-- Modal -->
<div class="modal fade modal-right" id="idRegistarSaldoCliente" tabindex="-1" role="dialog" aria-labelledby="idRegistarSaldoClienteLabel" aria-hidden="true">
    <div class="modal-dialog modal-lg" role="document">
        <div class="modal-content">
            <!-- Header principal -->
            <div class="main-header p-3 border-bottom  header-entrada-saldo-cliente">
                <h6 class="mb-0">Registar Saldo</strong></h6>
            </div>
            <!-- Corpo do modal -->
            <div class="modal-body">
                <form id="formRegistarSaldoCliente">
                    <!-- Campo de Data do Movimento -->
                    <div class="form-group">
                        <label for="dataMovimento" class="form-group has-float-label mb-4 position-relative">
                            <input type="date" class="form-control" id="dataMovimento" name="dataMovimento" required>
                            <span>Data do Movimento </span>
                        </label>
                    </div>
                    <!-- Campo de Valor -->
                    <div class="form-group mb-3">
                        <label for="valorSaldo" class="form-group has-float-label mb-4 position-relative">
                            <input type="number" step="0.01" class="form-control" id="valorSaldo" name="valorSaldo" placeholder="Insira o valor" required>
                            <span>Valor </span>
                        </label>
                    </div>
                    <!-- Campo de Tipo de Operação -->
                    <div class="form-group">
                        <label class="form-group has-float-label mb-4 position-relative">
                            <select class="form-control" name="tipoOperacao" id="tipoOperacao">

                            </select>
                            <span>Tipo de Operação</span>
                        </label>
                    </div> 

                    <!-- Campo de Descrição / Observação -->
                    <div class="form-group mb-3">
                        <label for="descricaoSaldo" class="form-group has-float-label mb-4 position-relative">
                            <textarea class="form-control" id="descricaoSaldo" name="descricaoSaldo" rows="3" placeholder="Insira uma descrição"></textarea>
                            <span>Descrição / Observação</span>
                        </label>
                    </div>
                    <!-- Campo de Forma de Pagamento -->
                    <div class="form-group mb-3">
                        <label for="formaPagamento" class="form-group has-float-label mb-4 position-relative">
                            <select class="form-control" id="idFormaPagamento" name="idFormaPagamento">

                            </select>
                            <span> Forma de Pagamento</span>
                        </label>
                    </div>
                    <hr>
                    <button type="button" class="btn btn-outline-danger closeSaldoCliente">
                        <i class="fas fa-times"></i> Cancelar
                    </button>
                    <button  type="submit" class="btn btn-primary adicionar">
                        <i class="fas fa-check"></i> Registar
                    </button>
                </form>
            </div>
           
        </div>
    </div>
</div>

<script>
    document.querySelectorAll('[data-bs-toggle="tooltip"]').forEach(tooltipEl => {
        new bootstrap.Tooltip(tooltipEl);
    });
</script>


