<style>
    /* Remove estilos de foco e hover da linha */
    table tr:focus,
    table tr:hover {
        background-color: transparent; /* Remove o fundo que geralmente aparece no hover */
        outline: none; /* Remove o foco ao redor da linha */
    }

    .icon-action {
        margin-right: 10px;
        color: #333;
        text-decoration: none;
    }

    .icon-action i {
        font-size: 26px;
    }

    /*    .icon-action:hover {
            color: #007bff;  Cor ao passar o mouse 
        }*/
    /* Alterar a aparência do campo de pesquisa */
    .dataTables_filter input {
        width: 300px; /* Largura maior */
        padding: 10px; /* Espaçamento interno */
        border-radius: 20px; /* Bordas arredondadas */
        border: 2px solid #007bff; /* Borda azul */
        outline: none;
    }

    .dataTables_filter input:focus {
        border-color: #28a745; /* Borda verde ao focar */
        box-shadow: 0 0 10px rgba(0, 123, 255, 0.5); /* Sombra ao focar */
    }
    /* Estilização do campo de pesquisa com o ícone de lupa */
    .search-with-icon {
        padding-left: 30px; /* Espaço para o ícone */
        background-image: url('../../src/img/icon/search.png'); /* URL do ícone de lupa */
        background-repeat: no-repeat;
        background-position: 5px center; /* Posição do ícone no campo */
        background-size: 16px 16px; /* Tamanho do ícone */
        border: 1px solid #ced4da; /* Estilização da borda */
        border-radius: 4px; /* Bordas arredondadas */
        height: 35px; /* Altura do campo de pesquisa */
    }
</style>


<main>
    <div class="container-fluid disable-text-selection">
        <div class="row">
            <div class="col-12">
                <div class="mb-2">
                    <h1>Lista de itens</h1>
                    <div class="top-right-button-container">
                        <button type="button" class="btn btn-primary  top-right-button mr-1 faturas">Faturas</button>
                        <div class="btn-group">

                        </div>
                    </div>

                </div>
                <div class="separator mb-5"></div>
            </div>
        </div> 
        <!--        FIM DAA PRIMEIRA DIV ROW QUE MOSTRA OS PRODUCTOS EM LISTA--> 
        <div class="container-fluid">
            <div class="row">
                <!-- Coluna maior (8/12 da tela) -->
                <div class="col-12">

                    <div class="card mb-3">
                        <div class="card-body"> 
                            <table class="table " id="tabelaProdutos"  style="width:100%">
                                <thead>
                                    <tr>
                                        <th width="20%">Desinação</th>
                                        <th width="10%">Stock </th>
                                        <th width="15%">Preço sem Iva</th>
                                        <th width="15%">Taxa%</th>
                                        <th width="10%">Preço com Iva</th>
                                        <th width="10%">Ações</th>
                                    </tr>
                                </thead>
                                <tbody>
                                    <!-- Dados da tabela serão preenchidos aqui -->
                                </tbody>
                            </table>
                        </div>
                    </div>
                </div>
                <!-- Coluna menor (4/12 da tela), alinhado na mesma linha -->
            </div>
        </div>
</main>

<script>
    $(document).ready(function () { 
        $(document).on('click', '.adicionar', function () {// 
             var idProduto = $(this).attr("id");
             localStorage.setItem('idProduto', idProduto);
             var redirect = BASE_URL + 'cPos/caixa?pg=faturas';
             window.location = redirect;
        });
         $(document).on('click', '.faturas', function () {// 
             localStorage.removeItem('idProduto');
             var redirect = BASE_URL + 'cPos/caixa?pg=faturas';
             window.location = redirect;
        });
        // Evento para remover o estilo de foco ao passar o mouse sobre uma linha
        $('table tr').on('mouseover', function () {
            $(this).blur(); // Remove o foco visual
        });

        // Caso queira restaurar algum estilo ao sair da linha
        $('table tr').on('mouseout', function () {
            $(this).css('background-color', ''); // Pode definir outro estilo ou deixar vazio
        });
        $('#tabelaProdutos').DataTable({
            language: {
                search: "" // Remove o texto padrão "Procurar"
            },
            initComplete: function () {
                // Define o placeholder do campo de pesquisa como "Procurar"
                $('#tabelaProdutos_filter input').attr('placeholder', 'Procurar');

                // Adiciona uma classe ao campo de pesquisa para estilização com o ícone
                $('#tabelaProdutos_filter input').addClass('search-with-icon');
            }
        });
        carregaProdutos();
        $(document).on('click', '.itens', function () {
            $("#exampleModalLeft").modal('show');

        });

        function carregaProdutos() {
            if ($.fn.DataTable.isDataTable('#tabelaProdutos')) {
                $('#tabelaProdutos').DataTable().clear().destroy();
            }

            var dataTable = $('#tabelaProdutos').DataTable({
                colReorder: true,
                responsive: true,
                "processing": true,
                "serverSide": true,
                "searching": true,
                "ordering": false,
                "lengthChange": true,
                initComplete: function () {
                    // Adicionar placeholder ao campo de pesquisa
                    $('#tabelaProdutos_filter input').attr('placeholder', 'Procurar');
                    // Adicionar classe personalizada para o ícone de lupa
                    $('#tabelaProdutos_filter input').addClass('search-icon');
                    $('#tabelaProdutos_filter input').css({
                        'padding-left': '30px',
                        'background-image': 'url("../../src/img/icon/search.png")',
                        'background-repeat': 'no-repeat',
                        'background-position': '5px center',
                        'background-size': '16px 16px',
                        'border': '1px solid #ced4da',
                        'border-radius': '4px',
                        'height': '35px'
                    });
                },
                "language": {
                    //   "lengthMenu": "Mostrando _MENU_ registros por página",
                    "lengthMenu": "_MENU_",
                    "zeroRecords": "Nada encontrado",
                    "info": "Mostrando _START_ a _END_ de _TOTAL_ registos",
                    //   info: "", // Define como uma string vazia
                    "infoEmpty": "Nenhum registro disponível",
                    "infoFiltered": "(filtrado de _MAX_ registros no total)",
                    search: "", // Remove o texto padrão "Procurar"
                    "processing": "Processando...",
                    "paginate": {
                        "previous": "Anterior",
                        "next": "Próximo"
                    },
                    "oAria": {
                        "sSortAscending": ": Ativar para ordenar a coluna de forma ascendente",
                        "sSortDescending": ": Ativar para ordenar a coluna de forma descendente"
                    }
                },
                "ajax": {
                    url: BASE_URL + "cItens/lista_itens_grid_pos", // URL da requisição
                    type: "post",
                    "data": function (searchParams) {
                        searchParams.pesquisa = $("#search").val();
                        searchParams.idCategoriaPontoVenda = idCategoriaPontoVenda; // Exemplo de parâmetro de categoria
                        searchParams.idGrupoPreco = idGrupoPreco; // Exemplo de parâmetro de preço mínimo
                    }
                }
            });
        }
    });
</script>


