<style>
    .section-title {
        font-size: 1.25rem;
        font-weight: bold;
        margin-bottom: 10px;
    }
    .thin-hr {
        border-width: 0.5px; /* Ajuste para a espessura desejada */
    }
</style>
<div class="modal fade modal-right" id="modalSagriaSuprimento" tabindex="-1" role="dialog"
     aria-labelledby="exampleModalLeft" aria-hidden="true">
    <div class="modal-dialog modal-lg" role="document">
        <div class="modal-content">
            <div class="modal-body">
                <div class="section-title">Dados da sangria</div>
                <form id="formSangria" novalidate >
                    <input type="hidden"  name="idCaixaAberto"  id="idCaixaAberto">

                    <div class="form-group">
                        <label class="form-group has-float-label mb-4 position-relative error-l-50">
                            <textarea class="form-control" name="motivoSangria" id="motivoSangria"  rows="3"  required />
                            <span>Motivo da sangria</span>
                        </label>
                    </div>
                    <div class="form-group">
                        <label class="form-group has-float-label mb-4 position-relative error-l-50">
                            <input type="number" class="form-control" name="valorSagria" id="valorSagria" required />
                            <span>Valor da sangria</span>
                        </label>
                    </div>
                    <div class="d-flex justify-content-end top-right-button">
                        <button class="btn btn-primary btn-lg btn-shadow" type="submit">Finalizar sangria</button>
                    </div>
                </form>
                <hr class="my-2 border-secondary thin-hr">
                <div class="section-title">Dados de suprimento</div>
                <form id="formSuprimento" novalidate >
                    <input type="hidden"  name="idCaixaAberto"  id="idCaixaAberto">
                    <div class="form-group">
                        <label class="form-group has-float-label mb-4 position-relative error-l-50">
                            <textarea class="form-control" name="motivoSuprimento" id="motivoSuprimento"  rows="3"  required />
                            <span>Motivo do suprimento</span>
                        </label>
                    </div>
                    <div class="form-group">
                        <label class="form-group has-float-label mb-4 position-relative error-l-50">
                            <input type="number" class="form-control" name="valoSuprimento" id="valoSuprimento" required />
                            <span>Valor do suprimento</span>
                        </label>
                    </div>
                    <div class="d-flex justify-content-end top-right-button">
                        <button class="btn btn-primary btn-lg btn-shadow" type="submit">Finalizar suprimento</button>
                    </div>
                </form>
            </div>

        </div>
    </div>
</div>
<!--Fim-->
<script>
    $(document).ready(function () {

        $("#formSangria").validate({
            rules: {
                valvalorSagriaor: {
                    required: true, // Campo obrigatório
                    number: true, // Aceita números decimais
                    pattern: /^[0-9]*\.?[0-9]+$/ // Permite apenas números positivos
                },
                motivoSangria: {
                    required: true,
                    minlength: 5
                }

            },
            messages: {
                valorSagria: {
                    required: "Por favor, insira um número.",
                    number: "Por favor, insira um número válido.",
                    pattern: "Por favor, insira apenas números positivos."
                },
                motivoSangria: {
                    required: "Informe o motivo da sangria",
                    minlength: "Deve ter pelo menos 5 caracteres."
                }

            },
            errorElement: 'div',
            errorClass: 'invalid-feedback',
            highlight: function (element) {
                $(element).addClass('is-invalid'); // Adiciona classe de erro Bootstrap ao campo
            },
            unhighlight: function (element) {
                $(element).removeClass('is-invalid'); // Remove a classe de erro quando válido
            },
            errorPlacement: function (error, element) {
                error.insertAfter(element); // Insere a mensagem de erro logo após o campo
            },

            success: function (label, element) {
                // Remove o tooltip quando o campo for válido
                $(element).next('.error-tooltip').remove();
            },
            submitHandler: function (form) {
                // Chama a função submeteFormLogin quando o formulário for validado com sucesso
                submeteFormSangria();

            }
        });
        function submeteFormSangria() {
            var data = $("#formSangria").serialize(); // a function serialize serve para pegar todos os valores que foram colocados nos inputs do form
            var parametrosAdicionais = {
                idUsuario: idUsuario
            };
// Concatene `data` com os parâmetros adicionais formatados
            data += "&" + $.param(parametrosAdicionais);

            $.ajax({
                // está é a função ajax, do jquery, ela será usada para fazer a requisição assícrona.
                url: BASE_URL + "cfluxocaixa/sangriaCaixa", // aqui vai a url da requisição
                data: data, // aqui vai os dados para o servidor, geralmente são os inputs do form
                method: "POST", // aqui vai o método da requisição, acho que você já sabe sobre o get e post !
                dataType: "json", // aqui será o tipo de resposta que vamos receber, será no formato json, um formato simples e mais usado.
                success: function (data) {
                    // Admin/dashboard?page=dashboard
                    if (data === 'OK') {
                       $("#modalSagriaSuprimento").modal('hide');
                        Swal.fire({
                            icon: 'info', // Tipo do alerta
                            title: 'Informação!',
                            text: "Sangria efectuada" // Mensagem de erro
                        });
                    } else {
                        Swal.fire({
                            icon: 'warning', // Tipo do alerta
                            title: 'Alert!',
                            text: data // Mensagem de erro
                        });
                    }
                },
                error: function () {
                    // Caso ocorra um erro na requisição
                    Swal.fire({
                        icon: 'warning', // Tipo do alerta: aviso
                        title: 'Atenção!',
                        text: 'Ocorreu um erro na comunicação com o servidor.'
//                            imageUrl: 'caminho/para/sua/imagem.png', // URL da imagem de erro
//                            imageWidth: 100,
//                            imageHeight: 100,
//                            imageAlt: 'Imagem de erro'
                    });
                }
            });
        }

        $("#formSuprimento").validate({
            rules: {
                valoSuprimento: {
                    required: true, // Campo obrigatório
                    number: true, // Aceita números decimais
                    pattern: /^[0-9]*\.?[0-9]+$/ // Permite apenas números positivos
                },
                motivoSuprimento: {
                    required: true,
                    minlength: 5
                }

            },
            messages: {
                valoSuprimento: {
                    required: "Por favor, insira um número.",
                    number: "Por favor, insira um número válido.",
                    pattern: "Por favor, insira apenas números positivos."
                },
                motivoSuprimento: {
                    required: "Informe o motivo do suprimento",
                    minlength: "Deve ter pelo menos 5 caracteres."
                }

            },
            errorElement: 'div',
            errorClass: 'invalid-feedback',
            highlight: function (element) {
                $(element).addClass('is-invalid'); // Adiciona classe de erro Bootstrap ao campo
            },
            unhighlight: function (element) {
                $(element).removeClass('is-invalid'); // Remove a classe de erro quando válido
            },
            errorPlacement: function (error, element) {
                error.insertAfter(element); // Insere a mensagem de erro logo após o campo
            },

            success: function (label, element) {
                // Remove o tooltip quando o campo for válido
                $(element).next('.error-tooltip').remove();
            },
            submitHandler: function (form) {
                // Chama a função submeteFormLogin quando o formulário for validado com sucesso
                submeteSuprimento();

            }
        });
        function submeteSuprimento() {
            var data = $("#formSuprimento").serialize(); // a function serialize serve para pegar todos os valores que foram colocados nos inputs do form
            var parametrosAdicionais = {
                idUsuario: idUsuario
            };
// Concatene `data` com os parâmetros adicionais formatados
            data += "&" + $.param(parametrosAdicionais);

            $.ajax({
                // está é a função ajax, do jquery, ela será usada para fazer a requisição assícrona.
                url: BASE_URL + "cfluxocaixa/suprimentoCaixa", // aqui vai a url da requisição
                data: data, // aqui vai os dados para o servidor, geralmente são os inputs do form
                method: "POST", // aqui vai o método da requisição, acho que você já sabe sobre o get e post !
                dataType: "json", // aqui será o tipo de resposta que vamos receber, será no formato json, um formato simples e mais usado.
                success: function (data) {
                    // Admin/dashboard?page=dashboard
                    if (data === 'OK') {
                        $("#modalSagriaSuprimento").modal('hide');
                        Swal.fire({
                            icon: 'info', // Tipo do alerta
                            title: 'Informação!',
                            text: "Suprimento registado" // Mensagem de erro
                        });
                    } else {
                        Swal.fire({
                            icon: 'warning', // Tipo do alerta
                            title: 'alert!',
                            text: data // Mensagem de erro
                        });
                    }
                },
                error: function () {
                    // Caso ocorra um erro na requisição
                    Swal.fire({
                        icon: 'warning', // Tipo do alerta: aviso
                        title: 'Atenção!',
                        text: 'Ocorreu um erro na comunicação com o servidor.'
//                            imageUrl: 'caminho/para/sua/imagem.png', // URL da imagem de erro
//                            imageWidth: 100,
//                            imageHeight: 100,
//                            imageAlt: 'Imagem de erro'
                    });
                }
            });
        }
    });





</script>
