// Mapeamento de países para suas respectivas moedas e códigos de formatação
function verificaMoeda(pais, total) {
    const moedas = {
        'Brasil': {currency: 'BRL', locale: 'pt-BR'},
        'Angola': {currency: 'AOA', locale: 'pt-AO'},
        'Estados Unidos': {currency: 'USD', locale: 'en-US'},
        'Reino Unido': {currency: 'GBP', locale: 'en-GB'},
        'Europa': {currency: 'EUR', locale: 'de-DE'},
        'Japão': {currency: 'JPY', locale: 'ja-JP'}
        // Adicione mais países e moedas conforme necessário
    };

    // Verifica se o país existe no objeto moedas
    if (moedas[pais]) {
        const {currency, locale} = moedas[pais];

        // Formata o total de acordo com a moeda e a localidade
        let totalFormatado = new Intl.NumberFormat(locale, {
            style: 'currency',
            currency: currency,
            minimumFractionDigits: 2
        }).format(total);

        return totalFormatado;
    } else {
        return 'País não suportado'; // Retorna uma mensagem de erro se o país não for encontrado
    }
}

// Mapeamento de países para suas respectivas moedas e códigos de formatação
function moeda(total) {
        // Formata o total de acordo com a moeda e a localidade
        let totalFormatado = new Intl.NumberFormat('pt-AO', {
            style: 'currency',
            currency: 'AOA',
            minimumFractionDigits: 2
        }).format(total);
        return totalFormatado;
}
function moeda2(total) {
    // Formata o total como número decimal com duas casas decimais e separador de milhares
    let totalFormatado = new Intl.NumberFormat('pt-AO', {
        style: 'decimal',
        minimumFractionDigits: 2,
        maximumFractionDigits: 2
    }).format(total);
    return totalFormatado;
}
// Exemplo de uso:
let total = 12345.67;
let pais = 'Angola';
console.log(verificaMoeda(pais, total)); // Saída: "AOA 12.345,67"
