$(document).ready(function () {
    listaDocsAnulados();
    function listaDocsAnulados() {
        if ($.fn.DataTable.isDataTable('#tabelaDocsAnulados')) {
            $('#tabelaDocsAnulados').DataTable().clear().destroy();
        }

        var dataTable = $('#tabelaDocsAnulados').DataTable({
            colReorder: true,
            responsive: true,
            "processing": true,
            "serverSide": true,
            "searching": false,
            "ordering": false,
            "lengthChange": false,
            initComplete: function () {
                // Adicionar placeholder ao campo de pesquisa
                       // Adicionar placeholder ao campo de pesquisa
                const filtersHtml = `
                 <div id="custom-filters" class="mb-3 p-3 border rounded bg-light">
                        <div class="row g-3 align-items-center">
                            <!-- Data Início -->
                            <div class="col-md-2">
                                <label for="filterStartDate" class="form-label">Data Início:</label>
                                <input type="date" id="filterStartDate" class="form-control rounded form-control-sm">
                            </div>

                            <!-- Data Fim -->
                            <div class="col-md-2">
                                <label for="filterEndDate" class="form-label">Data Fim:</label>
                                <input type="date" id="filterEndDate" class="form-control rounded form-control-sm">
                            </div> <!-- Botão Filtrar -->
                            <div class="col-auto ml-auto">
                                <label class="form-label d-block">&nbsp;</label>
                                <button id="filterBtn" class="btn btn-secondary btn-sm ">
                                    <i class="simple-icon-printer"></i> 
                                </button>
                            </div>
                        </div>
                </div> `;
                $('#tabelaDocsAnulados_wrapper').prepend(filtersHtml);
                $('<style>')
                        .prop('type', 'text/css')
                        .html(`
                          .icon-action {
                                margin-right: 10px;
                                
                                text-decoration: none;
                            }

                            .icon-action i {
                                font-size: 18px;
                            }
                        `)
                        .appendTo('head');
                $('#filterSearchField').on('focus', function () {
                    // Limpar o valor de todos os campos de filtro
                    $('#filterSearchField').val('');
                    $('#filterStartDate').val('');
                    $('#filterEndDate').val('');
                    $('#ativo').prop('checked', false); // Definindo o checkbox "Ativo" como marcado
                });
                $('#filterStartDate').on('change', function () {
                    // Limpar o valor de todos os campos de filtro
                    $('#filterSearchField').val('');
                    $('#filterEndDate').val('');
                    $('#ativo').prop('checked', false); // Definindo o checkbox "Ativo" como marcado
                });
                $('#filterBtn').on('click', function () {
                    // Obtenha os valores dos filtros
                    var startDate = $('#filterStartDate').val();
                    var endDate = $('#filterEndDate').val();
                    var ativo = $('#ativo').is(':checked') ? 's' : 'n';
                    var searchTerm = $('#filterSearchField').val();

                    // Verifique se as datas inicial e final foram fornecidas
                    if (startDate && endDate) {
                        // Converta as datas para objetos Date
                        var start = new Date(startDate);
                        var end = new Date(endDate);

                        // Verifique se a data final é maior ou igual à data inicial
                        if (end >= start) {
                            // Se as datas forem válidas, recarregue a tabela com os novos parâmetros
                            dataTable.ajax.reload(null, false);  // O segundo parâmetro "false" mantém a página atual
                        } else {
                            // Caso a data final seja menor que a inicial, mostre uma mensagem de erro
                            alert("A data final deve ser igual ou superior à data inicial.");
                        }
                    } else {
                        // Caso as datas não estejam definidas, exiba uma mensagem de erro
                        alert("Por favor, selecione as datas inicial e final.");
                    }
                });
                // Evento de clique para o botão "Refrescar"
                $('#refreshBtn').on('click', function () {
                    // Resetar os filtros
                    $('#filterStartDate').val('');
                    $('#filterEndDate').val('');
                    $('#ativo').prop('checked', false);  // Resetando o checkbox "Ativo" para "checked"
                    $('#filterSearchField').val('');

                    // Recarregar a tabela com os filtros resetados
                    dataTable.ajax.reload(null, false);  // O segundo parâmetro "false" mantém a página atual
                });
            },
            "language": {
                "lengthMenu": "Mostrando _MENU_ registros por página",
                "zeroRecords": "Nenhum registro encontrado",
                "info": "Mostrando _START_ a _END_ de _TOTAL_ registos",
                "infoEmpty": "Nenhum registro disponível",
                "infoFiltered": "(filtrado de _MAX_ registros no total)",
                search: "", // Remove o texto padrão "Procurar"
                "loadingRecords": "Carregando...",
                "processing": "Processando...",
                "paginate": {
                    "previous": "Anterior",
                    "next": "Próximo"
                },
                "oAria": {
                    "sSortAscending": ": Ativar para ordenar a coluna de forma ascendente",
                    "sSortDescending": ": Ativar para ordenar a coluna de forma descendente"
                },
                error: function (xhr, error, thrown) {
                    console.error("Erro ao carregar dados:", xhr, error, thrown);
                }
            },
            "ajax": {
                url: BASE_URL + "cNotaCredito/listaNotaCredito", // URL da requisição
                type: "post",
                "data": function (searchParams) {
                    searchParams.pesquisa = $("#search").val();
                },
                "dataSrc": function (json) {
                    return json.data; // Onde json.data é o array de dados da tabela
                }
            },
            columns: [

                {data: "numerodocumento"},
                {data: "Referencia"},
                {data: "dataAnulacao",
                    render: function (data, type, row) {
                        // Verificar se a data existe
                        if (data) {
                            // Converter a data para o formato 'dia mês ano'
                            const dateObj = new Date(data);
                            const options = {year: 'numeric', month: 'long', day: 'numeric'};
                            const formattedDate = dateObj.toLocaleDateString('pt-BR', options); // Formato "dia mês ano"

                            // Retornar a data formatada
                            return formattedDate;
                        }
                        return ''; // Caso não haja data, retornar uma string vazia
                    }
                },
                {data: "cliente"},
                {data: "total",
                    render: function (data, type, row) {
                        // Verificar se a data existe
                        if (data) {
                            return moeda(data); // Formato moeda"
                        }
                        return moeda(0); // Caso não haja data, retornar uma string vazia
                    }
                }, {
                    data: null,
                    render: function (data, type, row) {
                        return `
                    <a href="#" class="icon-action printDock" data-id="${row.idNota}" title="Imprimir documento" aria-label="Imprimir documento">
                        <i class="simple-icon-printer"></i>
                    </a>
                    
                        
                `;
                    }
                }
            ]
        });

    }
    // Capturar o clique no botão "Reimprimir fatura"
    $(document).on('click', '.printDock', function (e) {
        e.preventDefault(); // Evitar o comportamento padrão do link
        // Obter o ID da fatura a partir do atributo data-id
        let idNota = $(this).data('id');
        $.ajax({
            type: 'post',
            url: BASE_URL + "cDadosDocPDF/imprimirDocsAnuladosPDF", // Substitua pela URL do seu endpoint
            dataType: 'json',
            data: {
                idNota: idNota
            },
            success: function (response) {
                var produtos = response.produtos;
                var entidade = response.entidade;
                var empresa = response.empresa;
                var detalhesDoc = response.detalhesDoc;
                var dadosBanco = response.dadosBanco;
                var resumoImpostos = response.resumoImpostos;
                $('#loadingModal').removeClass('show').css('display', 'none').attr('aria-hidden', 'true');
                $('body').removeClass('modal-open');
                $('.modal-backdrop').remove();

                //// Adiciona um pequeno atraso antes de chamar imprimeA4
                imprimeNotaCredito(empresa, detalhesDoc, entidade, dadosBanco, resumoImpostos, produtos);

            },
            error: function (xhr, status, error) {
                console.error("Erro ao obter os produtos:", error);
                // Trate o erro como necessário
            }

        });
    });
   
});





