
$(document).ready(function () {

    var currentPage = 1;
    var itemsPerPage = 5; // Inicializa com 5 itens por página
    var totalPages = 0;
    var totalItems = 0;
    carregaArtigos();
    listar_categorias();
    listar_tipo_artigo();
    lista_unidade_medida();
    lista_imposto_cliente();
    motivo_insecao();
    function carregaArtigos() {
        if ($.fn.DataTable.isDataTable('#tabelaArtigos')) {
            $('#tabelaArtigos').DataTable().clear().destroy();
        }
        var dataTable = $('#tabelaArtigos').DataTable({
            colReorder: true,
            responsive: true,
            "processing": true,
            "serverSide": true,
            "searching": true,
            "ordering": false,
            "lengthChange": true,
            initComplete: function () {
                // Adicionar placeholder ao campo de pesquisa
                $('#tabelaArtigos_filter input').attr('placeholder', 'Procurar artigo');
                $('#tabelaProdutos_filter input').css({
                    'padding-left': '30px',
                    'background-image': 'url("' + BASE_PATH + 'src/img/icon/search.png")', // BASE_URL definido no seu script,
                    'background-repeat': 'no-repeat',
                    'background-position': '5px center',
                    'background-size': '16px 16px',
                    'border': '1px solid #ced4da',
                    'border-radius': '20px',
                    'height': '35px'
                });
            },
            "language": {
                "lengthMenu": "Mostrando _MENU_ registros por página",
                "zeroRecords": "Nenhum registro encontrado",
                "info": "Mostrando _START_ a _END_ de _TOTAL_ registos",
                //   info: "", // Define como uma string vazia
                "infoEmpty": "Nenhum registro disponível",
                "infoFiltered": "(filtrado de _MAX_ registros no total)",
                search: "", // Remove o texto padrão "Procurar"
                "loadingRecords": "Carregando...",
                "processing": "Processando...",
                "paginate": {
                    "previous": "Anterior",
                    "next": "Próximo"
                },
                "oAria": {
                    "sSortAscending": ": Ativar para ordenar a coluna de forma ascendente",
                    "sSortDescending": ": Ativar para ordenar a coluna de forma descendente"
                },
                error: function (xhr, error, thrown) {
                    console.error("Erro ao carregar dados:", xhr, error, thrown);
                }
            },
            "ajax": {
                url: BASE_URL + "cArtigos/listarArtigosDataList", // URL da requisição
                type: "post",
                "data": function (searchParams) {
                    searchParams.pesquisa = $("#search").val();
                },
                "dataSrc": function (json) {
                    return json.data; // Onde json.data é o array de dados da tabela
                }
            },
            columns: [
                {
                    data: "produto",
                    render: function (data, type, row) {
                        return `
                                <div class="produto-cell" style="display: flex; align-items: center;">
                                    <div class="dropdown" style="display: inline-block; position: relative;">
                                        <!-- Botão sem fundo e com apenas a seta -->
                                        <button type="button" 
                                            class="btn btn-link dropdown-toggle" 
                                            data-toggle="dropdown" 
                                            aria-haspopup="true" 
                                            aria-expanded="false">
                                            <i class="fa fa-chevron-down"></i> <!-- Ícone de seta para baixo -->
                                        </button>
                                        <div class="dropdown-menu" style="position: absolute; z-index: 9999;">
                                            <a class="dropdown-item codeBar " href="#" data-id="${row.idProduto}"><i class="iconsminds-qr-code">Code Bar</i></a>
                                           
                                            <a class="dropdown-item descricao" href="#" data-id="${row.idProduto}"><i class="iconsminds-pen-2">Descrição do Artigo</i></a>
                                            
                                            <a class="dropdown-item promo" href="#" data-id="${row.idProduto}"><i class="iconsminds-calendar-1">Promoção</i></a>
                                        </div>
                                    </div>
                                    <span class="produto-nome" style="margin-left: 5px;">${data}</span> <!-- Nome do produto -->
                                </div>
                            `;
                    }
                },
                {data: "iva"},
                {data: "codigodebara",
                    render: function (data, type, row) {
                        // Se 'codigodebara' não estiver vazio
                        if (data && data.trim() !== "") {
                            // Cria um elemento <svg> para o código de barras
                            var barcode = $('<svg></svg>');
                            try {
                                // Tenta gerar o código de barras no formato EAN13
                                JsBarcode(barcode[0], data, {
                                    format: "EAN13", // Primeiro tenta com EAN13
                                    displayValue: true, // Mostra o número abaixo do código de barras
                                    width: 1, // Largura das barras
                                    height: 20, // Altura do código de barras
                                    margin: 5             // Margem ao redor do código de barras
                                });
                            } catch (error) {
                                console.warn(`Erro com EAN13: ${error.message}. Tentando com CODE128.`);
                                // Se falhar, tenta com outro formato
                                JsBarcode(barcode[0], data, {
                                    format: "CODE128", // Formato alternativo
                                    displayValue: true,
                                    width: 1,
                                    height: 20,
                                    margin: 5
                                });
                            }

                            return barcode[0].outerHTML; // Retorna o código de barras gerado
                        }

                        return data; // Se estiver vazio, retorna o valor original
                    }
                },
                {data: "referencia"},
                {data: "categoria"},
                {data: "preco"},
                {data: "precoIVA"},
                {
                    data: null,
                    render: function (data, type, row) {
                        return `
                    <a href="#" class="icon-action editar" data-id="${row.idProduto}" title="Editar" aria-label="Editar">
                        <i class="simple-icon-note"></i>
                    </a>
                    <a href="#" class="icon-action eliminar" data-id="${row.idProduto}" title="Eliminar">
                        <i class="simple-icon-trash"></i>
                    </a>
                         <a href="#" class="icon-action stock" data-id="${row.idProduto}" data-artigo="${row.produto}" title="Adicionar stock">
                        <i class="iconsminds-box-close"></i>
                    </a>
                        
                `;
                    }
                }
            ]

        });
    }
    // Delegação de eventos para interações
    $('#tabelaArtigos').on('click', '.dropdown-item', function (e) {
        e.preventDefault();

        const idProduto = $(this).data('id');
        if ($(this).hasClass('codeBar')) {
            alert(`Editar produto ID: ${idProduto}`);
        } else if ($(this).hasClass('descricao')) {
            alert(`Eliminar produto ID: ${idProduto}`);
        } else if ($(this).hasClass('promo')) {
            alert(`Detalhes do produto ID: ${idProduto}`);
        }
    });
// Adiciona validação personalizada ao jQuery Validate
    $.validator.addMethod("requiredIfChecked", function (value, element) {
// Verifica se o checkbox está marcado
        if ($('#iscecao').is(':checked')) {
// O valor do select não pode ser vazio ou null
            return value !== '' && value !== null;
        }
        return true; // Validação passa se o checkbox não estiver marcado
    }, "Este campo é obrigatório quando o Isento IVA está marcado.");
// Atualiza a validação ao alterar o estado do checkbox
    $('#iscecao').change(function () {
        $("#idMotivoIsecao").valid(); // Revalida o campo "Tipo de Isenção"
    });
    $(document).on('click', '.addArtigo', function () {
        listar_categorias();
        listar_tipo_artigo();
        lista_imposto_cliente();
        // Configura o modal
        $("#modalAdicionaArtigo").modal({
            backdrop: 'static', // Impede fechar ao clicar fora
            keyboard: false     // Impede fechar com a tecla "ESC"
        });
        // Limpa o formulário ao abrir o modal
        $('#modalAdicionaArtigo').on('shown.bs.modal', function () {
            let form = $(this).find('form')[0];
            form.reset();
            $('.section-title').text('Registar Artigos');
            $(form).find('.form-control').removeClass('is-invalid'); // Remove estilos de erro
            $(form).find('.invalid-feedback').remove(); // Remove mensagens de erro
        });
        // Configura o validador
        $("#formAdicionaArtigo").validate({
            rules: {
                idTipo: {
                    required: true
                },
                artigo: {
                    required: true,
                    minlength: 3
                },
                venda: {
                    required: true
                },
                idMotivoIsecao: {
                    requiredIfChecked: true // Aplica a regra personalizada
                }
            },
            messages: {
                idTipo: {
                    required: "Por favor, selecione uma opção."
                },
                artigo: {
                    required: "Digite o nome do artigo",
                    minlength: "O nome deve ter pelo menos 3 caracteres."
                },
                venda: {
                    required: "Digite o preço de venda"
                },
                idMotivoIsecao: {
                    requiredIfChecked: "Por favor, selecione um motivo de isenção."
                }
            },
            errorElement: 'div',
            errorClass: 'invalid-feedback',
            highlight: function (element) {
                $(element).addClass('is-invalid');
            },
            unhighlight: function (element) {
                $(element).removeClass('is-invalid');
            },
            errorPlacement: function (error, element) {
                error.insertAfter(element);
            },
            success: function (label, element) {
                $(element).next('.error-tooltip').remove();
            },
            submitHandler: function (form) {
                // Chama a função de envio do formulário
                submeteFormArtigos();
            }
        });
    });
    $(document).on('click', '.fechaModalAdicionaArtigo', function () {
        $("#modalAdicionaArtigo").modal('hide');
    });
    function submeteFormArtigos() {
        var data = $("#formAdicionaArtigo").serialize(); // a function serialize serve para pegar todos os valores que foram colocados nos inputs do form
        $.ajax({
            // está é a função ajax, do jquery, ela será usada para fazer a requisição assícrona.
            url: BASE_URL + "cArtigos/registarArtigos", // aqui vai a url da requisição
            data: data, // aqui vai os dados para o servidor, geralmente são os inputs do form
            method: "POST", // aqui vai o método da requisição, acho que você já sabe sobre o get e post !
            dataType: "json", // aqui será o tipo de resposta que vamos receber, será no formato json, um formato simples e mais usado.
            success: function (data) {
                // Admin/dashboard?page=dashboard
                if (data === 'OK') {
                    $("#modalAdicionaArtigo").modal('hide');
                    $('#tabelaArtigos').DataTable().ajax.reload();
                } else {
                    Swal.fire({
                        icon: 'info', // Tipo do alerta
                        title: 'Informação!',
                        text: data // Mensagem de erro
                    });
                }
            },
            error: function () {
                // Caso ocorra um erro na requisição
                Swal.fire({
                    icon: 'warning', // Tipo do alerta: aviso
                    title: 'Atenção!',
                    text: 'Ocorreu um erro na comunicação com o servidor.'
                });
            }
        });
    }
    function listar_categorias() {// 
        $.ajax({
            url: BASE_URL + "cCategoria/listar_categorias", // aqui vai a url da requisição
            type: 'post',
            dataType: 'json',
            success: function (dados) {
                if (dados.length > 0) {
                    var option = ''; // Inicializa a variável option
                    $.each(dados, function (i, obj) {
                        option += '<option value="' + obj.idCategoria + '">' + obj.categoria + '</option>';
                    });
                    $('#idCategoriaArtigo').html(option).show();
                    // Seleciona automaticamente o primeiro elemento
                    $('#idCategoriaArtigo').val(dados[0].idCategoria);
                } else {
                    // Caso o retorno esteja vazio, mostra uma mensagem padrão
                    option = '<option value="" disabled selected>Nenhuma categoria disponível</option>';
                    $('#idCategoriaArtigo').html(option).show();
                }
            }, error: function () {
// Em caso de erro na requisição AJAX
                var option = '<option value="" disabled selected>Erro ao carregar categorias</option>';
                $('#idCategoriaArtigo').html(option).show();
            }
        });
    }
    function listar_tipo_artigo() {// 
        $.ajax({
            url: BASE_URL + "cArtigos/listaTipoProduto", // aqui vai a url da requisição
            type: 'post',
            dataType: 'json',
            success: function (dados) {
                var option = '<option value="" disabled selected>Selecionar tipo de artigo</option>'; // Adiciona a opção padrão
                if (dados.length > 0) {

                    $.each(dados, function (i, obj) {
                        option += '<option value="' + obj.idTipo + '">' + obj.tipoPr + '</option>';
                    });
                    $('#idTipo').html(option).show();
                    // Seleciona o segundo elemento (índice 1)
                    if (dados.length > 1) {
                        $('#idTipo').val(dados[2].idTipo);
                        // Verifica se a seleção foi bem-sucedida
                        if ($('#idTipo').val() !== dados[2].idTipo) {
                            console.error('Falha ao selecionar o segundo elemento. Verifique os valores.');
                        }
                    } else {
                        // Caso só exista um elemento, seleciona o primeiro
                        $('#idTipo').val(dados[0].idTipo);
                    }
                } else {
                    // Caso o retorno esteja vazio, mostra uma mensagem padrão
                    option = '<option value="" disabled selected>Nenhuma tipo de artigo disponível</option>';
                    $('#idTipo').html(option).show();
                }
            }, error: function () {
// Em caso de erro na requisição AJAX
                var option = '<option value="" disabled selected>Erro ao carregar tipo de artigo</option>';
                $('#idTipo').html(option).show();
            }
        });
    }
    function lista_unidade_medida() {// 
        $.ajax({
            url: BASE_URL + "cArtigos/lista_unidade_medida", // aqui vai a url da requisição
            type: 'post',
            dataType: 'json',
            success: function (dados) {
                if (dados.length > 0) {
                    var option = ''; // Inicializa a variável option
                    $.each(dados, function (i, obj) {
                        option += '<option value="' + obj.idUnidade + '">' + obj.nunidade + '</option>';
                    });
                    $('#idUnidade').html(option).show();
                    // Seleciona automaticamente o primeiro elemento
                    $('#idUnidade').val(dados[5].idUnidade);
                } else {
                    // Caso o retorno esteja vazio, mostra uma mensagem padrão
                    option = '<option value="" disabled selected>Nenhuma unidade de medida disponível</option>';
                    $('#idUnidade').html(option).show();
                }
            }, error: function () {
// Em caso de erro na requisição AJAX
                var option = '<option value="" disabled selected>Erro ao carregar as unidades de medidas</option>';
                $('#idUnidade').html(option).show();
            }
        });
    }
    function motivo_insecao() {// 
        $.ajax({
            url: BASE_URL + "cArtigos/motivo_insecao", // aqui vai a url da requisição
            type: 'post',
            dataType: 'json',
            success: function (dados) {
                var option = '<option value="" disabled selected>Selecione o motivo</option>'; // Adiciona a opção padrão
                if (dados.length > 0) {
                    $.each(dados, function (i, obj) {
                        option += '<option value="' + obj.idMotivoIsecao + '">' + obj.motivo + '</option>';
                    });
                    $('#idMotivoIsecao').html(option).show();
                } else {
                    // Caso o retorno esteja vazio, mostra uma mensagem padrão
                    option = '<option value="" disabled selected>Nenhum iseção disponível</option>';
                    $('#idMotivoIsecao').html(option).show();
                }
            }, error: function () {
// Em caso de erro na requisição AJAX
                var option = '<option value="" disabled selected>Erro ao carregar os motivos de isção de impostos</option>';
                $('#idMotivoIsecao').html(option).show();
            }
        });
    }
    function lista_imposto_cliente() {// 
        $.ajax({
            url: BASE_URL + "cArtigos/listaImpostos", // aqui vai a url da requisição
            type: 'post',
            dataType: 'json',
            success: function (dados) {
                if (dados.length > 0) {
                    var option = ''; // Inicializa a variável option
                    $.each(dados, function (i, obj) {
                        option += '<option value="' + obj.idImposto + '">' + obj.nimposto + '</option>';
                    });
                    $('#idImposto').html(option).show();
                    // Seleciona automaticamente o primeiro elemento
                    //   $('#idImposto').val(dados[5].idImposto);
                } else {
                    // Caso o retorno esteja vazio, mostra uma mensagem padrão
                    option = '<option value="" disabled selected>Nenhum imposto disponível</option>';
                    $('#nimposto').html(option).show();
                }
            }, error: function () {
// Em caso de erro na requisição AJAX
                var option = '<option value="" disabled selected>Erro ao carregar as taxas de impostos</option>';
                $('#idImposto').html(option).show();
            }
        });
    }
    $('#tabelaArtigos tbody').on('click', '.editar', function () {
        var idProduto = $(this).data('id');
        // Configura o modal
        $("#modalAdicionaArtigo").modal({
            backdrop: 'static', // Impede fechar ao clicar fora
            keyboard: false     // Impede fechar com a tecla "ESC"
        });
        // Limpa o formulário ao abrir o modal
        $('#modalAdicionaArtigo').on('shown.bs.modal', function () {
            let form = $(this).find('form')[0];
            $('.section-title').text('Editar Artigos');
            $(form).find('.form-control').removeClass('is-invalid'); // Remove estilos de erro
            $(form).find('.invalid-feedback').remove(); // Remove mensagens de erro
        });
        lista_imposto_cliente();
        pegaDadosArtigoEditar(idProduto);
        // Configura o validador
        $("#formAdicionaArtigo").validate({
            rules: {
                idTipo: {
                    required: true
                },
                artigo: {
                    required: true,
                    minlength: 3
                },
                venda: {
                    required: true
                },
                idMotivoIsecao: {
                    requiredIfChecked: true // Aplica a regra personalizada
                }
            },
            messages: {
                idTipo: {
                    required: "Por favor, selecione uma opção."
                },
                artigo: {
                    required: "Digite o nome do artigo",
                    minlength: "O nome deve ter pelo menos 3 caracteres."
                },
                venda: {
                    required: "Digite o preço de venda"
                },
                idMotivoIsecao: {
                    requiredIfChecked: "Por favor, selecione um motivo de isenção."
                }
            },
            errorElement: 'div',
            errorClass: 'invalid-feedback',
            highlight: function (element) {
                $(element).addClass('is-invalid');
            },
            unhighlight: function (element) {
                $(element).removeClass('is-invalid');
            },
            errorPlacement: function (error, element) {
                error.insertAfter(element);
            },
            success: function (label, element) {
                $(element).next('.error-tooltip').remove();
            },
            submitHandler: function (form) {
                // Chama a função de envio do formulário
                submeteFormArtigosEditar(idProduto)
            }
        });
    });
    function submeteFormArtigosEditar(idProduto) {
        var data = $("#formAdicionaArtigo").serialize(); // a function serialize serve para pegar todos os valores que foram colocados nos inputs do form
        // Concatena a variável extra aos dados do formulário
        var parametrosAdicionais = {
            idProduto: idProduto
        };
        data += "&" + $.param(parametrosAdicionais);
        $.ajax({
            // está é a função ajax, do jquery, ela será usada para fazer a requisição assícrona.
            url: BASE_URL + "cArtigos/editarArtigo", // aqui vai a url da requisição
            data: data, // aqui vai os dados para o servidor, geralmente são os inputs do form
            method: "POST", // aqui vai o método da requisição, acho que você já sabe sobre o get e post !
            dataType: "json", // aqui será o tipo de resposta que vamos receber, será no formato json, um formato simples e mais usado.
            success: function (data) {
                // Admin/dashboard?page=dashboard
                if (data === 'OK') {
                    $("#modalAdicionaArtigo").modal('hide');
                    $('#tabelaArtigos').DataTable().ajax.reload();
                } else {
                    Swal.fire({
                        icon: 'info', // Tipo do alerta
                        title: 'Informação!',
                        text: data // Mensagem de erro
                    });
                }
            },
            error: function () {
                // Caso ocorra um erro na requisição
                Swal.fire({
                    icon: 'warning', // Tipo do alerta: aviso
                    title: 'Atenção!',
                    text: 'Ocorreu um erro na comunicação com o servidor.'
                });
            }
        });
    }
    function pegaDadosArtigoEditar(idProduto) {
        $.ajax({
            type: 'get',
            url: BASE_URL + "cArtigos/pega_artigo_por_id", // Substitua pela URL do seu endpoint
            dataType: 'json',
            data: {
                idProduto: idProduto
            },
            success: function (dados) {

                console.log(dados.produto);
                // $('#idTipo').val(dados.idTipoArtigo);
                $('#artigo').val(dados.produto);
                $('#idCategoriaArtigo').val(dados.idCategoria);
                $('#codeBar').val(dados.codebar);
                $('#referencia').val(dados.referencia);
                $('#idUnidade').val(dados.idUnidade);
//                // Define o estado do switch com base no valor de control de stock
                if (dados.control === 's') {
                    $('#control').prop('checked', true); // Ativa o switch
                } else {
                    $('#control').prop('checked', false); // Desativa o switch
                }
                // Define o estado do switch com base no valor do statu do producto
                if (dados.ativo === 's') {
                    $('#ativo').prop('checked', true); // Ativa o switch
                } else {
                    $('#ativo').prop('checked', false); // Desativa o switch
                }
                // Define o estado do switch com base no satau da data de caducidade
                if (dados.dtcaducidade === 's') {
                    $('#dtcaducidade').prop('checked', true); // Ativa o switch
                } else {
                    $('#dtcaducidade').prop('checked', false); // Desativa o switch
                }
                $('#venda').val(dados.preco);
////              // Checa os checkboxes dos armazéns com base nos valores retornados
                if (dados.armazens && Array.isArray(dados.armazens)) {
                    dados.armazens.forEach(function (armazem) {
                        var checkbox = $('#checkbox_' + armazem.id); // Seleciona o checkbox pelo ID
                        if (armazem.checked === 's') {
                            checkbox.prop('checked', true); // Marca como checado
                        } else {
                            checkbox.prop('checked', false); // Desmarca
                        }
                    });
                }
            },
            error: function (xhr, status, error) {
                console.error("Erro ao obter os produtos:", error);
                // Trate o erro como necessário
            }

        });
    }

// Evento de clique para o botão de eliminar
    $('#tabelaArtigos tbody').on('click', '.eliminar', function () {
        var idProduto = $(this).data('id');
        Swal.fire({
            icon: 'question', // Tipo do alerta: pergunta
            // title: 'Atenção!',
            text: 'Deseja remover  o artigo selecionado',
            showCancelButton: true, // Mostra o botão de "Não"
            confirmButtonText: 'Sim', // Texto do botão de "Sim"
            cancelButtonText: 'Não', // Texto do botão de "Não"
            confirmButtonColor: '#3085d6', // Cor do botão de "Sim"
            cancelButtonColor: '#d33'      // Cor do botão de "Não"
        }).then((result) => {
            if (result.isConfirmed) {
                $.ajax({
                    type: 'post',
                    url: BASE_URL + "cArtigos/eiminarArtigo",
                    data: {idProduto: idProduto
                    },
                    dataType: 'json',
                    success: function (dados) {
                        if (dados === 'OK') {
                            $('#tabelaArtigos').DataTable().ajax.reload();
                        }
                        if (dados === 'N') {
                            Swal.fire({
                                icon: 'warning', // Tipo do alerta: aviso
                                title: 'Atenção!',
                                text: 'O artigo selecionado   não pode ser removido estar já vinculado  a um documento'
                            });
                        }
                    }
                });
            } else if (result.dismiss === Swal.DismissReason.cancel) {
// Ação para quando o usuário clica em "Não"
                console.log('Usuário clicou em Não');
            }
        });
    });
    $("#custo").on("input", function () {
        var custo = parseFloat($(this).val());
        var perDeconto = parseFloat($("#margemLucro").val());
        var multPercentagem = custo * perDeconto;
        var divPercentagem1 = Number(multPercentagem) / '100';
        var total = Number(custo) + Number(divPercentagem1);
        $('#venda').val(total.toFixed(2)).trigger("input"); // Atualiza #venda e dispara o evento input

    });
    $("#margemLucro").on("input", function () {
        var perDeconto = parseFloat($(this).val());
        var custo = parseFloat($("#custo").val());
        var multPercentagem = custo * perDeconto;
        var divPercentagem1 = Number(multPercentagem) / '100';
        var total = Number(custo) + Number(divPercentagem1);
        $('#venda').val(total.toFixed(2));
    });
    $("#idImposto").on("change", function () {
        var idImposto = parseFloat($(this).val());
        $.ajax({
            type: 'get',
            url: BASE_URL + "cArtigos/percentagemImpostos", // Substitua pela URL do seu endpoint
            dataType: 'json',
            data: {
                idImposto: idImposto
            },
            success: function (dados) {

                console.log(dados.produto);
                $('#percentagem').val(dados.percentagem);
                $('#percenteDivisao').val(dados.percenteDivisao);
            },
            error: function (xhr, status, error) {
                console.error("Erro ao obter os produtos:", error);
                // Trate o erro como necessário
            }

        });
    });
    $("#venda").on("input", function () {
        var valor = parseFloat($(this).val());
        var percentagem = $('#percentagem').val();
        var multPercentagem = valor * percentagem;
        var divPercentagem1 = Number(multPercentagem) / '100';
        var prIva = Number(valor) + Number(divPercentagem1);
        $('#taxa').val(divPercentagem1.toFixed(2)).trigger("input"); // Atualiza #venda e dispara o evento input;
        $('#prIVA').val(prIva.toFixed(2)).trigger("input"); // Atualiza #venda e dispara o evento input;
    });
    $("#prIVA").on("blur", function () {
        var valor = parseFloat($(this).val());
        var percenteDivisao = $('#percenteDivisao').val();
        var multPercentagem = valor / percenteDivisao;
        $('#venda').val(multPercentagem.toFixed(2)).trigger("input"); // Atualiza #venda e dispara o evento input
    });
    $('#tabelaArtigos tbody').on('click', '.stock', function () {
        var idProduto = $(this).data('id');
        var artigo = $(this).data('artigo'); // Obtém o nome do artigo
        localStorage.setItem('idProduto', idProduto);
        localStorage.setItem('artigo', artigo);
        var redirect = BASE_URL + 'cPainel/panel?pg=stock_por_produto';
        window.location = redirect;
    });
//    function updatePaginationControls() {
//
//        if (currentPage === 1) {
//            $('.first, .prev').parent().addClass('disabled');
//        } else {
//            $('.first, .prev').parent().removeClass('disabled');
//        }
//
//        if (currentPage === totalPages) {
//            $('.next, .last').parent().addClass('disabled');
//        } else {
//            $('.next, .last').parent().removeClass('disabled');
//        }
//
//        $('.page-item').removeClass('active');
//        $(`.page-item[data-page="${currentPage}"]`).addClass('active');
//
////         Eventos de clique nas páginas
//        $('.page-item[data-page]').off('click').on('click', function (e) {
//            e.preventDefault();
//            var selectedPage = $(this).data('page');
//            if (selectedPage !== currentPage) {
//                currentPage = selectedPage;
//                fetchProducts();  // Carregar os produtos da página selecionada
//            }
//        });
//
//        // Evento de clique na página
//        $('.page-item[data-page]').off('click').on('click', function () {
//            currentPage = $(this).data('page');
//            fetchProducts();
//        });
//
//        $('.first').off('click').on('click', function (e) {
//            e.preventDefault();
//            if (currentPage !== 1) {
//                currentPage = 1;
//                fetchProducts();
//            }
//        });
//
//        $('.last').off('click').on('click', function (e) {
//            e.preventDefault();
//            if (currentPage !== totalPages) {
//                currentPage = totalPages;
//                fetchProducts();
//            }
//        });
//
//        $('.prev').off('click').on('click', function (e) {
//            e.preventDefault();
//            if (currentPage > 1) {
//                currentPage--;
//                fetchProducts();
//            }
//        });
//
//        $('.next').off('click').on('click', function (e) {
//            e.preventDefault();
//            if (currentPage < totalPages) {
//                currentPage++;
//                fetchProducts();
//            }
//        });
//    }
//    function updateItemsInfo() {
//        var startItem = (currentPage - 1) * itemsPerPage + 1;
//        var endItem = Math.min(currentPage * itemsPerPage, totalItems);
//        $('.items-info').text(`Exibindo ${startItem}-${endItem} de ${totalItems} itens`);
//    }
//
//
//
//
//
//// Atualiza o número de itens por página ao selecionar no dropdown
//    $('.dropdown-menu a').on('click', function (e) {
//        e.preventDefault();
//        itemsPerPage = parseInt($(this).text());  // Atualiza o valor de itemsPerPage
//        currentPage = 1;  // Reinicia na primeira página
//        fetchProducts();  // Recarrega os produtos
//        $('.btn-outline-dark').text(itemsPerPage);  // Atualiza o botão com o novo valor
//    });
//
//// Carrega a primeira página
//    fetchProducts();

});


