$(document).ready(function () {
    lista_tipo_movimento();
    lista_tipo_pagamento();
    var idCliente = localStorage.getItem('idEntidadeSaldo');
    getInformacoesContaCliente();

    var nome = localStorage.getItem('nomeEntidade');
    var telefone = localStorage.getItem('telefoneEmpresa');
    atualizarCliente(nome, telefone);
    function atualizarCliente(nome, telefone) {
        nome = nome.toUpperCase(); // Converter para maiúsculas
        // Seleciona o mesmo elemento usando ambas as classes
        let titulo = $("h4.mb-2.nomeDaEntidade2");
        titulo.fadeOut(300, function () {
            $(this).html(`Cliente / <strong>${nome}</strong> <small style="font-size: 14px; color: gray;">(${telefone})</small>`);
            $(this).fadeIn(300);
        });
    }
    $(document).on('click', '.backEntidades', function () {
        var redirect = BASE_URL + 'cPainel/panel?pg=entidades';
        window.location = redirect;
    });
    function getInformacoesContaCliente() {
        $.ajax({
            url: BASE_URL + "cContaCliente/pegaInfoContaCliente",
            data: {idCliente: localStorage.getItem('idEntidadeSaldo')},
            method: 'POST',
            dataType: "json",
            success: function (response) {
                if (response && response.saldos) {
                    var saldos = response.saldos;
                    var $saldo1 = $(".saldo1"),
                            $descricao1 = $(".descricao1"),
                            $saldo2 = $(".saldo2"),
                            $descricao2 = $(".descricao2"),
                            $saldo3 = $(".saldo3"),
                            $descricao3 = $(".descricao3");

                    // Saldo Total
                    if (saldos.saldoTotal > 0) {
                        $saldo1.text(moeda2(saldos.saldoTotal))
                                .removeClass("saldo-negativo")
                                .addClass("saldo-positivo");
                        $descricao1.text("Valor que o cliente não pagou");
                    } else {
                        $saldo1.text(moeda2(saldos.saldoTotal))
                                .removeClass("saldo-positivo")
                                .addClass("saldo-negativo");
                        $descricao1.text("Valor que deve ao cliente");
                    }

                    // Dívidas Correntes
                    if (saldos.dividasCorrente > 0) {
                        $saldo2.text(moeda2(saldos.dividasCorrente));
                        $descricao2.hide();
                    } else {
                        $saldo2.text(moeda2(saldos.dividasCorrente));
                        $descricao2.show();
                    }

                    // Dívida Transitada
                    if (saldos.dividaTransitada > 0) {
                        $saldo3.text(moeda2(saldos.dividaTransitada));
                        $descricao3.hide();
                    } else {
                        $saldo3.text(moeda2(saldos.dividaTransitada));
                        $descricao3.show();
                    }
                } else {
                    console.error("Dados inválidos ou ausentes na resposta.");
                }
            },
            error: function (xhr, status, error) {
                console.error("Erro ao obter os produtos:", error);
            }
        });
    }

    listaContasCorrente();
    function listaContasCorrente() {
        if ($.fn.DataTable.isDataTable('#tabelaContaCliente')) {
            $('#tabelaContaCliente').DataTable().clear().destroy();
        }

        var dataTable = $('#tabelaContaCliente').DataTable({
            colReorder: true,
            responsive: true,
            "processing": true,
            "serverSide": true,
            "searching": false,
            "ordering": false,
            "lengthChange": false,
            initComplete: function () {
                // Adicionar placeholder ao campo de pesquisa
                // Adicionar placeholder ao campo de pesquisa
                const filtersHtml = `
                 <div id="custom-filters" class="mb-3 p-3 border rounded bg-light">
                        <div class="row g-3 align-items-center">
                            <!-- Data Início -->
                            <div class="col-md-2">
                                <label for="filterStartDate" class="form-label">Data Início:</label>
                                <input type="date" id="filterStartDate" class="form-control rounded form-control-sm">
                            </div>

                            <!-- Data Fim -->
                            <div class="col-md-2">
                                <label for="filterEndDate" class="form-label">Data Fim:</label>
                                <input type="date" id="filterEndDate" class="form-control rounded form-control-sm">
                            </div> <!-- Botão Filtrar -->
                            <div class="col-auto ml-auto">
                                <label class="form-label d-block">&nbsp;</label>
                                <button id="filterBtn" class="btn btn-primary">
                                    <i class="fas fa-filter"></i> Pesquisar
                                </button>
                                <button id="filterBtn2" class="btn btn-success">
                                    <i class="fas fa-file-download"></i> Exportar
                                </button>
                            </div>
                        </div>
                </div> `;
                $('#tabelaContaCliente_wrapper').prepend(filtersHtml);
                $('<style>')
                        .prop('type', 'text/css')
                        .html(`
                          .icon-action {
                                margin-right: 10px;
                                
                                text-decoration: none;
                            }

                            .icon-action i {
                                font-size: 18px;
                            }
                        `)
                        .appendTo('head');

                $('#filterStartDate').on('change', function () {
                    // Limpar o valor de todos os campos de filtro
                    $('#filterSearchField').val('');
                    $('#filterEndDate').val('');
                    $('#ativo').prop('checked', false); // Definindo o checkbox "Ativo" como marcado
                });
                $('#filterBtn').on('click', function () {
                    // Obtenha os valores dos filtros
                    var startDate = $('#filterStartDate').val();
                    var endDate = $('#filterEndDate').val();


                    // Verifique se as datas inicial e final foram fornecidas
                    if (startDate && endDate) {
                        // Converta as datas para objetos Date
                        var start = new Date(startDate);
                        var end = new Date(endDate);

                        // Verifique se a data final é maior ou igual à data inicial
                        if (end >= start) {
                            // Se as datas forem válidas, recarregue a tabela com os novos parâmetros
                            dataTable.ajax.reload(null, false);  // O segundo parâmetro "false" mantém a página atual
                        } else {
                            // Caso a data final seja menor que a inicial, mostre uma mensagem de erro
                            alert("A data final deve ser igual ou superior à data inicial.");
                        }
                    } else {
                        // Caso as datas não estejam definidas, exiba uma mensagem de erro
                        alert("Por favor, selecione as datas inicial e final.");
                    }
                });
                // Evento de clique para o botão "Refrescar"
                $('#refreshBtn').on('click', function () {
                    // Resetar os filtros
                    $('#filterStartDate').val('');
                    $('#filterEndDate').val('');
                    $('#ativo').prop('checked', false);  // Resetando o checkbox "Ativo" para "checked"
                    $('#filterSearchField').val('');

                    // Recarregar a tabela com os filtros resetados
                    dataTable.ajax.reload(null, false);  // O segundo parâmetro "false" mantém a página atual
                });
            },
            "language": {
                "lengthMenu": "Mostrando _MENU_ registros por página",
                "zeroRecords": "Nenhum registro encontrado",
                "info": "Mostrando _START_ a _END_ de _TOTAL_ registos",
                "infoEmpty": "Nenhum registro disponível",
                "infoFiltered": "(filtrado de _MAX_ registros no total)",
                search: "", // Remove o texto padrão "Procurar"
                "loadingRecords": "Carregando...",
                "processing": "Processando...",
                "paginate": {
                    "previous": "Anterior",
                    "next": "Próximo"
                },
                "oAria": {
                    "sSortAscending": ": Ativar para ordenar a coluna de forma ascendente",
                    "sSortDescending": ": Ativar para ordenar a coluna de forma descendente"
                },
                error: function (xhr, error, thrown) {
                    console.error("Erro ao carregar dados:", xhr, error, thrown);
                }
            },
            "ajax": {
                url: BASE_URL + "cContaCliente/listarContaCorrente", // URL da requisição
                type: "post",
                "data": function (d) {
                    d.idCliente = idCliente;
                    d.startDate = $("#filterStartDate").val();
                    d.endDate = $("#filterEndDate").val();
                },
                "dataSrc": function (json) {
                    return json.data; // Onde json.data é o array de dados da tabela
                }
            },
            columns: [
                {data: "data",
                    render: function (data, type, row) {
                        // Verificar se a data existe
                        if (data) {
                            // Converter a data para o formato 'dia mês ano'
                            const dateObj = new Date(data);
                            const options = {year: 'numeric', month: 'long', day: 'numeric'};
                            const formattedDate = dateObj.toLocaleDateString('pt-BR', options); // Formato "dia mês ano"

                            // Retornar a data formatada
                            return formattedDate;
                        }
                        return ''; // Caso não haja data, retornar uma string vazia
                    }
                },

                {data: "designacao"},
                {data: "saldo",
                    render: function (data, type, row) {
                        // Verificar se a data existe
                        if (data) {
                            return moeda(data); // Formato moeda"
                        }
                        return moeda(0); // Caso não haja data, retornar uma string vazia
                    }
                },
                {data: "divida",
                    render: function (data, type, row) {
                        // Verificar se a data existe
                        if (data) {
                            return moeda(data); // Formato moeda"
                        }
                        return moeda(0); // Caso não haja data, retornar uma string vazia
                    }
                },

                {data: "pagamento",
                    render: function (data, type, row) {
                        // Verificar se a data existe
                        if (data) {
                            return moeda(data); // Formato moeda"
                        }
                        return moeda(0); // Caso não haja data, retornar uma string vazia
                    }
                },
                {
                    data: "saldoTotal",
                    render: function (data, type, row) {
                        // Se houver dado, formata e aplica cor
                        if (data) {
                            var valorFormatado = moeda(data); // formata para moeda
                            if (data < 0) {
                                return '<span style="color:red;">' + valorFormatado + '</span>';
                            } else {
                                return '<span style="color:green;">' + valorFormatado + '</span>';
                            }
                        }
                        // Caso não haja dado, retorna moeda(0) com cor verde (por exemplo)
                        return '<span style="color:green;">' + moeda(0) + '</span>';
                    }
                }

            ]
        });

    }
    $(document).on('click', '.regularizar', function () {
        $("#idRegistarSaldoCliente").modal({
            backdrop: 'static', // Impede fechar ao clicar fora
            keyboard: false     // Impede fechar com a tecla "ESC"
        });
//        $("#idRegistarSaldoCliente").modal('show');
        $('#idRegistarSaldoCliente').on('shown.bs.modal', function () {
            let form = $(this).find('form')[0];
            form.reset();
            // Define a data de hoje no formato YYYY-MM-DD
            var today = new Date().toISOString().split('T')[0];
            $(this).find('#dataMovimento').val(today);
        });
        // Configura o validador
        $("#formRegistarSaldoCliente").validate({
            rules: {
                dataMovimento: {
                    required: true,
                    date: true
                },
                valorSaldo: {
                    required: true,
                    number: true, // Verifica se é um número válido
                    min: 1, // Define que o valor mínimo é 0.1
                    //  maxQuantity: true // Valida se a quantidade não excede o estoque
                },
                tipoOperacao: {
                    required: true
                },

                descricaoSaldo: {
                    required: true,
                    minlength: 10
                },
                idFormaPagamento: {
                    required: true // Aplica a regra personalizada
                }
            },
            messages: {
                dataMovimento: {
                    required: "Por favor, insira uma data.",
                    date: "Por favor, insira uma data válida."
                },
                valorSaldo: {
                    required: "Digite o valor de adiantamento",
                    number: "Digite um valor numérico válido",
                    min: "O valor deve ser maior que 0",

                },
                tipoOperacao: {
                    required: "Por favor, selecione uma opção."
                },
                descricaoSaldo: {
                    required: "Didite o motivo da operação",
                    minlength: "Deve ter pelo menos 10 caracteres."
                },
                idFormaPagamento: {
                    required: "Por favor, selecione uma opção."
                }

            },
            errorElement: 'div',
            errorClass: 'invalid-feedback',
            highlight: function (element) {
                $(element).addClass('is-invalid');
            },
            unhighlight: function (element) {
                $(element).removeClass('is-invalid');
            },
            errorPlacement: function (error, element) {
                error.insertAfter(element);
            },
            success: function (label, element) {
                $(element).next('.error-tooltip').remove();
            },
            submitHandler: function (form) {
                // Chama a função de envio do formulário
                submeteFormSaldoCliente();
            }
        });
//        ;
    });
    function submeteFormSaldoCliente() {
        var data = $("#formRegistarSaldoCliente").serialize();
        // Concatena a variável extra aos dados do formulário
        var parametrosAdicionais = {
            idCliente: localStorage.getItem('idEntidadeSaldo'),
        };
        data += "&" + $.param(parametrosAdicionais);
        $.ajax({
            // está é a função ajax, do jquery, ela será usada para fazer a requisição assícrona.
            url: BASE_URL + "cContaCliente/regularizar", // aqui vai a url da requisição
            data: data, // aqui vai os dados para o servidor, geralmente são os inputs do form
            method: "POST", // aqui vai o método da requisição, acho que você já sabe sobre o get e post !
            dataType: "json", // aqui será o tipo de resposta que vamos receber, será no formato json, um formato simples e mais usado.
            success: function (data) {
                // Admin/dashboard?page=dashboard
                if (data === 'OK') {
                    $("#idRegistarSaldoCliente").modal('hide');
                    getInformacoesContaCliente();
                    $('#tabelaContaCliente').DataTable().ajax.reload();
                } else {
                    Swal.fire({
                        icon: 'info', // Tipo do alerta
                        title: 'Informação!',
                        text: data // Mensagem de erro
                    });
                }
            },
            error: function () {
                // Caso ocorra um erro na requisição
                Swal.fire({
                    icon: 'warning', // Tipo do alerta: aviso
                    title: 'Atenção!',
                    text: 'Ocorreu um erro na comunicação com o servidor.'
                });
            }
        });
    }
    $(document).on('click', '.closeSaldoCliente', function (e) {
        $('#idRegistarSaldoCliente').modal('hide');
    });
    function lista_tipo_movimento() {// 
        $.ajax({
            url: BASE_URL + "cContaCliente/lista_tipo_movimento", // aqui vai a url da requisição
            type: 'post',
            dataType: 'json',
            success: function (dados) {
                if (dados.length > 0) {
                    var option = ''; // Inicializa a variável option
                    $.each(dados, function (i, obj) {
                        option += '<option value="' + obj.idTipoMovimento + '">' + obj.designacao + '</option>';
                    });
                    $('#tipoOperacao').html(option).show();
                    // Seleciona automaticamente o primeiro elemento
                    //   $('#idImposto').val(dados[5].idImposto);
                } else {
                    // Caso o retorno esteja vazio, mostra uma mensagem padrão
                    option = '<option value="" disabled selected>Nenhum tipo de movimento selecionado</option>';
                    $('#tipoOperacao').html(option).show();
                }
            }, error: function () {
// Em caso de erro na requisição AJAX
                var option = '<option value="" disabled selected>Erro ao carregar os tipos de movimento</option>';
                $('#tipoOperacao').html(option).show();
            }
        });
    }
    function lista_tipo_pagamento() {// 
        $.ajax({
            url: BASE_URL + "cTipoPagamento/listarTipoPagamento", // aqui vai a url da requisição
            type: 'post',
            dataType: 'json',
            success: function (dados) {
                if (dados.length > 0) {
                    var option = ''; // Inicializa a variável option
                    $.each(dados, function (i, obj) {
                        option += '<option value="' + obj.idFormaPagamento + '">' + obj.formaPagamento + '</option>';
                    });
                    $('#idFormaPagamento').html(option).show();
                    // Seleciona automaticamente o primeiro elemento
                    //   $('#idImposto').val(dados[5].idImposto);
                } else {
                    // Caso o retorno esteja vazio, mostra uma mensagem padrão
                    option = '<option value="" disabled selected>Nenhum de forma de pagamento selecionado</option>';
                    $('#idFormaPagamento').html(option).show();
                }
            }, error: function () {
// Em caso de erro na requisição AJAX
                var option = '<option value="" disabled selected>Erro ao carregar as formas de pagamento</option>';
                $('#idFormaPagamento').html(option).show();
            }
        });
    }
  $(document).on('click', '.liquiFatura', function () {
        var redirect = BASE_URL + 'cPainel/panel?pg=liquidar_fatura';
        window.location = redirect;
    });
});






