$(document).ready(function () {
    movimenGraficotoCaixa();
    dividasEmpresa();
    function movimenGraficotoCaixa() {


        $.ajax({
            type: 'post',
            url: BASE_URL + "cGrafico/graficoMovimentoCaixa", // Substitua pela URL do seu endpoint
            dataType: 'json',
            success: function (response) {
                var movMes = response.movMes;
                var movHoje = response.movHoje;
                var movAno = response.movAno;

                $("#recebeHoje").text(moeda2(movHoje.recebidoHoje));
                $("#pagoHoje").text(moeda2(movHoje.pagoHoje));
                $("#resultadoHoje").text(moeda2(movHoje.resultadoHoje));

                $("#recebeMes").text(moeda2(movMes.recebidoMes));
                $("#pagobeMes").text(moeda2(movMes.pagoMes));
                $("#resultadoMes").text(moeda2(movMes.resultadoMes));

                $("#recebeAno").text(moeda2(movAno.recebidoAno));
                $("#pagobeAno").text(moeda2(movAno.pagoAno));
                $("#resultadoAno").text(moeda2(movAno.resultadoAno));

            },
            error: function (xhr, status, error) {
                console.error("Erro ao obter os produtos:", error);
                // Trate o erro como necessário
            }

        });
    }

    function dividasEmpresa() {
        $.ajax({
            type: 'post',
            url: BASE_URL + "cGrafico/graficoDividas", // Substitua pela URL do seu endpoint
            dataType: 'json',
            success: function (response) {
                var dividasHoje = response.dividasHoje;
                var dividasMensal = response.dividasMensal;
                var dividasAno = response.dividasAno;
                graficoDividasHoje(dividasHoje);
                graficoDividasMes(dividasMensal);
                 graficoDividasAno(dividasAno);
            },
            error: function (xhr, status, error) {
                console.error("Erro ao obter os produtos:", error);
                // Trate o erro como necessário
            }

        });
    }


    function graficoDividasHoje(dividasHoje) {
        var pagar = parseFloat(dividasHoje[0].pagarHoje) || 0;
        var receber = parseFloat(dividasHoje[0].receberHoje) || 0;
        var total = pagar + receber;
        var arr = [pagar, receber];

        var canvas = $('#donutChartPagamentos').get(0);
        var donutChartCanvas = canvas.getContext('2d');

        var centerText = document.createElement('div');
        centerText.style.position = 'absolute';
        centerText.style.top = '50%';
        centerText.style.left = '50%';
        centerText.style.transform = 'translate(-50%, -50%)';
        centerText.style.fontSize = '15px';
        centerText.style.fontWeight = 'bold';
        centerText.style.color = '#002F5F';
        centerText.textContent = total > 0 ? ((pagar / total) * 100).toFixed(1) + '%' : '0%';

        $(canvas).parent().css('position', 'relative').append(centerText);

        var donutData = {
            labels: ['A pagar', 'A receber'],
            datasets: [{
                    data: arr,
                    backgroundColor: ['#f56954', '#3c8dbc'],
                    borderColor: "#ffffff",
                    borderWidth: 2
                }]
        };

        var donutOptions = {
            maintainAspectRatio: true,
            responsive: true,
            cutoutPercentage: 70,
            tooltips: {enabled: true}, // 🔹 Remove os valores fixos no gráfico
            plugins: {
                datalabels: {display: false} // 🔹 Remove os valores fixos dentro das fatias
            },
            hover: {
                onHover: function (event, activeElements) {
                    if (activeElements && activeElements.length > 0) {
                        var index = activeElements[0]._index;
                        var value = donutData.datasets[0].data[index];
                        var percent = total > 0 ? ((value / total) * 100).toFixed(1) + '%' : '0%';
                        centerText.textContent = percent; // 🔹 Exibe o valor ao passar o mouse
                    } else {
                        centerText.textContent = total > 0 ? ((pagar / total) * 100).toFixed(1) + '%' : '0%';
                    }
                }
            },
            legend: {
                position: 'top',
                labels: {
                    boxWidth: 10,
                    usePointStyle: true,
                    pointStyle: 'circle',
                    fontSize: 10,
                    fontColor: '#333'
                }
            }
        };

        new Chart(donutChartCanvas, {
            type: 'doughnut',
            data: donutData,
            options: donutOptions
        });
    }
     function graficoDividasMes(dividasMensal) {
        var pagar = parseFloat(dividasMensal[0].pagarMes) || 0;
        var receber = parseFloat(dividasMensal[0].receberMes) || 0;
        var total = pagar + receber;
        var arr = [pagar, receber];

        var canvas = $('#donutChartPagamentosMes').get(0);
        var donutChartCanvas = canvas.getContext('2d');

        var centerText = document.createElement('div');
        centerText.style.position = 'absolute';
        centerText.style.top = '50%';
        centerText.style.left = '50%';
        centerText.style.transform = 'translate(-50%, -50%)';
        centerText.style.fontSize = '15px';
        centerText.style.fontWeight = 'bold';
        centerText.style.color = '#002F5F';
        centerText.textContent = total > 0 ? ((pagar / total) * 100).toFixed(1) + '%' : '0%';

        $(canvas).parent().css('position', 'relative').append(centerText);

        var donutData = {
            labels: ['A pagar', 'A receber'],
            datasets: [{
                    data: arr,
                    backgroundColor: ['#17a2b8', '#ffc107'],
                    borderColor: "#ffffff",
                    borderWidth: 2
                }]
        };

        var donutOptions = {
            maintainAspectRatio: true,
            responsive: true,
            cutoutPercentage: 70,
            tooltips: {enabled: true}, // 🔹 Remove os valores fixos no gráfico
            plugins: {
                datalabels: {display: false} // 🔹 Remove os valores fixos dentro das fatias
            },
            hover: {
                onHover: function (event, activeElements) {
                    if (activeElements && activeElements.length > 0) {
                        var index = activeElements[0]._index;
                        var value = donutData.datasets[0].data[index];
                        var percent = total > 0 ? ((value / total) * 100).toFixed(1) + '%' : '0%';
                        centerText.textContent = percent; // 🔹 Exibe o valor ao passar o mouse
                    } else {
                        centerText.textContent = total > 0 ? ((pagar / total) * 100).toFixed(1) + '%' : '0%';
                    }
                }
            },
            legend: {
                position: 'top',
                labels: {
                    boxWidth: 10,
                    usePointStyle: true,
                    pointStyle: 'circle',
                    fontSize: 10,
                    fontColor: '#333'
                }
            }
        };

        new Chart(donutChartCanvas, {
            type: 'doughnut',
            data: donutData,
            options: donutOptions
        });
    }
    function graficoDividasAno(dividasAno) {
        var pagar = parseFloat(dividasAno[0].pagarAno) || 0;
        var receber = parseFloat(dividasAno[0].receberAno) || 0;
        var total = pagar + receber;
        var arr = [pagar, receber];

        var canvas = $('#donutChartPagamentosAno').get(0);
        var donutChartCanvas = canvas.getContext('2d');

        var centerText = document.createElement('div');
        centerText.style.position = 'absolute';
        centerText.style.top = '50%';
        centerText.style.left = '50%';
        centerText.style.transform = 'translate(-50%, -50%)';
        centerText.style.fontSize = '15px';
        centerText.style.fontWeight = 'bold';
        centerText.style.color = '#002F5F';
        centerText.textContent = total > 0 ? ((pagar / total) * 100).toFixed(1) + '%' : '0%';

        $(canvas).parent().css('position', 'relative').append(centerText);

        var donutData = {
            labels: ['A pagar', 'A receber'],
            datasets: [{
                    data: arr,
                    backgroundColor: ['#6f42c1', '#fd7e14'],
                    borderColor: "#ffffff",
                    borderWidth: 2
                }]
        };

        var donutOptions = {
            maintainAspectRatio: true,
            responsive: true,
            cutoutPercentage: 70,
            tooltips: {enabled: true}, // 🔹 Remove os valores fixos no gráfico
            plugins: {
                datalabels: {display: false} // 🔹 Remove os valores fixos dentro das fatias
            },
            hover: {
                onHover: function (event, activeElements) {
                    if (activeElements && activeElements.length > 0) {
                        var index = activeElements[0]._index;
                        var value = donutData.datasets[0].data[index];
                        var percent = total > 0 ? ((value / total) * 100).toFixed(1) + '%' : '0%';
                        centerText.textContent = percent; // 🔹 Exibe o valor ao passar o mouse
                    } else {
                        centerText.textContent = total > 0 ? ((pagar / total) * 100).toFixed(1) + '%' : '0%';
                    }
                }
            },
            legend: {
                position: 'top',
                labels: {
                    boxWidth: 10,
                    usePointStyle: true,
                    pointStyle: 'circle',
                    fontSize: 10,
                    fontColor: '#333'
                }
            }
        };

        new Chart(donutChartCanvas, {
            type: 'doughnut',
            data: donutData,
            options: donutOptions
        });
    }


});





