$(document).ready(function () {
    if (estadoCaixa === "A") {
        $('#carrinhoDiv').show();
        $('#aberturaCaixa').hide();
    } else {
        $('#carrinhoDiv').hide();
        $('#aberturaCaixa').show();
    }
    toastr.options = {
        "closeButton": true, // Adiciona um botão de fechar
        "debug": false, // Para propósitos de depuração
        "newestOnTop": true, // Exibe as notificações mais recentes no topo
        "progressBar": true, // Exibe uma barra de progresso para duração
        "positionClass": "toast-top-right", // Posição da notificação
        "preventDuplicates": true, // Evita duplicação de notificações
        "onclick": null, // Função de callback ao clicar na notificação
        "showDuration": "300", // Duração do efeito de exibição em ms
        "hideDuration": "1000", // Duração do efeito de ocultação em ms
        "timeOut": "5000", // Tempo que a notificação permanece visível
        "extendedTimeOut": "1000", // Tempo extra ao passar o mouse sobre a notificação
        "showEasing": "swing", // Tipo de efeito ao exibir
        "hideEasing": "linear", // Tipo de efeito ao ocultar
        "showMethod": "fadeIn", // Método de exibição
        "hideMethod": "fadeOut"           // Método de ocultação
    };
    $('#idTipoDocumento').val(2);
    $('#tituloDocumento').text('Factura Recibo');
    $('#abrev').text('FR');
    $('#totalGeral2').text(0);
    $('#totalGeal').text(moeda(0));
    $('#idUsuarioAbrCaixa').val(idUsuario);
    $("#formAberturaCaixa").validate({
        rules: {
            valorCaixa: {
                required: true, // Campo obrigatório
                number: true, // Aceita números decimais
                pattern: /^[0-9]*\.?[0-9]+$/ // Permite apenas números positivos
            }
        },
        messages: {
            valorCaixa: {
                required: "Por favor, insira um número.",
                number: "Por favor, insira um número válido.",
                pattern: "Por favor, insira apenas números positivos."
            }
        },
        errorElement: 'div',
        errorClass: 'invalid-feedback',
        highlight: function (element) {
            $(element).addClass('is-invalid'); // Adiciona classe de erro Bootstrap ao campo
        },
        unhighlight: function (element) {
            $(element).removeClass('is-invalid'); // Remove a classe de erro quando válido
        },
        errorPlacement: function (error, element) {
            error.insertAfter(element); // Insere a mensagem de erro logo após o campo
        },
        success: function (label, element) {
            // Remove o tooltip quando o campo for válido
            $(element).next('.error-tooltip').remove();
        },
        submitHandler: function (form) {
            // Chama a função submeteFormLogin quando o formulário for validado com sucesso
            submeteFormAberturaCaixa();

        }
    });
    function submeteFormAberturaCaixa() {
        var data = $("#formAberturaCaixa").serialize(); // a function serialize serve para pegar todos os valores que foram colocados nos inputs do form
        $.ajax({
            // está é a função ajax, do jquery, ela será usada para fazer a requisição assícrona.
            url: BASE_URL + "cFluxoCaixa/abrirCaixa3", // aqui vai a url da requisição
            data: data, // aqui vai os dados para o servidor, geralmente são os inputs do form
            cache: false, // impede cache da requisição
            method: "POST", // aqui vai o método da requisição, acho que você já sabe sobre o get e post !
            dataType: "json", // aqui será o tipo de resposta que vamos receber, será no formato json, um formato simples e mais usado.
            success: function (data) {
                if (data === 'OK') {
                    $('#carrinhoDiv').show();
                    $('#aberturaCaixa').hide();
                    Swal.fire({
                        icon: 'info', // Tipo do alerta
                        title: 'Informação!',
                        text: 'Caixa aberto'
                    });
                } else {
                    Swal.fire({
                        icon: 'info', // Tipo do alerta
                        title: 'Informação!',
                        text: data
                    });
                }
            },
            error: function () {
                // Caso ocorra um erro na requisição
                Swal.fire({
                    icon: 'warning', // Tipo do alerta: aviso
                    title: 'Atenção!',
                    text: 'Ocorreu um erro na comunicação com o servidor.'
                });
            }
        });
    }



//Modal iten Produtos
    $(document).on('click', '.adicionarModalQtd', function () {// 
        var idProduto = $(this).attr("id");
        $('#idProduto').val(idProduto);
        localStorage.setItem('idProduto', idProduto);
        $("#modalListaProdutos").modal('hide');
        carregaItens(idProduto);
    });
    var tableHeight = $(window).height() * 0.65; // 70% da altura da janela
    function carregaProdutos() {
        if ($.fn.DataTable.isDataTable('#tabelaProdutos')) {
            $('#tabelaProdutos').DataTable().clear().destroy();
        }

        var dataTable = $('#tabelaProdutos').DataTable({
            "scrollY": tableHeight + "px",
            scrollCollapse: true, // Colapsa a tabela se não houver muitas linhas
            colReorder: true,
            responsive: true,
            "processing": true,
            "serverSide": true,
            "searching": true,
            "ordering": false,
            "lengthChange": false,
            initComplete: function () {
                // Adicionar placeholder ao campo de pesquisa
                $('#tabelaProdutos_filter input').attr('placeholder', 'Procurar');
                // Adicionar classe personalizada para o ícone de lupa
                // $('#tabelaProdutos_filter input').addClass('search-with-icon');
                $('#tabelaProdutos_filter input').css({
                    'padding-left': '30px',
                    'background-image': 'url("' + BASE_PATH + 'src/img/icon/search.png")', // BASE_URL definido no seu script,
                    'background-repeat': 'no-repeat',
                    'background-position': '5px center',
                    'background-size': '16px 16px',
                    'border': '1px solid #ced4da',
                    'border-radius': '20px',
                    'height': '35px'
                });
            },
            "language": {
                //   "lengthMenu": "Mostrando _MENU_ registros por página",
                "lengthMenu": "_MENU_",
                "zeroRecords": "Nada encontrado",
                "info": "Mostrando _START_ a _END_ de _TOTAL_ registos",
                //   info: "", // Define como uma string vazia
                "infoEmpty": "Nenhum registro disponível",
                "infoFiltered": "(filtrado de _MAX_ registros no total)",
                search: "", // Remove o texto padrão "Procurar"
                "processing": "Processando...",
                "paginate": {
                    "previous": "Anterior",
                    "next": "Próximo"
                },
                "oAria": {
                    "sSortAscending": ": Ativar para ordenar a coluna de forma ascendente",
                    "sSortDescending": ": Ativar para ordenar a coluna de forma descendente"
                }
            },
            "ajax": {
                url: BASE_URL + "cItens/lista_itens_grid_pos", // URL da requisição
                type: "post",
                "data": function (searchParams) {
                    searchParams.pesquisa = $("#search").val();
                    searchParams.idCategoriaPontoVenda = idCategoriaPontoVenda; // Exemplo de parâmetro de categoria
                    searchParams.idGrupoPreco = idGrupoPreco; // Exemplo de parâmetro de preço mínimo
                }
            }

        });
    }
    $('#procurarItenBr').on('keypress', function (event) {
        // Verifica se a tecla pressionada foi "Enter" (código 13)
        if (event.which === 13) {
            // Impede o comportamento padrão do Enter (evita o submit do formulário)
            event.preventDefault();
            // Obtém o valor do campo
            var pesquisa = $(this).val().trim();
            if (pesquisa !== '') {
                $.ajax({
                    // está é a função ajax, do jquery, ela será usada para fazer a requisição assícrona.
                    url: BASE_URL + "cItens/pegaIdProduto", // aqui vai a url da requisição
                    data: {
                        pesquisa: pesquisa
                    },
                    method: "get", // aqui vai o método da requisição, acho que você já sabe sobre o get e post !
                    dataType: "json", // aqui será o tipo de resposta que vamos receber, será no formato json, um formato simples e mais usado.
                    success: function (data) {
                        if (data.length > 0) {

                            $('#idProduto').val(data[0].idpr);
                            carregaItens(data[0].idpr);
                            document.getElementById('procurarItenBr').value = '';
                        } else {

                            Swal.fire({
                                icon: 'warning', // Tipo do alerta
                                title: 'Alerta!',
                                text: +pesquisa + ' não encontrado'
                            });
                            document.getElementById('procurarItenBr').value = '';
                        }
                    },
                    error: function () {
                        // Caso ocorra um erro na requisição
                        Swal.fire({
                            icon: 'warning', // Tipo do alerta: aviso
                            title: 'Atenção!',
                            text: 'Ocorreu um erro na comunicação com o servidor.'
                        });
                    }
                });
            } else {
                toastr.error("digite o texto desejado no campo de pesquisa", "Erro");
            }
        }
    });
//Fim da modal iten Produtos
    function carregaItens(idProduto) {
        var idPr = localStorage.getItem('idProduto');

        $.ajax({
            type: 'get',
            url: BASE_URL + "cItens/itens_pos",
            data: {
                idProduto: idProduto,
                idCategoriaPontoVenda: idCategoriaPontoVenda,
                idGrupoPreco: idGrupoPreco,
                idLoja: idLoja,
                //   idProduto: idProduto,
            },
            dataType: 'json',
            success: function (dados) {
                $('.modal-backdrop').remove();
                $("#exampleModalLeft").modal({
                    backdrop: 'static', // Impede fechar ao clicar fora
                    keyboard: false     // Impede fechar com a tecla "ESC"
                });
                $('#exampleModalLeft').on('shown.bs.modal', function () {
                    $('#qtd').trigger('focus');
                    $('#qtd').val('');
                });
                $('#produto').val(dados[0].produto);
                $('#desconto').val(dados[0].desconto);
                if (idRegime === '1') {
                    $('#preco').val(dados[0].precoIva);
                    $('#custo').val(dados[0].precoIva);
                } else {
                    $('#preco').val(dados[0].preco);
                    $('#custo').val(dados[0].preco);
                }
                $("#SemIva").val(dados[0].preco);
                $('#precoIva').val(dados[0].precoIva);
                $('#control').val(dados[0].control);
                $('#stock').val(dados[0].stock);
                $('#tipo').val(dados[0].tipo);
                $('#iva').val(dados[0].iva);
                $('#total2').val(moeda(0));
                $('#imposto').val(moeda(0));


            }
        });
    }
    $(document).on('click', '.itens', function () {
        $('#action').val('gravar');
        $("#modalListaProdutos").modal('show');
        carregaProdutos();
//        if ($("#idFatura").val() === '0') {
//            $('#action').val('gravar');
//            $("#modalListaProdutos").modal('show');
//            carregaProdutos();
//        } else {
//            toastr.warning('Clique em novo documento para poder emitir outro', 'Alert');
//        }
    });
    function mostrarAlerta(qtd) {
        $('.adicionar').prop('disabled', true);
        if (qtd > 0) {
            $('#alerta-stock').fadeIn();
            setTimeout(function () {
                $('#alerta-stock').fadeOut();
            }, 4000); // 10000 milissegundos = 10 segundos
        }
    }
    function calculaTotal() {
        $('#precoIva').val();
    }

    $("#qtd").on("input", function () {
        var qtd = parseFloat($(this).val());
        $('#precoActual').val($("#SemIva").val());
        var preco = $("#SemIva").val();
        var control = $("#control").val();
        var stock = parseFloat($("#stock").val());
        var tipo = $("#tipo").val();
        var iva = $("#iva").val();
        var custo = $("#custo").val();
        var desconto = $("#desconto").val();
        if (tipo === '3' && control === 's' && stock >= qtd && qtd > '0') {// se for um produto e com control de stock
            var percetagemdesconto = desconto;
            var custoinicial = preco;
            var descontoPercentagem = custoinicial * percetagemdesconto;
            var descontoPercentagem1 = Number(descontoPercentagem) / '100';
            var custoComDesconto = custoinicial - descontoPercentagem1;
            // calculo do iva
            var totalSemIva = qtd * custoComDesconto;
            var ivaPercentagem = iva;
            var calcIva = totalSemIva * ivaPercentagem;
            var iva = Number(calcIva) / '100';
            var total = Number(totalSemIva) + Number(iva);
            // Formatar o valor com a moeda Kwanza (AOA)

            let ivaFormatado = new Intl.NumberFormat('pt-AO', {
                style: 'currency',
                currency: 'AOA',
                minimumFractionDigits: 2
            }).format(iva);
            let totalGeral = new Intl.NumberFormat('pt-AO', {
                style: 'currency',
                currency: 'AOA',
                minimumFractionDigits: 2
            }).format(total);
            $('#total').val(total.toFixed(2));
            $('#imposto').val(ivaFormatado);
            $('#total2').val(totalGeral);
            $('.adicionar').prop('disabled', false);
        } else if (tipo === '3' && control === 'n' && qtd > '0') {/// se  for um produto mas sem control de stock


            var percetagemdesconto = desconto;
            var custoinicial = preco;
            var descontoPercentagem = custoinicial * percetagemdesconto;
            var descontoPercentagem1 = Number(descontoPercentagem) / '100';
            var custoComDesconto = custoinicial - descontoPercentagem1;
            // calculo do iva
            var totalSemIva = qtd * custoComDesconto;
            var ivaPercentagem = iva;
            var calcIva = totalSemIva * ivaPercentagem;
            var iva = Number(calcIva) / '100';
            var total = Number(totalSemIva) + Number(iva);
            // Formatar o valor com a moeda Kwanza (AOA)

            let ivaFormatado = new Intl.NumberFormat('pt-AO', {
                style: 'currency',
                currency: 'AOA',
                minimumFractionDigits: 2
            }).format(iva);

            $('#total').val(total.toFixed(2));
            $('#imposto').val(ivaFormatado);
            $('#total2').val(moeda(total));
            $('.adicionar').prop('disabled', false);
        } else if (tipo === '2') {// se for um serviço

            var total = qtd * custo;
            var total2 = Ext.Number.toFixed(total, 2)
            var total2 = Ext.Number.toFixed(total, 2)
            format = "0,000.00";
            Ext.util.Format.thousandSeparator = ".";
            Ext.util.Format.decimalSeparator = ",";
            var t = Ext.util.Format.number(total2, format);
//                frmDadosProduto.down('#total').setValue(total2);
//                frmDadosProduto.down('#total3').setValue(t);
//                frmDadosProduto.down('#taxa').setValue(Ext.util.Format.number(iva, format));
            $('.adicionar').prop('disabled', false);
        } else {
            // Chamar a função para exibir o alerta
            var preco = $('#preco').val();
            if (stock < qtd || qtd === '0' || qtd === '' || preco === '0' || preco === '') {
                $('.adicionar').prop('disabled', true);
                $('#total2').val('');
                $('#imposto').val(moeda(0));
            }
            mostrarAlerta(qtd);

        }


    });
    $("#preco").on("input", function () {
        var preco = parseFloat($(this).val());
        var qtd = parseFloat($(this).val());
        if (!isNaN(preco) && preco > 0 && !isNaN(qtd) && qtd > 0) {
            $('.adicionar').prop('disabled', false);
        } else {
            $('.adicionar').prop('disabled', true);
            $('#total2').val(moeda(0));
            $('#imposto').val(moeda(0));
        }
    });
    // Iniciar nova venda
    function nova_venda() {
        $.ajax({
            type: 'post',
            url: BASE_URL + "cFaturas/novoDocumento",
            data: {idUsuario: idUsuario,
            },
            dataType: 'json',
            success: function (dados) {
                localStorage.setItem('IdVenda', dados);
                carrinho();
            }
        });
    }
    function carrinho() {
        $.ajax({
            type: 'post',
            url: BASE_URL + "cFaturas/corrinho",
            data: {
                total: $('#total').val(),
                custo: $('#precoActual').val(),
                idProduto: $('#idProduto').val(),
                desconto: $('#desconto').val(),
                iva: $('#iva').val(),
                qtd: $('#qtd').val(),
                imei: $('#imei').val(),
                sim: $('#sim').val(),
                idVenda: localStorage.getItem('IdVenda'),
                action: $('#action').val(),
                iditem: $('#idItem').val(),
                idGrupoPreco: idGrupoPreco
            },
            dataType: 'json',
            success: function (data) {
                if (data === 'OK') {
                    localStorage.removeItem('idProduto');
                    $('#exampleModalLeft').modal('hide'); // Fecha o modal manualmente
                    $('#exampleModalLeft').on('hidden.bs.modal', function () {
//                        Resetar campos de entrada dentro do modal
                        $('#exampleModalLeft input').val(''); // Limpa todos os inputs
                        $('#exampleModalLeft select').val(''); // Limpa todos os selects
                        $('#exampleModalLeft textarea').val(''); // Limpa todos os textareas
                        // Resetar checkboxes e botões de rádio (radio buttons)
                        //  $('#exampleModalLeft input[type="checkbox"]').prop('checked', false).prop('disabled', true);
                        $('#exampleModalLeft input[type="checkbox"]').prop('checked', false);
                        $('#adicionar').prop('disabled', true);
                    });
                    $('#tabelaListaIntensCarrinho').DataTable().ajax.reload();
//                    carregaItensCarrinho();
                } else {
//                    
                }
            }, error: function () {

            }
        });
    }
    function resetarDados() {
        localStorage.removeItem('IdVenda'); // ou ""  
        localStorage.removeItem('idCliente');
        document.getElementById('entidade').value = '';
        localStorage.removeItem('idProduto');
        $('#totalLinha').text('Prod 0/ 0 Unid');
        $('#idTipoDocumento').val(2);
        $('#tituloDocumento').text('Factura Recibo');
        $('#abrev').text('FR');
        $('#fatura-recibo').prop('checked', true);
        document.getElementById('procurarItenBr').value = '';

        $('#totalGeral2').text(0);
        $('#totalGeal').text(moeda(0));
        $("#idFatura").val(0);
        // Primeiro, limpar e destruir a instância existente da tabela
        $('#tabelaListaIntensCarrinho').DataTable().clear().draw();
    }
    $(document).on('click', '.criarNovoDocumento', function () {// 
        resetarDados();
    });
    function adicionaItenCarrinho() {
        const IdVenda = localStorage.getItem('IdVenda');
        if (IdVenda === null || IdVenda === '' || IdVenda === 'null') {
            nova_venda();
        } else {
            carrinho();
        }
    }
    $(document).on('click', '.adicionar', function () {
        adicionaItenCarrinho();
    });
    $('#qtd').on('keypress', function (event) {
        // Verifica se a tecla pressionada foi "Enter" (código 13)
        if (event.which === 13) {
            // Impede o comportamento padrão do Enter (evita o submit do formulário)
            event.preventDefault();
            // Obtém o valor do campo
            // Verifica se o campo está vazio ou contém conteúdo inválido
            var preco = parseFloat($(this).val());
            var qtd = parseFloat($(this).val());
            if (!isNaN(preco) && preco > 0 && !isNaN(qtd) && qtd > 0) {
                adicionaItenCarrinho();
            }
        }
    });
    carregaItensCarrinho();
    function carregaItensCarrinho() {
        $('#tabelaListaIntensCarrinho').DataTable().clear().destroy();

        var dataTable = $('#tabelaListaIntensCarrinho').DataTable({
            dom: '<"top"i>rt', // Remove a busca (s) e exibe apenas informações (i) e a tabela (t)
            scrollY: '200px', // Define a altura da rolagem vertical
            scrollX: true, // Ativa a rolagem horizontal
            scrollCollapse: true, // Colapsa a tabela se não houver muitas linhas
            paging: false,
            ordering: false, // Desativa a ordenação
            info: false, // Remove a mensagem de informações
            language: {
                "decimal": ",",
                "thousands": ".",
                "emptyTable": " ",
                "loadingRecords": "Carregando...",
                "processing": "Processando...",
                "zeroRecords": "Nenhum registro encontrado"
            },
            "ajax": {
                url: BASE_URL + "cFaturas/listaItemCarrinho2", // URL da requisição
                type: "post",
                "data": function (searchParams) {
                    searchParams.idVenda = localStorage.getItem('IdVenda');
                    searchParams.idLoja = idLoja;
                    searchParams.idUsuario = idUsuario;
                },
                "dataSrc": function (json) {
                    // Aqui você pode capturar outros dados do retorno, como o total
                    if (json.totalLinha) {
                        // Exibe o total retornado no local desejado
                        $('#totalLinha').text(json.totalLinha);
                        $('#totalLinha2').text(json.totalLinha);
                        $('#totalItens3').text(json.totalLinha);
                    }
                    if (json.totalGeral) {
                        // Exibe o total retornado no local desejado  
                        $('#totalGeral2').val(json.totalGeral);
                        $('#totalGeal').text(moeda(json.totalGeral));
                        $('#pendente').text(moeda(json.totalGeral));
                        $('#pendente2').val(json.totalGeral);
                    }

                    // Retorna os dados para a tabela
                    return json.data; // Onde json.data é o array de dados da tabela
                }
            },

            columns: [
                {data: "produto"},
                {data: "custo"},
                {data: "desconto"},
                {data: "qtd"},
                {data: "iva"},
                {data: "total"},
                {
                    data: null,
                    render: function (data, type, row) {
                        return `
                    <a href="#" class="icon-action editar" data-id="${row.idProduto}" title="Editar">
                        <i class="simple-icon-note"></i>
                    </a>
                    <a href="#" class="icon-action eliminar" data-id="${row.idProduto}" title="Eliminar">
                        <i class="iconsminds-remove-cart"></i>
                    </a>
                `;
                    }
                },
                {data: "stock", visible: false},
                {data: "idTipo", visible: false},
                {data: "idItem", visible: false}
            ],
//            
            createdRow: function (row, data, dataIndex) {
                // Adiciona a classe p-0 em todas as células <td> de cada linha criada
                $(row).find('td').addClass('p-1');
            }

        });
    }
    $(document).on('click', '.fechaModal', function () {
        $('#exampleModalLeft').modal('hide'); // Fecha o modal manualmente
        $('#exampleModalLeft').on('hidden.bs.modal', function () {
//                        Resetar campos de entrada dentro do modal
            $('#exampleModalLeft input').val(''); // Limpa todos os inputs
            $('#exampleModalLeft select').val(''); // Limpa todos os selects
            $('#exampleModalLeft textarea').val(''); // Limpa todos os textareas
            // Resetar checkboxes e botões de rádio (radio buttons)
            //  $('#exampleModalLeft input[type="checkbox"]').prop('checked', false).prop('disabled', true);
            $('#exampleModalLeft input[type="checkbox"]').prop('checked', false);
            $('#adicionar').prop('disabled', true);
        });
    });
    // Evento de clique para o botão de editar
    $('#tabelaListaIntensCarrinho tbody').on('click', '.editar', function () {
        $('#action').val('editar');
        var table = $('#tabelaListaIntensCarrinho').DataTable();
        var rowData = table.row($(this).closest('tr')).data();
        var idProduto = rowData.idProduto; // Acessa idProduto diretamente
        $('#idItem').val(rowData.idItem);
        console.log("Editar:", rowData);
        localStorage.setItem('idProduto', idProduto);
        $('#adicionar').prop('disabled', true);
        carregaItens(idProduto);

    });

    // Evento de clique para o botão de eliminar
    $('#tabelaListaIntensCarrinho tbody').on('click', '.eliminar', function () {
        var table = $('#tabelaListaIntensCarrinho').DataTable();
        var rowData = table.row($(this).closest('tr')).data();
        var produto = rowData.produto;
        var idItem = rowData.idItem;
        Swal.fire({
            icon: 'question', // Tipo do alerta: pergunta
            // title: 'Atenção!',
            text: 'Deseja remover -' + ' ' + produto + '?',
            showCancelButton: true, // Mostra o botão de "Não"
            confirmButtonText: 'Sim', // Texto do botão de "Sim"
            cancelButtonText: 'Não', // Texto do botão de "Não"
            confirmButtonColor: '#3085d6', // Cor do botão de "Sim"
            cancelButtonColor: '#d33'      // Cor do botão de "Não"
        }).then((result) => {
            if (result.isConfirmed) {
                $.ajax({
                    type: 'post',
                    url: BASE_URL + "cFaturas/removeItemCarrinha2",
                    data: {iditem: idItem
                    },
                    dataType: 'json',
                    success: function (dados) {
                        if (dados === 'ok') {
                            $('#tabelaListaIntensCarrinho').DataTable().ajax.reload();
                        }
                        if (dados === 'cancelada') {
                            resetarDados();
                        }
                    }
                });
            } else if (result.dismiss === Swal.DismissReason.cancel) {
                // Ação para quando o usuário clica em "Não"
                console.log('Usuário clicou em Não');
            }
        });

    });
    $("#entidade").autocomplete({
        source: function (request, response) {
            $.ajax({
                url: BASE_URL + "cCliente/lista_entidades_txt_search",
                type: 'GET',
                dataType: 'json',
                data: {term: request.term},
                success: function (dados) {
                    if (dados && dados.length > 0) {
                        localStorage.removeItem('idCliente');
                        response($.map(dados, function (obj) {
                            return {
                                label: obj.nome, // Nome do paciente
                                value: obj.idcliente // ID do paciente
//                                nascimento: obj.nascimento // Data de nascimento do paciente
                            };
                        }));
                    } else {
                        console.warn("Nenhum dado encontrado.");
                    }
                },
                error: function (xhr, status, error) {
                    console.error("Erro no autocomplete:", error);
                    console.log("Resposta do servidor:", xhr.responseText);
                }
            });
        },
        minLength: 2,
        select: function (event, ui) {
            console.log("Paciente selecionado:", ui.item.value);
            var idcliente = ui.item.value;

            $.ajax({
                url: BASE_URL + "cCliente/pega_dados_cliente_tooltip",
                type: 'GET',
                dataType: 'json',
                data: {idCliente: idcliente},
                success: function (dados) {

                    console.log("Dados do paciente:", dados);
                    if (dados.length > 0) {
                        ;
                        populateTextInput(dados);
                    }
                },
                error: function (xhr, status, error) {
                    console.error("Erro na requisição do  cliente:", error);
                }
            });
        }
    });
    // 
    pegaDadosClientes();
    function pegaDadosClientes() {//  Carregar os dados de entidade seleciona 
        $.ajax({
            url: BASE_URL + "cCliente/pega_dados_cliente_tooltip",
            type: 'GET',
            dataType: 'json',
            data: {
                idCliente: localStorage.getItem('idCliente')
            },
            success: function (dados) {

                console.log("Dados do paciente:", dados);
                if (dados.length > 0) {
                    ;
                    populateTextInput(dados);
                }
            },
            error: function (xhr, status, error) {
                console.error("Erro na requisição do  cliente:", error);
            }
        });
    }

    function populateTextInput(dados) {
        $('#entidade').val(dados[0].nome); // Preenche o campo de nome
        $('#idCliente').val(dados[0].idcliente); // Preenche o campo de idade
        // Adicione outros campos conforme necessário
    }
    // Abre a modal com o tipo de documento
    $(document).on('click', '.tipoDoc', function () {
        $("#modalTipoDocumento").modal('show');
    });
    // Abre a modal com o tipo de documento
    $(document).on('click', '.abrev', function () {
        $("#modalTipoDocumento").modal('show');
    });

    // Quando um radio button for selecionado
    $('input[name="documento"]').on('change', function () {
        // Pega o valor do radio selecionado
        var idTipoDoc = $('input[name="documento"]:checked').val();

        $('#idTipoDocumento').val(idTipoDoc);
        if (idTipoDoc === '1') {
            $("#modalTipoDocumento").modal('hide');
            $('#tituloDocumento').text('Factura');
            $('#abrev').text('FT');
        }
        if (idTipoDoc === '2') {
            $("#modalTipoDocumento").modal('hide');
            $('#tituloDocumento').text('Factura Recibo');
            $('#abrev').text('FR');
        }
        if (idTipoDoc === '3') {
            $("#modalTipoDocumento").modal('hide');
            $('#tituloDocumento').text('Factura Pró-Forma');
            $('#abrev').text('PP');
        }
        if (idTipoDoc === '4') {
            $("#modalTipoDocumento").modal('hide');
            $('#tituloDocumento').text('Orçamento');
            $('#abrev').text('OR');
        }
        if (idTipoDoc === '5') {
            $("#modalTipoDocumento").modal('hide');
            $('#tituloDocumento').text('Guia de Remessa');
            $('#abrev').text('GR');
        }
    });
    // Quando um radio button do  formato de documento é checado
    $('input[name="formato"]').on('change', function () {
        // Pega o valor do radio selecionado
        var idFormato = $('input[name="formato"]:checked').val();
        $('#idFormato').val(idFormato);
        $('#collapseFormato').collapse('hide');
        if (idFormato === '1') {
            $('#nomeFormato').text('A4');

        }
        if (idFormato === '3') {
            $('#nomeFormato').text('Ticket');

        }
    });
    function finalizaDocumentos() {
        var idTipoDocumento = ($('#idTipoDocumento').val());
        var idFatura = $('#idFatura').val();
        if (idFatura === '0') {
            if (idTipoDocumento === '1') {// se for fatura
                var datapagamento = $('#dataPagamento').val();
                if (datapagamento === '' || datapagamento === null) {
                    Swal.fire({
                        icon: 'error', // Tipo do alerta: aviso
                        title: 'Erro!',
                        text: 'Selecionar a data de vencimento'
                    });
                } else if ($('#idCliente').val() === '' || $('#idCliente').val() === '0') {
                    Swal.fire({
                        icon: 'error', // Tipo do alerta: aviso
                        title: 'Erro!',
                        text: 'O cliente selecionado não é válido para este tipo de documento'
                    });
                } else {
                    finalizarDocFaturas();
                }
            }
            if (idTipoDocumento === '2') { // se for fatura_recibo

                $("#detalhesPagamentoModal").modal('show');
                var total = $('#totalGeral2').val();
                $('#totalGeral3').text(moeda(total));
                $('#trocoInPut').val(total);
                $('#troco').text(moeda(0));
            }
            if (idTipoDocumento === '3') {// Factura Pró-forma
                finalizarFaturaProforma();
            }
            if (idTipoDocumento === '4') {// Factura Pró-forma
                finalizarOrcamento();
            }
        } else {
            dadosFaturaFrFtParaPdf(idFatura);
        }

    }
    $(document).on('click', '.finalizarDocumento', function () {

        var idVenda = localStorage.getItem('IdVenda');
        if (idVenda === '0' || idVenda === null || idVenda === 'null') {
            toastr.warning('Tens de adicionar os itens no carrinho para poder finalizar um documento', 'Alert');
        } else {
            finalizaDocumentos();
        }
    });
    $('#switchS').on('change', function () {
        let isChecked = $(this).prop('checked');
        if (isChecked) {
            $('#preco').prop('readonly', false); // Adiciona o atributo "readonly"
            $('#preco').val('');
            $('#qtd').val('');

            $('.adicionar').prop('disabled', true);
        } else {
            var custoProdutoBd = $('#custo').val();
            $("#SemIva").val(custoProdutoBd);
            $('#preco').val(custoProdutoBd);
            $('#precoActual').val(custoProdutoBd); // Adiciona o atributo "readonly"
            $('#preco').prop('readonly', true); // Adiciona o atributo "readonly"
            $('#qtd').val('');
            $('.adicionar').prop('disabled', true);
        }
        console.log(isChecked); // Retorna true se checado, false caso contrário
    });
    $('#preco').on('input', function () {
        var custoDigitado = $('#preco').val();
        $('#precoActual').val(custoDigitado); // Adiciona o atributo "readonly"
        $("#SemIva").val(custoDigitado);
    });
    $('input[name="metodoPagamento"]').on('change', function () {
        // Pega o valor do radio selecionado
        var idTipoPagamento = $('input[name="metodoPagamento"]:checked').val();
        $('#idTipoPagamento').val(idTipoPagamento);
        if (idTipoPagamento === '1') {

            $('#detalhesPag').hide();  // Ocultar a div
        }
        if (idTipoPagamento === '2') {
            $('#detalhesPag').hide();  // Ocultar a div
        }
        if (idTipoPagamento === '5') {
            $('#detalhesPag').show();  // Mostrar a div
        }
        if (idTipoPagamento === '7') {
            $('#detalhesPag').hide();  // Ocultar a div
        }
        if (idTipoPagamento === '8') {
            $('#detalhesPag').hide();  // Ocultar a div
        }
    });
    // calcula o troco
    $("#trocoInPut").on("input", function () {
        var total = parseFloat($('#totalGeral2').val());
        var entregue = parseFloat($('#trocoInPut').val());
        var troco = entregue - total;
        if (!isNaN(entregue) && entregue > total) {
            $('#troco').text(moeda(troco));
        } else {
            $('#troco').text(moeda(0));
        }

    });
    // pega o valor das parcelas a pagar
    $("#dinheiroRecebido").on("input", function () {
        var total = $('#totalGeral2').val();
        var dinheiro = $('#dinheiroRecebido').val();
        var multicaixa = $('#multicaixaRecebido').val();
        var transferenciaRecebido = $('#transferenciaRecebido').val();
        var conferido = dinheiro + multicaixa + transferenciaRecebido;
        $('#conferido').text(moeda(conferido));
        $('#conferido2').val(conferido);
        var pendente2 = $('#pendente2').val();
        var conferido2 = $('#conferido2').val();
        var p2 = total - conferido2;
        if (dinheiro === '0' || dinheiro === '') {
            $('#pendente2').val(total);
            $('#pendente').text(moeda(total));
        } else {
            $('#pendente2').val(p2);
            $('#pendente').text(moeda(p2));
        }
    });
    $("#multicaixaRecebido").on("input", function () {
        var total = $('#totalGeral2').val();
        var dinheiro = $('#dinheiroRecebido').val();
        var multicaixa = $('#multicaixaRecebido').val();
        var transferenciaRecebido = $('#transferenciaRecebido').val();
        var conferido = dinheiro + multicaixa + transferenciaRecebido;
        $('#conferido').text(moeda(conferido));
        $('#conferido2').val(conferido);
        var pendente2 = $('#pendente2').val();
        var conferido2 = $('#conferido2').val();
        var p2 = total - conferido2;
        if (dinheiro === '0' || dinheiro === '') {
            $('#pendente2').val(total);
            $('#pendente').text(moeda(total));
        } else {
            $('#pendente2').val(p2);
            $('#pendente').text(moeda(p2));
        }
    });
    $("#transferenciaRecebido").on("input", function () {
        var total = $('#totalGeral2').val();
        var dinheiro = $('#dinheiroRecebido').val();
        var multicaixa = $('#multicaixaRecebido').val();
        var transferenciaRecebido = $('#transferenciaRecebido').val();
        var conferido = dinheiro + multicaixa + transferenciaRecebido;
        $('#conferido').text(moeda(conferido));
        $('#conferido2').val(conferido);
        var pendente2 = $('#pendente2').val();
        var conferido2 = $('#conferido2').val();
        var p2 = total - conferido2;
        if (dinheiro === '0' || dinheiro === '') {
            $('#pendente2').val(total);
            $('#pendente').text(moeda(total));
        } else {
            $('#pendente2').val(p2);
            $('#pendente').text(moeda(p2));
        }
    });
    function finalizarDocFaturas() {
        $('#loadingModal').modal('show');
        $("#loadingModal").modal({
            backdrop: 'static', // Impede fechar ao clicar fora
            keyboard: false     // Impede fechar com a tecla "ESC"
        });
        // Realizar a requisição AJAX para obter os dados dos produtos
        $.ajax({
            type: 'post',
            url: BASE_URL + "cFaturas/finalizarDocsFatura", // Substitua pela URL do seu endpoint
            dataType: 'json',
            data: {
                idVenda: localStorage.getItem('IdVenda'),
                idCategoriaPontoVenda: idCategoriaPontoVenda,
                idGrupoPreco: idGrupoPreco,
                idLoja: idLoja,
                idTipoDocumento: $('#idTipoDocumento').val(),
                idTipoPagamento: $('#idTipoPagamento').val(),
                idCliente: $('#idCliente').val(),
                dinheiro: $('#dinheiroRecebido').val(),
                vrtpa: $('#multicaixaRecebido').val(),
                tbancaria: $('#transferenciaRecebido').val(),
                datapagamento: $('#dataPagamento').val(),
                descontoGlobal: $('#descontoGlobal').val(),
                idUsuario: idUsuario,
                idcaixa: idCaixaLoja,
                valorRecebido: $('#trocoInPut').val(),
                troco: $('#troco2').val(),
                totalgeral: $('#totalGeral2').val(),
                entidade: $('#entidade').val()
            },
            success: function (response) {
                var msgRes = response.msg;
                var idFatura = response.idFatura;  // Atualiza total de itens
                if (msgRes === 'INV') {
                    $('#alerta-detalhesFr').text('Verificar a data e hora do servidor');
                    $('#alerta-detalhesFr').fadeIn();
                    setTimeout(function () {
                        $('#alerta-detalhesFr').fadeOut();
                    }, 4000); // 10000 milissegundos = 10 segundos
                }
                if (msgRes === 'OK') {
                    $('#tabelaListaIntensCarrinho').DataTable().clear().draw();
                    $("#detalhesPagamentoModal").modal('hide');
                    $('#idTipoDocumento').val(2);
                    $('#tituloDocumento').text('Factura Recibo');
                    $('#abrev').text('FR');
                    $('#fatura-recibo').prop('checked', true);
                    localStorage.removeItem('IdVenda'); // ou "" 
                    document.getElementById('entidade').value = '';
                    dadosFaturaFrFtParaPdf(idFatura);
                    localStorage.removeItem('idCliente');

                }
            },
            error: function (xhr, status, error) {
                console.error("Erro ao obter os produtos:", error);
                // Trate o erro como necessário
            }
        });
    }
    //Método que finaliza as facturas recibos
    $(document).on('click', '.finalizarFR', function () {
        finalizarDocFaturas();
    });
//    Imprime fatuta Ticket
//    
    // Pega os dados da fatura  dadosFaturaFrFtParaPdf(idFatura);
    function dadosFaturaFrFtParaPdf(idFatura) {
        // Realizar a requisição AJAX para obter os dados dos produtos
        $.ajax({
            type: 'get',
            url: BASE_URL + "cDadosDocPDF/documentosFaturasPDF", // Substitua pela URL do seu endpoint
            dataType: 'json',
            data: {
                idFatura: idFatura
            },
            success: function (response) {
                var produtos = response.produtos;
                var entidade = response.entidade;
                var empresa = response.empresa;
                var detalhesDoc = response.detalhesDoc;
                var dadosBanco = response.dadosBanco;
                var resumoImpostos = response.resumoImpostos;
                $('#loadingModal').removeClass('show').css('display', 'none').attr('aria-hidden', 'true');
                $('body').removeClass('modal-open');
                $('.modal-backdrop').remove();

                //// Adiciona um pequeno atraso antes de chamar imprimeA4
                setTimeout(function () {
                    if ($('#idFormato').val() === '1') {
                        imprimeA4(empresa, detalhesDoc, entidade, dadosBanco, resumoImpostos, produtos);
                    }
                    if ($('#idFormato').val() === '3') {
                        imprimeTicket(empresa, detalhesDoc, entidade, produtos);
                    }
                }, 300); // Atraso de 100ms

            },
            error: function (xhr, status, error) {
                console.error("Erro ao obter os produtos:", error);
                // Trate o erro como necessário
            }

        });
        $('#loadingModal').on('hidden.bs.modal', function () {
            console.log("Modal foi fechado"); // Isso deve aparecer no console quando o modal for fechado
            $(this).remove();
        });
    }
    function finalizarFaturaProforma() {

        // Realizar a requisição AJAX para obter os dados dos produtos
        $.ajax({
            type: 'post',
            url: BASE_URL + "cFaturaProforma/registarFaturaProforma", // Substitua pela URL do seu endpoint
            dataType: 'json',
            data: {
                idVenda: localStorage.getItem('IdVenda'),

                idTipoDocumento: $('#idTipoDocumento').val(),
                idTipoPagamento: $('#idTipoPagamento').val(),
                idCliente: $('#idCliente').val(),
                dinheiro: $('#dinheiroRecebido').val(),
                vrtpa: $('#multicaixaRecebido').val(),
                tbancaria: $('#transferenciaRecebido').val(),
                datapagamento: $('#dataPagamento').val(),
                descontoGlobal: $('#descontoGlobal').val(),
                idUsuario: idUsuario,
                valorRecebido: $('#trocoInPut').val(),
                troco: $('#troco2').val(),
                totalgeral: $('#totalGeral2').val(),
                entidade: $('#entidade').val()
            },
            success: function (response) {
                var msgRes = response.msg;
                var idFatura = response.idFatura;  // Atualiza total de itens

                if (msgRes === 'OK') {
                    $('#tabelaListaIntensCarrinho').DataTable().clear().draw();
                    dadosFaturaPPPdf(idFatura);
                    document.getElementById('entidade').value = '';
                    $('#idTipoDocumento').val(2);
                    $('#tituloDocumento').text('Factura Recibo');
                    $('#abrev').text('FR');
                    $('#fatura-recibo').prop('checked', true);
                    localStorage.removeItem('IdVenda'); // ou ""  
                    localStorage.removeItem('idCliente');
                }
            },
            error: function (xhr, status, error) {
                Swal.fire({
                    icon: 'error', // Tipo do alerta: aviso
                    title: 'Erro!',
                    text: 'Ocorreu um erro na comunicação com o servidor.' + 'Erro: ' + error
                });

            }
        });
    }
//   
    function dadosFaturaPPPdf(idFatura) {

        // Realizar a requisição AJAX para obter os dados dos produtos
        $.ajax({
            type: 'get',
            url: BASE_URL + "cDadosDocPDF/imprimirFaturaPPPDF", // Substitua pela URL do seu endpoint
            dataType: 'json',
            data: {
                idFatura: idFatura
            },
            success: function (response) {
                var produtos = response.produtos;
                var entidade = response.entidade;
                var empresa = response.empresa;
                var detalhesDoc = response.detalhesDoc;
                var dadosBanco = response.dadosBanco;
                var resumoImpostos = response.resumoImpostos;
                $('#loadingModal').removeClass('show').css('display', 'none').attr('aria-hidden', 'true');
                $('body').removeClass('modal-open');
                $('.modal-backdrop').remove();
                imprimeDocInfPDF(empresa, detalhesDoc, entidade, dadosBanco, resumoImpostos, produtos);

            },
            error: function (xhr, status, error) {
                console.error("Erro ao obter os produtos:", error);
                // Trate o erro como necessário
            }

        });
        $('#loadingModal').on('hidden.bs.modal', function () {
            console.log("Modal foi fechado"); // Isso deve aparecer no console quando o modal for fechado
            $(this).remove();
        });
    }
    function finalizarOrcamento() {

        // Realizar a requisição AJAX para obter os dados dos produtos
        $.ajax({
            type: 'post',
            url: BASE_URL + "cOrcamento/registar_orcamento", // Substitua pela URL do seu endpoint
            dataType: 'json',
            data: {
                idVenda: localStorage.getItem('IdVenda'),
                idTipoDocumento: $('#idTipoDocumento').val(),
                idTipoPagamento: $('#idTipoPagamento').val(),
                idCliente: $('#idCliente').val(),
                dinheiro: $('#dinheiroRecebido').val(),
                vrtpa: $('#multicaixaRecebido').val(),
                tbancaria: $('#transferenciaRecebido').val(),
                datapagamento: $('#dataPagamento').val(),
                descontoGlobal: $('#descontoGlobal').val(),
                idUsuario: idUsuario,
                valorRecebido: $('#trocoInPut').val(),
                troco: $('#troco2').val(),
                totalgeral: $('#totalGeral2').val(),
                entidade: $('#entidade').val()
            },
            success: function (response) {
                var msgRes = response.msg;
                var idFatura = response.idFatura;  // Atualiza total de itens

                if (msgRes === 'OK') {
                    $('#tabelaListaIntensCarrinho').DataTable().clear().draw();
                    document.getElementById('entidade').value = '';
                    $('#idTipoDocumento').val(2);
                    $('#tituloDocumento').text('Factura Recibo');
                    $('#abrev').text('FR');
                    $('#fatura-recibo').prop('checked', true);
                    localStorage.removeItem('IdVenda'); // ou ""  
                    localStorage.removeItem('idCliente');
                    dadosOrcamentoPdf(idFatura);
                }
            },
            error: function (xhr, status, error) {
                Swal.fire({
                    icon: 'error', // Tipo do alerta: aviso
                    title: 'Erro!',
                    text: 'Ocorreu um erro na comunicação com o servidor.' + 'Erro: ' + error
                });

            }
        });
    }
    function dadosOrcamentoPdf(idFatura) {

        // Realizar a requisição AJAX para obter os dados dos produtos
        $.ajax({
            type: 'get',
            url: BASE_URL + "cDadosDocPDF/imprimirOrcamentoPDF", // Substitua pela URL do seu endpoint
            dataType: 'json',
            data: {
                idFatura: idFatura
            },
            success: function (response) {
                var produtos = response.produtos;
                var entidade = response.entidade;
                var empresa = response.empresa;
                var detalhesDoc = response.detalhesDoc;
                var dadosBanco = response.dadosBanco;
                var resumoImpostos = response.resumoImpostos;
                $('#loadingModal').removeClass('show').css('display', 'none').attr('aria-hidden', 'true');
                $('body').removeClass('modal-open');
                $('.modal-backdrop').remove();
                imprimeDocInfPDF(empresa, detalhesDoc, entidade, dadosBanco, resumoImpostos, produtos);


            },
            error: function (xhr, status, error) {
                console.error("Erro ao obter os produtos:", error);
                // Trate o erro como necessário
            }

        });
        $('#loadingModal').on('hidden.bs.modal', function () {
            console.log("Modal foi fechado"); // Isso deve aparecer no console quando o modal for fechado
            $(this).remove();
        });
    }
});





