$(document).ready(function () {


    $(document).on('click', '.crudEmpresas', function () {
        localStorage.setItem('idEmpresa', null);
        localStorage.setItem('nomeEmpresa', 'Registar empresa');
        localStorage.setItem('nif', '');
        var redirect = BASE_URL + 'cPainel/panel?pg=criar_empresa';
        window.location = redirect;
    });
    $(document).on('click', '.listaEmpresas', function () {
        var redirect = BASE_URL + 'cPainel/panel?pg=empresas';
        window.location = redirect;
    });



    getEmpresas();
    function   getEmpresas() {
        if ($.fn.DataTable.isDataTable('#tabelaListaEmpresa')) {
            $('#tabelaListaEmpresa').DataTable().clear().destroy();
        }
        var dataTable = $('#tabelaListaEmpresa').DataTable({
            colReorder: true,
            responsive: true,
            "processing": true,
            "serverSide": true,
            "searching": false,
            "ordering": false,
            "lengthChange": false,
            paging: false, // Oculta a paginação
            info: false,
            initComplete: function () {
                // Adicionar placeholder ao campo de pesquisa

            },
            "language": {
                "lengthMenu": "Mostrando _MENU_ registros por página",
                "zeroRecords": "Nenhum registro encontrado",
                "info": "Mostrando _START_ a _END_ de _TOTAL_ registos",
                "infoEmpty": "Nenhum registro disponível",
                "infoFiltered": "(filtrado de _MAX_ registros no total)",
                search: "", // Remove o texto padrão "Procurar"
                "loadingRecords": "Carregando...",
                "processing": "Processando...",
                "paginate": {
                    "previous": "Anterior",
                    "next": "Próximo"
                },
                "oAria": {
                    "sSortAscending": ": Ativar para ordenar a coluna de forma ascendente",
                    "sSortDescending": ": Ativar para ordenar a coluna de forma descendente"
                },
                error: function (xhr, error, thrown) {
                    console.error("Erro ao carregar dados:", xhr, error, thrown);
                }
            },
            "ajax": {
                url: BASE_URL + "CEmpresa/listar_empresa", // URL da requisição
                type: "get",
                "data": function (d) {


                },
                "dataSrc": function (json) {
                    return json.data; // Onde json.data é o array de dados da tabela
                }
            },
            columns: [
                {
                    data: null, // ou 'nome' se preferir usar o objeto, mas usaremos o row completo
                    render: function (data, type, row) {
                        return '<div class="contact-info">' +
                                '<p><strong>Nome:</strong> ' + row.nome + '</p>' +
                                '<p><strong>Nif:</strong> <em>' + row.nif + '</em></p>' +
                                '</div>';
                    }
                }, {
                    data: 'endereco',
                    render: function (data, type, row) {
                        return '<div class="contact-info">' +
                                '<p><strong>Endereço:</strong> ' + row.endereco + '</p>' +
                                '<p><strong>Email:</strong> ' + row.email + '</p>' +
                                '<p><strong>Telefones:</strong> ' + row.telefone + (row.fone1 ? ' - ' + row.fone1 : '') + '</p>' +
                                '<p><strong>Website:</strong> ' + row.website + '</p>' +
                                '</div>';
                    }
                },
                {data: 'provincia'},

                {
                    data: null,
                    render: function (data, type, row) {
                        return ` 
                    <a href="#" class="icon-action editar" data-id="${row.idEmpresa}" data-nome="${row.nome}" data-nif="${row.nif}" title="Editar" aria-label="Editar">
                       <i class="fa fa-edit"></i>
                    </a>
                      <a href="#" class="icon-action imprimir" data-id="${row.idEmpresa}"   title="Visualizar" aria-label="Visualizar">
                       <i class="fa fa-eye"></i>
                    </a>
                `;
                    }
                }
            ]
        });

    }

    $('#tabelaListaEmpresa tbody').on('click', '.editar', function () {
        var idEmpresa = $(this).data('id');
        var nome = $(this).data('nome');
        var nif = $(this).data('nif');
        localStorage.setItem('idEmpresa', idEmpresa);
        localStorage.setItem('nomeEmpresa', nome);
        localStorage.setItem('nif', nif);
        var redirect = BASE_URL + 'cPainel/panel?pg=criar_empresa';
        window.location = redirect;
    });






    // Método de validação personalizado para verificar o número de telefone com intlTelInput
    $.validator.addMethod("validPhone", function (value, element) {
        return this.optional(element) || iti.isValidNumber(); // Permite campo vazio, mas valida se preenchido
    }, "Por favor, insira um número de telefone válido.");
    $("#formEmpresa").validate({
        rules: {
            idProvincia: {
                required: true // Aplica a regra personalizada
            },
            nempresa: {
                required: true,
                minlength: 3 // 
            },
            nif: {
                required: true,
                minlength: 6 // 
            },
            endereco: {
                required: true,
                minlength: 5 // 
            },
            telefone: {
                required: false, // O campo não é obrigatório
                validPhone: true // Aplica a regra de validação personalizada para o campo de telefone
            },
            telefone2: {
                required: false, // O campo não é obrigatório
                validPhone: true // Aplica a regra de validação personalizada para o campo de telefone
            },
            email: {
                required: false, // O campo não é obrigatório
                email: true     // Valida se é um e-mail no formato correto
            },
            idRegime: {
                required: true // Aplica a regra personalizada
            },
            logo: {
                required: function (element) {
                    return $("#logoDadosEmpresa").is(":checked");
                }
            }

        },
        messages: {
            idProvincia: {
                required: "Por favor, selecione uma opção."
            },
            nempresa: {
                required: "O nome da empresa é obrigatório",
                minlength: "O nome deve ter pelo menos 3 caracteres."
            },
            nif: {
                required: "O NIF da empresa é obrigatório",
                minlength: "O Nif deve ter pelo menos 6 caracteres."
            },
            endereco: {
                required: "O endereço da empresa é obrigatório",
                minlength: "O endereço deve ter pelo menos 5 caracteres."
            },
            telefone: {
                validPhone: "Por favor, insira um número de telefone válido."
            },
            telefone2: {
                validPhone: "Por favor, insira um número de telefone válido."
            },
            email: {
                email: "Por favor, insira um endereço de e-mail válido."
            },
            idRegime: {
                required: "Por favor, selecione uma opção."
            },
            logo: {
                required: "O campo de logotipo é obrigatório quando o checkbox está marcado."
            }

        },
        errorElement: 'div',
        errorClass: 'invalid-feedback',
        highlight: function (element) {
            $(element).addClass('is-invalid'); // Adiciona classe de erro Bootstrap ao campo
        },
        unhighlight: function (element) {
            $(element).removeClass('is-invalid'); // Remove a classe de erro quando válido
        },
        errorPlacement: function (error, element) {
            error.insertAfter(element); // Insere a mensagem de erro logo após o campo
        },

        success: function (label, element) {
            // Remove o tooltip quando o campo for válido
            $(element).next('.error-tooltip').remove();
        },
        submitHandler: function (form) {
            // Chama a função submeteFormLogin quando o formulário for validado com sucesso
            submeterFormEmpresa();

        }
    });
    function submeterFormEmpresa() {
        // Cria um objeto FormData a partir do formulário
        var form = document.getElementById("formEmpresa");
        var formData = new FormData(form);

        // Adiciona o parâmetro extra (idEmpresa) ao FormData
        formData.append("idEmpresa", localStorage.getItem('idEmpresa'));
        $.ajax({
            // está é a função ajax, do jquery, ela será usada para fazer a requisição assícrona.
            url: BASE_URL + "CEmpresa/crud_empresa", // aqui vai a url da requisição
            data: formData, // aqui vai os dados para o servidor, geralmente são os inputs do form
            method: "POST", // aqui vai o método da requisição, acho que você já sabe sobre o get e post !
            dataType: "json",
            contentType: false, // Impede o jQuery de definir um cabeçalho contentType
            processData: false, // Impede o jQuery de converter os dados em uma string
            success: function (response) {
                if (response === 'ENC') {
                    Swal.fire({
                        iconHtml: '<i class="fas fa-exclamation-triangle "></i>',
                        iconColor: '#ffc107', // Você pode ajustar a cor conforme desejar
                        title: 'Atenção!',
                        text: 'Sem permissão para adicionar nova empresa.'
                    });
                }
                if (response === 'GR') {
                    Swal.fire({
                        iconHtml: '<i class="fas fa-exclamation-triangle "></i>',
                        iconColor: '#ffc107', // Você pode ajustar a cor conforme desejar
                        title: 'Atenção!',
                        text: 'A imagem é demasiado grande. Por favor, envie uma imagem com tamanho inferior a 2MB.'
                    });
                }
                if (response === 'OK') {
                    var redirect = BASE_URL + 'cPainel/panel?pg=empresas';
                    window.location = redirect;

                }
            },
            error: function () {
                // Caso ocorra um erro na requisição
                Swal.fire({
                    icon: 'warning', // Tipo do alerta: aviso
                    title: 'Atenção!',
                    text: 'Ocorreu um erro na comunicação com o servidor.'
                });
            }
        });
    }
});






