$(document).ready(function () {
    // $('#fone').mask('(00) 00000-0000', {placeholder: "(00) 00000-0000"});
    var input = document.querySelector("#fone");
    var input2 = document.querySelector("#fone1");
    var iti = window.intlTelInput(input, {
        initialCountry: "ao", // ou outro país padrão
        utilsScript: utilsScriptPath, // Caminho local do arquivo utils.js
        validationNumberType: "ANY", // Validação para números móveis
        customFlags: flags, // Caminho para as bandeiras
        preferredCountries: ['ao', 'us', 'fr', 'br'], // Exemplo de países preferidos
        inputMode: "tel", // Sugere números
        customPlaceholder: function (selectedCountryPlaceholder, selectedCountryData) {
            return  selectedCountryPlaceholder;
        }

    });
    // Método de validação personalizado para verificar o número de telefone com intlTelInput
    $.validator.addMethod("validPhone", function (value, element) {
        return this.optional(element) || iti.isValidNumber(); // Permite campo vazio, mas valida se preenchido
    }, "Por favor, insira um número de telefone válido.");
    // Inicializa o intlTelInput para o segundo campo
    window.intlTelInput(input2, {
        initialCountry: "ao", // País inicial
        validationNumberType: "FIXED_LINE",
        utilsScript: utilsScriptPath, // Caminho para o utils.js
        preferredCountries: ['ao', 'us', 'fr', 'br']  // Países preferidos
    });
    input.addEventListener('input', function () {
        this.value = this.value.replace(/\D/g, ''); // Remove tudo que não for número
    });
    toastr.options = {
        "closeButton": true, // Adiciona um botão de fechar
        "debug": false, // Para propósitos de depuração
        "newestOnTop": true, // Exibe as notificações mais recentes no topo
        "progressBar": true, // Exibe uma barra de progresso para duração
        "positionClass": "toast-top-right", // Posição da notificação
        "preventDuplicates": true, // Evita duplicação de notificações
        "onclick": null, // Função de callback ao clicar na notificação
        "showDuration": "300", // Duração do efeito de exibição em ms
        "hideDuration": "1000", // Duração do efeito de ocultação em ms
        "timeOut": "5000", // Tempo que a notificação permanece visível
        "extendedTimeOut": "1000", // Tempo extra ao passar o mouse sobre a notificação
        "showEasing": "swing", // Tipo de efeito ao exibir
        "hideEasing": "linear", // Tipo de efeito ao ocultar
        "showMethod": "fadeIn", // Método de exibição
        "hideMethod": "fadeOut"           // Método de ocultação
    };

    carregaEnditades();
    var tableHeight = $(window).height() * 0.65; // 70% da altura da janela
    function carregaEnditades() {
        $('#tabelaEntidades').DataTable().clear().destroy();
        var dataTable = $('#tabelaEntidades').DataTable({
            scrollCollapse: true, // Colapsa a tabela se não houver muitas linhas
            colReorder: true,
            responsive: true,
            "processing": true,
            "serverSide": true,
            "searching": true,
            "ordering": false,
            "lengthChange": false,
            initComplete: function () {
                // Adicionar placeholder ao campo de pesquisa
                $('#tabelaEntidades_filter input').attr('placeholder', 'Procurar');
                // Adicionar classe personalizada para o ícone de lupa
                $('#tabelaEntidades_filter input').addClass('search-icon');
                $('#tabelaEntidades_filter input').css({
                    'padding-left': '30px',
                    'background-image': 'url("../../src/img/icon/search.png")',
                    'background-repeat': 'no-repeat',
                    'background-position': '5px center',
                    'background-size': '16px 16px',
                    'border': '1px solid #ced4da',
                    'border-radius': '20px',
                    'height': '35px'
                });
            },
            "language": {
                //   "lengthMenu": "Mostrando _MENU_ registros por página",
                "lengthMenu": "_MENU_",
                "zeroRecords": "Nada encontrado",
                "info": "Mostrando _START_ a _END_ de _TOTAL_ registos",
                //   info: "", // Define como uma string vazia
                "infoEmpty": "Nenhum registro disponível",
                "infoFiltered": "(filtrado de _MAX_ registros no total)",
                search: "", // Remove o texto padrão "Procurar"
                "processing": "Processando...",
                "paginate": {
                    "previous": "Anterior",
                    "next": "Próximo"
                },
                "oAria": {
                    "sSortAscending": ": Ativar para ordenar a coluna de forma ascendente",
                    "sSortDescending": ": Ativar para ordenar a coluna de forma descendente"
                }
            },
            "ajax": {
                url: BASE_URL + "cCliente/listarEntidades", // URL da requisição
                type: "post",
                "data": function (searchParams) {
                    searchParams.pesquisa = $("#search").val();
                },
                "dataSrc": function (json) {
                    return json.data; // Onde json.data é o array de dados da tabela
                }
            },
            columns: [
                {data: "nome"},
                {data: "telefoneEmp"},
                {data: "telefonePessoal"},
                {data: "nif"},
                {data: "email"},
                {data: "localizacao"},
                {
                    data: null,
                    render: function (data, type, row) {
                        return `
                    <a href="#" class="icon-action selecionarEtidade" data-id="${row.idcliente}" data-nome="${row.nome}" data-telefone="${row.telefoneEmp}" title="Saldo conta corrente">
                        <i class="iconsminds-financial"></i>
                    </a>
                        <a href="#" class="icon-action editar" data-id="${row.idcliente}" title="Editar">
                        <i class="simple-icon-note"></i>
                    </a>
                    <a href="#" class="icon-action eliminar" data-id="${row.idcliente}" title="Eliminar">
                        <i class="iconsminds-remove-cart"></i>
                    </a>
                `;
                    }
                }
            ]

        });
    }

    $(document).on('click', '.novoEntidade', function () {

//        $("#exampleEntidades").modal('show');
        $("#exampleEntidades").modal({
            backdrop: 'static', // Impede fechar ao clicar fora
            keyboard: false     // Impede fechar com a tecla "ESC"
        });
        $('#exampleEntidades').on('shown.bs.modal', function () {
            $('#nome').trigger('focus');
            let form = $(this).find('form')[0];
            form.reset();

            // Remove mensagens de erro e estilos de validação
            $(form).find('.form-control').removeClass('is-invalid'); // Remove os estilos de erro
            $(form).find('.invalid-feedback').remove(); // Remove as mensagens de erro (caso haja)
            $("#formEntidade").validate({
                rules: {
                    nome: {
                        required: true,
                        minlength: 2
                    },
                    fone: {
                        required: false, // O campo não é obrigatório
                        validPhone: true // Aplica a regra de validação personalizada para o campo de telefone
                    },
                    email: {
                        required: false, // O campo não é obrigatório
                        email: true     // Valida se é um e-mail no formato correto
                    }
                },
                messages: {
                    nome: {
                        required: "O nome da entidade é obrigatório",
                        minlength: "O nome deve ter pelo menos 2 caracteres."
                    },
                    fone: {
                        validPhone: "Por favor, insira um número de telefone válido."
                    },
                    email: {
                        email: "Por favor, insira um endereço de e-mail válido."
                    }
                },
                errorElement: 'div',
                errorClass: 'invalid-feedback',
                highlight: function (element) {
                    $(element).addClass('is-invalid'); // Adiciona classe de erro Bootstrap ao campo
                },
                unhighlight: function (element) {
                    $(element).removeClass('is-invalid'); // Remove a classe de erro quando válido
                },
                errorPlacement: function (error, element) {
                    error.insertAfter(element); // Insere a mensagem de erro logo após o campo
                },

                success: function (label, element) {
                    // Remove o tooltip quando o campo for válido
                    $(element).next('.error-tooltip').remove();
                },
                submitHandler: function (form) {
                    // Chama a função submeteFormLogin quando o formulário for validado com sucesso
                    submeteFormLogin();

                }
            });
        });
    });
    $(document).on('click', '.fechaModalEntidade', function () {

        $("#exampleEntidades").modal('hide');

    });



    function submeteFormLogin() {
        var data = $("#formEntidade").serialize(); // a function serialize serve para pegar todos os valores que foram colocados nos inputs do form
        $.ajax({
            // está é a função ajax, do jquery, ela será usada para fazer a requisição assícrona.
            url: BASE_URL + "cCliente/registaEntidade", // aqui vai a url da requisição
            data: data, // aqui vai os dados para o servidor, geralmente são os inputs do form
            method: "POST", // aqui vai o método da requisição, acho que você já sabe sobre o get e post !
            dataType: "json", // aqui será o tipo de resposta que vamos receber, será no formato json, um formato simples e mais usado.
            success: function (data) {
                // Admin/dashboard?page=dashboard
                if (data === 'OK') {
                    $("#exampleEntidades").modal('hide');
                    $('#tabelaEntidades').DataTable().ajax.reload();
                } else {
                    Swal.fire({
                        icon: 'info', // Tipo do alerta
                        title: 'Informação!',
                        text: data // Mensagem de erro
                    });
                }
            },
            error: function () {
                // Caso ocorra um erro na requisição
                Swal.fire({
                    icon: 'warning', // Tipo do alerta: aviso
                    title: 'Atenção!',
                    text: 'Ocorreu um erro na comunicação com o servidor.'
//                            imageUrl: 'caminho/para/sua/imagem.png', // URL da imagem de erro
//                            imageWidth: 100,
//                            imageHeight: 100,
//                            imageAlt: 'Imagem de erro'
                });
            }
        });
    }


    // Evento de clique para o botão de editar
    $('#tabelaEntidades tbody').on('click', '.selecionarEtidade', function () {
        var idCliente = $(this).data('id');
        var nomeEntidade = $(this).data('nome');
        var telefoneEmpresa = $(this).data('telefone');
        localStorage.setItem('idEntidadeSaldo', idCliente);
        localStorage.setItem('nomeEntidade', nomeEntidade);
        localStorage.setItem('telefoneEmpresa', telefoneEmpresa);
        var redirect = BASE_URL + 'cPainel/panel?pg=cli_conta_corrente';
        window.location = redirect;

    });
    $(document).on('click', '.doc', function () {
        var redirect = BASE_URL + 'cPainel/panel?pg=cli_conta_corrente';
        window.location = redirect;
    });
    // Evento de clique para o botão de eliminar
    $('#tabelaEntidades tbody').on('click', '.eliminar', function () {
        var idCliente = $(this).data('id');
        Swal.fire({
            icon: 'question', // Tipo do alerta: pergunta
            // title: 'Atenção!',
            text: 'Deseja remover  a entidade selecionada',
            showCancelButton: true, // Mostra o botão de "Não"
            confirmButtonText: 'Sim', // Texto do botão de "Sim"
            cancelButtonText: 'Não', // Texto do botão de "Não"
            confirmButtonColor: '#3085d6', // Cor do botão de "Sim"
            cancelButtonColor: '#d33'      // Cor do botão de "Não"
        }).then((result) => {
            if (result.isConfirmed) {
                $.ajax({
                    type: 'post',
                    url: BASE_URL + "cCliente/eliminarCliente",
                    data: {idCliente: idCliente
                    },
                    dataType: 'json',
                    success: function (dados) {
                        if (dados === 'OK') {
                            $('#tabelaEntidades').DataTable().ajax.reload();
                        }
                        if (dados === 'N') {
                            Swal.fire({
                                icon: 'warning', // Tipo do alerta: aviso
                                title: 'Atenção!',
                                text: 'A entidade selecionada não pode ser eliminada.'
//                            imageUrl: 'caminho/para/sua/imagem.png', // URL da imagem de erro
//                            imageWidth: 100,
//                            imageHeight: 100,
//                            imageAlt: 'Imagem de erro'
                            });
                        }
                    }
                });
            } else if (result.dismiss === Swal.DismissReason.cancel) {
                // Ação para quando o usuário clica em "Não"
                console.log('Usuário clicou em Não');
            }
        });
    });
});





