


function imprimeTicket(empresa, detalhesDoc, entidade, produtos) {
    console.log(produtos.produto); // Verificar se o nome está sendo passado corretamente
    const {jsPDF} = window.jspdf;

    const doc = new jsPDF({
        unit: 'px',
//        format: [220.77, 1000] // 80mm de largura e altura dinâmica
        format: [160, 10000] // 80mm de largura e altura dinâmica
    });

// Definições de margens e posicionamento
    var marginLeft = 10;   // Margem esquerda
    var marginRight = 10;  // Margem direita
    var y = 12;            // Posição vertical inicial
//    var pageWidth = 220.77; // Definido como 80mm (220.77px) 
    var pageWidth = 160; // Definido como 80mm (220.77px) 
    var usableWidth = pageWidth - marginLeft * 2; // Largura utilizável para o texto 200

// Cabeçalho da empresa (Nome)
    doc.setFont("helvetica", "bold");
    doc.setFontSize(9);

// Dividir o nome da empresa em várias linhas se for necessário
    var text = doc.splitTextToSize(empresa.nomeEmpresa, usableWidth);

// Desenhar o nome da empresa com alinhamento à esquerda
    doc.text(text, marginLeft, y, {align: 'left'});
    y += 16; // Ajusta a posição vertical

// Definições para o restante do texto
    doc.setFont("helvetica", "normal");
    doc.setFontSize(9);

// Desenhar o endereço da empresa
    doc.text("Endereço: " + empresa.endereco, marginLeft, y, {align: 'left'});
    y += 10; // Ajusta a posição vertical

// Desenhar o NIF da empresa
    doc.text("NIF: " + empresa.nif, marginLeft, y, {align: 'left'});
    y += 10; // Ajusta a posição vertical

// Desenhar o telefone da empresa
    doc.text("Telefone: " + empresa.fone, marginLeft, y, {align: 'left'});
    y += 10; // Ajusta a posição vertical

// Desenhar a província e país
    doc.text(empresa.provincia + " - Angola", marginLeft, y, {align: 'left'});
    y += 13; // Ajusta a posição vertical

// Texto "Original" alinhado à direita
    doc.setFont("helvetica", "bold");
    doc.setFontSize(10);

// Ajuste a altura do texto "Original" (alterando 'y' para a altura desejada, neste caso 10 para 50, por exemplo)
    var text = "Original";
    var textWidth = doc.getTextWidth(text); // Obter a largura do texto
    var x = pageWidth - textWidth - marginRight; // Calcular a posição correta horizontal (à direita)

    doc.text(text, x, y); // Alinha o texto "Original" à direita na posição horizontal correta
    y += 4;
    doc.setFont("helvetica", "normal");
    // Ajuste a fonte e tamanho para a tabela
    doc.setFontSize(10);
    doc.text("...................................................................", 10, y);
    y += 8;
    doc.setFontSize(9);

// Definir as larguras das células
//    var cellWidthLeft = 100; // Largura da célula esquerda
//    var cellWidthRight = pageWidth - cellWidthLeft - marginLeft - marginRight; // Largura da célula direita

// Desenhar a primeira célula (texto alinhado à esquerda)
    doc.text(detalhesDoc.tipoDocumento, marginLeft, y);
// Desenhar a segunda célula (texto alinhado à direita)
    doc.text(detalhesDoc.numeroFatuta, pageWidth - marginRight, y, {align: 'right'});
    y += 4;
    doc.setFontSize(10);
    doc.text("...................................................................", 10, y);
    y += 8;
    doc.setFontSize(9);
    // Desenhar a primeira célula (texto alinhado à esquerda)
    doc.text("Data de Emissão", marginLeft, y);
// Desenhar a segunda célula (texto alinhado à direita)
    doc.text(detalhesDoc.dataEmissaoTicket, pageWidth - marginRight, y, {align: 'right'});
    y += 8;
    // Nome do Cliente
    doc.setFontSize(9);
    doc.text("Cliente: " + entidade.nome, 10, y);
    y += 8;
    // Detalhes da venda
    doc.text("Nif: " + entidade.nif, 10, y);
    y += 12;
    doc.setFontSize(10);
    doc.text("...................................................................", 10, y);


    // ------------------------------------
// Adicionando a tabela com uma linha e quatro células
// ------------------------------------
    doc.setFont("helvetica", "bold");
    doc.setFontSize(8);
// Definições da tabela
    // Definições da tabela
    var cellWidths = [50, 25, 40, 30]; // Largura de cada célula
    var cellHeight = 15; // Altura da célula

// Posição inicial da tabela

// Posição inicial da tabela
    var tableY = y + 0; // Deixar um espaço antes da tabela
    var cellX = marginLeft; // Posição inicial horizontal da tabela

// Desenhar a primeira linha da tabela sem bordas
    doc.text("Descrição", cellX + 2, tableY + 10); // Célula 1
    cellX += cellWidths[0]; // Mover para a próxima célula

    doc.text("Taxa", cellX + 2, tableY + 10); // Célula 2
    cellX += cellWidths[1]; // Mover para a próxima célula

    doc.text("Qtd x Pr", cellX + 2, tableY + 10); // Célula 3
    cellX += cellWidths[2]; // Mover para a próxima célula

    doc.text("Valor", cellX + 2, tableY + 10); // Célula 4
    y += 12;
    doc.setFont("helvetica", "normal");
    doc.setFontSize(10);
    doc.text("...................................................................", 10, y);
    y += 5;
    // Dados dos produtos

    const produtoRows = produtos.flatMap(produto => [
            [{content: produto.produto, colSpan: 3, styles: {fontSize: 8, halign: 'left'}}], // Nome do produto ocupa duas colunas 
            // Segunda linha com quantidade e IVA
            [{content: produto.iva, styles: {fontSize: 8, halign: 'right'}},
                {content: produto.qtd + ' x ' + produto.custo, styles: {fontSize: 8, halign: 'right'}},
                {content: produto.total, styles: {fontSize: 8, halign: 'right'}}
            ]
        ]);

    // Cabeçalho e corpo da tabela
    doc.autoTable({
        startY: y, // Começo da tabela
        startX: marginLeft, // Definir a posição inicial horizontal para alinhar à esquerda
        body: produtoRows,
        //   theme: 'grid', // Tema 'plain' remove as bordas
        theme: 'plain', // Tema 'plain' remove as bordas

        columnStyles: {
            0: {cellWidth: 30}, // Largura da primeira coluna (Produto)
            1: {cellWidth: 70}, // Largura da segunda coluna (Quantidade)
            2: {cellWidth: 40}   // Largura da terceira coluna (IVA)

        },
        // Defina quantas colunas a tabela tem
        columns: [
            {header: '', dataKey: 'produto'}, // Coluna Produto (ocupa duas colunas com o colSpan)
            {header: '', dataKey: 'qtd'}, // Coluna Quantidade
            {header: '', dataKey: 'iva'}, // Coluna IVA
            {header: '', dataKey: 'total'}       // Coluna IVA
        ],
        // Ajuste de padding e altura mínima das células
        styles: {
            cellPadding: {top: 1, right: 1, bottom: 1, left: 1}, // Reduzir o padding para diminuir o espaço interno
            lineHeight: 1, // Reduzir o espaçamento entre as linhas
            fontSize: 8, // Ajustar o tamanho da fonte, se necessário
        }, // Ajuste de altura mínima da célula
        didParseCell: function (data) {
            data.cell.styles.minCellHeight = 5;  // Diminuir a altura mínima das células
        },
        margin: {left: marginLeft} // Define a margem para a tabela
    });

    // Mover o Y para abaixo da tabela
    let finalY = doc.lastAutoTable.finalY + 10;
    doc.setFont("helvetica", "normal");
    doc.setFontSize(10);
    doc.text("...................................................................", 10, finalY);
    finalY += 8;
    doc.setFont("helvetica", "normal");
    doc.setFontSize(8);
    // Desenhar a primeira célula (texto alinhado à esquerda)
    doc.text("Total ilíquido:", marginLeft, finalY);
// Desenhar a segunda célula (texto alinhado à direita)
    doc.text(moeda(detalhesDoc.totalIliquidi), pageWidth - marginRight, finalY, {align: 'right'});
    finalY += 8;
    // Desenhar a  célula (texto alinhado à esquerda)
    doc.text("Desc.Comercia:", marginLeft, finalY);
// Desenhar a segunda célula (texto alinhado à direita)
    doc.text(moeda(detalhesDoc.descoComercial), pageWidth - marginRight, finalY, {align: 'right'});
    finalY += 8;
    // Desenhar a  célula (texto alinhado à esquerda)
    doc.text("Desc. Financeiro:", marginLeft, finalY);
// Desenhar a segunda célula (texto alinhado à direita)
    doc.text(moeda(detalhesDoc.descoFinaceiro), pageWidth - marginRight, finalY, {align: 'right'});
    finalY += 8;
    // Desenhar a  célula (texto alinhado à esquerda)
    doc.text("Sub-Total:", marginLeft, finalY);
// Desenhar a segunda célula (texto alinhado à direita)
    doc.text(moeda(detalhesDoc.subtotal), pageWidth - marginRight, finalY, {align: 'right'});
    finalY += 8;
    // Desenhar a  célula (texto alinhado à esquerda)
    doc.text("IVA:", marginLeft, finalY);
// Desenhar a segunda célula (texto alinhado à direita)
    doc.text(moeda(detalhesDoc.totalIva), pageWidth - marginRight, finalY, {align: 'right'});
    finalY += 8;
    // Desenhar a  célula (texto alinhado à esquerda)
    doc.text("Total Documento:", marginLeft, finalY);
// Desenhar a segunda célula (texto alinhado à direita)
    doc.text(moeda(detalhesDoc.totalGeral), pageWidth - marginRight, finalY, {align: 'right'});
    finalY += 8;

    if (detalhesDoc.troco > 0) {
        // Desenhar a  célula (texto alinhado à esquerda)
        doc.text("Valor recebido:", marginLeft, finalY);
// Desenhar a segunda célula (texto alinhado à direita)
        doc.text(moeda(detalhesDoc.valorRecebido), pageWidth - marginRight, finalY, {align: 'right'});
        finalY += 8;
        // Desenhar a  célula (texto alinhado à esquerda)
        doc.text("Troco:", marginLeft, finalY);
// Desenhar a segunda célula (texto alinhado à direita)
        doc.text(moeda(detalhesDoc.troco), pageWidth - marginRight, finalY, {align: 'right'});
        finalY += 8;
    }
    doc.setFont("helvetica", "normal");
    doc.setFontSize(10);
    doc.text("...................................................................", 10, finalY);
    finalY += 8;
    if (detalhesDoc.idForma === '5') {
        doc.setFontSize(8);
        doc.text("Numerário: " + moeda(detalhesDoc.cash), 10, finalY);
        finalY += 10;
        doc.text("Multicaixa: " + moeda(detalhesDoc.tpa), 10, finalY);
        finalY += 5;
    } else {
        doc.setFontSize(8);
        doc.text("Forma Pagto: " + detalhesDoc.tipo, 10, finalY);
        finalY += 5;
    }
    doc.setFontSize(10);
    doc.text("...................................................................", 10, finalY);
    finalY += 8;
    doc.text("Impostos:" + detalhesDoc.impostoRegime, 10, finalY);
    finalY += 5;

    doc.setFont("helvetica", "normal");
    doc.setFontSize(8);
// Definições da tabela
    var tableY = finalY + 5; // Deixar um espaço antes da tabela
    var cellX = marginLeft; // Posição inicial horizontal da tabela
    var lineHeight = 8; // Altura entre as linhas
    // Definições da tabela
    var cellWidths = [70, 30, 50]; // Largura de cada célula
    if (detalhesDoc.idRegime === '2' || detalhesDoc.idRegime === '3') {
        // Desenhar a primeira linha da tabela sem bordas
        doc.text("Incidência", cellX + 2, tableY + 10); // Célula 1
        cellX += cellWidths[0]; // Mover para a próxima célula
        doc.text("Taxa%", cellX + 2, tableY + 10); // Célula 1
        cellX += cellWidths[1]; // Mover para a próxima célula
        doc.text("Imposto%", cellX + 2, tableY + 10); // Célula 1
        cellX += cellWidths[2]; // Mover para a próxima célula
        // Resetar `cellX` para a segunda linha
        cellX = marginLeft;
        tableY += lineHeight; // Mover para a segunda linha

        // Segunda linha com valores
        doc.text(moeda(detalhesDoc.subtotal), cellX + 2, tableY); // Valor de Incidência
        cellX += cellWidths[0]; // Mover para a próxima célula
        doc.text(detalhesDoc.taxa+ "%", cellX + 2, tableY); // Valor da Taxa%
        cellX += cellWidths[1]; // Mover para a próxima célula
        doc.text(moeda(detalhesDoc.totalIva), cellX + 2, tableY); // Valor do Imposto%
        cellX += cellWidths[2]; // Mover para a próxima célula
    } else {
        // Desenhar a primeira linha da tabela
        doc.text("Incidência", cellX + 2, tableY); // Célula 1
        cellX += cellWidths[0]; // Mover para a próxima célula
        doc.text("Taxa%", cellX + 2, tableY); // Célula 2
        cellX += cellWidths[1]; // Mover para a próxima célula
        doc.text("Imposto%", cellX + 2, tableY); // Célula 3
        cellX += cellWidths[2]; // Mover para a próxima célula

        // Resetar `cellX` para a segunda linha
        cellX = marginLeft;
        tableY += lineHeight; // Mover para a segunda linha

        // Segunda linha com valores
        doc.text(moeda(detalhesDoc.subtotal), cellX + 2, tableY); // Valor de Incidência
        cellX += cellWidths[0]; // Mover para a próxima célula
        doc.text(moeda(0) + "%", cellX + 2, tableY); // Valor da Taxa%
        cellX += cellWidths[1]; // Mover para a próxima célula
        doc.text(moeda(0), cellX + 2, tableY); // Valor do Imposto%
        cellX += cellWidths[2]; // Mover para a próxima célula
    }
    finalY += 30;
    // Dividir o nome da empresa em várias linhas se for necessário
    doc.setFontSize(8);
    var text = doc.splitTextToSize("Os bens foram colocados a disposição do cliente a datado documento", usableWidth);
    // Desenhar o nome da empresa com alinhamento à esquerda
    doc.text(text, marginLeft, finalY, {align: 'left'});
    finalY += 10;
    doc.setFontSize(10);
    doc.text("...................................................................", 10, finalY);
    finalY += 12;
    doc.setFontSize(8);
    var text = doc.splitTextToSize(detalhesDoc.hashcontrol + "-Processado por programa validado nº141/AGT/2019 - ©SGESOFT", usableWidth);
    // Desenhar o texto com alinhamento centralizado
    doc.text(text, pageWidth / 2, finalY, {align: 'center'});
    finalY += 17;
    doc.setFontSize(10);
    var text = doc.splitTextToSize("Atendindo por: " + detalhesDoc.usuario, usableWidth);
    // Desenhar o texto com alinhamento centralizado
    doc.text(text, pageWidth / 2, finalY, {align: 'center'});
    finalY += 12;
    doc.setFontSize(8);
    var text = doc.splitTextToSize("*****Obrigado pela preferência *****", usableWidth);
    // Desenhar o texto com alinhamento centralizado
    doc.text(text, pageWidth / 2, finalY, {align: 'center'});
    finalY += 10;


    // Imprimir o PDF diretamente
    doc.autoPrint();

    const hiddFrame = document.createElement('iframe');
    hiddFrame.style.position = 'fixed';
// "visibility: hidden" would trigger safety rules in some browsers like safari，
// in which the iframe display in a pretty small size instead of hidden.
// here is some little hack ~
    hiddFrame.style.width = '1px';
    hiddFrame.style.height = '1px';
    hiddFrame.style.opacity = '0.01';
    const isSafari = /^((?!chrome|android).)*safari/i.test(window.navigator.userAgent);
    if (isSafari) {
        // fallback in safari
        hiddFrame.onload = () => {
            try {
                hiddFrame.contentWindow.document.execCommand('print', false, null);
            } catch (e) {
                hiddFrame.contentWindow.print();
            }
        };
    }
    hiddFrame.src = doc.output('bloburl');
    document.body.appendChild(hiddFrame);
}


