$(document).ready(function () {

    var idCliente = localStorage.getItem('idEntidadeSaldo');
    var nome = localStorage.getItem('nomeEntidade');
    var telefone = localStorage.getItem('telefoneEmpresa');
    atualizarCliente(nome, telefone);
    function atualizarCliente(nome, telefone) {
        nome = nome.toUpperCase(); // Converter para maiúsculas
        // Seleciona o mesmo elemento usando ambas as classes
        let titulo = $("h4.mb-2.nomeDaEntidade2");
        titulo.fadeOut(300, function () {
            $(this).html(`Cliente / <strong>${nome}</strong> <small style="font-size: 14px; color: gray;">(${telefone})</small>`);
            $(this).fadeIn(300);
        });
    }
    $(document).on('click', '.backEntidades', function () {
        var redirect = BASE_URL + 'cPainel/panel?pg=entidades';
        window.location = redirect;
    });

    lista_tipo_pagamento();
    function lista_tipo_pagamento() {
        $.ajax({
            url: BASE_URL + "cTipoPagamento/listarTipoPagamento",
            type: 'post',
            dataType: 'json',
            success: function (dados) {
                var option = '';
                if (dados.length > 0) {
                    // Adiciona a opção padrão
                    option += '<option value="" disabled selected>Selecione forma de pagamento</option>';
                    $.each(dados, function (i, obj) {
                        option += '<option value="' + obj.idFormaPagamento + '">' + obj.formaPagamento + '</option>';
                    });
                } else {
                    option = '<option value="" disabled selected>Nenhuma forma de pagamento encontrada</option>';
                }
                $('#idFormaPagamento').html(option).show();
            },
            error: function () {
                var option = '<option value="" disabled selected>Erro ao carregar as formas de pagamento</option>';
                $('#idFormaPagamento').html(option).show();
            }
        });
    }

    listaContasCorrente();
    function listaContasCorrente() {
        if ($.fn.DataTable.isDataTable('#tabelaLiquidarFatura')) {
            $('#tabelaLiquidarFatura').DataTable().clear().destroy();
        }
        var dataTable = $('#tabelaLiquidarFatura').DataTable({
            colReorder: true,
            responsive: true,
            "processing": true,
            "serverSide": true,
            "searching": false,
            "ordering": false,
            "lengthChange": false,
            initComplete: function () {
                // Adicionar placeholder ao campo de pesquisa

            },
            "language": {
                "lengthMenu": "Mostrando _MENU_ registros por página",
                "zeroRecords": "Nenhum registro encontrado",
                "info": "Mostrando _START_ a _END_ de _TOTAL_ registos",
                "infoEmpty": "Nenhum registro disponível",
                "infoFiltered": "(filtrado de _MAX_ registros no total)",
                search: "", // Remove o texto padrão "Procurar"
                "loadingRecords": "Carregando...",
                "processing": "Processando...",
                "paginate": {
                    "previous": "Anterior",
                    "next": "Próximo"
                },
                "oAria": {
                    "sSortAscending": ": Ativar para ordenar a coluna de forma ascendente",
                    "sSortDescending": ": Ativar para ordenar a coluna de forma descendente"
                },
                error: function (xhr, error, thrown) {
                    console.error("Erro ao carregar dados:", xhr, error, thrown);
                }
            },
            "ajax": {
                url: BASE_URL + "cContaCliente/listarContasReceber", // URL da requisição
                type: "get",
                "data": function (d) {
                    d.idCliente = localStorage.getItem('idEntidadeSaldo');

                },
                "dataSrc": function (json) {
                    return json.data; // Onde json.data é o array de dados da tabela
                }
            },
            columns: [
                {data: "datavenda",
                    render: function (data, type, row) {
                        // Verificar se a data existe
                        if (data) {
                            // Converter a data para o formato 'dia mês ano'
                            const dateObj = new Date(data);
                            const options = {year: 'numeric', month: 'long', day: 'numeric'};
                            const formattedDate = dateObj.toLocaleDateString('pt-BR', options); // Formato "dia mês ano"

                            // Retornar a data formatada
                            return formattedDate;
                        }
                        return ''; // Caso não haja data, retornar uma string vazia
                    }
                },

                {data: "referencia"},
                {data: "valor",
                    render: function (data, type, row) {
                        // Verificar se a data existe
                        if (data) {
                            return moeda(data); // Formato moeda"
                        }
                        return moeda(0); // Caso não haja data, retornar uma string vazia
                    }
                },

                {
                    data: "credito",
                    render: function (data, type, row) {
                        if (data) {
                            return '<span style="color:red;">' + moeda(data) + '</span>';
                        }
                        return '<span style="color:red;">' + moeda(0) + '</span>';
                    }
                }, {
                    data: "debito",
                    render: function (data, type, row) {
                        if (data) {
                            return '<span style="color:green;">' + moeda(data) + '</span>';
                        }
                        return '<span style="color:green;">' + moeda(0) + '</span>';
                    }
                },
                {data: "data_vencimento",
                    render: function (data, type, row) {
                        // Verificar se a data existe
                        if (data) {
                            // Converter a data para o formato 'dia mês ano'
                            const dateObj = new Date(data);
                            const options = {year: 'numeric', month: 'long', day: 'numeric'};
                            const formattedDate = dateObj.toLocaleDateString('pt-BR', options); // Formato "dia mês ano"

                            // Retornar a data formatada
                            return formattedDate;
                        }
                        return ''; // Caso não haja data, retornar uma string vazia
                    }
                },
                {
                    data: null,
                    render: function (data, type, row) {
                        return ` 
                    <a href="#" class="icon-action liquidar" data-id="${row.idCliente}" data-valor="${row.credito}" 
                     data-estado="${row.idEstadoPagFatura}"     data-idrecebimento="${row.idrecebimento}"  data-referencia="${row.referencia}" title="Liquidar" aria-label="Liquidar">
                       <i class="iconsminds-financial"></i>
                    </a>
                      <a href="#" class="icon-action imprimir" data-id="${row.idCliente}" data-valor="${row.credito}" 
                       data-estado="${row.idEstadoPagFatura}"   data-idrecebimento="${row.idrecebimento}"  data-referencia="${row.referencia}" title="Imprimir" aria-label="Imprimir">
                       <i class="simple-icon-printer"></i>
                    </a>
                `;
                    }
                }

//
            ]
        });

    }
    $('#tabelaLiquidarFatura tbody').on('click', '.liquidar', function () {
        var referencia = $(this).data('referencia');
        var valor = $(this).data('valor');
        var estadoFatura = $(this).data('estado');
        var idrecebimento = $(this).data('idrecebimento');
        if (estadoFatura === 3 || estadoFatura === '3') {
            Swal.fire({
                icon: 'info', // Tipo do alerta: aviso
                title: 'Info',
                text: 'Afactura selecionada já foi paga na totalidade.'
            });
        } else {
            $("#idRegistarSaldoCliente").modal('show');
            $('#formRegistarPagamentoCliente').on('shown.bs.modal', function () {
                let form = $(this).find('form')[0];
                form.reset();

            });
            $('.referenciaFatura').text(referencia);
            $('#totalApagar').text(valor);
            $('#totalApagar2').text(moeda(valor));
            $("#idRegistarPagamentoCliente").modal({
                backdrop: 'static', // Impede fechar ao clicar fora
                keyboard: false     // Impede fechar com a tecla "ESC"
            });
//      
            // Adiciona um método customizado ao jQuery Validate
            $.validator.addMethod("maxFromTotal", function (value, element, param) {
                // Obtém o texto do total e substitui a vírgula por ponto para converter em número
                var totalText = $(param).text().trim().replace(",", ".");
                var total = parseFloat(totalText);
                var inputValue = parseFloat(value);
                // Permite se o campo estiver vazio (optional) ou se o valor for menor ou igual ao total
                return this.optional(element) || (inputValue <= total);
            }, "O valor digitado não pode ser maior que o valor a pagar.");

            // Configura o validador
            $("#formRegistarPagamentoCliente").validate({
                rules: {

                    valorPago: {
                        required: true,
                        number: true, // Verifica se é um número válido
                        min: 1, // Define que o valor mínimo é 0.1
                        maxFromTotal: "#totalApagar" // Usa o id do elemento que contém o valor a pagar
                    },

                    idFormaPagamento: {
                        required: true // Aplica a regra personalizada
                    }
                },
                messages: {

                    valorPago: {
                        required: "Digite o valor de adiantamento",
                        number: "Digite um valor numérico válido",
                        min: "O valor deve ser maior que 0",
                        maxFromTotal: "O valor digitado não pode ser maior que o valor a pagar."

                    },
                    idFormaPagamento: {
                        required: "Por favor, selecione uma opção."
                    }

                },
                errorElement: 'div',
                errorClass: 'invalid-feedback',
                highlight: function (element) {
                    $(element).addClass('is-invalid');
                },
                unhighlight: function (element) {
                    $(element).removeClass('is-invalid');
                },
                errorPlacement: function (error, element) {
                    error.insertAfter(element);
                },
                success: function (label, element) {
                    $(element).next('.error-tooltip').remove();
                },
                submitHandler: function (form) {
                    // Chama a função de envio do formulário
                    submeteFormpPagamentoCliente(idrecebimento, referencia);
                }
            });
        }


//        ;
    });
    function submeteFormpPagamentoCliente(idReccebimento, referencia) {
        var data = $("#formRegistarPagamentoCliente").serialize();
        // Concatena a variável extra aos dados do formulário
        var parametrosAdicionais = {
            idCliente: localStorage.getItem('idEntidadeSaldo'),
            idReccebimento: idReccebimento,
            fatura: referencia,
            idUsuario: idUsuario
        };
        data += "&" + $.param(parametrosAdicionais);
        $.ajax({
            // está é a função ajax, do jquery, ela será usada para fazer a requisição assícrona.
            url: BASE_URL + "cFluxoCaixa/pagamentoDeCredito", // aqui vai a url da requisição
            data: data, // aqui vai os dados para o servidor, geralmente são os inputs do form
            method: "POST", // aqui vai o método da requisição, acho que você já sabe sobre o get e post !
            dataType: "json", // aqui será o tipo de resposta que vamos receber, será no formato json, um formato simples e mais usado.
            success: function (response) {
                var msgRes = response.msg;
                var idPagamento = response.idPagamento;  // Atualiza total de itens
                if (msgRes === 'INV') {
//                    $('#alerta-detalhesFr').text('Verificar a data e hora do servidor');
//                    $('#alerta-detalhesFr').fadeIn();
//                    setTimeout(function () {
//                        $('#alerta-detalhesFr').fadeOut();
//                    }, 4000); // 10000 milissegundos = 10 segundos
                }
                if (msgRes === 'OK') {
                    $('#tabelaLiquidarFatura').DataTable().ajax.reload();
                    $('#idRegistarPagamentoCliente').modal('hide');
                    carregaDadosRecibo(idPagamento);

                }
            },
            error: function () {
                // Caso ocorra um erro na requisição
                Swal.fire({
                    icon: 'warning', // Tipo do alerta: aviso
                    title: 'Atenção!',
                    text: 'Ocorreu um erro na comunicação com o servidor.'
                });
            }
        });
    }
    $(document).on('click', '.closeModalPagamento', function (e) {
        $('#idRegistarPagamentoCliente').modal('hide');
    });

    $('#tabelaLiquidarFatura tbody').on('click', '.imprimir', function () {
        var referencia = $(this).data('referencia');
        var valor = $(this).data('valor');
        var idrecebimento = $(this).data('idrecebimento');
        var estadoFatura = $(this).data('estado');
        if (estadoFatura === 1 || estadoFatura === '1') {
            Swal.fire({
                iconHtml: '<i class="fas fa-exclamation-triangle "></i>',
                iconColor: '#ffc107', // Você pode ajustar a cor conforme desejar
                title: 'Atenção!',
                text: 'Tem de liquidar a factura na totalidade ou parcialmente para visualizar ou imprimir o recibo.'
            });
        } else {
            $("#modalImprimeRecibo").modal('show');
            $('.referenciaFatura2').text(referencia);
            listaDividasPagas(idrecebimento);

        }
        ;
    });
    function listaDividasPagas(idrecebimento) {
        $.ajax({
            url: BASE_URL + "cFluxoCaixa/dividasPagas", // Substitua por sua URL/endpoint
            type: "get",
            dataType: "json",
            data: {idRecebimento: idrecebimento},
            success: function (response) {
                // Supondo que response seja um array de objetos, ex:
                // [{ dtPagamento: "2025-02-18", valor: "1000.00", id: 1 }, {...}]
                let rows = "";
                $.each(response, function (index, item) {
                    rows += `<tr>
                           <td>${moment(item.data).format("DD/MM/YYYY")}</td>
                           <td>${item.valor}</td>
                           <td>
                              <a href="#" class="icon-action imprimeRecibo" data-id="${item.idPagamento}"> <i class="simple-icon-printer"></i></a>
                           </td>
                         </tr>`;
                });
                $("table.listarPagamentosFaturas tbody").html(rows);
            },
            error: function (xhr, status, error) {
                console.error("Erro ao carregar dados: " + error);
            }
        });
    }
    $('.listarPagamentosFaturas tbody').on('click', '.imprimeRecibo', function () {
        var idPagamento = $(this).data('id');
        carregaDadosRecibo(idPagamento);
        $('#idRegistarPagamentoCliente').modal('hide');
//        ;
    });
    function carregaDadosRecibo(idPagamento) {
        $.ajax({
            type: 'post',
            url: BASE_URL + "cDadosDocPDF/imprimirRecibo", // Substitua pela URL do seu endpoint
            dataType: 'json',
            data: {
                idPagamento: idPagamento
            },
            success: function (response) {
                var dadosRecibo = response.dadosRecibo;
                var entidade = response.entidade;
                var empresa = response.empresa;
                var detalhesDoc = response.detalhesDoc;
                $('#loadingModal').removeClass('show').css('display', 'none').attr('aria-hidden', 'true');
                $('body').removeClass('modal-open');
                $('.modal-backdrop').remove();

                //// Adiciona um pequeno atraso antes de chamar imprimeA4
                imprimeReciboPagamento(empresa, detalhesDoc, entidade, dadosRecibo);

            },
            error: function (xhr, status, error) {
                Swal.fire({
                    icon: 'warning', // Tipo do alerta: aviso
                    title: 'Atenção!',
                    text: 'Ocorreu um erro ao imprimir o documento.'
                });
            }

        });
    }
   $(document).on('click', '.ccorrente', function () {
        var redirect = BASE_URL + 'cPainel/panel?pg=lista_cli_conta_corrente';
        window.location = redirect;
    });
});






