$(document).ready(function () {
    listaContasCorrente();
     $(document).on('click', '.backEntidades', function () {
        var redirect = BASE_URL + 'cPainel/panel?pg=entidades';
        window.location = redirect;
    });
    function listaContasCorrente() {
        if ($.fn.DataTable.isDataTable('#tabelaPagamentoDeCliente')) {
            $('#tabelaPagamentoDeCliente').DataTable().clear().destroy();
        }

        var dataTable = $('#tabelaPagamentoDeCliente').DataTable({
            colReorder: true,
            responsive: true,
            "processing": true,
            "serverSide": true,
            "searching": true,
            "ordering": false,
            "lengthChange": false,
            initComplete: function () {
                // Adicionar placeholder ao campo de pesquisa
                $('#tabelaPagamentoDeCliente_filter input').attr('placeholder', 'Procurar artigo');
                $('#tabelaPagamentoDeCliente_filter input').css({
                    'padding-left': '30px',
                    'background-image': 'url("' + BASE_PATH + 'src/img/icon/search.png")', // BASE_URL definido no seu script,
                    'background-repeat': 'no-repeat',
                    'background-position': '5px center',
                    'background-size': '16px 16px',
                    'border': '1px solid #ced4da',
                    'border-radius': '20px',
                    'height': '35px'
                });



            },
            "language": {
                "lengthMenu": "Mostrando _MENU_ registros por página",
                "zeroRecords": "Nenhum registro encontrado",
                "info": "Mostrando _START_ a _END_ de _TOTAL_ registos",
                "infoEmpty": "Nenhum registro disponível",
                "infoFiltered": "(filtrado de _MAX_ registros no total)",
                search: "", // Remove o texto padrão "Procurar"
                "loadingRecords": "Carregando...",
                "processing": "Processando...",
                "paginate": {
                    "previous": "Anterior",
                    "next": "Próximo"
                },
                "oAria": {
                    "sSortAscending": ": Ativar para ordenar a coluna de forma ascendente",
                    "sSortDescending": ": Ativar para ordenar a coluna de forma descendente"
                },
                error: function (xhr, error, thrown) {
                    console.error("Erro ao carregar dados:", xhr, error, thrown);
                }
            },
            "ajax": {
                url: BASE_URL + "cContaCliente/listaGeralContaCorrente", // URL da requisição
                type: "get",
                "data": function (d) {
                    d.pesquisa = $("#search").val();

                },
                "dataSrc": function (json) {
                    return json.data; // Onde json.data é o array de dados da tabela
                }
            },
            columns: [
                {data: "nome"},
                {data: "nif"},
                {data: "fone"},
                {data: "total",
                    render: function (data, type, row) {
                        // Verificar se a data existe
                        if (data) {
                            return moeda(data); // Formato moeda"
                        }
                        return moeda(0); // Caso não haja data, retornar uma string vazia
                    }
                },
                {
                    data: "credito",
                    render: function (data, type, row) {
                        if (data) {
                            return '<span style="color:red;">' + moeda(data) + '</span>';
                        }
                        return '<span style="color:red;">' + moeda(0) + '</span>';
                    }
                }, {
                    data: "debito",
                    render: function (data, type, row) {
                        if (data) {
                            return '<span style="color:green;">' + moeda(data) + '</span>';
                        }
                        return '<span style="color:green;">' + moeda(0) + '</span>';
                    }
                }, {
                    data: null,
                    render: function (data, type, row) {
                        return `
                    <a href="#" class="icon-action visualizar" data-id="${row.idCliente}" data-nome="${row.nome}" data-telefone="${row.fone}" title="Visualizar" aria-label="Visualizar">
                       <i class="iconsminds-financial"></i>
                    </a>    
                `;
                    }
                }



            ]
        });

    }
     // Evento de clique para o botão de editar
    $('#tabelaPagamentoDeCliente tbody').on('click', '.visualizar', function () {
        var idCliente = $(this).data('id');
        var nomeEntidade = $(this).data('nome');
        var telefoneEmpresa = $(this).data('telefone');
        localStorage.setItem('idEntidadeSaldo', idCliente);
        localStorage.setItem('nomeEntidade', nomeEntidade);
        localStorage.setItem('telefoneEmpresa', telefoneEmpresa);
        var redirect = BASE_URL + 'cPainel/panel?pg=liquidar_fatura';
        window.location = redirect;

    });

});






