$(document).ready(function () {
    listaDocsFatura();
    function listaDocsFatura() {
        if ($.fn.DataTable.isDataTable('#tabelaRelFaturas')) {
            $('#tabelaRelFaturas').DataTable().clear().destroy();
        }

        var dataTable = $('#tabelaRelFaturas').DataTable({
            colReorder: true,
            responsive: true,
            "processing": true,
            "serverSide": true,
            "searching": false,
            "ordering": false,
            "lengthChange": true,
            initComplete: function () {
                // Adicionar placeholder ao campo de pesquisa
                const filtersHtml = `
                 <div id="custom-filters" class="mb-3 p-3 border rounded bg-light">
                        <div class="row g-3 align-items-center">
                            <!-- Data Início -->
                            <div class="col-md-2">
                                <label for="filterStartDate" class="form-label">Data Início:</label>
                                <input type="date" id="filterStartDate" class="form-control rounded form-control-sm">
                            </div>

                            <!-- Data Fim -->
                            <div class="col-md-2">
                                <label for="filterEndDate" class="form-label">Data Fim:</label>
                                <input type="date" id="filterEndDate" class="form-control rounded form-control-sm">
                            </div> <!-- Botão Filtrar -->
                            <div class="col-md-2">
                                <label class="form-label d-block">&nbsp;</label>
                                <button id="filterBtn" class="btn btn-secondary">
                                    <i class="fas fa-filter"></i> Filtrar
                                </button>
                            </div>
                           

                            <!-- Checkbox Ativo -->
                            <div class="col-md-2">
                                <label class="form-label d-block">Anuladas:</label>
                                <div class="custom-switch custom-switch-primary mb-2 custom-switch-small">
                                    <input class="custom-switch-input" name="ativo" value="s" id="ativo" type="checkbox">
                                    <label class="custom-switch-btn" for="ativo"></label>
                                </div>
                            </div>

                           

                            <!-- Campo de Pesquisa -->
                            <div class="col-md-3">
                                <label for="filterSearchField" class="form-label">Pesquisar:</label>
                                <div class="input-group input-group-sm">
                                    <input type="text" id="filterSearchField" class="form-control" placeholder="Digite o número da factura">
                                    <button id="filterSearchBtn" class="btn btn-primary">
                                        <i class="simple-icon-magnifier"></i>
                                    </button>
                                </div>
                            </div>

                            <!-- Botão Refresh -->
                            <div class="col-md-1 d-flex justify-content-end" style="margin-top: 30px;">
                                <button id="refreshBtn" class="btn btn-outline-secondary btn-sm icon-action">
                                    <i class="iconsminds-reload-2"></i>
                                </button>
                            </div>
                        </div>
                </div> `;
                $('#tabelaRelFaturas_wrapper').prepend(filtersHtml);

                $('<style>')
                        .prop('type', 'text/css')
                        .html(`
                           
                            /* Ajusta a altura do botão para ficar igual ao do campo de input */
                            #filterSearchField, #filterSearchBtn {
                                box-sizing: border-box; /* Inclui as bordas e o padding no tamanho total do elemento */
                                height: 38px; /* Definindo uma altura fixa para ambos */
                                padding: .375rem .75rem; /* Ajuste do padding para os dois */
                                border: 0.3pxsolid #ced4da; /* Definindo uma borda, ajuste conforme necessário */
                            }
                            /* Estilo do campo de pesquisa */
                            #filterSearchField {
                               border-top-left-radius: .90rem;  /* Arredonda a borda superior esquerda */
                               border-bottom-left-radius: .90rem;  /* Arredonda a borda inferior esquerda */
                            }

                            /* Estilo do botão dentro do campo de pesquisa */
                            #filterSearchBtn {
                                border-top-left-radius: 0;
                                border-bottom-left-radius: 0;
                            }
                              #refreshBtnContainer {
                               margin-top: 10px;
                              }
                            /* Garantir que o botão de refrescar esteja ao lado da paginação */
                            .dataTables_paginate {
                                display: flex;
                                align-items: center;
                                justify-content: space-between;
                            }
                          .icon-action {
                                margin-right: 10px;
                                
                                text-decoration: none;
                            }

                            .icon-action i {
                                font-size: 18px;
                            }
                        `)
                        .appendTo('head');
                $('#filterSearchField').on('focus', function () {
                    // Limpar o valor de todos os campos de filtro
                    $('#filterSearchField').val('');
                    $('#filterStartDate').val('');
                    $('#filterEndDate').val('');
                    $('#ativo').prop('checked', false); // Definindo o checkbox "Ativo" como marcado
                });
                $('#filterStartDate').on('change', function () {
                    // Limpar o valor de todos os campos de filtro
                    $('#filterSearchField').val('');
                    $('#filterEndDate').val('');
                    $('#ativo').prop('checked', false); // Definindo o checkbox "Ativo" como marcado
                });
                $('#filterBtn').on('click', function () {
                    // Obtenha os valores dos filtros
                    var startDate = $('#filterStartDate').val();
                    var endDate = $('#filterEndDate').val();
                    var ativo = $('#ativo').is(':checked') ? 's' : 'n';
                    var searchTerm = $('#filterSearchField').val();

                    // Verifique se as datas inicial e final foram fornecidas
                    if (startDate && endDate) {
                        // Converta as datas para objetos Date
                        var start = new Date(startDate);
                        var end = new Date(endDate);

                        // Verifique se a data final é maior ou igual à data inicial
                        if (end >= start) {
                            // Se as datas forem válidas, recarregue a tabela com os novos parâmetros
                            dataTable.ajax.reload(null, false);  // O segundo parâmetro "false" mantém a página atual
                        } else {
                            // Caso a data final seja menor que a inicial, mostre uma mensagem de erro
                            toastr.warning('A data final deve ser igual ou superior à data inicia', 'Aviso');
                        }
                    } else {
                        // Caso as datas não estejam definidas, exiba uma mensagem de erro
                        toastr.warning('Por favor, selecione as datas inicial e final', 'Aviso');
                    }
                });
                // Evento de clique para o botão "Refrescar"
                $('#refreshBtn').on('click', function () {
                    // Resetar os filtros
                    $('#filterStartDate').val('');
                    $('#filterEndDate').val('');
                    $('#ativo').prop('checked', false);  // Resetando o checkbox "Ativo" para "checked"
                    $('#filterSearchField').val('');

                    // Recarregar a tabela com os filtros resetados
                    dataTable.ajax.reload(null, false);  // O segundo parâmetro "false" mantém a página atual
                });

            },
            "language": {
                "lengthMenu": "Mostrando _MENU_ registros por página",
                "zeroRecords": "Nenhum registro encontrado",
                "info": "Mostrando _START_ a _END_ de _TOTAL_ registos",
                "infoEmpty": "Nenhum registro disponível",
                "infoFiltered": "(filtrado de _MAX_ registros no total)",
                search: "", // Remove o texto padrão "Procurar"
                "loadingRecords": "Carregando...",
                "processing": "Processando...",
                "paginate": {
                    "previous": "Anterior",
                    "next": "Próximo"
                },
                "oAria": {
                    "sSortAscending": ": Ativar para ordenar a coluna de forma ascendente",
                    "sSortDescending": ": Ativar para ordenar a coluna de forma descendente"
                },
                error: function (xhr, error, thrown) {
                    console.error("Erro ao carregar dados:", xhr, error, thrown);
                }
            },
            "ajax": {
                url: BASE_URL + "cFaturas/listarDocsFatura", // URL da requisição
                type: "post",
                "data": function (d) {
                    // Envia os parâmetros de filtro para a requisição
                    // Envia os parâmetros de filtro para a requisição
                    d.pesquisa = $("#filterSearchField").val();
                    d.startDate = $("#filterStartDate").val();
                    d.endDate = $("#filterEndDate").val();
                    d.ativo = $("#ativo").is(':checked') ? 's' : 'n';
                },
                "dataSrc": function (json) {
                    // Atualizar dinamicamente os nomes dos armazéns
                    return json.data; // Onde json.data é o array de dados da tabela
                }
            },
            columns: [
                {data: "numeroFatura",
                    render: function (data, type, row) {
                        return `
                            <div class="produto-cell" style="display: flex; align-items: center;">
                                <div class="dropdown" style="display: inline-block; position: relative;">
                                    <!-- Botão sem fundo e com apenas a seta -->
                                    <button type="button" 
                                        class="btn btn-link dropdown-toggle" 
                                        data-toggle="dropdown" 
                                        aria-haspopup="true" 
                                        aria-expanded="false">
                                        <i class="fa fa-chevron-down"></i> <!-- Ícone de seta para baixo -->
                                    </button>
                                    <div class="dropdown-menu" style="position: absolute; z-index: 9999;">
                                        <a class="dropdown-item reimprimiFatura" href="#" data-id="${row.idFatura}">Reimprimir documento</a>
                                        <!-- Submenu com editar e adicionar -->
                                        <div class="dropdown-submenu">
                                            <a class="dropdown-item dropdown-toggle" href="#">Acertos a documentos</a>
                                            <div class="dropdown-menu">
                                                <a class="dropdown-item acertosrFatura" href="#" data-fatura="${row.numeroFatura}" data-id="${row.idFatura}">Nota de crédito</a>
                                                <a class="dropdown-item notaDebito" href="#" data-fatura="${row.numeroFatura}" data-id="${row.idFatura}">Nota de débito</a>
                                            </div>
                                        </div>
                                       <a class="dropdown-item  anular" href="#" data-fatura="${row.numeroFatura}" data-id="${row.idFatura}">Anular documento</a>
                                    </div>
                                </div>
                                <span class="produto-nome" style="margin-left: 5px;">${data}</span> <!-- Nome do produto -->
                            </div>
                        `;
                    }

                },
                {data: "dataFatura",
                    render: function (data, type, row) {
                        // Verificar se a data existe
                        if (data) {
                            // Converter a data para o formato 'dia mês ano'
                            const dateObj = new Date(data);
                            const options = {year: 'numeric', month: 'long', day: 'numeric'};
                            const formattedDate = dateObj.toLocaleDateString('pt-BR', options); // Formato "dia mês ano"

                            // Retornar a data formatada
                            return formattedDate;
                        }
                        return ''; // Caso não haja data, retornar uma string vazia
                    }
                },
                {data: "entidade"},
                {data: "totalDescontos",
                    render: function (data, type, row) {
                        // Verificar se a data existe
                        if (data) {
                            return moeda(data); // Formato moeda"
                        }
                        return moeda(0); // Caso não haja data, retornar uma string vazia
                    }
                }, {data: "credito",
                    render: function (data, type, row) {
                        // Verificar se a data existe
                        if (data) {
                            return moeda(data); // Formato moeda"
                        }
                        return moeda(0); // Caso não haja data, retornar uma string vazia
                    }
                }, {data: "debito",
                    render: function (data, type, row) {
                        // Verificar se a data existe
                        if (data) {
                            return moeda(data); // Formato moeda"
                        }
                        return moeda(0); // Caso não haja data, retornar uma string vazia
                    }
                }, {data: "totalIva",
                    render: function (data, type, row) {
                        // Verificar se a data existe
                        if (data) {
                            return moeda(data); // Formato moeda"
                        }
                        return moeda(0); // Caso não haja data, retornar uma string vazia
                    }
                }, {data: "totalgeral",
                    render: function (data, type, row) {
                        // Verificar se a data existe
                        if (data) {
                            return moeda(data); // Formato moeda"
                        }
                        return moeda(0); // Caso não haja data, retornar uma string vazia
                    }
                }
//                {data: "dataValidade", }
            ]
        });

    }
    // Capturar o clique no botão "Reimprimir fatura"
    $(document).on('click', '.reimprimiFatura', function (e) {
        e.preventDefault(); // Evitar o comportamento padrão do link
        // Obter o ID da fatura a partir do atributo data-id
        let idFatura = $(this).data('id');
        $('#idFatura').val(idFatura);
        // Exibir uma mensagem no console (ou realizar uma ação)
        $('#smallModalImpFactura').modal('show');

    });

    $(document).on('click', '.closeModalDetalhes', function (e) {
        $('#smallModalFaturaGlobal').modal('hide');
    });
    //Método que finaliza as facturas recibos
    $(document).on('click', '.reimprimir', function () {
        // Para pegar o valor inicial já selecionado
        var formato = $('input[name="format"]:checked').val();
        var via = $('input[name="via"]:checked').val();
        $('#smallModalImpFactura').modal('hide');
        var idFatura = $('#idFatura').val();
        dadosFaturaFrFtParaPdf(idFatura, formato, via);
    });
    // Pega os dados da fatura  dadosFaturaFrFtParaPdf(idFatura);
    function dadosFaturaFrFtParaPdf(idFatura, formato, via) {
        // Realizar a requisição AJAX para obter os dados dos produtos
        $.ajax({
            type: 'get',
            url: BASE_URL + "cDadosDocPDF/documentosFaturasPDF", // Substitua pela URL do seu endpoint
            dataType: 'json',
            data: {
                idFatura: idFatura,
                via: via
            },
            success: function (response) {
                var produtos = response.produtos;
                var entidade = response.entidade;
                var empresa = response.empresa;
                var detalhesDoc = response.detalhesDoc;
                var dadosBanco = response.dadosBanco;
                var resumoImpostos = response.resumoImpostos;
                $('#loadingModal').removeClass('show').css('display', 'none').attr('aria-hidden', 'true');
                $('body').removeClass('modal-open');
                $('.modal-backdrop').remove();

                //// Adiciona um pequeno atraso antes de chamar imprimeA4
                setTimeout(function () {
                    if (formato === 'A4') {
                        imprimeA4(empresa, detalhesDoc, entidade, dadosBanco, resumoImpostos, produtos);
                    }
                    if (formato === 'Ticket') {
                        imprimeTicket(empresa, detalhesDoc, entidade, produtos);
                    }
                    if (formato === 'A5') {
                        Swal.fire({
                            icon: 'warning', // Tipo do alerta: aviso
                            title: 'Atenção!',
                            text: 'Não disponivel de momento.'
                        });
                    }
                }, 300); // Atraso de 100ms

            },
            error: function (xhr, status, error) {
                console.error("Erro ao obter os produtos:", error);
                // Trate o erro como necessário
            }

        });
        $('#loadingModal').on('hidden.bs.modal', function () {
            console.log("Modal foi fechado"); // Isso deve aparecer no console quando o modal for fechado
            $(this).remove();
        });
    }
    // Capturar o clique no botão "Reimprimir fatura"
    $(document).on('click', '.acertosrFatura', function (e) {
        e.preventDefault(); // Evitar o comportamento padrão do link
        // Obter o ID da fatura a partir do atributo data-id
        let idFatura = $(this).data('id');
        let numeroFatura = $(this).data('fatura');

        carrega_dados_acertos_fatura(idFatura);
        $('#idFatura2').val(idFatura);
        $('#modalAcertosDocumentoLabel').text(`ACERTOS NO DOCUMENTO Nº ${numeroFatura} `);
        $('#idFatura').val(idFatura);

        // Exibir uma mensagem no console (ou realizar uma ação)
        $('#modalAcertosDocumento').modal('show');

    });
    function carrega_dados_acertos_fatura(idFatura) {
        $.ajax({
            url: BASE_URL + "cFaturas/listaProdutosFaturasAnular", // Substitua pela URL do seu backend listaProdutosFaturasAnular
            method: 'GET',
            dataType: 'json',
            data: {
                idFatura: idFatura
            },
            success: function (dados) {
                var listaFatura = $('#listaFatura');
                $.each(dados, function (i, obj) {
                    listaFatura.append('<li class="list-group-item" data-id="' + obj.idProduto + '">' + obj.produto + '</li>');
                });

            },
            error: function () {
                toastr.warning('Erro ao carregar os dados !', 'Aviso');
            }
        });
    }
    // Capturar o clique no botão "Reimprimir fatura"
    $(document).on('click', '.anular', function (e) {
        e.preventDefault(); // Evitar o comportamento padrão do link
        // Obter o ID da fatura a partir do atributo data-id
        let idFatura = $(this).data('id');
        let numeroFatura = $(this).data('fatura');
        Swal.fire({
            icon: 'question', // Tipo do alerta: pergunta
            // title: 'Atenção!',
            text: 'Deseja anular o documento ' + ' ' + numeroFatura,
            showCancelButton: true, // Mostra o botão de "Não"
            confirmButtonText: 'Sim', // Texto do botão de "Sim"
            cancelButtonText: 'Não', // Texto do botão de "Não"
            confirmButtonColor: '#3085d6', // Cor do botão de "Sim"
            cancelButtonColor: '#d33'      // Cor do botão de "Não"
        }).then((result) => {
            if (result.isConfirmed) {
                $.ajax({
                    type: 'post',
                    url: BASE_URL + "cNotaCredito/anularDocumento",
                    data: {
                        idFatura: idFatura,
                        idUsuario: idUsuario
                    },
                    dataType: 'json',
                    success: function (response) {
                        var msgRes = response.msg;
                        var idNota = response.idNota;  // Atualiza total de itens
                        if (msgRes === 'INV') {
                            Swal.fire({
                                icon: 'warning', // Tipo do alerta: aviso
                                title: 'Atenção!',
                                text: 'Verificar a data e hora do servidor.'
                            });
                        }
                        if (msgRes === 'Rep') {
                            Swal.fire({
                                icon: 'warning', // Tipo do alerta: aviso
                                title: 'Atenção!',
                                text: 'Não se pode alterar ou anular um documento já reportado a AGT.'
                            });
                        }
                        if (msgRes === 'OK') {
                            pegaDadosNotaDeCreditoPDF(idNota);
                        }
                    },
                    error: function (xhr, status, error) {
                        Swal.fire({
                            icon: 'warning', // Tipo do alerta: aviso
                            title: 'Atenção!',
                            text: 'Ocorreu um erro na comunicação com o servidor.'
                        });
                    }
                });
            } else if (result.dismiss === Swal.DismissReason.cancel) {
                console.log('Usuário clicou em Não');
            }
        });

    });
    function pegaDadosNotaDeCreditoPDF(idNota) {
        // Realizar a requisição AJAX para obter os dados dos produtos
        $.ajax({
            type: 'post',
            url: BASE_URL + "cDadosDocPDF/imprimirDocsAnuladosPDF", // Substitua pela URL do seu endpoint
            dataType: 'json',
            data: {
                idNota: idNota
            },
            success: function (response) {
                var produtos = response.produtos;
                var entidade = response.entidade;
                var empresa = response.empresa;
                var detalhesDoc = response.detalhesDoc;
                var dadosBanco = response.dadosBanco;
                var resumoImpostos = response.resumoImpostos;
                $('#loadingModal').removeClass('show').css('display', 'none').attr('aria-hidden', 'true');
                $('body').removeClass('modal-open');
                $('.modal-backdrop').remove();

                imprimeNotaCredito(empresa, detalhesDoc, entidade, dadosBanco, resumoImpostos, produtos);

            },
            error: function (xhr, status, error) {
                console.error("Erro ao obter os produtos:", error);
                // Trate o erro como necessário
            }

        });

    }


    // Evento para Vendas por artigo
    $('#faturaPorArtigo').click(function (e) {
        e.preventDefault(); // Impede o comportamento padrão do link
        console.log('Clicou em Vendas por artigo');
        // Adicione aqui a lógica para gerar relatório de vendas por artigo
    });

  
    // Capturar o clique no botão "Imprimir factura global"
    $(document).on('click', '#detalhesVenda', function (e) {
        e.preventDefault(); // Evitar o comportamento padrão do link
        // Obter o ID da fatura a partir do atributo data-id
     
        // Resetar o modal antes de abrir
        $('#smallModalFaturaGlobal').on('show.bs.modal', function () {
            // Resetar todos os campos do formulário
            $('#formFaturaGlobal')[0].reset(); // Usa o método reset() do formulário
        });
        // Exibir uma mensagem no console (ou realizar uma ação)
        $('#smallModalFaturaGlobal').modal('show');

    });
    $(document).on('click', '.closeModal', function (e) {
        $('#smallModalImpFactura').modal('hide');
    });

    // Evento para Vendas por categoria
    $('#faturaPorCategoria').click(function (e) {
        e.preventDefault();
        var startDate = $('#filterStartDate').val();
        var endDate = $('#filterEndDate').val();
        $.ajax({
            type: 'post',
            url: BASE_URL + "cDadosRelaPDF/vendasPorArtigo", // Substitua pela URL do seu endpoint
            dataType: 'json',
            data: {
                dataminima: startDate,
                datamaxima: endDate
            },
            success: function (response) {
                var produtos = response.produtos;
                var empresa = response.empresa;
                var totais = response.totais;
                var datais = response.datais;
                $('#loadingModal').removeClass('show').css('display', 'none').attr('aria-hidden', 'true');
                $('body').removeClass('modal-open');
                $('.modal-backdrop').remove();

                imprimeResumoVendaPorCategoria(empresa, produtos, totais, datais);

            },
            error: function (xhr, status, error) {
                Swal.fire({
                    icon: 'warning', // Tipo do alerta: aviso
                    title: 'Atenção!',
                    text: 'Erro ao imprimir o documento.'
                });
            }

        });
        // Adicione aqui a lógica para gerar relatório de vendas por categoria
    });

    // Evento para Resumo de vendaGolbal
    $('#faturaGlobal').click(function (e) {
        e.preventDefault();
        var startDate = $('#filterStartDate').val();
        var endDate = $('#filterEndDate').val();
        if (startDate && endDate) {

            $.ajax({
                type: 'post',
                url: BASE_URL + "cDadosRelaPDF/resumoDeVendasPDF", // Substitua pela URL do seu endpoint
                dataType: 'json',
                data: {
                    dataminima: startDate,
                    datamaxima: endDate
                },
                success: function (response) {
                    var ftItens = response.ftItens;
                    var frItens = response.frItens;
                    var empresa = response.empresa;
                    var totais = response.totais;
                    var datais = response.datais;
                    $('#loadingModal').removeClass('show').css('display', 'none').attr('aria-hidden', 'true');
                    $('body').removeClass('modal-open');
                    $('.modal-backdrop').remove();

                    imprimeFaturaGlobal(empresa, ftItens, frItens, totais, datais);

                },
                error: function (xhr, status, error) {
                    Swal.fire({
                        icon: 'warning', // Tipo do alerta: aviso
                        title: 'Atenção!',
                        text: 'Erro ao imprimir o documento.'
                    });
                }

            });


        } else {
            // Caso as datas não estejam definidas, exiba uma mensagem de erro
            toastr.warning('Por favor, selecione as datas inicial e final', 'Aviso');
        }
    });
    $("#nomeEntidade").autocomplete({
        source: function (request, response) {
            $.ajax({
                url: BASE_URL + "cCliente/lista_entidades_txt_search",
                type: 'GET',
                dataType: 'json',
                data: {term: request.term},
                success: function (dados) {
                    if (dados && dados.length > 0) {
                        response($.map(dados, function (obj) {
                            return {
                                label: obj.nome, // Nome do paciente
                                value: obj.idcliente // ID do paciente
//                                nascimento: obj.nascimento // Data de nascimento do paciente
                            };
                        }));
                    } else {
                        console.warn("Nenhum dado encontrado.");
                    }
                },
                error: function (xhr, status, error) {
                    console.error("Erro no autocomplete:", error);
                    console.log("Resposta do servidor:", xhr.responseText);
                }
            });
        },
        minLength: 2,
        select: function (event, ui) {
            console.log("Entidade selecionado:", ui.item.value);
            var idcliente = ui.item.value;

            $.ajax({
                url: BASE_URL + "cCliente/pega_dados_cliente_tooltip",
                type: 'GET',
                dataType: 'json',
                data: {idCliente: idcliente},
                success: function (dados) {

                    console.log("Dados da entidade1:", dados);
                    if (dados.length > 0) {
                        populateTextInput(dados);
                    }
                },
                error: function (xhr, status, error) {
                    console.error("Erro na requisição do  cliente:", error);
                }
            });
        }
    });

    function populateTextInput(dados) {
        $('#nomeEntidade').val(dados[0].nome); // Preenche o campo de nome
        $('#idCliente').val(dados[0].idcliente); // Preenche o campo de idade
        // Adicione outros campos conforme necessário
    }
     $(document).on('click', '.imprimirFaturaGlobal', function (e) {
       e.preventDefault();
        var startDate = $('#filterStartDate').val();
        var endDate = $('#filterEndDate').val();
        if (startDate && endDate) {

            $.ajax({
                type: 'get',
                url: BASE_URL + "cFaturaGlobal/docFaturaConsolidadaPDF", // Substitua pela URL do seu endpoint
                dataType: 'json',
                data: {
                    dataminima: startDate,
                    datamaxima: endDate,
                    idCliente:$('#idCliente').val()
                },
                success: function (response) {
                    var produtos = response.produtos;
                    var entidade = response.entidade;
                    var empresa = response.empresa;
                    var dadosBanco = response.dadosBanco;
                     var detalhesDoc = response.detalhesDoc;
                    $('#loadingModal').removeClass('show').css('display', 'none').attr('aria-hidden', 'true');
                    $('body').removeClass('modal-open');
                    $('.modal-backdrop').remove();

                    imprimirFaturaCinsolidadaPDF(empresa, produtos, entidade, dadosBanco,detalhesDoc);

                },
                error: function (xhr, status, error) {
                    Swal.fire({
                        icon: 'warning', // Tipo do alerta: aviso
                        title: 'Atenção!',
                        text: 'Erro ao imprimir o documento.'
                    });
                }

            });


        } else {
            // Caso as datas não estejam definidas, exiba uma mensagem de erro
            toastr.warning('Por favor, selecione as datas inicial e final', 'Aviso');
        }
    });
    // Evento para imprimir a factura global poe Entidade
  // Evento para Resumo de vendaGolbal
    $('#faturaPorOperador').click(function (e) {
        e.preventDefault();
        var startDate = $('#filterStartDate').val();
        var endDate = $('#filterEndDate').val();
        if (startDate && endDate) {
            $.ajax({
                type: 'get',
                url: BASE_URL + "cDadosRelaPDF/resumoDeVendasPorOperadorPDF", // Substitua pela URL do seu endpoint
                dataType: 'json',
                data: {
                    dataminima: startDate,
                    datamaxima: endDate
                },
                success: function (response) {
                    var dadosDocumentos = response.dadosDocumentos;
                    var empresa = response.empresa;
                    var totais = response.totais;
                    var datais = response.datais;
                    $('#loadingModal').removeClass('show').css('display', 'none').attr('aria-hidden', 'true');
                    $('body').removeClass('modal-open');
                    $('.modal-backdrop').remove();

                    imprimeResumoVendaPorOperador(empresa, dadosDocumentos, totais, datais);

                },
                error: function (xhr, status, error) {
                    Swal.fire({
                        icon: 'warning', // Tipo do alerta: aviso
                        title: 'Atenção!',
                        text: 'Erro ao imprimir o documento.'
                    });
                }

            });


        } else {
            // Caso as datas não estejam definidas, exiba uma mensagem de erro
            toastr.warning('Por favor, selecione as datas inicial e final', 'Aviso');
        }
    });

});





