


function imprimeResumoVendaPorCategoria(empresa, produtos, totais, datais) {
    const {jsPDF} = window.jspdf;

    const doc = new jsPDF({
        unit: 'mm',
        format: 'a4' // Alterar para o formato A4
    });

    let totalPages;
// Tamanho da página A4
    var pageWidth = doc.internal.pageSize.getWidth();

// Margens
    var marginTop = 15; // Distância do topo da página
    var marginBottom = 25; // Distância da parte inferior da página
    function addHeader() {
        doc.setFont("helvetica", "bold");
        doc.setFontSize(8);

        // Nome da empresa e data (data alinhada à direita)
        doc.text("Empresa: " + empresa.nomeEmpresa, 10, marginTop);
        doc.text("Data: " + new Date().toLocaleDateString(), pageWidth - 50, marginTop);

        // Título centralizado
        doc.setFontSize(14);
        doc.setTextColor(0, 0, 0);
        doc.text("Resumo de vendas por artigo", pageWidth / 2, marginTop + 10, {align: "center"});
        // Adiciona uma linha abaixo do texto
        let textWidth = doc.getTextWidth("Resumo de vendas por artigo"); // Obtém a largura do texto
        let textX = (pageWidth / 2) - (textWidth / 2); // Calcula a posição inicial da linha

        doc.setDrawColor(0, 0, 0); // Define a cor da linha (preta)
        doc.setLineWidth(0.5); // Define a espessura da linha
        doc.line(textX, marginTop + 12, textX + textWidth, marginTop + 12); // Linha contínua abaixo do texto

        // Período da consulta
        doc.setFontSize(12);
        // Adiciona linha separadora a cima da  data
        doc.setDrawColor(0, 0, 0); // Cor preta
        doc.setLineWidth(0.3); // Espessura da linha
        doc.line(10, marginTop + 18, pageWidth - 10, marginTop + 18); // Linha horizontal
        doc.setFont("helvetica", "bold");
        doc.text("Equivalente desde:", 10, marginTop + 23);
        doc.text(datais.dataminima, 50, marginTop + 23);
        doc.text("até", 100, marginTop + 23);
        doc.text(datais.datamaxima, 130, marginTop + 23);
        // Adiciona linha separadora abaixo do cabeçalho
        doc.setDrawColor(0, 0, 0); // Cor preta
        doc.setLineWidth(0.3); // Espessura da linha
        doc.line(10, marginTop + 26, pageWidth - 10, marginTop + 26); // Linha horizontal

    }
        function addHeader2() {
        doc.setFontSize(14);
        doc.setTextColor(0, 0, 0);
        doc.text("Resumo de vendas por artigo", pageWidth / 2, marginTop + 10, {align: "center"});
        // Adiciona uma linha abaixo do texto
        let textWidth = doc.getTextWidth("Resumo de vendas por artigo"); // Obtém a largura do texto
        let textX = (pageWidth / 2) - (textWidth / 2); // Calcula a posição inicial da linha

        doc.setDrawColor(0, 0, 0); // Define a cor da linha (preta)
        doc.setLineWidth(0.5); // Define a espessura da linha
        doc.line(textX, marginTop + 12, textX + textWidth, marginTop + 12); // Linha contínua abaixo do texto

        // Período da consulta
        doc.setFontSize(12);
        // Adiciona linha separadora a cima da  data
        doc.setDrawColor(0, 0, 0); // Cor preta
        doc.setLineWidth(0.3); // Espessura da linha
        doc.line(10, marginTop + 18, pageWidth - 10, marginTop + 18); // Linha horizontal
        doc.setFont("helvetica", "bold");
        doc.text("Equivalente desde:", 10, marginTop + 23);
        doc.text(datais.dataminima, 50, marginTop + 23);
        doc.text("até", 100, marginTop + 23);
        doc.text(datais.datamaxima, 130, marginTop + 23);
        // Adiciona linha separadora abaixo do cabeçalho
        doc.setDrawColor(0, 0, 0); // Cor preta
        doc.setLineWidth(0.3); // Espessura da linha
        doc.line(10, marginTop + 26, pageWidth - 10, marginTop + 26); // Linha horizontal

    }
    addHeader();
    function addFooter(pageNumber) {
        var marginLeft = 10;   // Margem esquerda
        var marginRight = 10;  // Margem direita
        var pageWidth = doc.internal.pageSize.getWidth();
        var pageHeight = doc.internal.pageSize.getHeight();

        var startX = marginLeft;
        var endX = pageWidth - marginRight;

        var startYFooter = pageHeight - 10; // Ajuste para a posição do rodapé
        var text = 'Página ' + pageNumber;

        doc.setFontSize(8);

        // Calcula a largura do texto para alinhamento à direita
        var textWidth = doc.getTextWidth(text);
        var startXText = pageWidth - marginRight - textWidth;

        // Desenha a linha acima do número da página
        var lineY = startYFooter - 5; // Ajuste para a linha ficar logo acima
        doc.setDrawColor(0, 0, 0); // Cor preta
        doc.setLineWidth(0.3);
        doc.line(startX, lineY, endX, lineY);

        // Adiciona o número da página
        doc.text(text, startXText, startYFooter, {align: 'left'});
    }
// Define algumas variáveis para as margens e a posição vertical inicial
    const marginLeft = 10;
    const marginRight = 10;

    // Agrupar os produtos por categoria usando reduce
    const groupedProducts = produtos.reduce((groups, produto) => {
        if (!groups[produto.categoria]) {
            groups[produto.categoria] = [];
        }
        groups[produto.categoria].push(produto);
        return groups;
    }, {});


// Cria um array combinado com as linhas do corpo da tabela
// Para cada categoria, insere uma linha com o título da categoria e depois as linhas de produtos
    const combinedRows = [];
    const totalColumns = 7; // Nossa tabela terá 4 colunas: Produto, Preço, Quantidade, Total
    // Para cada categoria, adiciona uma linha com o nome da categoria e, para cada produto, duas linhas:
// - Uma linha para o nome do produto (ocupando todas as colunas com colSpan)
// - Uma linha de detalhes do produto (preço, quantidade e total)
    let globalSumQtd = 0;
    let globalSumMedia = 0;
    let globalSumTotalVenda = 0;
    let globalSumGastos = 0;
    let globalSumLucroBruto = 0;
    for (let categoria in groupedProducts) {
        // Linha com o título da categoria (ocupando todas as colunas)
        combinedRows.push([{
                content: categoria,
                colSpan: totalColumns,
                rowPageBreak: 'avoid', // Impede que essa linha seja dividida da(s) próxima(s) linha(s)
                styles: {
                    halign: 'left',
                    fontStyle: 'bolditalic', // Negrito e itálico
                    fontSize: 8, // Tamanho da fonte 8
                    fillColor: [243, 245, 248] // Cor de fundo
                }

            }]);
        // Inicializa os acumuladores para os totais da categoria
        let sumQtd = 0;
        let sumMedia = 0;
        let sumTotalVenda = 0;
        let sumGastos = 0;
        let sumLucroBruto = 0;


        // Para cada produto da categoria:
        groupedProducts[categoria].forEach(produto => {
            // Linha com o nome do produto, ocupando toda a linha
            combinedRows.push([{
                    content: produto.artigo,
                    colSpan: totalColumns,
                    styles: {halign: 'left', fontStyle: 'normal', fillColor: [255, 255, 255]},
                    isProductName: true  // Propriedade customizada para identificar essa linha
                }]);

            // Linha com os detalhes: deixamos a primeira célula vazia para manter o número de colunas
            // e usamos as demais para preço, quantidade e total
            combinedRows.push([
                produto.unidade,
                produto.qtd,
                moeda2(produto.media),
                moeda2(produto.totalVenda),
                moeda2(produto.gastos),
                moeda2(produto.lucroBruto),
                produto.percentagemLucro
            ]);
            // Soma os valores
            sumQtd += parseFloat(produto.qtd);
            sumMedia += parseFloat(produto.media);
            sumTotalVenda += parseFloat(produto.totalVenda);
            sumGastos += produto.gastos;
            sumLucroBruto += produto.lucroBruto;
        });
        // Linha de total da categoria (soma dos campos: media, totalVenda, gastos, lucroBruto)
        // Aqui, mesclamos as duas primeiras colunas para exibir o rótulo "Total <categoria>"
        combinedRows.push([
            {
                content: "Total: " + categoria,
                //   colSpan: 2,
                styles: {halign: 'left', fontStyle: 'bold'}
            },
            {content: sumQtd, styles: {fontStyle: 'bold'}},
            {content: moeda2(sumMedia), styles: {fontStyle: 'bold'}},
            {content: moeda2(sumTotalVenda), styles: {fontStyle: 'bold'}},
            {content: moeda2(sumGastos), styles: {fontStyle: 'bold'}},
            {content: moeda2(sumLucroBruto), styles: {fontStyle: 'bold'}},

            "" // Última coluna (percentagemLucro) deixada vazia
        ]);
        // Acumula os totais gerais com os totais desta categoria
        globalSumQtd += sumQtd;
        globalSumMedia += sumMedia;
        globalSumTotalVenda += sumTotalVenda;
        globalSumGastos += sumGastos;
        globalSumLucroBruto += sumLucroBruto;

    }
    // Após processar todas as categorias, insere uma linha final com os totais gerais
    combinedRows.push([
        {content: "Total Geral", colSpan: 2, styles: {halign: 'right', fontStyle: 'bold'}},
        {content: globalSumQtd, styles: {fontStyle: 'bold', halign: 'center'}},
        {content: moeda2(globalSumMedia), styles: {fontStyle: 'bold', halign: 'center'}},
        {content: moeda2(globalSumTotalVenda), styles: {fontStyle: 'bold', halign: 'center'}},
        {content: moeda2(globalSumGastos), styles: {fontStyle: 'bold', halign: 'center'}},
        {content: moeda2(globalSumLucroBruto), styles: {fontStyle: 'bold', halign: 'center'}},
        "" // Última coluna vazia
    ]);

// Cria a tabela única com autoTable
    var startY = marginTop + 25; // Deixar espaço para o cabeçalho
    doc.autoTable({
        head: [['Descrição/ Unid.Medida', 'QTd. Vend', 'Val.Med. Venda', 'Val.Vendas', 'Total gastos', 'Lucro Bruto', '% Margem Lucro']], // Cabeçalho que será repetido em cada página
        body: combinedRows, // Dados combinados de todas as categorias
        tartY: marginTop + 25,
        margin: {top: 50, bottom: marginBottom, left: 10, right: 10},
        showHead: 'everyPage', // Cabeçalho repetido no início de cada página
        styles: {fontSize: 10},
        headStyles: {
            fillColor: [230, 230, 230], // Cor de fundo do cabeçalho (cinza)
            textColor: 0, // Cor do texto (preto)
            fontStyle: 'bold', // Texto em negrito
            halign: 'center', // Alinhamento centralizado
            fontSize: 8, // Tamanho menor da fonte
            cellPadding: 2              // Menor espaçamento interno
        },
        didDrawCell: function (data) {
            const currentPage = data.pageNumber;
            // Verifica se a célula ocupa todas as colunas (totalColumns) e que não seja uma linha de cabeçalho (head)
            if (data.section === 'body' && data.cell.colSpan === totalColumns && data.cell.styles.fontStyle !== 'bold') {
                let cell = data.cell;
                doc.setDrawColor(0, 0, 0);
                doc.setLineWidth(0.3);

                // Se a célula for uma linha de nome do produto (identificada pela propriedade isProductName),
                // NÃO desenhar a borda inferior; caso contrário, desenhar.
                if (!(data.cell.raw && data.cell.raw.isProductName === true)) {
                    // Desenha a linha inferior
                    doc.line(cell.x, cell.y + cell.height, cell.x + cell.width, cell.y + cell.height);
                }
                // Desenha sempre a linha superior (ou a borda superior)
                doc.line(cell.x, cell.y, cell.x + cell.width, cell.y);
                if (currentPage === 1) {
                    addHeader();


                } else {
                    startY = marginTop + 10; // Posição inicial para páginas seguintes
                }
                doc.autoTable({

                    startY: startY,
                    margin: {top: marginTop, bottom: marginBottom, left: 10, right: 10}
                    // Outras opções da tabela
                });
            }
        }
    });

// Salva o PDF
    totalPages = doc.internal.getNumberOfPages();
    for (var i = 1; i <= totalPages; i++) {
        doc.setPage(i);
        addHeader2();
        addFooter(i);
    }
    var pdfOutput = doc.output('blob'); // Gera um blob do PDF
    var blobUrl = URL.createObjectURL(pdfOutput); // Cria uma URL para o blob

// Abre em uma nova aba
    window.open(blobUrl);


}


