


function imprimeResumoVendaPorOperador(empresa, dadosDocumentos, totais, datais) {
    const {jsPDF} = window.jspdf;
    const doc = new jsPDF({
        unit: 'mm',
        format: 'a4' // Alterar para o formato A4
    });
    let totalPages;
// Tamanho da página A4
    var pageWidth = doc.internal.pageSize.getWidth();
// Margens
    var marginTop = 15; // Distância do topo da página
    var marginBottom = 25; // Distância da parte inferior da página
    function addHeader() {
        doc.setFont("helvetica", "bold");
        doc.setFontSize(8);
        // Nome da empresa e data (data alinhada à direita)
        doc.text("Empresa: " + empresa.nomeEmpresa, 10, marginTop);
        // Título centralizado
        doc.setFontSize(14);
        doc.setTextColor(0, 0, 0);
        doc.text("Resumo de vendas por operador", pageWidth / 2, marginTop + 10, {align: "center"});
        // Adiciona uma linha abaixo do texto
        let textWidth = doc.getTextWidth("Resumo de vendas por operador"); // Obtém a largura do texto
        let textX = (pageWidth / 2) - (textWidth / 2); // Calcula a posição inicial da linha

        doc.setDrawColor(0, 0, 0); // Define a cor da linha (preta)
        doc.setLineWidth(0.5); // Define a espessura da linha
        doc.line(textX, marginTop + 12, textX + textWidth, marginTop + 12); // Linha contínua abaixo do texto
        doc.setFont("helvetica", "italic");
        doc.text("Resumo/Tot.Operadores. Todas Divisões", pageWidth / 2, marginTop + 17, {align: "center"});
        // Período da consulta
        doc.setFont("helvetica", "bold");
        doc.setFontSize(12);
        // Adiciona linha separadora a cima da  data
        doc.setDrawColor(0, 0, 0); // Cor preta
        doc.setLineWidth(0.3); // Espessura da linha
        doc.line(10, marginTop + 24, pageWidth - 10, marginTop + 24); // Linha horizontal

        doc.text("Período:", 10, marginTop + 28);
        doc.text(datais.dataminima, 50, marginTop + 28);
        doc.text("a", 100, marginTop + 28);
        doc.text(datais.datamaxima, 130, marginTop + 28);
        // Adiciona linha separadora abaixo do cabeçalho
        doc.setDrawColor(0, 0, 0); // Cor preta
        doc.setLineWidth(0.3); // Espessura da linha
        doc.line(10, marginTop + 31, pageWidth - 10, marginTop + 31); // Linha horizontal

    }

    addHeader();
    function addFooter(pageNumber) {
        var marginLeft = 10; // Margem esquerda
        var marginRight = 10; // Margem direita
        var pageWidth = doc.internal.pageSize.getWidth();
        var pageHeight = doc.internal.pageSize.getHeight();
        var startX = marginLeft;
        var endX = pageWidth - marginRight;
        var startYFooter = pageHeight - 10; // Ajuste para a posição do rodapé
        var text = 'Página ' + pageNumber;
        doc.setFontSize(8);
        // Calcula a largura do texto para alinhamento à direita
        var textWidth = doc.getTextWidth(text);
        var startXText = pageWidth - marginRight - textWidth;
        // Desenha a linha acima do número da página
        var lineY = startYFooter - 5; // Ajuste para a linha ficar logo acima
        doc.setDrawColor(0, 0, 0); // Cor preta
        doc.setLineWidth(0.3);
        doc.line(startX, lineY, endX, lineY);
        // Adiciona o número da página
        doc.text(text, startXText, startYFooter, {align: 'left'});
    }
// Define algumas variáveis para as margens e a posição vertical inicial
    const marginLeft = 10;
    const marginRight = 10;
    // Definição do cabeçalho
    const head = [
        [
            {content: "Operador", rowSpan: 2, styles: {halign: 'center', fontStyle: 'bold'}},
            {content: "Qtd. Documentos", rowSpan: 2, styles: {halign: 'center', fontStyle: 'bold'}},
            {content: "Totais dos Documentos", colSpan: 2, styles: {halign: 'center', fontStyle: 'bold'}}
        ],
        [
            {content: "Crédito", styles: {halign: 'center', fontStyle: 'bold'}},
            {content: "Dinheiro", styles: {halign: 'right', fontStyle: 'bold'}}
        ]
    ];
    const linhasRows = dadosDocumentos.map(dados => [
            {content: dados.operador, styles: {fontSize: 8, halign: 'left'}},
            {content: dados.docs, styles: {fontSize: 8, halign: 'center'}},
            {content: moeda(dados.credito), styles: {fontSize: 8, halign: 'center'}},
            {content: moeda(dados.dinheiro), styles: {fontSize: 8, halign: 'right'}}

        ]);
    // Adiciona uma linha de totais ao final do array de linhas
    linhasRows.push([
        {content: "Total", styles: {fontSize: 8, halign: 'left', fontStyle: 'bold'}, isTotalRow: true},
        {content: totais.totalDoc, styles: {fontSize: 8, halign: 'center', fontStyle: 'bold'}, isTotalRow: true},
        {content: moeda(totais.totalCredito), styles: {fontSize: 8, halign: 'center', fontStyle: 'bold'}, isTotalRow: true},
        {content: moeda(totais.totalDinheiro), styles: {fontSize: 8, halign: 'right', fontStyle: 'bold'}, isTotalRow: true}
    ]);
// Cria a tabela única com autoTable
    var startY = marginTop + 25; // Deixar espaço para o cabeçalho
    doc.autoTable({
        head: head, // Cabeçalho que será repetido em cada página
        body: linhasRows, // 
        tartY: marginTop + 25,
        margin: {top: 50, bottom: marginBottom, left: 10, right: 10},
        showHead: 'everyPage', // Cabeçalho repetido no início de cada página
        theme: 'plain',
        styles: {fontSize: 8},
        columnStyles: {
            0: {cellWidth: 80}, // Incidência
            1: {cellWidth: 40}, // Taxa
        },
        headStyles: {
            fillColor: [230, 230, 230], // Cor de fundo do cabeçalho (cinza)
            textColor: 0, // Cor do texto (preto)
            fontStyle: 'bold', // Texto em negrito
            halign: 'center', // Alinhamento centralizado
            fontSize: 8, // Tamanho menor da fonte
            cellPadding: 2, // Menor espaçamento interno
            lineWidth: 0.3, // Espessura da borda
            lineColor: [0, 0, 0]         // Cor da borda (preto)
        },
        didDrawCell: function (data) {
            const currentPage = data.pageNumber;
            // Verifica se a linha é marcada como "total"
            if (data.row.raw && data.row.raw[0] && data.row.raw[0].isTotalRow === true) {
                let cell = data.cell;
                doc.setDrawColor(0, 0, 0);
                doc.setLineWidth(0.3);
                // Desenha a linha superior
                doc.line(cell.x, cell.y, cell.x + cell.width, cell.y);
                // Desenha a linha inferior
                doc.line(cell.x, cell.y + cell.height, cell.x + cell.width, cell.y + cell.height);
            }

        }
    });
    // Após gerar a tabela, obtém a posição final:
    // Definir posição inicial
    let finalY = doc.lastAutoTable ? doc.lastAutoTable.finalY + 10 : 20;
// Define o estilo do texto e centraliza-o na página
    doc.setFont("helvetica", "bold");
    doc.setFontSize(10);
    doc.text("Resumo Geral por forma de Pagamento", doc.internal.pageSize.getWidth() / 2, finalY + 10, {align: "center"});


//
// Dados da tabela
    const resumoGeral = [
        [
            {content: "NUMERARIO", styles: {fontSize: 10, halign: 'left'}},
            {content: "AKZ", styles: {fontSize: 10, halign: 'center'}},
            {content: moeda2(totais.totalCash), styles: {fontSize: 10, halign: 'right'}}
        ],
        [
            {content: "TPA", styles: {fontSize: 10, halign: 'left'}},
            {content: "AKZ", styles: {fontSize: 10, halign: 'center'}},
            {content: moeda2(totais.totalTpa), styles: {fontSize: 10, halign: 'right'}}
        ],
        [
            {content: "TRANSF.BANCARIA", styles: {fontSize: 10, halign: 'left'}},
            {content: "AKZ", styles: {fontSize: 10, halign: 'center'}},
            {content: moeda2(totais.totalTrans), styles: {fontSize: 10, halign: 'right'}}
        ]
    ];
    const head2 = [[{content: "Forma Pagto.", styles: {fontStyle: 'bold', halign: 'left'}},
            {content: "Moeda", styles: {fontStyle: 'bold', halign: 'center'}},
            {content: "Valor", styles: {fontStyle: 'bold', halign: 'right'}}]
    ];
    // Calcula a posição X inicial para centralizar a tabela
    const tableWidth = 120; // Largura estimada da tabela
    const startX = (pageWidth - tableWidth) / 2; // Centraliza a tabela
// Gera a tabela
    doc.autoTable({
        head: head2, // Cabeçalho que será repetido em cada página
        startY: finalY + 13,
        body: resumoGeral,
        theme: 'plain',
        styles: {fontSize: 8},
        headStyles: {fillColor: [240, 240, 240], textColor: 0, fontSize: 10},
        margin: {left: startX, right: startX}, // Centraliza a tabela
        didDrawCell: function (data) {
            if (data.section === 'body') {
                var cell = data.cell;
                var doc = data.doc;

                // Apenas a borda inferior
                doc.setDrawColor(0, 0, 0);  // Cor preta
                doc.setLineWidth(0.3);      // Espessura da linha inferior
                doc.line(
                        cell.x, cell.y + cell.height,
                        cell.x + cell.width, cell.y + cell.height
                        );
            }
        },
    });
// Salvar ou visualizar o PDF

// Salva o PDF
    totalPages = doc.internal.getNumberOfPages();
    for (var i = 1; i <= totalPages; i++) {
        doc.setPage(i);
        addFooter(i);
    }

    var pdfOutput = doc.output('blob'); // Gera um blob do PDF
    var blobUrl = URL.createObjectURL(pdfOutput); // Cria uma URL para o blob

// Abre em uma nova aba
    window.open(blobUrl);
}


