$(document).ready(function () {
    listaLojasLojas();
    function listaLojasLojas() {
        if ($.fn.DataTable.isDataTable('#tabelaStokLojas')) {
            $('#tabelaStokLojas').DataTable().clear().destroy();
        }

        var dataTable = $('#tabelaStokLojas').DataTable({
            colReorder: true,
            responsive: true,
            "processing": true,
            "serverSide": true,
            "searching": true,
            "ordering": false,
            "lengthChange": true,
            initComplete: function () {

                $('#tabelaStokLojas_filter input').attr('placeholder', 'Procurar artigo');
                $('#tabelaStokLojas_filter input').css({
                    'padding-left': '30px',
                    'background-image': 'url("' + BASE_PATH + 'src/img/icon/search.png")',
                    'background-repeat': 'no-repeat',
                    'background-position': '5px center',
                    'background-size': '16px 16px',
                    'border': '1px solid #ced4da',
                    'border-radius': '20px',
                    'height': '35px'
                });
            },
            "language": {
                "lengthMenu": "Mostrando _MENU_ registros por página",
                "zeroRecords": "Nenhum registro encontrado",
                "info": "Mostrando _START_ a _END_ de _TOTAL_ registos",
                "infoEmpty": "Nenhum registro disponível",
                "infoFiltered": "(filtrado de _MAX_ registros no total)",
                search: "", // Remove o texto padrão "Procurar"
                "loadingRecords": "Carregando...",
                "processing": "Processando...",
                "paginate": {
                    "previous": "Anterior",
                    "next": "Próximo"
                },
                "oAria": {
                    "sSortAscending": ": Ativar para ordenar a coluna de forma ascendente",
                    "sSortDescending": ": Ativar para ordenar a coluna de forma descendente"
                },
                error: function (xhr, error, thrown) {
                    console.error("Erro ao carregar dados:", xhr, error, thrown);
                }
            },
            "ajax": {
                url: BASE_URL + "cStock/clistaArtigosQtdStock", // URL da requisição
                type: "post",
                "data": function (searchParams) {
                    searchParams.pesquisa = $("#search").val();
                },
                "dataSrc": function (json) {
                    // Atualizar dinamicamente os nomes dos armazéns
                    var totalItens = json.totalItens;
                    $("#totalQtd").text(totalItens.totalQtd);
                    $("#totalCompra").text(moeda(totalItens.totalGeralCompra));
                    $("#valorVenda").text(moeda(totalItens.totaGralVenda));
                    return json.data; // Onde json.data é o array de dados da tabela
                }
            },
            columns: [
                {data: "produto",
                    render: function (data, type, row) {
                        return `
                                <div class="produto-cell" style="display: flex; align-items: center;">
                                    <div class="dropdown" style="display: inline-block; position: relative;">
                                        <!-- Botão sem fundo e com apenas a seta -->
                                        <button type="button" 
                                            class="btn btn-link dropdown-toggle" 
                                            data-toggle="dropdown" 
                                            aria-haspopup="true" 
                                            aria-expanded="false">
                                            <i class="fa fa-chevron-down"></i> <!-- Ícone de seta para baixo -->
                                        </button>
                                        <div class="dropdown-menu" style="position: absolute; z-index: 9999;">
                                            <a class="dropdown-item codeBar " href="#" data-id="${row.idProduto}"><i class="iconsminds-qr-code">Acertos de inventario</i></a>
                                           
                                           
                                            
                                            <a class="dropdown-item promo" href="#" data-id="${row.idProduto}"><i class="iconsminds-calendar-1">Histórico de saidas do produto</i></a>
                                        </div>
                                    </div>
                                    <span class="produto-nome" style="margin-left: 5px;">${data}</span> <!-- Nome do produto -->
                                </div>
                            `;
                    }
                },
                {data: "custo"},
                {data: "qtd"},
                {data: "venda"},
                {data: "totalv"},
                {data: "totalLucro"}
            ]
        });
        // Quando o select customizado for alterado, atualiza o page length
        $('#lengthChange').on('change', function () {
            var newLength = $(this).val();
            dataTable.page.len(newLength).draw();
        });
    }
    // Quando qualquer item do dropdown com id específico for clicado
    $('#entrada-stock').click(function (event) {
        event.preventDefault();  // Evita o comportamento padrão do link
        listaArtigosParaEntrStock()
        $('#fullScreenModal').modal('show');
    });


// Variável global para armazenar os dados dos fornecedores no cache
    let cachedFornecedores = null;
    let cellCache = {}; // Objeto para armazenar os valores de células
    function listaArtigosParaEntrStock() {
        // Verifica se a tabela já foi inicializada, e se sim, destrói para recriar
        if ($.fn.DataTable.isDataTable('#tabelaAdicionarStock')) {
            $('#tabelaAdicionarStock').DataTable().clear().destroy();
        }

        // Inicializa a DataTable
        var dataTable = $('#tabelaAdicionarStock').DataTable({
            colReorder: false, // Permite reordenar colunas
            responsive: true, // Adapta a tabela para dispositivos móveis
            "processing": true, // Exibe indicador de "processando" enquanto carrega dados
            "serverSide": true, // Ativa carregamento de dados no servidor
            "searching": true, // Habilita a funcionalidade de busca
            "ordering": false, // Desabilita ordenação de colunas
            "lengthChange": true, // Permite alterar o número de registros por página
            initComplete: function () {
                // Personaliza o campo de busca da tabela
                $('#tabelaArtigos_filter input').attr('placeholder', 'Procurar artigo');
            },
            "language": {// Configurações de idioma para a tabela
                "lengthMenu": "Mostrando _MENU_ registros por página",
                "zeroRecords": "Nenhum registro encontrado",
                "info": "Mostrando _START_ a _END_ de _TOTAL_ registros",
                "infoEmpty": "Nenhum registro disponível",
                "infoFiltered": "(filtrado de _MAX_ registros no total)",
                search: "", // Remove o texto padrão "Procurar"
                "loadingRecords": "Carregando...",
                "processing": "Processando...",
                "paginate": {
                    "previous": "Anterior",
                    "next": "Próximo"
                }
            },
            "ajax": {// Configuração para carregar dados do servidor
                url: BASE_URL + "cStock/clistaArtigosAddStock", // URL para a requisição
                type: "post", // Método POST
                "data": function (searchParams) {
                    // Passa parâmetros adicionais para a requisição AJAX
                    searchParams.pesquisa = $("#search").val(); // Exemplo: adiciona valor de pesquisa
                },
                "dataSrc": function (json) {

                    return json.data; // Retorna apenas os dados da tabela
                }
            },
            columns: [
                {data: "produto"}, // Coluna para o nome do produto
                {data: "narmanze"}, // Coluna para o nome do armazém
                {data: "qtd"}, // Coluna para a quantidade
                {
                    data: null, // Coluna não mapeada
                    createdCell: function (td, cellData, rowData, row, col) {
                        const uniqueId = rowData.idstock; // ID único para identificar a linha
                        const columnKey = `idFornecedor_${col}`; // Chave única para a coluna (pode usar `col` ou outro identificador)

                        // Recupera valor do cache, se disponível
                        const cachedValue = cellCache[uniqueId]?.[columnKey] || cellData;

                        // Popula o dropdown com fornecedores
                        if (cachedFornecedores) {
                            populateFornecedoresDropdown(cachedFornecedores, td, cachedValue);
                        } else {
                            // Caso contrário, realiza a requisição AJAX
                            $.ajax({
                                url: BASE_URL + "cFornecedores/getFornecedoresCB", // URL para buscar fornecedores
                                method: 'GET',
                                dataType: 'json',
                                timeout: 5000, // 5 segundos
                                success: function (fornecedores) {
                                    cachedFornecedores = fornecedores; // Salva os dados no cache
                                    populateFornecedoresDropdown(fornecedores, td, cachedValue);
                                },
                                error: function () {
                                    // Exibe mensagem de erro em caso de falha
                                    $(td).html('<select class="form-control"><option disabled selected>Erro ao carregar fornecedores</option></select>');
                                }
                            });
                        }

                        // Escuta alterações no dropdown para salvar o valor no cache
                        $(td).on('change', 'select', function () {
                            const selectedValue = $(this).val();
                            if (!cellCache[uniqueId]) {
                                cellCache[uniqueId] = {};
                            }
                            cellCache[uniqueId][columnKey] = selectedValue; // Armazena o valor no cache
                        });
                    }
                },
                {
                    data: null, // Coluna para entrada de número
                    createdCell: function (td, cellData, rowData, row, col) {
                        const uniqueId = rowData.idstock; // ID único da linha
                        const columnKey = `custo_${col}`; // Chave única para esta coluna

                        // Recupera o valor do cache, se existir
                        const cachedValue = cellCache[uniqueId]?.[columnKey] || cellData;

                        // Insere o campo de entrada para números com o valor armazenado
                        $(td).html(`<input type="number" class="form-control" value="${cachedValue}">`);

                        // Escuta mudanças no campo de entrada
                        $(td).find('input').on('input', function () {
                            const inputValue = $(this).val();

                            // Armazena o valor no cache
                            if (!cellCache[uniqueId]) {
                                cellCache[uniqueId] = {};
                            }
                            cellCache[uniqueId][columnKey] = inputValue;
                        });
                    }
                },

                {
                    data: null, // Coluna para entrada de número
                    createdCell: function (td, cellData, rowData, row, col) {
                        const uniqueId = rowData.idstock; // ID único da linha
                        const columnKey = `qtd_${col}`; // Chave única para esta coluna

                        // Recupera o valor do cache, se existir
                        const cachedValue = cellCache[uniqueId]?.[columnKey] || cellData;

                        // Insere o campo de entrada para números com o valor armazenado
                        $(td).html(`<input type="number" class="form-control" value="${cachedValue}">`);

                        // Escuta mudanças no campo de entrada
                        $(td).find('input').on('input', function () {
                            const inputValue = $(this).val();

                            // Armazena o valor no cache
                            if (!cellCache[uniqueId]) {
                                cellCache[uniqueId] = {};
                            }
                            cellCache[uniqueId][columnKey] = inputValue;
                        });
                    }
                },
                {
                    data: null, // Coluna para entrada de texto
                    createdCell: function (td, cellData, rowData, row, col) {
                        const uniqueId = rowData.idstock; // ID único da linha
                        const columnKey = `lote_${col}`; // Chave única para esta coluna

                        // Recupera o valor do cache, se existir
                        let cachedValue = cellCache[uniqueId]?.[columnKey] || ""; // Inicializa como vazio;

                        // Insere o campo de entrada de texto com o valor armazenado
                        $(td).html(`<input type="text" class="form-control" value="${cachedValue}">`);

                        // Escuta mudanças no campo de entrada
                        $(td).find('input').on('input', function () {
                            const inputValue = $(this).val();

                            // Armazena o valor no cache
                            if (!cellCache[uniqueId]) {
                                cellCache[uniqueId] = {};
                            }
                            // Armazena o valor no cache (como string)
                            cellCache[uniqueId][columnKey] = inputValue;
                        });
                    }
                },

                {
                    data: null, // Coluna para entrada de data
                    createdCell: function (td, cellData, rowData, row, col) {
                        const uniqueId = rowData.idstock; // ID único da linha
                        const columnKey = `dtCaducidade_${col}`; // Chave única para esta coluna

                        // Recupera o valor do cache, se existir
                        const cachedValue = cellCache[uniqueId]?.[columnKey] || cellData || ''; // Valor do cache ou o valor original

                        // Insere o campo de entrada de data com o valor armazenado
                        $(td).html(`<input type="date" class="form-control" value="${cachedValue}">`);

                        // Escuta mudanças no campo de entrada
                        $(td).find('input').on('change', function () {
                            const inputValue = $(this).val();

                            // Armazena o valor no cache
                            if (!cellCache[uniqueId]) {
                                cellCache[uniqueId] = {};
                            }
                            // Armazena o valor no cache (como string de data)
                            cellCache[uniqueId][columnKey] = inputValue;
                        });
                    }
                }
            ]
        });
    }

// Função auxiliar para popular a coluna de fornecedores com um dropdown
    function populateFornecedoresDropdown(fornecedores, td, cellData) {
        let options = '<option disabled selected>Selecione</option>'; // Opção padrão
        // Itera pelos fornecedores para criar opções
        $.each(fornecedores, function (i, obj) {
            const selected = obj.idfornecedor === cellData ? 'selected' : ''; // Marca como selecionado, se necessário
            options += `<option value="${obj.idfornecedor}" ${selected}>${obj.nome}</option>`;
        });
        // Insere o dropdown na célula
        $(td).html(`<select class="form-control">${options}</select>`);
    }
    $('#saveChanges').on('click', function () {
        let alteredRows = [];

        // Itera sobre o cache para identificar linhas alteradas
        for (const rowId in cellCache) {
            const rowChanges = cellCache[rowId]; // Obtém as alterações da linha
            if (Object.keys(rowChanges).length > 0) {
                // Inclui o `id_stock` e os valores alterados no JSON
                alteredRows.push({
                    id_stock: rowId, // Usando id_stock como chave única
                    qtd: rowChanges[`qtd_5`] || null, // Pega a chave para a quantidade (ajustar conforme o índice de coluna)
                    custo: rowChanges[`custo_4`] || null, // Pega a chave para o custo
                    dt_caducidade: rowChanges[`dtCaducidade_7`] || null, // Pega a chave para data de caducidade
                    lote: rowChanges[`lote_6`] || null, // Pega a chave para o lote
                    ...rowChanges // Mergulha com as demais alterações
                });
            }
        }

        if (alteredRows.length > 0) {
            console.log('Linhas alteradas a serem enviadas:', alteredRows);
            var parametrosAdicionais = {

                idUsuario: idUsuario,
            };

// Incluindo os parâmetros adicionais no objeto JSON de dados
            var dadosPost = {
                ...parametrosAdicionais, // Adiciona os parâmetros adicionais
                alterations: alteredRows  // Inclui o array de alterações (suponho que você já tenha ele)
            };

            // Envia os dados como um objeto JSON via AJAX
            $.ajax({
                url: BASE_URL + "cStock/rececao_stock_varios",
                method: 'POST',
                contentType: 'application/json', // Indica que está enviando JSON
                data: JSON.stringify(dadosPost), // Converte o array de objetos para JSON
                dataType: "json", // aqui será o tipo de resposta que vamos receber, será no formato json, um formato simples e mais usado.
//                beforeSend: function () {
//                    iniciarProgressBar();
//                },
                success: function (data) {
                    // Admin/dashboard?page=dashboard
                    if (data === 'OK') {
                        $("#fullScreenModal").modal('hide');
                        $('#tabelaStokLojas').DataTable().ajax.reload();
                        cellCache = {}; // Objeto para armazenar os valores de células
                    } else if (data === 'N') {
                        Swal.fire({
                            icon: 'warning', // Tipo do alerta
                            title: 'Aviso!',
                            text: 'Nenhum dado válido encontrado.' // Mensagem de erro
                        });
                    } else if (data === 'NerroDt') {
                        Swal.fire({
                            icon: 'warning', // Tipo do alerta
                            title: 'Aviso!',
                            text: `Produto exige controle de validade e lote, verifica se inseriu a data  de validade  no formato
                            certo e forneça lote do Produto
                           ` // Mensagem de erro
                        });
                    }
                },
                error: function () {
                    // Caso ocorra um erro na requisição
                    Swal.fire({
                        icon: 'warning', // Tipo do alerta: aviso
                        title: 'Atenção!',
                        text: 'Ocorreu um erro na comunicação com o servidor.'
                    });
                }
//                complete: function () {
//                    // Remove ou esconde a barra no final da operação
//                     finalizarProgressBar();
//                }
            });
        } else {
            Swal.fire({
                icon: 'warning', // Tipo do alerta: aviso
                title: 'Atenção!',
                text: 'Nenhuma alteração foi feita.'
            });

        }
    });
    listaArtigosDtCad();
    function listaArtigosDtCad() {
        if ($.fn.DataTable.isDataTable('#tabelaStokLojasDtCaducidade')) {
            $('#tabelaStokLojasDtCaducidade').DataTable().clear().destroy();
        }

        var dataTable = $('#tabelaStokLojasDtCaducidade').DataTable({
            colReorder: true,
            responsive: true,
            "processing": true,
            "serverSide": true,
            "searching": true,
            "ordering": false,
            "lengthChange": true,
            initComplete: function () {
                // Adicionar placeholder ao campo de pesquisa
                $('#tabelaStokLojasDtCaducidade_filter input').attr('placeholder', 'Procurar artigo');
                $('#tabelaStokLojasDtCaducidade_filter input').css({
                    'padding-left': '30px',
                    'background-image': 'url("' + BASE_PATH + 'src/img/icon/search.png")',
                    'background-repeat': 'no-repeat',
                    'background-position': '5px center',
                    'background-size': '16px 16px',
                    'border': '1px solid #ced4da',
                    'border-radius': '20px',
                    'height': '35px'
                });
            },
            "language": {
                "lengthMenu": "Mostrando _MENU_ registros por página",
                "zeroRecords": "Nenhum registro encontrado",
                "info": "Mostrando _START_ a _END_ de _TOTAL_ registos",
                "infoEmpty": "Nenhum registro disponível",
                "infoFiltered": "(filtrado de _MAX_ registros no total)",
                search: "", // Remove o texto padrão "Procurar"
                "loadingRecords": "Carregando...",
                "processing": "Processando...",
                "paginate": {
                    "previous": "Anterior",
                    "next": "Próximo"
                },
                "oAria": {
                    "sSortAscending": ": Ativar para ordenar a coluna de forma ascendente",
                    "sSortDescending": ": Ativar para ordenar a coluna de forma descendente"
                },
                error: function (xhr, error, thrown) {
                    console.error("Erro ao carregar dados:", xhr, error, thrown);
                }
            },
            "ajax": {
                url: BASE_URL + "cStock/clistaArtigosDtCaducidade", // URL da requisição
                type: "post",
                "data": function (searchParams) {
                    searchParams.pesquisa = $("#search").val();
                },
                "dataSrc": function (json) {
                    // Atualizar dinamicamente os nomes dos armazéns
                    return json.data; // Onde json.data é o array de dados da tabela
                }
            },
            columns: [
                {data: "produto",
                    render: function (data, type, row) {
                        return `
                                <div class="produto-cell" style="display: flex; align-items: center;">
                                    <div class="dropdown" style="display: inline-block; position: relative;">
                                        <!-- Botão sem fundo e com apenas a seta -->
                                        <button type="button" 
                                            class="btn btn-link dropdown-toggle" 
                                            data-toggle="dropdown" 
                                            aria-haspopup="true" 
                                            aria-expanded="false">
                                            <i class="fa fa-chevron-down"></i> <!-- Ícone de seta para baixo -->
                                        </button>
                                        <div class="dropdown-menu" style="position: absolute; z-index: 9999;">
                                            <a class="dropdown-item codeBar " href="#" data-id="${row.idProduto}"><i class="iconsminds-qr-code">Acertos de inventario</i></a>
                                           
                                           
                                            
                                            <a class="dropdown-item promo" href="#" data-id="${row.idProduto}"><i class="iconsminds-calendar-1">Histórico de saidas do produto</i></a>
                                        </div>
                                    </div>
                                    <span class="produto-nome" style="margin-left: 5px;">${data}</span> <!-- Nome do produto -->
                                </div>
                            `;
                    }
                },
                {data: "qtd"},
                {data: "lote"},
                {data: "dataValidade",
                    render: function (data, type, row) {
                        // Verificar se a data existe
                        if (data) {
                            // Converter a data para o formato 'dia mês ano'
                            const dateObj = new Date(data);
                            const options = {year: 'numeric', month: 'long', day: 'numeric'};
                            const formattedDate = dateObj.toLocaleDateString('pt-BR', options); // Formato "dia mês ano"

                            // Retornar a data formatada
                            return formattedDate;
                        }
                        return ''; // Caso não haja data, retornar uma string vazia
                    }
                }
            ]
        });
    }


});