$(document).ready(function () {
    localStorage.getItem('idProduto');
    var artigo = localStorage.getItem('artigo');
    $(".meuTitulo").text(`STOCK / ${artigo}`);
    $("#tituloDocumento").text(artigo);
    $("#tituloDocumento2").text(`HISTÓRICO DE STOCK / ${artigo}`);
    listarProdutosLojas();
    function listarProdutosLojas() {
        if ($.fn.DataTable.isDataTable('#tabeTotalStockl')) {
            $('#tabeTotalStockl').DataTable().clear().destroy();
        }
        var dataTable = $('#tabeTotalStockl').DataTable({
            colReorder: true,
            responsive: true,
            "processing": true,
            "serverSide": false,
            "searching": false,
            "ordering": false,
            paging: false, // Desativa a paginação
            lengthChange: false, // Remove a opção de alterar o número de registros exibidos
            info: false, // Remove a mensagem "Showing X to Y of Z entries"
            "language": {
                "zeroRecords": "Nenhum registro encontrado",
                "infoEmpty": "Nenhum registro disponível",
                "loadingRecords": "Carregando...",
                "processing": "Processando...",
                "oAria": {
                    "sSortAscending": ": Ativar para ordenar a coluna de forma ascendente",
                    "sSortDescending": ": Ativar para ordenar a coluna de forma descendente"
                },
                error: function (xhr, error, thrown) {
                    console.error("Erro ao carregar dados:", xhr, error, thrown);
                }
            },
            "ajax": {
                url: BASE_URL + "cArtigos/listarProdutosLojas", // URL da requisição
                type: "post",
                "data": function (searchParams) {
                    searchParams.idpr = localStorage.getItem('idProduto'); // 'idpr' corresponde ao esperado no método PHP;
                },
                "dataSrc": function (json) {
                    $('#totalProdutos').text(json.totalProdutos);
                    return json.data; // Onde json.data é o array de dados da tabela
                }
            },
            columns: [
                {data: "narmanze"},
                {data: "qtd"},
                {
                    data: null,
                    render: function (data, type, row) {
                        return `
                <a href="#" class="icon-action stock" data-id="${row.idArmaze}" title="Adicionar stock">
                    <i class="iconsminds-box-close"></i>
                </a>
                <a href="#" class="icon-action transStock" data-id="${row.idArmaze}"   data-qtd="${row.qtd}" title="Transferir stock">
                    <i class="iconsminds-sync"></i>
                </a>
                <a href="#" class="icon-action historico" data-id="${row.idArmaze}" data-qtd="${row.qtd}" title="Histórico stock">
                    <i class="iconsminds-calendar-4"></i>
                </a>
            `;
                    }
                }


            ]

        });
    }
    function listarHistoricoStock(idArmanze) {
        if ($.fn.DataTable.isDataTable('#tabelaHistoricoStock')) {
            $('#tabelaHistoricoStock').DataTable().clear().destroy();
        }
        var dataTable = $('#tabelaHistoricoStock').DataTable({
            colReorder: true,
            responsive: true,
            "processing": true,
            "serverSide": false,
            "searching": false,
            "ordering": false,
            paging: false, // Desativa a paginação
            lengthChange: false, // Remove a opção de alterar o número de registros exibidos
            info: false, // Remove a mensagem "Showing X to Y of Z entries"
            "language": {
                "zeroRecords": "Nenhum registro encontrado",
                "infoEmpty": "Nenhum registro disponível",
                "loadingRecords": "Carregando...",
                "processing": "Processando...",
                "oAria": {
                    "sSortAscending": ": Ativar para ordenar a coluna de forma ascendente",
                    "sSortDescending": ": Ativar para ordenar a coluna de forma descendente"
                },
                error: function (xhr, error, thrown) {
                    console.error("Erro ao carregar dados:", xhr, error, thrown);
                }
            },
            "ajax": {
                url: BASE_URL + "cStock/listarHistoricoPorLojas", // URL da requisição
                type: "get",
                "data": function (searchParams) {
                    searchParams.idProduto = localStorage.getItem('idProduto'); // 'idProduto' corresponde ao esperado no método PHP;
                    searchParams.idArmanze = idArmanze; // 'idArmanze' corresponde ao esperado no método PHP;
                },
                "dataSrc": function (json) {

                    return json.data; // Onde json.data é o array de dados da tabela
                }
            },
            columns: [
                {
                    data: null, // Dados combinados ou formatados
                    render: function (data, type, row) {
                        // Supondo que row.data está no formato "YYYY-MM-DD"
                        const dateParts = row.data.split("-"); // Divide a data
                        const formattedDate = `${dateParts[2]}-${dateParts[1]}-${dateParts[0]}`; // Reorganiza para DD-MM-YY
                        let formatted = ''; // Variável para armazenar o HTML formatado
                        if (row.tipo === 'SAIDA') {
                            formatted = `
                              <div style="text-align: left;">
                                <span style="color:black; font-weight:bold;">
                                    <i class="iconsminds-remove" style="font-weight: bold; vertical-align: middle; margin-right: 5px;"></i>
                                    ${formattedDate}
                                </span>
                                <br>
                                <span style="font-style:italic; padding-left: 25px;">
                                    ${row.hora}
                                </span>
                            </div>
                        `;
                        } else {
                            formatted = `
                              <div style="text-align: left;">
                                <span style="color:black; font-weight:bold;">
                                    <i class="iconsminds-add" style="font-weight: bold; vertical-align: middle; margin-right: 5px;"></i>
                                    ${formattedDate}
                                </span>
                                <br>
                                <span style="font-style:italic; padding-left: 25px;">
                                    ${row.hora}
                                </span>
                            </div>
                        `;
                        }

                        return formatted;
                    }
                },
                {
                    data: null, // Dados combinados ou formatados
                    render: function (data, type, row) {

                        const formatted = `
                            <span style="color:black; font-weight:bold;">
                                ${row.operacao}
                            </span>
                            <br>
                        <i> ${row.usuario}</i>
                            
                        
                        `;
                        return formatted;
                    }
                },
//                {data: "observacao"},
                {
                    data: null, // Dados combinados ou formatados
                    render: function (data, type, row) {
                        let formatted = ''; // Variável para armazenar o HTML formatado

                        if (row.tipo === 'SAIDA') {
                            formatted = `
                                <span style="color:black; font-weight:bold;">
                                    ${row.armanzeOrigem}
                                </span>
                                <div class="iconsminds-sync" style="margin: 0 5px;"></div>
                                <span style="color:blue;">
                                    ${row.armanzeDestino}
                                </span>
                            `;
                        } else if (row.tipo === 'ENTRADA') {
                            formatted = `
                                <span style="color:blue; font-weight:bold;">
                                    ${row.armanzeDestino}
                                </span>
                                <div class="iconsminds-sync" style="margin: 0 5px;"></div>
                                <span style="color:black;">
                                    ${row.armanzeOrigem}
                                </span>
                            `;
                        } else if (row.tipo === 'ENTRADA2') {
                            formatted = ''; // Vazio para ENTRADA2
                        } else {
                            formatted = `<span style="color:gray;">Sem operação definida</span>`;
                        }

                        return formatted; // Retorna o HTML formatado
                    }
                },
                {
                    data: null,
                    render: function (data, type, row) {
                        let formatted = ''; // Variável para armazenar o HTML formatado
                        if (row.tipo === 'SAIDA') {
                            formatted = ` <span style="color: red; font-weight: bold;"> - ${row.qtd}</span>`;
                        } else {
                            formatted = ` <span style="color: green; font-weight: bold;">${data.qtd}</span>`;
                        }
                        return formatted; // Retorna o HTML formatado

                    }
                }



            ]

        });
    }
    $('#tabeTotalStockl tbody').on('click', '.stock', function () {
        var idArmazen = $(this).data('id');
        $("#modalAdicionarStockPorProduto").modal({
            backdrop: 'static', // Impede fechar ao clicar fora
            keyboard: false     // Impede fechar com a tecla "ESC"
        });
        pegaEstadoDataCaducidade(localStorage.getItem('idProduto'));
        // Limpa o formulário ao abrir o modal
        $('#modalAdicionarStockPorProduto').on('shown.bs.modal', function () {
            let form = $(this).find('form')[0];
            $(form).find('.form-control').removeClass('is-invalid'); // Remove estilos de erro
            $(form).find('.invalid-feedback').remove(); // Remove mensagens de erro
        });

        $("#formStockPorProduto").validate({
            rules: {

                qtd: {
                    required: true,
                    number: true, // Verifica se é um número válido
                    min: 0.1 // Define que o valor mínimo é 0.1
                }

            },
            messages: {
                qtd: {
                    required: "Digite a quantidade",
                    number: "Digite um valor numérico válido",
                    min: "A quantidade deve ser maior que 0"
                }
            },
            errorElement: 'div',
            errorClass: 'invalid-feedback',
            highlight: function (element) {
                $(element).addClass('is-invalid');
            },
            unhighlight: function (element) {
                $(element).removeClass('is-invalid');
            },
            errorPlacement: function (error, element) {
                error.insertAfter(element);
            },
            success: function (label, element) {
                $(element).next('.error-tooltip').remove();
            },
            submitHandler: function (form) {
                // Chama a função de envio do formulário
                submeteFormStockPorProduto(idArmazen);
            }
        });
    });
    function submeteFormStockPorProduto(idArmazen) {

        var data = $("#formStockPorProduto").serialize(); // a function serialize serve para pegar todos os valores que foram colocados nos inputs do form
        // Concatena a variável extra aos dados do formulário
        var parametrosAdicionais = {
            idArmanze: idArmazen,
            idProduto: localStorage.getItem('idProduto'),
            idUsuario: idUsuario,
        };
        data += "&" + $.param(parametrosAdicionais);
        $.ajax({
            // está é a função ajax, do jquery, ela será usada para fazer a requisição assícrona.
            url: BASE_URL + "cStock/rececao_stock", // aqui vai a url da requisição
            data: data, // aqui vai os dados para o servidor, geralmente são os inputs do form
            method: "POST", // aqui vai o método da requisição, acho que você já sabe sobre o get e post !
            dataType: "json", // aqui será o tipo de resposta que vamos receber, será no formato json, um formato simples e mais usado.
            success: function (data) {
                // Admin/dashboard?page=dashboard
                if (data === 'OK') {
                    $("#modalAdicionarStockPorProduto").modal('hide');
                    $('#tabeTotalStockl').DataTable().ajax.reload();
                    listarHistoricoStock(idArmazen);
                } else {
                    Swal.fire({
                        icon: 'info', // Tipo do alerta
                        title: 'Informação!',
                        text: data // Mensagem de erro
                    });
                }
            },
            error: function () {
                // Caso ocorra um erro na requisição
                Swal.fire({
                    icon: 'warning', // Tipo do alerta: aviso
                    title: 'Atenção!',
                    text: 'Ocorreu um erro na comunicação com o servidor.'
                });
            }
        });
    }

    // Adiciona a regra personalizada para verificar a quantidade máxima
    $.validator.addMethod("maxQuantity", function (value, element) {
        var qtdExistente = parseFloat($("#qtdExistente").val());
        return parseFloat(value) <= qtdExistente;
    }, "A quantidade a transferir não pode exceder o saldo existente no armazém de origem.");

    // Adiciona a regra personalizada para verificar se os armazéns são diferentes
    $.validator.addMethod("differentWarehouses", function (value, element) {
        var idArmazenOrigem = $("#idArmazenAtual").val();
        return value !== idArmazenOrigem;
    }, "O armazém de destino deve ser diferente do de origem.");



    // Configura o evento para abrir o modal e inicializar o formulário
    $('#tabeTotalStockl tbody').on('click', '.transStock', function () {
        var idArmazenOrigem = $(this).data('id');
        var qtdExistente = $(this).data('qtd');
        // Preenche os campos do modal
        $("#idArmazenAtual").val(idArmazenOrigem);
        $("#qtdExistente").val(qtdExistente);

        // Abre o modal
        $("#modalTransfereStock").modal({
            backdrop: 'static', // Impede fechar ao clicar fora
            keyboard: false     // Impede fechar com a tecla "ESC"
        });

        // Inicializa o formulário ao abrir o modal
        $('#modalTransfereStock').on('shown.bs.modal', function () {
            let form = $(this).find('form')[0];

            // Remove validações anteriores
            $(form).find('.form-control').removeClass('is-invalid'); // Remove estilos de erro
            $(form).find('.invalid-feedback').remove(); // Remove mensagens de erro

            // Verifica se o validate já foi inicializado
            if (!$(form).data("validator")) {
                $("#formTransStockProduto").validate({
                    rules: {
                        qtd: {
                            required: true,
                            number: true, // Verifica se é um número válido
                            min: 0.1, // Define que o valor mínimo é 0.1
                            maxQuantity: true // Valida se a quantidade não excede o estoque
                        },
                        idArmanzeDestino: {
                            required: true, // Campo obrigatório
                            differentWarehouses: true // Valida se o destino é diferente do origem
                        }
                    },
                    messages: {
                        qtd: {
                            required: "Digite a quantidade a transferir",
                            number: "Digite um valor numérico válido",
                            min: "A quantidade deve ser maior que 0",
                            maxQuantity: "A quantidade a transferir não pode exceder o saldo existente no armazém de origem."
                        },
                        idArmanzeDestino: {
                            required: "Por favor, selecione um armazém de destino.",
                            differentWarehouses: "O armazém de destino deve ser diferente do de origem."
                        }
                    },
                    errorElement: 'div',
                    errorClass: 'invalid-feedback',
                    highlight: function (element) {
                        $(element).addClass('is-invalid');
                    },
                    unhighlight: function (element) {
                        $(element).removeClass('is-invalid');
                    },
                    errorPlacement: function (error, element) {
                        error.insertAfter(element);
                    },
                    success: function (label, element) {
                        $(element).next('.error-tooltip').remove();
                    },
                    submitHandler: function (form) {
                        // Função para enviar o formulário
                        submeteFormStockTransfereStock(idArmazenOrigem);
                    }
                });
            }
        });

    });

    function submeteFormStockTransfereStock(idArmazenOrigem) {

        var data = $("#formTransStockProduto").serialize(); // 
        // Concatena a variável extra aos dados do formulário
        var parametrosAdicionais = {
            idArmanzeOrigem: idArmazenOrigem,
            idProduto: localStorage.getItem('idProduto'),
            idUsuario: idUsuario,
        };
        data += "&" + $.param(parametrosAdicionais);
        $.ajax({
            // está é a função ajax, do jquery, ela será usada para fazer a requisição assícrona.
            url: BASE_URL + "cStock/transferirProdutos", // aqui vai a url da requisição
            data: data, // aqui vai os dados para o servidor, geralmente são os inputs do form
            method: "POST", // aqui vai o método da requisição, acho que você já sabe sobre o get e post !
            dataType: "json", // aqui será o tipo de resposta que vamos receber, será no formato json, um formato simples e mais usado.
            success: function (data) {
                // Admin/dashboard?page=dashboard
                if (data === 'OK') {
                    $("#modalAdicionarStockPorProduto").modal('hide');
                    $('#tabeTotalStockl').DataTable().ajax.reload();
                    listarHistoricoStock(idArmazenOrigem);
                } else {
                    Swal.fire({
                        icon: 'info', // Tipo do alerta
                        title: 'Informação!',
                        text: data // Mensagem de erro
                    });
                }
            },
            error: function () {
                // Caso ocorra um erro na requisição
                Swal.fire({
                    icon: 'warning', // Tipo do alerta: aviso
                    title: 'Atenção!',
                    text: 'Ocorreu um erro na comunicação com o servidor.'
                });
            }
        });
    }
    $('#tabeTotalStockl tbody').on('click', '.historico', function () {
        var idArmazen = $(this).data('id');
        $("#gridHistoricostock").removeAttr("hidden");
//        $("#gridHistoricostock").show();
        listarHistoricoStock(idArmazen);
    });

    $(document).on('click', '.cancelarStockPorProduto', function () {
        $("#modalAdicionarStockPorProduto").modal('hide');
    });
    $(document).on('click', '.cancelarStockTransf', function () {
        $("#modalTransfereStock").modal('hide');
    });
    function pegaEstadoDataCaducidade(idProduto) {

        // Realizar a requisição AJAX para obter os dados dos produtos
        $.ajax({
            type: 'get',
            url: BASE_URL + "cArtigos/pega_estado_dt_caducidade", // Substitua pela URL do seu endpoint
            dataType: 'json',
            data: {
                idProduto: idProduto
            },
            success: function (dados) {
//                // Define o estado do switch com base no valor de control de stock
                if (dados.dtcaducidade === 's') {
                    $('#loteCaducidade').show(); // Ativa o switch
                } else {
                    $('#loteCaducidade').hide(); // Desativa o switch
                }

////             
            },
            error: function (xhr, status, error) {
                console.error("Erro ao obter os produtos:", error);
                // Trate o erro como necessário
            }

        });
    }
    listar_armanze_trasferir();
    function listar_armanze_trasferir() {// 
        $.ajax({
            url: BASE_URL + "cArtigos/listaArmanzeTransferir", // aqui vai a url da requisição
            type: 'post',
            dataType: 'json',

            success: function (dados) {
                var option = '<option value="" disabled selected>Selecionar a loja de destino</option>'; // Adiciona a opção padrão
                if (dados.length > 0) {

                    $.each(dados, function (i, obj) {
                        option += '<option value="' + obj.idArmanzeDestino + '">' + obj.narmanze + '</option>';
                    });
                    $('#idArmanzeDestino').html(option).show();

                } else {
                    // Caso o retorno esteja vazio, mostra uma mensagem padrão
                    option = '<option value="" disabled selected>Nenhuma loja disponivel</option>';
                    $('#idArmanzeDestino').html(option).show();
                }
            }, error: function () {
                // Em caso de erro na requisição AJAX
                var option = '<option value="" disabled selected>Erro ao carregar a  loja de destino</option>';
                $('#idArmanzeDestino').html(option).show();
            }
        });
    }
});